;;						- 1 -
;;***********************************************
;;    programa svatiq i ras{ifrowki kartinki
;;  -------------------------------------------
;;  wers.3.5.41			 data:22-SEP-90
;;***********************************************
;;
	MACLIB	RSPACE
	MACLIB	BLOCK
	MACLIB	GOBLOCK
;;
	ORG	DUMP
;;
PROGRAM:
;	XRA	A
;	OUT	10H
;	CALL	BEGIN
	CALL	DUMPAB
	LHLD	ADRDUMP
	XCHG
	LHLD	BGNDUMP
	MOV	A,E
	SUB	L
	MOV	L,A
	MOV	A,D
	SBB	H
	MOV	H,A
	SHLD	LNDUMP
	CALL	DUMPC
	CALL	BEGIN1
	CALL	PUTDUMP
	RET
BEGIN:
	MAKE
	CLS
	COLOR	2,3
	POINT	0,0,PN
	SQR	255,128
	COLOR	5,3
	PLOT	20,235,PN
	SQR	225,10
	COLOR	7,1
	PLOT	0,0,PN
	LINE	255,255
	RETURN
BEGIN1:
	MAKE
	CLS
	RETURN
;;;;						- 2 -
SETBYTE	MACRO	REG
	MOV	REG,M
	MOV	A,H
	ADI	20H
	MOV	H,A
	ENDM
FINDBIT	MACRO	REG
	MOV	A,REG
	ADD	A
	MOV	REG,A
	MOV	A,L
	RAR
	MOV	L,A
	ENDM
;;
;;  najti cwet to~ki s korrekciej TV koordinat
;;  whod:
;;    <B> - tek.cwet i s~et~ik bit
;;    <C> - s~et~ik to~ek
;;    <H,D,E> - bajty izobraveniq
;;  wyhod:
;;    flag Z = 1 -> najden konec kartinki / Z = 0 -> <L> - cwet to~ki
FINDCLR:
	MOV	A,B
	ANI	00011000B	; s~et~ik bit perepolnen ?
	JZ	FINDPNT
	MOV	A,B		; s~et~ik bit:=0
	ANI	11100000B
	MOV	B,A
	LHLD	BNDTV		; smenitx bajty izobraveniq
	XCHG
	LHLD	TV
	INR	H
	DCR	D
	JNZ	FINDTV
	LDA	BGNTV+1
	MOV	H,A
	LDA	DIMTV+1
	MOV	D,A
	INR	L
	DCR	E
	RZ			; dostignut konec kartinki ?
;;
;;  ustanowitx 3 bajta izobraveniq
;;  whod: <D,E> - BNDTV i <H,L> - TV
FINDTV:
	SHLD	TV
	XCHG
	SHLD	BNDTV
	XCHG
	SETBYTE	D		; porqdok registrow ne menqtx !!!
	SETBYTE	E
	MOV	H,M
FINDPNT:			;  tolxko najti cwet to~ki
	MVI	L,0
	FINDBIT	D
	FINDBIT	E
	FINDBIT	H
	INR	B		; s~et~ik bit+:=1
	RET			; flag Z ne movet bytx ustanowlen !!!
;;;;						- 3 -
DUMPAB:
	LHLD	BGNDUMP		; podgotowitx dannye o bufere i kartinke
	SHLD	ADRDUMP
	LHLD	DIMTV
	XCHG
	LHLD	BGNTV
	LXI	B,0001H		; s~et~ik bit:=0 i s~et~ik to~ek:=1
	CALL	FINDTV
;;
DUMP1:
	MOV	A,B		; tek.cwet := cwet to~ki
	ANI	00001111B
	ORA	L
	MOV	B,A
DUMP2:
	CALL	FINDCLR
	JZ	WRTDUMP
	MOV	A,B
	ANI	11100000B	; cwet to~ki i tek.cwet sowpada`t ?
	CMP	L
	JNZ	NEQCLR
	INR	C		; s~et~ik to~ek +:= 1
	JNZ	DUMP2		; s~et~ik perepolnen ?
	CALL	WRT2
	JMP	DUMP1
NEQCLR:
	MOV	A,C		; drugoj cwet srazu posle perepolneniq ?
	ORA	A
	CNZ	WRTDUMP
	MVI	C,1		; bez perepolneniq s~et~ik := 1
	JMP	DUMP1
;;
WRTDUMP:
	MOV	A,C
	ANI	11110000B
	JNZ	WRT2		; s~et~ik>15 ?
	PUSH	H
	LHLD	ADRDUMP
	MOV	A,B
	ANI	11100000B
	ORI	00010000B
	ORA	C
	MOV	M,A
	INX	H
	JMP	EXWRT
WRT2:
	PUSH	H
	LHLD	ADRDUMP
	MOV	A,B
	ANI	11100000B
	ORI	00010000B
	MOV	M,A
	INX	H
	MOV	M,C
	INX	H
EXWRT:
	SHLD	ADRDUMP
	POP	H
	RET
;;;;						- 4 -
;;  pro~itatx komandu
NEWCOMAND:
	PUSH	H
	LHLD	ADRDUMP
	MOV	A,M
	MOV	B,A
	ANI	00010000B
	MOV	A,B
	JZ	TWOCLR
;				; odnocwetnye komandy
	ANI	00001111B	; najti s~et~ik
	JNZ	$+5
	INX	H
	MOV	A,M
	MOV	C,A
;
	MOV	A,B
	ANI	11110000B	; cwet to~ki + priznak dekrement. s~et~ika
	MOV	B,A
	RRC
	RRC
	RRC
	RRC
	ORA	B
	MOV	B,A
	JMP	EXFC
;
TWOCLR:				; dwucwetnye komandy
	RRC
	STC
	RAL
	MOV	B,A		; ustanowitx 2 cweta i 1 priznak dekr.
;
	MVI	C,1
	JC	$+5		; s~et~ik
	INX	H
	MOV	C,M
EXFC:
	INX	H
	SHLD	ADRDUMP
	POP	H
	RET
;;
SETPNT	MACRO	REG		; ustanowitx to~ku w o~erednom bajte
	MOV	A,B
	RLC
	MOV	B,A
	MOV	A,REG
	RAL
	MOV	REG,A
	ENDM
;;
TOTV	MACRO	REG		; wywesti bajt w |kran
	MOV	M,REG
	MOV	A,H
	ADI	20H
	MOV	H,A
	ENDM
;;;;						- 5 -
ONEPURE	MACRO	REG
	ADD	A
	MVI	REG,0
	JNC	$+5
	MVI	REG,0FFH
	ENDM
PURECLR	MACRO			; podgotowitx 3 bajta ~istogo cweta
	MOV	A,B
	ONEPURE	E
	ONEPURE	D
	ONEPURE	H
	ENDM
;;
ONETWO	MACRO	REG
	LOCAL	EQUEL,EXIT
	ADD	A
	JPO	EQUEL
	JM	$+8
	MVI	REG,055H
	JMP	EXIT
	MVI	REG,0AAH
	JMP	EXIT
EQUEL:
	JZ	$+8
	MVI	REG,0FFH
	JMP	EXIT
	MVI	REG,000H
EXIT:	ENDM
ALTCLR	MACRO				; podgotowka bajta ~ered.cweta
	MOV	A,B
	ONETWO	H
	ONETWO	D
	ONETWO	E
	ENDM
;;
;;  ras{ifrowka dampa kartinki
PUTDUMP:
	LHLD	DIMTV
	SHLD	BNDTV
	LHLD	BGNDUMP
	SHLD	ADRDUMP
	LHLD	BGNTV
	SHLD	TV
REDUMP1:
	CALL	NEWCOMAND
REDUMP2:
	MOV	A,B		; prostaq komanda ?
	ANI	00010000B
	MOV	A,C
	JZ	dwacweta
;;
	SUI	8
	JC	BITS
	MOV	C,A
	PURECLR			; wywod ~istogo cweta
	JMP	wywod
dwacweta:
	SUI	4
	JC	BITS
	MOV	C,A
	ALTCLR			; wywod ~eredu`}. cweta
	JMP	wywod
;;;;						- 6 -
BITS:
	MVI	L,8		; s~et~ik bit
CLBITS:
	SETPNT	E
	SETPNT	D
	SETPNT	H
	MOV	A,B
	RLC
	MOV	B,A
	DCR	C
	JC	$+4		; proweritx bit dekrem.
	INR	C		; s~et~ik to~ek -:= 1 ?
	CZ	NEWCOMAND	; podgotowitx nowu` komandu
	DCR	L		; s~et~ik bit -:= 1
	JNZ	CLBITS
;;
wywod:
	MOV	A,H		; wywesti bajty na |kran
	LHLD	TV
	TOTV	A
	TOTV	D
	MOV	M,E
;;
	LHLD	BNDTV		; smenitx bajty izobraveniq
	XCHG
	LHLD	TV
	INR	H
	DCR	D
	JNZ	RETV
;;
	LDA	BGNTV+1		; situaciq "konec stroki"
	MOV	H,A
	LDA	DIMTV+1
	MOV	D,A
	INR	L
	DCR	E
	RZ			; dostignut konec kartinki ?
RETV:
	SHLD	TV
	XCHG
	SHLD	BNDTV
;;
	MOV	A,C		; s~et~ik to~ek is~erpan
	ORA	A
	JNZ	REDUMP2
	JMP	REDUMP1
;;;;						- 7 -
;;  wywod dwuh komand tipa s
;;  whod:
;;    <B,C> - CLR1,CLR2
;;    <D,E> - OUTPUT
;;    <H,L> - INPUT+2 / na tretx` komandu /
OUTCC:
	CALL	OUTC
	MOV	B,C		; CLR2
	MOV	C,M		; CLR3
;;
;;  wywod komandy tipa s
;;  whod:
;;    <B,C> - CLR1,CLR2
;;    <D,E> - OUTPUT
OUTC:
	MOV	A,B
	ANI	11100000B
	INR	A		; priznak dekrem. s~et~ika to~ek
	MOV	B,A
	MOV	A,C
	ANI	11100000B
	RRC
	RRC
	RRC
	RRC
	ORA	B
	STAX	D
	INX	D
	RET
;;
;;  perwaq programma svatiq dampa
;;  whod:
;;    BGNDUMP,LNDUMP
DUMPC:
	LHLD	LNDUMP
	PUSH	H
;;
	LHLD	BGNDUMP
	MOV	D,H		; <D,E> - OUTPUT
	MOV	E,L		; <H,L> - INPUT
DMC1:
	MOV	A,M		; prowerka perwoj komandy
	MOV	B,A
	ANI	00001111B
	JZ	STAND2		; COUNT > 15 ?
	CPI	2
	JNC	STAND1		; COUNT > 1 ?
;;
	INX	H		; prowerka wtoroj komandy
	MOV	A,M
	MOV	C,A
	ANI	00001111B
	JZ	STAND1-1	; COUNT > 15 ? / na DCX H /
	CPI	3
	JNC	STAND2-1	; COUNT > 2 ?  / na DCX H /
	DCR	A
	JNZ	CHECK121
	CALL	OUTC		; komanda tipa C
	INX	H
	JMP	EXDMC
;;;;						- 8 -
CHECK121:
	INX	H		; prowerka tretxej komandy
	MOV	A,M
	ANI	00001111B
	DCR	A
	JNZ	STAND2-2	; COUNT > 2 ?  / na DCX	H ; DCX H /
;;
	CALL	OUTCC		; dwe komandy tipa C
	INX	H
	JMP	EXDMC
;;
	DCX	H
	DCX	H
STAND2:
	MOV	A,M		; wywod stand. 2-h bajt. komand
	STAX	D
	INX	H
	INX	D
	JMP	$+4
;;
	DCX	H
STAND1:
	MOV	A,M			;  wywod stand. odnobajt. komandy
	STAX	D
	INX	H
	INX	D
;;
EXDMC:
	XTHL
	DCX	H
	MOV	A,H
	ORA	L
	XTHL
	JNZ	DMC1
	POP	H
	RET
;;
	ORG	FILE
;;
BGNDUMP:	DW	FDUMP
;;
ADRDUMP:	DS	2
LNDUMP:		DS	2
TV:		DS	2
BNDTV:		DS	2
;;
	ORG	FILE+100H
;;
BGNTV:		DW	0A000H
DIMTV:		DW	02000H
FDUMP:
;;
	END




