
;   ANSI 
;  -------------------------
;  : 29-dec-93

	maclib	Test
	IF	TEST = 1
	Common	/ansi/
	db	'ANSI		v.2.12	21-jan-94$'
	ENDIF

	maclib	STRCT
	STRUCTURE

extrn	FromIn, ToOut
extrn	ReadTimer, ChkTm
extrn	AK8, K8A
extrn	What, FileExchange, File, FCBF, bfname, excode
extrn	InpBuf, ZAString, MakeCName, MakeFCBName, CopyString
extrn	OneMarker

CO	equ	0f809h
Inkey	equ	0f81bh

OK	equ	0
USAbort	equ	4

F1		equ	0		; help
F2		equ	1		; upload
F3		equ	2		; download

CHANAL		equ	0	;  STATIN
INPUTANSI	equ	1
COMANDANSI	equ	2
UPLOAD		equ	3
DOWNLOAD	equ	4

KEYCHANAL	equ	0	;  STATKEY
BGNINPNAME	equ	1
INPNAME		equ	2

	DSeg
public	NameF
NameF:				;     
	db	true
	db	14
	ds	1
TNameF:	ds	14		; V:NNNNNNNN.XXX
	db	0

	CSeg

public	TermANSI
TermANSI:
	call IniANSI
	DO
	  call DrvANSI
	  call OneMarker
	  SWITCH
	    call OneMarker
	    mov a,l
	  CASE OK
	  CASE USAbort		;  -     .
	    BREAK		;   !!!
	  DEFAULT
	    sta excode
	    LEAVE
	  ENDCASE
	  mIF Z
	    in 1
	    ani 60h		;  : + !!!
	  mTHEN
	    LETBC excode,USAbort
	    LEAVE
	  mENDIF
	ENDDO
	ret


;   ANSI 
;  :
;      
;  :
;      

public	DrvANSI
DrvANSI:
	call SetTANSI		;     ANSI 

	DO
	  mIF C
	    call ChkTANSI
	  mTHEN
	    LEAVE
	  mENDIF

	  LETBC EoW,false
	  SWITCH
	    lda STATIN
	  CASE CHANAL
	    mIF Z
	      call FromIn		;    
	    mTHEN
	      LETBC EoW,true
	      BREAK
	    mENDIF
	    mIF Z
	      cpi ESC
	    mTHEN
	      LETBC STATIN,INPUTANSI
	      LETWC AInpANSI,InpANSI
	    mELSE
	      call K8A			; -8 <-- .
	      mov c,a
	      call CO
	    mENDIF
	    BREAK

	  CASE INPUTANSI
	    mIF Z
	      call FromIn		;   ANSI   
	    mTHEN
	      LETBC EoW,true
	      BREAK
	    mENDIF
	    mIF NC
	      lhld AInpANSI
	      mov m,a
	      inx h
	      shld AInpANSI	      
	      sui 'A'			; 41h
	      cpi 'z'-'A'+1
	    mTHEN			;  ANSI 
	      LETBC STATIN,COMANDANSI
	    mENDIF
	    BREAK

	  CASE COMANDANSI
	    call ANSI			; ANSI 
	    LETBC STATIN,CHANAL
	    BREAK

	  CASE UPLOAD
	    LETWC File,4000h
	    LETBC What,-1
	    PRINTLN < UPLOAD STARTED>
	    call FileExchange
	    PRINTLN <UPLOAD ENDED>
	    LETBC STATIN,CHANAL
	    BREAK

	  CASE DOWNLOAD
	    LETWC File,4000h
	    LETBC What,0
	    PRINTLN < DOWNLOAD STARTED>
	    call FileExchange
	    PRINT <FILE: >
	    PRINTDZ bfname
	    PRINTLN < DOWNLOAD ENDED>
	    LETBC STATIN,CHANAL

	  DEFAULT
	  ENDCASE

	  SWITCH
	    lda STATKEY
	  CASE KEYCHANAL
	    SWITCH
	      call Inkey
	    CASE 0ffh
	      BREAK
	    CASE F1
	      PRINTD CRLF
	      PRINTLN	<F2 - upload	F3  - download>
	      BREAK
	    CASE F2
	      LETBC NameF,true
	      LETBC NameF+2,0
	      LETBC STATKEY,INPNAME
	      PRINTLN <ENTER FILE NAME - >
	      BREAK
	    CASE F3
	      LETBC STATIN,DOWNLOAD
	      BREAK
	    DEFAULT
	      call AK8			; . <-- -8
	      call WriteRing
	    ENDCASE
	    BREAK

	  CASE INPNAME
	    call Inkey
	    lxi h,NameF
	    call InpBuf
	    mIF Z
	      lda NameF
	      ora a				; false ?
	    mTHEN
	      lxi h,NameF			;  C STRING
	      call ZAString
	      PRINT <FILE: >
	      PRINTDZ TNameF
	      lxi d,bfname
	      lxi h,TNameF
	      call CopyString
	      LETBC STATKEY,KEYCHANAL
	      LETBC STATIN,UPLOAD
	    mENDIF
	  DEFAULT
	  ENDCASE

	  mIF Z
	    lda CRing
	    ora a
	  mTHEN				;    
	    mIF Z
	      lda EoW
	      cpi true
	    mTHEN			;      
	      LEAVE
	    mENDIF
	  mELSE				;    
	    call ReadRing
	    mIF NZ
	      call ToOut		;    
	    mTHEN
	      call NextReadRing
	    mENDIF
	  mENDIF

	ENDDO
	ret


public	ANSI
ANSI:
	ret


	DSeg

int AInpANSI			;    
char InpANSI,16			;  

char WARing,1			;      (0..15)
char RARing,1			;      (0..15)
char CRing,1			;        (0..15)
char Ring,16			;   ( "")

int TANSI			; -    
				;   ANSI 

char EoW,1
char STATIN,1
char STATKEY,1

CRLF: db 0dh,0ah,'$'

	CSeg

QTANSI	equ	80/20		; 80 ms

public	SetTANSI, ChkTANSI
SetTANSI:			;     ANSI 
	call ReadTimer
	shld TANSI
	ret

ChkTANSI:			;    ANSI 
	lxi d,QTANSI
	lhld TANSI
	jmp ChkTm		; :  C=1 - - 

public	IniANSI
IniANSI:			;  ANSI 
	xra a
	sta CRing
	sta WARing
	sta RARing
	LETBC STATIN,CHANAL
	LETBC STATKEY,KEYCHANAL
	ret

public	ReadRing
ReadRing:			;     
	lda RARing
	mov c,a
	mvi b,0
	lxi h,Ring
	dad b
	mov a,m			; <a> - 
	ret

public NextReadRing
NextReadRing:			;     
	lda RARing
	inr a
	ani 0fh
	sta RARing
	DECB CRing
	ret

public	WriteRing
WriteRing:			;   <a>   
	mov b,a

	lda CRing
	inr a
	cpi 16
	cmc
	rc			; :  C=1 -  
	sta CRing

	lda WARing
	mov c,a
	inr a
	ani 0fh
	sta WARing

	mov a,b
	mvi b,0
	lxi h,Ring
	dad b
	mov m,a
	xra a			; :  C=0 -   
	ret


;    ASCII  INTEGER
;  :
;    <hl> -    (- )
;  :
;    <hl> -  -
;    <a> - INTEGER 

public	INTASC
INTASC:
	push	b
	mov	a,m
	sui	'0'
	mov	b,a
	dcx	h

	mov	a,m
	sui	'0'
	cpi	10
	jnc	ExCPr

	mov	c,a
	add	a
	add	a
	add	c
	add	a
	add	b
	mov	b,a
	dcx	h
ExCPr:
	mov	a,b
	pop	b
	ret


;   INTEGER  ASCII
;  :
;    <hl> -     ASCII 
;    <c> - INTEGER 0..99

public	ASCINT
ASCINT:
	push	b
	mvi	c,0
	mov	a,b

	sui	10
	inr	c
	jnc	$-3
	adi	10
	mov	b,a

	dcr	c
	jz	OneDec

	mov	a,c		;   
	adi	'0'
	mov	m,a
	inx	h
OneDec:
	mov	a,b		;  
	adi	'0'
	mov	m,a
	inx	h

	pop	b
	ret

	end

