	ORG	0100H
BDOSBEGIN			EQU	0C800H
BIOSBEGIN			EQU	0DB00H
CHARGEN				EQU	0F300H
CO				EQU	0F809H
FORMATCDISK			EQU	0DB1BH
INIDRV				EQU	0F800H
L0000				EQU	00H
L0001				EQU	01H
LINEOFBDOS			EQU	2000H
LINEOFBIOS			EQU	1300H
LINEOFCHARGENANDDRIVERS		EQU	0D00H
LINEOFRST6			EQU	08H
PLACEOFBDOS			EQU	0300H
PLACEOFBIOS			EQU	3400H
PLACEOFCHARGEN			EQU	2700H
RST6				EQU	30H

BEGIN:					;0100H
	JMP	MOVEALLBIOS				;0210H

NEXT:					;0103H
	LHLD	BDOSLINECELL				;0201H
	MOV	B,H
	MOV	C,L
	LDA	L0001+1					;2
	SUB	B
;
;  <DE> := 0D800H - 2000H = 0C800H
	MOV	D,A
	MVI	E,0
	PUSH	D
	PUSH	B
	PUSH	D
	LXI	H,PLACEOFBDOS				;0300H

L0115:					;0115H
	MOV	A,B
	ORA	C
	JZ	L0122					;0122H
	DCX	B
	MOV	A,M
	STAX	D
	INX	D
	INX	H
	JMP	L0115					;0115H
;
;  ispolxzowanie karty BITMAP dlq nastrojki tela BDOS

L0122:					;0122H
	POP	D
	POP	B
	PUSH	H
	MOV	H,D
	DCR	H

CORR:					;0127H
	MOV	A,B
	ORA	C
	JZ	ENDOFCORRECTION				;0145H
	DCX	B
	MOV	A,E
	ANI	7
	JNZ	L0138					;0138H
	XTHL
	MOV	A,M
	INX	H
	XTHL
	MOV	L,A

L0138:					;0138H
	MOV	A,L
	RAL
	MOV	L,A
	JNC	L0141					;0141H
	LDAX	D
	ADD	H
	STAX	D

L0141:					;0141H
	INX	D
	JMP	CORR					;0127H
;
;  perehod na na~alo bloka BDOS

ENDOFCORRECTION:			;0145H
	POP	H
	RET
	DS	00BAH

BDOSLINECELL:				;0201H
	DW	LINEOFBDOS				;2000H
	DS	000DH

MOVEALLBIOS:				;0210H
	DI
	LXI	SP,BEGIN				;0100H
	LXI	H,LINEOFCHARGENANDDRIVERS		;0D00H
	LXI	D,PLACEOFCHARGEN			;2700H
	LXI	B,CHARGEN				;0F300H
	CALL	COPYDETOBC				;02A3H
	CALL	INIDRV					;0F800H
;
;  zapolnenie tablic dlq funkcii PLOT(X,Y)
	PUSH	H
	MVI	A,0C0H
	MVI	B,0A0H
	MVI	C,' '	;20H

L022A:					;022AH
	MVI	D,8

L022C:					;022CH
	MOV	M,A
	INX	H
	MOV	M,B
	INX	H
	DCR	D
	JNZ	L022C					;022CH
	INR	A
	INR	B
	DCR	C
	JNZ	L022A					;022AH
	POP	H
; 
	LXI	B,0200H
	DAD	B
	MVI	A,80H
	MVI	C,0

L0243:					;0243H
	MOV	M,A
	INX	H
	MOV	M,A
	INX	H
	RRC
	DCR	C
	JNZ	L0243					;0243H
;
;  iniciirowatx drajwer wywoda na konsolx
	MVI	C,1BH
	CALL	CO					;0F809H
	MVI	C,'E'	;45H
	CALL	CO					;0F809H
; 
	LXI	H,LINEOFBIOS				;1300H
	LXI	D,PLACEOFBIOS				;3400H
	LXI	B,BIOSBEGIN				;0DB00H
	CALL	COPYDETOBC				;02A3H
; 
	LXI	H,BDOSBEGIN+LINEOFBDOS			;0D800H
	SHLD	L0001					;1
	MVI	A,0F7H
	STA	L0000					;0
; 
	LXI	D,PLACEOFRST6				;029BH
	LXI	B,RST6					;30H
	LXI	H,LINEOFRST6				;8
	CALL	COPYDETOBC				;02A3H
; 
	IN	1
	ANI	'@'	;40H
	CZ	FORMATCDISK				;0DB1BH
; 
	MVI	A,81H
	OUT	4
	MVI	A,0FFH
	OUT	5
	OUT	6
	MVI	A,0DH
	OUT	7
	MVI	A,0EFH
	OUT	5
	MVI	A,0FFH
	OUT	5
	OUT	7
	JMP	NEXT					;0103H

PLACEOFRST6:				;029BH
	MVI	A,'#'	;23H
	OUT	10H
	LHLD	L0001					;1
	PCHL

COPYDETOBC:				;02A3H
	LDAX	D
	STAX	B
	INX	D
	INX	B
	DCX	H
	MOV	A,L
	ORA	H
	JNZ	COPYDETOBC				;02A3H
	RET
	END
L

COPYDETOBC:				;02A3H
	LDAX	D
	STAX	B
	INX	D
	INX	B
	DCX	H
	MOV	A,L
	ORA	H
	JNZ	COPYDETOBC				;02A3H