;;						- 1 -
;;**************************************
;;	   mikroreassembler Z80
;;  --------   programma   -----------
;;  wers.2.5.95		data:12-MAY-90
;;**************************************
;;
CPU	EQU	1500H
;;
	ORG	100H
;;
		DS	3
		JMP	CPU		; GOTO ON CPU-PROGRAM
COMPLEX:	DS	3
CBYTE:		DS	3
PEC:		DS	3
BPRIWORDLABEL:	DS	3
;;
PC:		DS	1		; GLOBAL DATA FIELD
PCHIGH:		DS	1		;   FOR RESRC & CPU
OFFSET:		DS	1
OFFSHIGH:	DS	1
MODECOM:	DS	1
PCPLUSOFFSET:	DS	2
;;;;						- 2 -
	ORG	CPU
;;
	JMP	Z80REASS
;;
WORD:	DS	2
;;
LINE:	DS	1			; dlina komandy
;;
PRIWORDLABEL:
	PUSH	B
	CALL	BPRIWORDLABEL
	POP	B
	RET
;;
;;  ustanowitx parametry komandy i 
;;    najti podhodq}ij |lement tablicy
;;  whod:
;;    <A> - dlina komandy (bez 8- ili 16-bitn. dannyh)
;;    <H,L> - adres tek. bajta komandy dlq obrabotki
;;    <D,E> - adres tablicy komand Z80
;;  wyhod:
;;    <flag C>=1/0 - |lement najden / ne najden
;;      <H,L> - adres dlq programmy obrabotki mnemoniki
FINDELM:
	SHLD	PCPLUSOFFSET
	STA	LINE
	MOV	B,M
	XCHG
	JMP	SEARCH
;;
NEXTELM:
	MOV	A,M		; smenitx |lement
	ANI	3FH
	MOV	E,A
	INX	H
	MVI	D,0
	DAD	D
SEARCH:
	MOV	A,M
	ORA	A
	RZ			; konec tablicy ?
;;
	MOV	A,B
	ANA	M		; maska
	INX	H
	CMP	M		; obrazec
	INX	H
	JNZ	NEXTELM		; |lement najden ?
	MOV	A,M		; dlina |lementa
	ANI	11000000B
	STC
	RZ			; dop. prowerka ne trebuetsq ?
	JP	DCH210
	MOV	A,B
	ANI	00111000B
	CPI	00110000B
	RZ			; zapr. kod ?
	STC
	RET
DCH210:
	MOV	A,B
	ANI	00000111B
	CPI	00000110B
	RZ			; zapr.kod ?
	STC
	RET
;;;;						- 3 -
;;  wywod teksta do 0
;;  whod:
;;    <B> - MAX ~islo liter
;;    <H,L> - adres na~ala teksta
;;
NEXTCH:
	CALL	COMPLEX
	INX	H
	DCR	B
	RZ
PRITXT:
	MOV	A,M
	ORA	A
	JNZ	NEXTCH
	RET
;;
;;  wywod 8-BIT argumenta
;;  whod:
;;    <A> - argument
PRIHEX:
	PUSH	PSW
	CPI	' '
	JC	LT1F
	CPI	5BH
	JNC	LT1F
	CALL	PRICHAR
	MVI	A,''''
	CALL	COMPLEX
	CALL	PRITAB
	CALL	PRIPM
LT1F:
	MVI	A,'0'
	CALL	COMPLEX
	POP	PSW
	CALL	CBYTE
	MVI	A,'H'
	JMP	COMPLEX
PRITAB:
	MVI	A,'	'
	JMP	COMPLEX
PRIPM:
	MVI	A,';'
	JMP	COMPLEX
PRICHAR:
	PUSH	PSW
	MVI	A,''''
	CALL	COMPLEX
	POP	PSW
	CPI	''''
	JNZ	COMPLEX
	PUSH	PSW
	CALL	COMPLEX
	POP	PSW
	JMP	COMPLEX
;;;;						- 4 -
;;  obrabotka |lementa tablicy
;;  whod:
;;    <B> - prower. bajt
;;    <H,L> - adres dliny mnemoniki
ELEMENT:
	MOV	A,M
	ANI	3FH
	MOV	C,A		; dlina komandy
	INX	H
CELM:
	MOV	A,M
	ORA	A
	INX	H
	JM	SPECIAL		; spec.litery
	CALL	COMPLEX
CELMN:
	DCR	C
	JNZ	CELM
	RET
;;
;;  obrabotka specliter
;;  whod:
;;    <a> - speclitera
;;    <B> - prower.bajt
SPECIAL:
	PUSH	H
	CPI	'R'+80H
	JZ	SLR
	CPI	'G'+80H
	JZ	SLG
	CPI	'P'+80H
	JZ	SLP
	CPI	'Q'+80H
	JZ	SLQ
	CPI	'C'+80H
	JZ	SLC
	CPI	'M'+80H
	JZ	SLM
	CPI	'I'+80H
	JZ	SLI
	CPI	'F'+80H
	JZ	SLF
	CPI	'B'+80H
	JZ	SLB
	CPI	'D'+80H
	JZ	SLD
	CPI	'A'+80H
	JZ	SLA
	CPI	'Z'+80H
	JZ	SLZ
	CPI	'S'+80H
	JZ	SLS
	CPI	'T'+80H
	JZ	SLT
	CPI	'E'+80H
	JZ	SLE
	CPI	'J'+80H
	JZ	SLJ
	CPI	'X'+80H
	JZ	SLX
	CPI	'O'+80H
	JZ	SLO
EXSP:
	POP	H
	JMP	CELMN
;;;;						- 5 -
SLG:
	MOV	A,B
	RRC
	RRC
	RRC
	JMP	SLR+1
;;
SLF:
	MOV	A,B
	RRC
	RRC
	RRC
	ANI	0000111B
	JMP	RINPUT
;;
SLR:
	MOV	A,B
;;
	ANI	00000111B
	CPI	00000110B
;;
	JZ	EXHL
RINPUT:
	LXI	H,REGISTR
	CALL	HLADDA
	MOV	A,M
	CALL	COMPLEX
	JMP	EXSP
EXHL:
	CALL	PEC
	DB	'(HL)',0
	JMP	EXSP
;;
REGISTR:
	DB	'BCDEHLFA'
;;;;						- 6 -
SLM:
	MOV	A,B
	ANI	00111000B
	RRC
	MOV	H,A
	RRC
	ADD	H
	LXI	H,MCOM
	PUSH	B
	MVI	B,6
	JMP	SLMB
;;
SLB:
	LXI	H,BCOM
	MOV	A,B
	ANI	00111000B
	RRC
	PUSH	B
	MVI	B,4
SLMB:
	CALL	HLADDA
	CALL	PRITXT
	POP	B
	JMP	EXSP
MCOM:
	DB	'ADD	A,'
	DB	'ADC	A,'
	DB	'SUB	',0,0
	DB	'SBC	A,'
	DB	'AND	',0,0
	DB	'XOR	',0,0
	DB	'OR	',0,0,0
	DB	'CP	',0,0,0
BCOM:
	DB	'RLC	'
	DB	'RRC	'
	DB	'RL	',0
	DB	'RR	',0
	DB	'SLA	'
	DB	'SRA	'
	DB	'   	'
	DB	'SRL	'
;;;;						- 7 -
SLI:
	LXI	H,IREG
	JMP	PRIRP
;;
SLP:
	LXI	H,PREG
	JMP	SLS+3
;;
SLQ:
	LXI	H,QREG
	JMP	SLS+3
;;
SLS:
	LXI	H,SREG
	MOV	A,B
	ANI	00110000B
	RRC
	RRC
	RRC
	CALL	HLADDA
PRIRP:
	PUSH	B
	MVI	B,2
	CALL	PRITXT
	POP	B
	JMP	EXSP
;;
PREG:
	DB	'BC'
	DB	'DE'
	DB	'HL'
	DB	'SP'
QREG:
	DB	'BC'
	DB	'DE'
	DB	'HL'
	DB	'AF'
SREG:
	DB	'BC'
	DB	'DE'
IREG:	DB	'IX'
	DB	'SP'
;;;;						- 8 -
SLX:
	LHLD	PCPLUSOFFSET
	DCX	H
	JMP	SLXO
;;
SLO:
	LHLD	PCPLUSOFFSET
	INX	H
SLXO:
	SHLD	PCPLUSOFFSET
	MOV	A,M
	LXI	H,LINE
	INR	M
	PUSH	PSW
	MVI	A,'0'
	CALL	COMPLEX
	POP	PSW
	CALL	CBYTE
	MVI	A,'H'
	CALL	COMPLEX
	JMP	EXSP
;;
SLD:
	LXI	H,LINE
	INR	M
	LHLD	PCPLUSOFFSET
	INX	H
	SHLD	PCPLUSOFFSET
	MOV	A,M
	CALL	PRIHEX
	JMP	EXSP
;;
SLE:
	LXI	H,LINE
	INR	M
	LHLD	PCPLUSOFFSET
	INX	H
	MOV	A,M
	RLC
	RRC
	MOV	E,A
	SBB	A
	MOV	D,A
	LHLD	PC
	DAD	D
	INX	H
	INX	H
	SHLD	WORD
	XCHG
	CALL	PRIWORDLABEL
	JMP	EXSP
;;
SLA:
	LXI	H,LINE
	INR	M
	INR	M
	LHLD	PCPLUSOFFSET
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	WORD
	XCHG
	CALL	PRIWORDLABEL
	JMP	EXSP
;;;;						- 9 -
SLZ:
	MVI	A,09H
	CALL	COMPLEX
	MVI	A,';'
	CALL	COMPLEX
	LHLD	WORD
	CALL	CADDR
	MVI	A,'H'
	CALL	COMPLEX
	JMP	EXSP
;;
SLJ:
	MOV	A,B
	ANI	00111000B
	RRC
	RRC
	RRC
	CALL	LOWA
	CALL	COMPLEX
	JMP	EXSP
;;
SLC:
	LXI	H,COND
	MOV	A,B
	ANI	00111000B
	RRC
	RRC
	CALL	HLADDA
	JMP	PRIRP
COND:
	DB	'NZ'
	DB	'Z',0
	DB	'NC'
	DB	'C',0
	DB	'PO'
	DB	'PE'
	DB	'P',0
	DB	'M',0
;;
SLT:
	MOV	A,B
	ANI	00111000B
	CALL	CBYTE
	MVI	A,'H'
	CALL	COMPLEX
	JMP	EXSP
;;;;						- 10 -
;;  mikroreassembler dlq Z80
;;  whod:
;;    <D,E> - adres na~ala komandy
;;    <H,L> - sme}enie
;;  wyhod:
;;    PC - adres na~ala sled. komandy
Z80REASS:
	MVI	A,80H
	STA	MODECOM		; NO COMMENTS
	DAD	D
;;
	MOV	B,M		; kod 1-go bajta komandy
;;
	MOV	A,B
	CPI	0CBH
	JZ	FINDB
	CPI	0EDH
	JZ	FINDE
	MVI	C,'X'
	CPI	0DDH
	JZ	FINDCD
	MVI	C,'Y'
	CPI	0FDH
	JZ	FINDCD
;;
FINDA:
	MVI	A,1
	LXI	D,ATAB
	JMP	FINDTAB
FINDB:
	MVI	A,2
	INX	H
	LXI	D,BTAB
	JMP	FINDTAB
FINDCD:
	MOV	A,C		; ustanowitx
	STA	IREG+1		;   revim IX ili IY
	INX	H
	MOV	B,M		; 2-j bajt komandy
	MOV	A,B
	CPI	0CBH
	JZ	FINDD
FINDC:
	MVI	A,2
	LXI	D,CTAB
	JMP	FINDTAB
FINDD:
	MVI	A,3		; dlina 3 bajta + 8-bitn.dannoe
	INX	H
	INX	H
	LXI	D,DTAB
	JMP	FINDTAB
FINDE:
	MVI	A,2
	INX	H
	LXI	D,ETAB
;;;;						- 11 -
FINDTAB:
	CALL	FINDELM		; poisk w ukazannoj tablice
	JNC	NOCOM
;;
	CALL	ELEMENT		; komanda Z80
	XRA	A
	STA	MODECOM
	LDA	LINE
	MVI	D,0
	MOV	E,A
	LHLD	PC
	DAD	D
	SHLD	PC
	JMP	CRLF
;;
NOCOM:
	XRA	A
	STA	MODECOM
	CALL	PEC
	DB	'DB	',0
	LHLD	PC
	XCHG
	LHLD	OFFSET
	DAD	D
	MOV	A,M
	CALL	PRIHEX
	XCHG
	INX	H
	SHLD	PC
	JMP	CRLF
;;;;						- 12 -
;;  tablica a.
ATAB:
	DB	0FFH,0EBH,  8,'EX	DE,HL'
	DB	0FFH,008H,  9,'EX	AF,AF'''
	DB	0FFH,0D9H,  3,'EXX'
	DB	0FFH,0E3H, 10,'EX	(SP),HL'
	DB	0C0H,080H,  2,'M'+80H,'R'+80H
	DB	0C7H,0C6H,  2,'M'+80H,'D'+80H
	DB	0C7H,004H,  5,'INC	','G'+80H
	DB	0C7H,005H,  5,'DEC	','G'+80H
	DB	0FFH,076H,  4,'HALT'
	DB	0C0H,040H,  6,'LD	','G'+80H,',','R'+80H
	DB	0C7H,006H,  6,'LD	','G'+80H,',','D'+80H
	DB	0FFH,00AH,  9,'LD	A,(BC)'
	DB	0FFH,01AH,  9,'LD	A,(DE)'
	DB	0FFH,03AH,  9,'LD	A,(','A'+80H,')','Z'+80H
	DB	0FFH,002H,  9,'LD	(BC),A'
	DB	0FFH,012H,  9,'LD	(DE),A'
	DB	0FFH,032H,  9,'LD	(','A'+80H,'),A','Z'+80H
;;
	DB	0CFH,001H,  7,'LD	','P'+80H,',','A'+80H,'Z'+80H
	DB	0FFH,02AH, 10,'LD	HL,(','A'+80H,')','Z'+80H
	DB	0FFH,022H, 10,'LD	(','A'+80H,'),HL','Z'+80H
	DB	0FFH,0F9H,  8,'LD	SP,HL'
	DB	0CFH,0C5H,  6,'PUSH	','Q'+80H
	DB	0CFH,0C1H,  5,'POP	','Q'+80H
;;
	DB	0FFH,027H,  3,'DAA'
	DB	0FFH,02FH,  3,'CPL'
	DB	0FFH,037H,  3,'SCF'
	DB	0FFH,03FH,  3,'CCF'
	DB	0FFH,000H,  3,'NOP'
	DB	0FFH,0F3H,  2,'DI'
	DB	0FFH,0FBH,  2,'EI'
;;
	DB	0CFH,009H,  8,'ADD	HL,','P'+80H
	DB	0CFH,003H,  5,'INC	','P'+80H
	DB	0CFH,00BH,  5,'DEC	','P'+80H
;;
	DB	0FFH,007H,  4,'RLCA'
	DB	0FFH,017H,  3,'RLA'
	DB	0FFH,00FH,  4,'RRCA'
	DB	0FFH,01FH,  3,'RRA'
;;
	DB	0FFH,0CDH,  8,'CALL	','A'+80H,'	','Z'+80H
	DB	0C7H,0C4H,  9,'CALL	','C'+80H,',','A'+80H,'Z'+80H
	DB	0FFH,0C9H,  3,'RET'
	DB	0C7H,0C0H,  5,'RET	','C'+80H
	DB	0C7H,0C7H,  5,'RST	','T'+80H
;;
	DB	0FFH,0C3H,  6,'JP	','A'+80H,'	','Z'+80H
	DB	0C7H,0C2H,  7,'JP	','C'+80H,',','A'+80H,'Z'+80H
	DB	0FFH,018H,  6,'JR	','E'+80H,'	','Z'+80H
	DB	0FFH,038H,  7,'JR	C,','E'+80H,'Z'+80H
	DB	0FFH,030H,  8,'JR	NC,','E'+80H,'Z'+80H
	DB	0FFH,028H,  7,'JR	Z,','E'+80H,'Z'+80H
	DB	0FFH,020H,  8,'JR	NZ,','E'+80H,'Z'+80H
	DB	0FFH,010H,  8,'DJNZ	','E'+80H,'	','Z'+80H
	DB	0FFH,0E9H,  7,'JP	(HL)'
;;
	DB	0FFH,0DBH,  8,'IN	A,(','D'+80H,')'
	DB	0FFH,0D3H,  9,'OUT	(','D'+80H,'),A'
	DB	0
;;;;						- 13 -
;;  tabl. B
BTAB:
	DB	0C0H,000H,82H,'B'+80H,'R'+80H
	DB	0C0H,040H,  7,'BIT	','J'+80H,',','R'+80H
	DB	0C0H,080H,  7,'RES	','J'+80H,',','R'+80H
	DB	0C0H,0C0H,  7,'SET	','J'+80H,',','R'+80H
	DB	0
;;
;;  tabl. C
CTAB:
	DB	0FFH,0E3H,  9,'EX	(SP),','I'+80H
	DB	0C7H,086H,  6,'M'+80H,'(','I'+80H,'+','O'+80H,')'
	DB	0FFH,034H,  9,'INC	(','I'+80H,'+','O'+80H,')'
	DB	0FFH,035H,  9,'DEC	(','I'+80H,'+','O'+80H,')'
;;
	DB	0C7H,046H,8AH,'LD	','G'+80H,',(','I'+80H,'+','O'+80H,')'
	DB	0F8H,070H,4AH,'LD	(','I'+80H,'+','O'+80H,'),','R'+80H
	DB	0FFH,036H, 10,'LD	(','I'+80H,'+','O'+80H,'),','D'+80H
;;
	DB	0FFH,021H,  7,'LD	','I'+80H,',','A'+80H,'Z'+80H
	DB	0FFH,02AH,  9,'LD	','I'+80H,',(','A'+80H,')','Z'+80H
	DB	0FFH,022H,  9,'LD	(','A'+80H,'),','I'+80H,'Z'+80H
	DB	0FFH,0F9H,  7,'LD	SP,','I'+80H
	DB	0FFH,0E5H,  6,'PUSH	','I'+80H
	DB	0FFH,0E1H,  5,'POP	','I'+80H
;;
	DB	0CFH,009H,  7,'ADD	','I'+80H,',','S'+80H
	DB	0FFH,023H,  5,'INC	','I'+80H
	DB	0FFH,02BH,  5,'DEC	','I'+80H
;;
	DB	0FFH,0E9H,  6,'JP	(','I'+80H,')'
	DB	0
;;
;;  tabl. D
DTAB:
	DB	0C7H,006H,86H,'B'+80H,'(','I'+80H,'+','X'+80H,')'
	DB	0C7H,046H, 11,'BIT	','J'+80H,',(','I'+80H,'+','X'+80H,')'
	DB	0C7H,086H, 11,'RES	','J'+80H,',(','I'+80H,'+','X'+80H,')'
	DB	0C7H,0C6H, 11,'SET	','J'+80H,',(','I'+80H,'+','X'+80H,')'
	DB	0
;;;;						- 14 -
;;  tabl. E
ETAB:
	DB	0FFH,0A0H,  3,'LDI'
	DB	0FFH,0B0H,  4,'LDIR'
	DB	0FFH,0A8H,  3,'LDD'
	DB	0FFH,0B8H,  4,'LDDR'
	DB	0FFH,0A1H,  3,'CPI'
	DB	0FFH,0B1H,  4,'CPIR'
	DB	0FFH,0A9H,  3,'CPD'
	DB	0FFH,0B9H,  4,'CPDR'
;;
	DB	0FFH,057H,  6,'LD	A,I'
	DB	0FFH,05FH,  6,'LD	A,R'
	DB	0FFH,047H,  6,'LD	I,A'
	DB	0FFH,04FH,  6,'LD	R,A'
;;
	DB	0CFH,04BH,  9,'LD	','P'+80H,',(','A'+80H,')','Z'+80H
	DB	0CFH,043H,  9,'LD	(','A'+80H,'),','P'+80H,'Z'+80H
;;
	DB	0FFH,044H,  3,'NEG'
	DB	0FFH,046H,  4,'IM	0'
	DB	0FFH,056H,  4,'IM	1'
	DB	0FFH,05EH,  4,'IM	2'
;;
	DB	0CFH,04AH,  8,'ADC	HL,','P'+80H
	DB	0CFH,042H,  8,'SBC	HL,','P'+80H
;;
	DB	0FFH,06FH,  3,'RLD'
	DB	0FFH,067H,  3,'RRD'
;;
	DB	0FFH,04DH,  4,'RETI'
	DB	0FFH,045H,  4,'RETN'
;;
	DB	0C7H,040H,  8,'IN	','F'+80H,',(C)'
;;
	DB	0FFH,0A2H,  3,'INI'
	DB	0FFH,0B2H,  4,'INIR'
	DB	0FFH,0AAH,  3,'IND'
	DB	0FFH,0BAH,  4,'INDR'
;;
	DB	0C7H,041H,89H,'OUT	(C),','F'+80H
;;
	DB	0FFH,0A3H,  4,'OUTI'
	DB	0FFH,0B3H,  4,'OTIR'
	DB	0FFH,0ABH,  4,'OUTD'
	DB	0FFH,0BBH,  4,'OTDR'
;;
	DB	0
;;;;						- 15 -
;;  modelirowanie sredy RESOURCE
CRLF:
	MVI	A,0DH
	CALL	COMPLEX
	MVI	A,0AH
	JMP	COMPLEX
;;
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
	JMP	CBYTE
SPACE:
	MVI	A,' '
	JMP	COMPLEX
;;
LOWA:
	ANI	0FH
	CPI	10
	JC	$+5
	ADI	7
	ADI	'0'
	RET
;;
HLADDA:
	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET
;;
	END
