
;  Basic Animation Sprite Prepare procedure
;  ----------------------------------------
;      '  Bas25
;  ----------------------------------------
;  	     date:09-jan-93

	maclib	BAS

extrn	SetGB, SetShow, SetCoord, SetSc1, SetSc2, SetOCB
extrn	SetAct, SetPass, SetMove, ReadX, ReadY
extrn	SetF, SeeF, ShowP
extrn	HLaddA, HLadd2A

	jmp	SetAddrObject	;  0
	jmp	Scena		;  3
	jmp	SetGB		;  6
	jmp	SetOCB		;  9
	jmp	Object		; 12
	jmp	SetShow		; 15
	jmp	SetCoord	; 18
	jmp	ReadX		; 21
	jmp	ReadY		; 24
	jmp	SetSc1		; 27
	jmp	SetSc2		; 30
	jmp	SetAct		; 33
	jmp	SetPass		; 36
	jmp	SetMove		; 39
	jmp	SetF		; 42
	jmp	SeeF		; 45
	jmp	ShowP		; 48


;   
;  ----------------------------

public	Copy
Copy:
	mov	a,m
	stax	d
	inx	h
	inx	d
	dcr	c
	jnz	Copy
	ret

;     
;  :
;    <hl> -   
;  :
;    <hl> -    
;     C
;	1 -   
;       0 -    <de> -     
;	(   -  0004h   )
;  :
;       (./.)   '$'   
;        VARMODE (0-./1-.)

public	SearArray
SearArray:
	dcx	h		;   
	rst	2
	mov	b,m
	call	CHECKAZRANGE
	jc	ERROR2

	xra	a		;   
	mov	c,a
	sta	VARMODE
	rst	2
	jc	Digit		;   -  ?
	call	CHECKAZRANGE
	jc	EndOfName

Digit:
	mov	c,a

SkipNameChar:
	rst	2		;  .  
	jc	SkipNameChar
	call	CHECKAZRANGE
	jnc	SkipNameChar

EndOfName:
	sui	'$'
	jnz	AfterName	;   -  ?

	inr	a		;  !!!
	sta	VARMODE
	rrc
	add	c
	mov	c,a
	rst	2

AfterName:
	push	h		;   BASIC   
	lhld	ADRESBEGINARRAY

clSAr	equ	$+1
	mvi	a,19h		; 19h - dad d
	xchg
	lhld	ADRESFREEFIELD
	xchg
	HLDE
;	jz	ArrayIsNotFinded	;    ?
	jz	BadParam

	mov	a,m
	cmp	c		;  1-  
	inx	h
	jnz	BadName

	mov	a,m
	cmp	b		;  2-  

BadName:
	inx	h
	mov	e,m
	inx	h
	mov	d,m
	inx	h
	jnz	clSAr		;   ?

	xchg			;  !!!
	pop	h
	ora	a
	ret

;ArrayIsNotFinded:
;	pop	h		;   !!!
;	stc
;	ret


	DSeg

public	NameOfArray		;   ,  OCB,  BASIC
NameOfArray:			;   
	ds	2

	CSeg

;     '

Public	StoreD, Store
StoreD:
	ldax	d
	inx	d
Store:
	push	psw
	push	h
	lhld	AddrStore
	mov	m,a
	inx	h
	shld	AddrStore

	push	d		;    
	xchg			;   '
	lhld	EndObject
	HLDE
	jz	ErrFullMemory
	pop	d
	pop	h
	pop	psw
	ret

EoS:	push	h		;    
	lhld	AddrStore
	mvi	m,0
	pop	h
	ret


	DSeg

public	AddrStore
AddrStore:			; .     
	ds	2		;    '

public	BgnObject, EndObject
BgnObject:			;    '
	ds	2
EndObject:			;  
	ds	2

	CSeg

;        '
;  :
;    USR(BASS),BgnObject,EndObject
;  :
;    BgnObject -    '
;    EndObject -   (   . )

SetAddrObject:
	pop	h
	pop	h
	pop	h
	rst	1
	db	','
	call	COMPUTEINT
	push	h
	xchg

;      !!!

	shld	BgnObject
	shld	AddrStore		;    
	call	EoS			;  c

	pop	h
	rst	1
	db	','
	call	COMPUTEINT
	push	h
	xchg

;      !!!

	shld	EndObject
	jmp	Return

;   
;  :
;    USR(BASS+3),QFz,SB$
;  :
;    Qfz -     (1..16)
;    SB$ -    12     QFz ,
;	      
;  :
;    SB$    , ..  QFz    
;             

Scena:
	pop	h
	pop	h
	pop	h
	lxi	d,16
	call	Param		; QFz - (1..16)
	sta	Qfz
	mov	c,a
	add	a
	add	c
	add	a
	add	a
	inr	a		;    
	call	Store
	mov	a,c		;  
	call	Store

	rst	1
	db	','
	call	SearArray
	push	h		;   . 

;   
;  :
;    <de> -   

	lxi	h,BadParam
	push	h
	rc			;   ?
	lda	VARMODE
	ora	a
	rz			;  String  ?

	ldax	d
	inx	d
	dcr	a
	rnz			;    1 ?

	ldax	d		;   
	inx	d
	mov	c,a
	ldax	d
	inx	d
	ora	a
	jnz	GoodScn		;     ?

QFz	equ	$+1		; .  !!!
	mvi	a,0		; 1..16
	dcr	a
	cmp	c
	rnc			;   ?

GoodScn:
	lda	QFz		;    
	mov	c,a
clElmn:
	ldax	d
	inx	d
	cpi	12
	rnz			;    12  ?
	ldax	d
	inx	d
	ora	a
	rnz
	call	OnePhase
	inx	d
	inx	d
	dcr	c
	jnz	clElmn

	pop	h		;    BadParam

	call	EoS		;     !!!
	jmp	Return

;     
;  :
;    <de> -     12    

OnePhase:
	push	d
	push	b
	xchg
	mov	a,m		; <de> :=   
	inx	h
	mov	h,m
	mov	l,a
	xchg

	ldax	d		; DX
	inx	d
	mov	c,a
	call	StoreD		; DY
	mov	a,c
	call	Store

	mvi	b,5		;   4  
clPict:
	ldax	d		; PX
	inx	d
	ani	00011111b
	mov	c,a

	ldax	d		; PY
	inx	d
	ani	00011111b
	add	a
	add	a
	add	a
	call	Store		; (PY and 00011111b)*8

	mov	a,c
	call	Store		; (PX and 00011111b)*100h

	dcr	b
	jnz	clPict

	pop	b
	pop	d
	ret

;   '
;  :
;    USR(BASS+12),Lx,Ly
;  :
;    Lx,Ly 	-  ' (1..4)
;  :
;    DObj	-   DIM DObj(2),     OCB
;		    '.   
;		  USR(BASS+12),Dobj
;  :
;      '     -  !!!

Object:
	pop	h
	pop	h	
	pop	h
	lxi	d,4
	call	Param			; Lx
	mov	c,a
	push	b
	call	Param			; Ly
	pop	b
	mov	b,a
	dcr	a
	sta	Ly
	mov	a,c			; Lx
	dcr	a
	sta	Lx

	xra	a
	add	b			; <a>:=Lx*Ly
	dcr	c			;     !!!
	jnz	$-2
	sta	QBufers			; Lx*LY -   

	call	FindOCB
	push	h

	lxi	h,ExampleOCB		;  OCB  DObj
	mvi	c,10
	call	Copy
	jmp	Return

	DSeg

public	ExampleOCB, LX, LY, QBufers
ExampleOCB:
	db	0		; y
	db	0		; x
	db	0		; 
Ly:	db	0
Lx:	db	0
QBufers:
	db	0		;    
	db	-1		; BF (  )
	db	-1		; BB (  )
	dw	0		;   

	CSeg

;--------------------------------------------------------------
;    OCB
;  :
;    <hl> -      DIM Array(2),  
;	    OCB,  BASIC 
;  :
;    <de> -  OCB
;    <hl> -   BASIC    

public	SearOCB
SearOCB:
	push	b
	rst	1
	db	','
	shld	NameOfArray	;   DObj
	call	VarSearch	;   DObj

	lda	VARMODE
	ora	a
	jnz	BadParam	;    

	pop	b
	ret

;     DObj

public	FindOCB
FindOCB:
	push	h
	push	b
	lhld	NameOfArray
	call	VarSearch
	pop	b
	pop	h
	ret


;   
;  :
;    <hl> -   BASIC 
;    <de> -   1..<de>
;  :
;    <a> :=  (1..<de>)

public	Param
Param:
	rst	1
	db	','
	push	d
	call	COMPUTEINT
	dcx	d
	xthl
	xchg
	HLDE
	jnc	BadParam
	mov	a,l
	inr	a
	pop	h
	ret

public	Return, BadParam, BadMode, ErrReturn
ErrReturn:
	jc	BadMode
Return:					;   USR 
	lxi	h,09a1h
	push	h
	jmp	24abh

BadParam:
	mvi	e,8			;  
	jmp	PRINTERRMSG

ErrFullMemory:
	mvi	e,0ch			;  
	jmp	PRINTERRMSG

BadMode:
	mvi	e,18h			;  
	jmp	PRINTERRMSG

	end




