;      
;  -------------------------------------------
;  .1.18			:20-dec-93

	maclib	STRCT
	STRUCTURE TEST

STOP	macro	NN
	mIF Z
	lda Count
	dcr a
	sta Count
	mTHEN
	public LStop
   LStop:  mvi a,NN
	  sta Count
	mENDIF
	DSeg
	public Count
	Count: db NN
	CSeg
	ENDM

Base		equ	6800h
Initial		equ	Base
Markers		equ	Base+08h
ToBigBufer	equ	Base+10h
FromBigBufer	equ	Base+18h
ExitAll		equ	Base+20h
ToOut		equ	Base+28h
FromIn		equ	Base+30h
Acceptor	equ	Base+38h
Sender		equ	Base+40h
Find2100	equ	Base+48h
PrintVers	equ	Base+50h

TRUE		equ	Low -1
FALSE		equ	0

SENDDWNLD	equ	1
WAITBELL	equ	2
SENDFDSCR	equ	3
WAITENQ		equ	4
WAITENUMB	equ	5
SENDBLOCK	equ	6
SENDEOT		equ	7
SENDSOH		equ	8
SENDDATA	equ	9
WAITACK		equ	10

SENDBELL	equ	51
WAITPKT		equ	52
RCVFDSCR	equ	53
SENDENQ		equ	54
RCVPKT		equ	55
RCVLENBLK	equ	56
RCVDATA		equ	57
SENDACK		equ	58

ABEND		equ	91
COMPLETE	equ	92
FMEXIT		equ	93

SOH	equ	1
EOT	equ	4
ENQ	equ	5
ACK	equ	6
NAK	equ	15h
SYN	equ	16h
BELL	equ	7

OK	equ	0
TRABRT	equ	1

BELLREPEAT	equ	6
PKTREPEAT	equ	10

PRINT	macro	Text
	local	AText
	lxi	d,AText
	mvi	c,9
	call	5
	DSeg
	AText:	db	Text,'$'
	CSeg
	endm
SEND	macro	What,NN
	lxi	h,What
	lxi	d,NN
	call	OutMBlk
	endm
RCV	macro	What,NN
	lxi	h,What
	lxi	d,NN
	call	InpMBlk
	endm

	DSeg

int bgnDATA		; . 
int LENBLK
int AdrDATA

AENQ: db ENQ		;   
int ENUMB
MAXLENBLK: dw 200h

char PKT,1
char excode,1
char path,1
char FMarker,1
char PKTCNT,1
char BELLCNT,1
char RCVF,1		;   

ADDLINK: db BELL,'ADD_link?',BELL
AEOT: db EOT
BellV: db BELL,'V'
AACK: db ACK
ASOH: db SOH			;   
int LENBYTES

public	FD, flen, flen0, dttm, dttm0, bfname, blklen
LineFD	equ	25
FD:
typPKT: db SYN
        db 'V'
flen:   dw 0
flen0:  dw 0			; . 
dttm:   ds 2
dttm0:  ds 2
bfname: db 'aaaaaaaa.aaa',0	; . 
blklen: dw 512

EoFD:

	CSeg

	lxi	sp,100h
	call	PrintVers
	lxi	h,2000h
	shld	bgnDATA
	call	Initial

	mIF NZ
	lda What
	ora a
	mTHEN
	  mIF Z
	    call Sender
	    mov a,h
	    ora l
	  mTHEN
	    LETBC path,SENDDWNLD
	    call KA
	  mENDIF
	mELSE
	  mIF Z
	    call Acceptor
	    mov a,h
	    ora l
	  mTHEN
	    LETBC BELLCNT,BELLREPEAT
	    LETBC path,SENDBELL
	    call KA
	  mENDIF
	mENDIF

	call ExitAll
	jmp 0

;    

public KA
KA:
	call IniMBlk
	DO
	  LETBC FMarker,TRUE

	  SWITCH
	  lda path
	  CASE SENDDWNLD
	    SEND ADDLINK,11
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,WAITBELL
	    mENDIF
	    BREAK

	  CASE WAITBELL
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,SENDFDSCR
	      LETBC FMarker,FALSE
	    mENDIF
	    BREAK

	  CASE SENDFDSCR
	    SEND FD,LineFD
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,WAITENQ
	    mENDIF
	    BREAK

	  CASE WAITENQ
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      SWITCH
	      lda PKT
	      CASE ENQ
	        LETBC path,WAITENUMB
	        BREAK
	      CASE ACK
	        LETBC path,COMPLETE
	        BREAK
	      CASE NAK
	        LETBC excode,TRABRT
	        LETBC path,ABEND
	        BREAK
	      CASE BELL
	      CASE 'P'
	      CASE 'V'
	        LETBC FMarker,TRUE
	        BREAK
	      DEFAULT
	        LETBC excode,TRABRT
	        LETBC path,ABEND
	      ENDCASE
	    mENDIF
	    BREAK

	  CASE WAITENUMB
	    RCV ENUMB,4		;  MAXLENBLK 
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      LETBC path,SENDBLOCK
	    mENDIF
	    BREAK

	  CASE SENDBLOCK
	    call PrepDATA
	    LETBC FMarker,FALSE
	    mIF Z
	      lda LENBLK
	      ora a
	    mTHEN
	      LETBC path,SENDEOT
	    mELSE
	      LETBC path,SENDSOH
	    mENDIF
	    BREAK

	  CASE SENDEOT
	    SEND AEOT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC path,COMPLETE
	      LETBC excode,OK
	    mENDIF
	    BREAK

	  CASE SENDSOH
	    SEND ASOH,3		;  LENBYTES 
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      LETBC path,SENDDATA
	    mENDIF
	    BREAK

	  CASE SENDDATA
	    lhld LENBYTES
	    xchg
	    lhld AdrDATA
	    call OutMBlk	    
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      lxi h,ENUMB
	      inr m
	      LETBC path,WAITACK
	    mENDIF
	    BREAK

	  CASE WAITACK
	    RCV PKT,1
	    mIF Z
	    mov a,h
	    ora l
	    mTHEN
	      LETBC FMarker,FALSE
	      SWITCH
	      lda PKT
	      CASE ACK
	        LETBC path,SENDBLOCK
	        BREAK
	      DEFAULT
	        LETBC path,ABEND
	        LETBC excode,TRABRT
	      ENDCASE
	    mENDIF
	    BREAK

;------------------------------------------------

	  CASE SENDBELL
	    mIF Z
	      lxi h,BELLCNT
	      dcr m
	    mTHEN
	      LETBC excode,TRABRT
	      LETBC path,ABEND
	      LETBC FMarker,false
	    mELSE
	      SEND BellV,2
	      mIF Z
	        mov a,h
	        ora l
	      mTHEN
	        LETBC path,WAITPKT
	        LETBC PKTCNT,PKTREPEAT
	      mENDIF
	    mENDIF
	    BREAK

	  CASE WAITPKT
	    RCV PKT,1
	    mIF Z
	      mov a,h
	      ora l 
	    mTHEN
	      mIF Z
		lda PKT
	        cpi SYN
	      mTHEN
	        LETBC FMarker,false
	        LETBC path,RCVFDSCR
	      mELSE
	        mIF Z
	          lxi h,PKTCNT
	          dcr m
	        mTHEN
	          LETBC path,SENDBELL
	        mENDIF
	      mENDIF
	    mENDIF
	    BREAK

	  CASE RCVFDSCR
	    RCV FD+1,LineFD-1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      PRINT 'Input file'
	      LETBC FMarker,false
	      LETBC ENUMB,1			;    
	      LETBC path,SENDENQ
	    mENDIF
	    BREAK

	  CASE SENDENQ
	    SEND AENQ,5
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC path,RCVPKT
	      LETBC rcvf,false		;   
	    mENDIF
	    BREAK

	  CASE RCVPKT
	    RCV PKT,1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC FMarker,false
	      SWITCH
	        lda PKT
	      CASE EOT
	        LETBC path,COMPLETE
	        LETBC rcvf,true
	        LETBC excode,OK
	        BREAK
	      CASE SOH
	        LETBC path,RCVLENBLK
	        BREAK
	      DEFAULT
	        LETBC path,ABEND
	        LETBC excode,TRABRT
	      ENDCASE
	      BREAK
	    mENDIF
	    BREAK

	  CASE RCVLENBLK
	    RCV LENBLK,2
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC FMarker,false
	      LETBC path,RCVDATA
	      call BgnBLOCK		; adrDATA := bgnDATA+512*(E_NUMB-1)
	    mENDIF
	    BREAK

	  CASE RCVDATA
	    lhld LENBLK
	    xchg
	    lhld AdrDATA
	    call InpMBlk	    
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      PRINT 'recieved E_NUMB blocks from ...'
	      lxi h,ENUMB
	      inr m
	      LETBC FMarker,false
	      LETBC path,SENDACK
	    mENDIF
	    BREAK

	  CASE SENDACK
	    SEND AACK,1
	    mIF Z
	      mov a,h
	      ora l
	    mTHEN
	      LETBC path,RCVPKT
	    mENDIF
	    BREAK

;------------------------------------------------

	  CASE COMPLETE
	    LETBC excode,OK
	    LETBC path,FMEXIT
	    BREAK

	  CASE ABEND
	    LETBC path,FMEXIT
	    LETBC FMarker,FALSE
	    BREAK

	  CASE FMEXIT
	    LEAVE

	  DEFAULT
	    LETBC excode,99h		;   
	    LEAVE

	  ENDCASE

	  mIF NZ
	    lda FMarker
	    ora a
	  mTHEN
	    call MARKERS
	    mIF NZ
	      mov a,l
	      ora a
	    mTHEN
	      shld excode
	      LETBC path,ABEND
	    mENDIF
	  mENDIF

	ENDDO

	ret

;     adrDATA   lenblk    ENUMB

public	PrepDATA
PrepDATA:
	lhld	ENUMB
	dcx	h
	dad	h
	dad	h		; 4*(ENUMB-1)
	xchg
	lhld	flen
	call	HLsubDE
	jnc	$+6
	lxi	h,0
	lxi	d,4
	call	HLDE
	jc	$+4
	xchg			; min(4,abs(flen-4*(ENUMB-1)))
	shld	lenblk

	ora	a
	mov	a,l
	rar
	mov	h,a
	mvi	a,0
	rar
	mov l,a
	shld	LENBYTES	; LENBYTES := 128*LENBLK

public	BgnBlock
BgnBlock:
	lhld	ENUMB
	mov	b,h
	mov	c,l
	lhld	bgnDATA
	lxi	d,512
claD:	dcx	b
	mov	a,b
	ora	c
	jz	StoreL
	dad	d
	jmp	claD
StoreL:
	shld	adrDATA		; bgnDATA+512*(ENUMB-1)
	ret


; /     
; :
;     ( Line=0)
;     <de> -  
;     <hl> - /
;        (Line<>0)
;     Line -  ;     
;     Where - /
; :
;   <hl> -  

public	OutMBlk,InpMBlk, IniMBlk
IniMBlk:
	LETWC	Line,0
	ret

OutMBlk:
	push	h
	lxi	h,ToBigBufer
	jmp	PrepMBlk
InpMBlk:
	push	h
	lxi	h,FromBigBufer
PrepMBlk:
	shld	modMBlk

	lhld	Line
	mov	a,h
	ora	l
	jz	FirstMBlk
	xchg				; 
	pop	h
	lhld	Where
	jmp	WorkMBlk
FirstMBlk:
	pop	h			;    
WorkMBlk:
	push	d			;  
	push	h			; /
modMBlk	equ	$+1
	call	0
	xchg				; <de> -  
	pop	h			;   /
	dad	d
	shld	Where			;   /
	pop	h			; <hl> -  
	call	HLsubDE			; <hl>:=()-()->
	shld	Line
	ret

HLsubDE:
	mov	a,l
	sub	e
	mov	l,a
	mov	a,h
	sbb	d
	mov	h,a
	ret
	
HLDE:
	mov	a,h
	cmp	d
	rnz
	mov	a,l
	cmp	e
	ret

	DSeg

public	What, Line, Where
What:
	db	0		; 0 -> , -1 -> 
Line:
	ds	2
Where:
	ds	2

	end
