;;						- 1 -
;;**************************************
;;	~tenie fajlow "SINCLAIR"
;;  ----------------------------------
;;  wers.3.14.108	data:09-FEB-90
;;**************************************
;;
werhswist	EQU	4FH
nivnswist	EQU	20H
perehod		EQU	1DH
;;
FCB		EQU	0005CH	; buf dlq tek.fajla
FILEBGN		EQU	00800H	; na~alo oblasti SINCLAIR zapisi
;;
	ORG	100H
;;
	LXI	SP,FILEBGN-1
	CALL	PROGRAM
	LXI	D,literal
;;
;;  wyhod w sistemu s soob}eniem
;;  whod:
;;    <D,E> - adres soob}eniq
ERROR:
	CALL	PEC
	JMP	WARM
;;
NUMFL:	DS	1		; nomer tek.fajla
ERRFL:	DS	1		; kod priema tek.fajla
FILE:	DS	2		; na~alo tek.fajla
ENDFL:	DS	2		; adres za tek.fajlom
LINEFL:	DS	2		; dlina tek.zapisi dlq INFFILE
;;
MAXADR:	DS	2		; MAX dopustimyj adres ozu
DISK:	DS	2		; tek.adres disk.fajla
DCOUNT:	DS	2		; s~et~ik blokow dlq disk.fajla
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:	DS	2		; adres imeni fajla
	DS	2		; adres FCB
;;;;						- 2 -
;;  rabota s operaciqmi mikro-dos
;;  -----------------------------
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM
;;
;;  wywod stroki na konsolx
;;  whod:
;;    <D,E> - adres tekst.stroki
PEC:
	PUSH	H
	PUSH	D
	PUSH	B
	SYSTEM	9
	JMP	EXSYS
;;
CRLF:
	MVI	C,0DH
	CALL	CO
	MVI	C,0AH
;;
;;  wywod na konsolx
CO:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,C
	SYSTEM	2
EXSYS:
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wyhod w sistemu
WARM:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H
;;;;						- 3 -
;;  proweritx imq na neodnozna~nostx
;;  whod: <D,E> - FCB
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,11*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXWTH
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXWTH:
	POP	D
	RET
;;
;;  wwod imeni diskowogo fajla
;;  whod: <D,E> - na~alo imeni
wwodimeni:
	LXI	H,MODEFILE
	LXI	D,FCB+9
	LXI	B,3
	CALL	MOVE
	LXI	D,FCB
	CALL	WITHQ
	LXI	D,NONAME	; newerno zadano imq fajla
	JZ	ERROR		;  na diske
;;
;;  wywod imeni tek.fajla
wywimq:
	LXI	D,Timq
	CALL	PEC
	LXI	H,FCB
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
	RET
;;;;						- 4 -
;;  sozdatx fajl
sozdatx:
	CALL	wwodimeni
;;
	LXI	H,FCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,FCB
	SYSTEM	13H		; udalitx fajl
	LXI	D,FCB
	SYSTEM	16H		; sozdatx fajl
	INR	A
	LXI	D,CRTERR
	JZ	ERROR
	RET
;;
;;  dopolnitx fajl o~erednoj zapisx` SINCLAIR
;;  whod:
;;    COUNT - ~islo wywodimyh w fajl blokow 128BYTE
dopolnitx:
	LXI	H,FILEBGN	; na~alo fajla
	SHLD	DISK
;;
NEXTBLC:
	LHLD	DISK		; ustanowitx bufer pdp
	XCHG
	SYSTEM	1AH
;;
	LXI	D,FCB		; zapisatx blok
	SYSTEM	15H
	INR	A
	PUSH	PSW
	CZ	zakrytx		; zakrytx pri perepolnenii diska
	POP	PSW
	LXI	D,DISCFULL
	JZ	ERROR
;;
	LHLD	DISK		; smestitx pdp
	LXI	D,80H
	DAD	D
	SHLD	DISK
;;
	LHLD	DCOUNT
	DCX	H
	SHLD	DCOUNT
	MOV	A,H
	ORA	L
	JNZ	NEXTBLC
	RET
;;
;;  zakrytx fajl na diske
zakrytx:
	LXI	H,1
	SHLD	DCOUNT
	CALL	dopolnitx
	LXI	D,FCB		; zakrytx fajl
	SYSTEM	10H
	INR	A
	LXI	D,NOFILE
	JZ	ERROR
	RET
;;;;						- 5 -
;;  blok dopoln.podprogramm
;;  -----------------------
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;;;						- 6 -
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET
;;
CMEM:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	CALL	CADDR
	XCHG
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;;;						- 7 -
BMCO:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCO
	RET
;;
;;  wnesti bajt w bufer
;;  whod:
;;    <D> - bajt
;;    <H,L> - adres w bufere
;;  wyhod:
;;    <H,L>+:=1
;;    flag Z=1 - perepolnenie bufera
TOBUF:
	LDA	MAXADR+1
	CMP	H
	RZ
	MOV	M,D
	INX	H
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	INX	H
	JNZ	$-4
	RET
;;;;						- 8 -
;;  najti dlinu signala
;;  whod:
;;    <C> - pred.sostoqnie kanala
;;  wyhod:
;;    <D,E> - dlina signala (po 36 taktow)
;;  flag Z=1 - wyhod po navati` us klawi{i
COUNT:
	IN	01H
	ANI	01010000B	;  7 ;
	CMP	C		;  5 ;
	JZ	$-5		; 10 ;
	MOV	C,A		;  5 ;
	ANI	01000000B	;  7 ;
	RZ			;  5 ;
;;
korrekciq	EQU	2
;;
	LXI	D,korrekciq-1	; 10 ; SUM=65 => korrekciq:=65/36=2
;;
	IN	01H		; 10 ;
	ANI	01010000B	;  7 ;
	CMP	C		;  5 ;
	INX	D		;  4 ;
	JZ	$-6		; 10 ; SUM=36
	MOV	C,A
	ANI	01000000B
	RET
;;
;;  najti na~alo fajla
;;  wyhod:
;;    flag Z=1 - po navati` us klawi{i
BEGIN:
	IN	01H		; na~atx s perepada
	ANI	01010000B
	MOV	C,A
	LXI	H,0		; s~et~ik dlq zagolowka
NEXT:
	INX	H
;;
	CALL	COUNT
	RZ
	MOV	A,D
	ORA	A
	JNZ	BEGIN
	MOV	A,E
;;
	CPI	werhswist	; swistok ?
	JNC	BEGIN
	CPI	nivnswist
	JNC	NEXT
	CPI	perehod		; sinhrosignal ?
	JNC	BEGIN
	LXI	D,0100H		; swistok dlinnyj ?
	CALL	HLDE
	JC	BEGIN
;;
	MVI	A,0FFH
	ORA	A
	RET
;;;;						- 9 -
;;  wwod bajta
;;  whod:
;;    <C> - pred{estw.sostoqnie kanala
;;    <E> - paritet
;;  wyhod:
;;    <A> - bajt
;;    <E> - paritet
;;    flag C=1 - priznak o{ibki, pri |tom
;;	flag Z=1 - ostanowka operatorom
;;	flag Z=0 - sli{kom dlinnyj perepad
RDBYTE:
	PUSH	D
	MVI	B,01H
ciklwwod:
	CALL	COUNT
	JZ	EXRD		; wyhod po navati` us
	MOV	A,D
	ORA	A
	JNZ	EXRD		; wyhod po o{ibke ~teniq
	MVI	A,perehod
	CMP	E
	MOV	A,B
	ADC	A
	MOV	B,A
	JNC	ciklwwod
	POP	D
	XRA	E		; paritet
	MOV	E,A
	MOV	A,B
	RET
EXRD:
	STC
	POP	D
	MOV	A,E
	RET
;;;;						- 10 -
;;  wwesti fajl
;;  whod:
;;    FILE - na~alo oblasti dlq zapisi fajla
;;  wyhod:
;;    ERRFL - kod wozwrata
;;	00H - norm.wwod
;;	01H - naru{en paritet
;;	02H - po navati` us
;;	03H - is~erpana pamqtx
;;    flag C=1 - priznak o{ibki
;;    ENDFL - adres za koncom fajla SINCLAIR
INPFILE:
	CALL	ONMOTOR
	DI
	CALL	BEGIN		; najti na~alo fajla
	MVI	A,02H
	JZ	RDERRFL		; ostanowka po us
	LHLD	FILE
	MVI	M,0		; nulewaq dlina
	INX	H
	MVI	M,0
	INX	H
	MVI	E,0		; paritet
NEXTRD:
	CALL	RDBYTE
	JC	EXRDFILE
	MOV	D,A
	CALL	TOBUF
	JNZ	NEXTRD
;;
	MVI	A,03H		; is~erpano ozu
	JMP	RDERRFL
;;
EXRDFILE:			; konec s~itywaniq
	EI
	MVI	A,02H
	JZ	RDERRFL		; po navati` us
	CALL	OFFMOTOR
	MOV	A,E
	ORA	A
	MVI	A,01H		; naru{en paritet
	JNZ	RDERRFL
;;
	SHLD	ENDFL
	XCHG
	LHLD	FILE
	SHLD	dlina		; modifikaciq programmy !!!
	INX	H
	INX	H
	XCHG
	CALL	SUHLDE		; dlina informacii
dlina	EQU	$+1
	SHLD	FILEBGN		; modificiruemaq komanda
	XRA	A
	STA	ERRFL
	RET
;;
RDERRFL:
	EI
	STA	ERRFL		; kod o{ibki
	PUSH	PSW
	CALL	OFFMOTOR
	LXI	D,TERRD		; soob}enie ob o{ibke
	CALL	PEC		;  pri wwode fajla
	POP	PSW
	CALL	CBYTE
	STC
	RET
;;
ONMOTOR:
	RET			; perehod na podprogrammu wkl.
	DS	2		;  motor
OFFMOTOR:
	RET			; perehod na podprogrammu wykl.
	DS	2		;  motor
;;;;						- 11 -
;;  wywod informacii o fajle
;;  whod:
;;    NUMFL,ERRFL,FILE
INFFILE:
	CALL	CRLF
;;
	LDA	NUMFL		; nomer fajla
	CALL	CBYTE
	CALL	SPACE
;;
	LHLD	FILE
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	SHLD	LINEFL
	XCHG
	MOV	A,M
	CALL	CBYTE		; nulewoj bajt zapisi
	MOV	A,M
	ORA	A
	JZ	zagolowok
;;
	LXI	B,23*100H+' '
	JMP	NOSTFL
;;;;						- 12 -
zagolowok:
	CALL	SPACE
	INX	H
	MOV	A,M		; tip zagolowka
	CPI	4
	JC	STANDART
;;
	CALL	CBYTE		; zagolowok 4...255
	LXI	B,20*100H+' '
NOSTFL:
	CALL	BCO
	LHLD	LINEFL		; dlina fajla dejstw.
	DCX	H
	DCX	H
	CALL	CADDR
	JMP	ostatok
;;
STANDART:
	ADD	A
	ADD	M
	ADD	A
	LXI	D,tip
	ADD	E
	MOV	E,A
	JNC	$+4
	INR	D
	CALL	PEC
;;
	CALL	SPACE
	INX	H
	MVI	B,10		; standart.tip zagolowka
	CALL	BMCO
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,16		; na~alo fajla dannyh
	DAD	D
	CALL	CMEM
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,14		; dlina fajla dannyh
	DAD	D
	CALL	CMEM
;;
ostatok:
	RET
;;;;						- 13 -
PROGRAM:
	LXI	D,ADVERT
	CALL	PEC
	LHLD	0006H
	SHLD	MAXADR
;;
	CALL	sozdatx
;;
	LXI	H,FILEBGN	; podgotowka dannyh
	SHLD	FILE
	MVI	A,0
	STA	NUMFL
;;
	LXI	D,zagtip
	CALL	PEC
;;
wwesti:
	CALL	INPFILE
	JC	ENDREAD		; nepraw.wwedennyj fajl
;;
	LXI	H,NUMFL		; uwel. nomer fajla
	INR	M
;;
	CALL	INFFILE		; wywesti informaci`
;;
	LXI	D,FILEBGN
	LHLD	ENDFL
	CALL	SUHLDE
	XRA	A
	DAD	H
	ACI	0
	MOV	L,H
	MOV	H,A
	SHLD	DCOUNT
	ORA	L
	JNZ	ADDFILE
	LHLD	ENDFL		; perwyj blok 128 bajt ne zapolnen
	SHLD	FILE
	JMP	wwesti
;;
ADDFILE:
	CALL	dopolnitx
	LHLD	ENDFL
	MOV	A,L
	ANI	7FH
	MOV	L,A
	MVI	H,0
	LXI	D,FILEBGN
	DAD	D
	SHLD	FILE
	ORA	A
	JZ	wwesti
	MVI	B,0
	MOV	C,A		; peredwinutx posl.blok na mesto
	LHLD	ENDFL		;   perwogo
	MOV	A,L
	ANI	80H
	MOV	L,A
	LXI	D,FILEBGN
	CALL	MOVE
	JMP	wwesti
;;
ENDREAD:
	LHLD	FILE		; steretx konec posl.bloka
	MVI	A,80H
	CALL	CLR
	CALL	zakrytx
	RET
;;;;						- 14 -
;;  prowerka HEX-litery
;;  whod: <A> - HEX-litera
;;  wyhod: <A> - HEX-cifra
;;    flag C=1 - prawilxnoe preobr.
QUHEX:
	SUI	'0'
	CPI	10
	RC
	SUI	'A'-'0'-10
	CPI	16
	RET
;;
;;  wwod HEX-~isla
;;  whod:<D,E> - ASCII posledowatelxnostx
;;  wyhod:<H,L> - ~islo
;;    <D,E> - ukazatelx na perwu` ne HEX-literu
HEXCHAR:
	LXI	H,0
CHCH:
	LDAX	D
	CALL	QUHEX
	RNC
	INX	D
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	MOV	C,A
	MVI	B,0
	DAD	B
	JMP	CHCH
;;;;						- 15 -
;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	' SINCLAIR LOAD PROGRAM ',18H,18H
	DB	' VERS.3.14.108 '
	DB	1BH,5CH
	DB	' (s)1990,filippow e.w. ',18H,18H
	DB	'   09-FEB-90   '
	DB	1BH,'a',1BH,5EH,0FH,'$'
TERRD:
	DB	0DH,0AH,1BH,5CH,'kod wozwrata: ',0FH,'$'
tip:
	DB	'BASIC$'
	DB	'DIGIT$'
	DB	'CHAR $'
	DB	'CODE $'
zagtip:
	DB	0DH,0AH,1BH,05CH,1BH,'b',0DH,0AH
	DB	' N  Z  tip  ...imq.... na~. dln. '
	DB	1BH,'a',0DH,0AH,0FH,'$'
;;
literal:
	DB	1BH,5CH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
;;
CRTERR:	DB	1BH,5CH
	DB	0DH,0AH,'net mesta w oglawlenii',0FH,'$'
DISCFULL:
	DB	1BH,5CH
	DB	0DH,0AH,'net mesta na diske',0FH,'$'
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
NONAME:
	DB	1BH,5CH
	DB	0DH,0AH,'newerno ukazano imq fajla',0FH,'$'
;;
MODEFILE:
	DB	'SNC'
;;
	ORG	($ OR 0FH) + 1
;;
	DB	'----------------'
	DB	'  filippow e.w. '
	DB	'    g.ki{inew   '
	DB	'   t.52-80-27   '
	DB	'  wers.3.14.108 '
	DB	'----------------'
;;
	END
