;;						- 1 -
;;**************************************
;;     podgotowka fajlow "SINCLAIR"
;;  ----------------------------------
;;  wers.3.5.59		data:15-FEB-90
;;**************************************
;;
FCB	EQU	0005CH		; buf dlq fajla rezulxtata
FIELD	EQU	00800H		; oblastx dlq raboty s diskom
KEYS	EQU	FIELD+100H	; tablica kl`~ej
;;
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM
;;
	ORG	100H
;;
	JMP	PROGRAM
;;
NUMFL:	DS	1		; nomera zapisi i programmy w KEY
;;
RDISK:	DW	FIELD		; adres pdp disk.fajla
RDCNT:	DS	2		; s~et~ik dlq ~teniq disk.fajla
RFCB:	DS	35		; FCB dlq ~teniq
	DS	1
;;
WDISK:	DW	FIELD+80H	; adres pdp dlq zapisi
WDCNT:	DS	2		; s~et~ik dlq zapisi disk.fajla
WFCB:	DS	35		; FCB dlq zapisi
	DS	1
;;
TABKEY:	DW	KEYS		; adres dlq formirowaniq KEY-fajla
NEWKEY:	DW	KEYS		; adres dlq wosstanowleniq TABKEY
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:	DS	2		; adres imeni fajla
	DS	2		; adres FCB
;;
BUFER:
	DB	15
	DS	20H-1
;;
;;  wyhod w sistemu s soob}eniem
;;  whod:
;;    <D,E> - adres soob}eniq
ERROR:
	CALL	PEC
;;
;;  wyhod w sistemu
WARM:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H
;;;;						- 2 -
;;  wywod stroki na konsolx
;;  whod:
;;    <D,E> - adres tekst.stroki
PEC:
	PUSH	H
	PUSH	D
	PUSH	B
	SYSTEM	9
	JMP	EXSYS
;;
CRLF:
	MVI	C,0DH
	CALL	CO
	MVI	C,0AH
;;
;;  wywod na konsolx
CO:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,C
	SYSTEM	2
EXSYS:
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wwod s konsoli
CI:
	PUSH	H
	PUSH	D
	PUSH	B
	MVI	E,0FDH
	SYSTEM	6
	JMP	EXSYS
;;
;;  wwod komandnoj stroki
wwodkom:
	LXI	D,BUFER
	SYSTEM	0AH
	LXI	H,BUFER+1
	MOV	E,M
	INX	H
	MVI	D,0
	DAD	D
	MVI	M,0
	RET
;;;;						- 3 -
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET
;;;;						- 4 -
CMEM:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	CALL	CADDR
	XCHG
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;
BMCO:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCO
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	INX	H
	JNZ	$-4
	RET
;;;;						- 5 -
;;  proweritx stroki na sowpadenie
;;  whod: <C> - dlina
;;    <D,E> i <H,L> - stroki
;;  wyhod: flag Z=1 - sowpada`t
CHECK:
	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	DCR	C
	JNZ	CHECK
	RET
;;
;;  najti infrormaci` w KEYTAB
;;  whod:  <A> - nomer zapisi w KEY (<A>.GE.1)
;;  wyhod: <H,L> - adres sootw.zapisi
KEYCNT:
	DCR	A
	MVI	D,0
	MOV	E,A
	LHLD	TABKEY
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	D
	RET
;;
;;  podgotowka FCB dlq wwoda
;;  whod: <D,E> - adres imeni fajla
DOFCB:
	LXI	H,RFCB
	SHLD	PFCB+2
	XCHG
	SHLD	PFCB
	LXI	D,PFCB
	SYSTEM	98H
	RET
;;;;						- 6 -
;;  proweritx imq na neodnozna~nostx i wywesti soob}enie
;;  whod: <D,E> - imq fajla
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,12*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXNM
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXNM:
	POP	D
	RET
;;
;;  wywod imeni tek.fajla
;;  whod:  <D,E> - FCB
wywimq:
	PUSH	D
	LXI	D,Timq
	CALL	PEC
	POP	H
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
	RET
;;;;						- 7 -
;;  otkrytx su}estwu`}ij diskowyj fajl dlq ~teniq
;;  wyhod: flag Z=1 - fajl otsutstwuet
OPEN:
	LXI	D,RFCB
	CALL	wywimq
	LXI	D,RFCB
	CALL	WITHQ
	RZ			; newernoe imq ?
;;
	LHLD	RDISK		; podgotowitx drajwer wwoda
	SHLD	RDCNT
	XRA	A
	STA	READFLAG
;;
	LXI	H,RFCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,RFCB
	SYSTEM	0FH		; otkrytx fajl
	INR	A
	LXI	D,NOFILE
	RET
;;
;;  sozdatx diskowyj fajl dlq zapisi
;;  wyhod: flag Z=1 - fajl otsutstwuet
CREATE:
	LXI	D,WFCB
	CALL	wywimq
	LXI	D,WFCB
	CALL	WITHQ
	LXI	D,NONAME	; newerno zadano imq fajla
	JZ	ERROR		;  na diske
;;
	LHLD	WDISK		; podgotowitx drajwer wywoda
	SHLD	WDCNT
;;
	LXI	H,WFCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,WFCB
	SYSTEM	13H		; udalitx fajl
	LXI	D,WFCB
	SYSTEM	16H		; sozdatx fajl
	INR	A
	LXI	D,NOFILE
	RET
;;;;						- 8 -
;;  drajwer wwoda s diska
;;  wyhod:
;;    <A> - bajt informacii
DRVRD:
	PUSH	H
	LHLD	RDCNT
	MOV	A,L
	ANI	7FH
	CZ	RBLC
	MOV	A,M
	INX	H
	SHLD	RDCNT
	POP	H
	RET
;;
;;  s~itatx o~erednoj blok fajla
;;  whod:
;;    READFLAG - priznak poslednego bloka fajla
;;  prime~.:
;;    pri popytke wwesti li{nij blok daet awost
RBLC:
	PUSH	D
	PUSH	B
	LHLD	RDISK
	XCHG
	SYSTEM	1AH		; ustanowitx pdp
READFLAG	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	LXI	D,FILEEND
	JNZ	ERROR
;;
	LXI	D,RFCB		; ~itatx blok
	SYSTEM	14H
	CPI	0FFH
	LXI	D,READERR
	JZ	ERROR
	STA	READFLAG	; modifikaciq programmy
;;
	LHLD	RDISK
	POP	B
	POP	D
	RET
;;;;						- 9 -
;;  kopirowatx dannye s diska na disk
;;  whod:
;;    <B,C> - dlina bloka dannyh
;;    MODCOPY - priznak kopirowaniq
;;  prime~anie:
;;    dlina=0 - o{ibka !!!
kopirowatx:
	LHLD	RDCNT
	XCHG
	LHLD	WDCNT
cklkop:
	MOV	A,E
	ANI	7FH
	XCHG
	CZ	RBLC
	XCHG
	LDAX	D
	INR	E
	MOV	M,A
	LDA	MODCOPY
	ORA	A
	JZ	nekopir
	INR	L
	CZ	WBLC
nekopir:
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	cklkop
	SHLD	WDCNT
	XCHG
	SHLD	RDCNT
	RET
;;;;						- 10 -
;;  drajwer wywoda na diska
;;  whod:
;;    <C> - bajt informacii
DRVWR:
	PUSH	H
	LHLD	WDCNT
	MOV	M,C
	INX	H
	MOV	A,L
	ANI	7FH
	CZ	WBLC
	SHLD	WDCNT
	POP	H
	RET
;;
;;  zapisatx o~erednoj blok fajla
WBLC:
	PUSH	D
	PUSH	B
	LHLD	WDISK
	XCHG
	SYSTEM	1AH		; ustanowitx pdp
;;
	LXI	D,WFCB		; pisatx blok
	SYSTEM	15H
	ORA	A
	LXI	D,WRTERR
	JNZ	ERROR
;;
	LHLD	WDISK
	POP	B
	POP	D
	RET
;;
;;  zakrytx fajl dlq wywoda
CLOSE:
	LXI	D,WFCB
	CALL	wywimq
;;
	LXI	B,8000H			; zapisatx posl.blok
	CALL	DRVWR
	DCR	B
	JNZ	$-4
;;
	LXI	D,WFCB
	SYSTEM	10H			; zakrytx fajl
	RET
;;;;						- 11 -
;;  komanda INPUT KEY FILE
ICOM:
	LXI	D,BUFER+3
	LDAX	D
	ORA	A
	CNZ	DOFCB			; ukazano imq fajla
;;
	LXI	H,KEYFILE		; podg. KEY fajl
	LXI	D,RFCB+9
	LXI	B,3
	CALL	MOVE
;;
	CALL	OPEN			; otkrytx KEY fajl
	LXI	D,NOFILE
	JZ	BADCOM
;;
	LHLD	TABKEY			; ~itatx KEY fajl
IKEY:
	CALL	DRVRD
	MOV	M,A
	INX	H
	CPI	0FFH
	JZ	COMAND
;;
	MVI	B,15
IK:
	CALL	DRVRD
	MOV	M,A
	INX	H
	DCR	B
	JNZ	IK
	DCX	H
	MVI	M,0
	INX	H
	JMP	IKEY
;;;;						- 12 -
;;  komanda prosmotr i modifikaciq KEY fajla
QUESTCOM:
	LHLD	TABKEY			; rabotatx s na~ala KEY fajla
	SHLD	NEWKEY
	LXI	H,KEYS
	SHLD	TABKEY
;;
	LXI	H,CQLC
	JMP	$+6
PCOM:
	LXI	H,opros
	SHLD	MODREG
;;
	LXI	D,zagtip
	CALL	PEC
	XRA	A
	STA	NUMFL
	STA	priznak			; modifikaciq programmy !!!
CQLC:
	CALL	CRLF
CNOPRG:
	LXI	H,NUMFL
	INR	M
	MOV	A,M
	CALL	KEYCNT
	MOV	A,M			; priznak konca KEYTAB ?
	CPI	0FFH
	JZ	COMAND
	INX	H
	MOV	A,M			; imq progrorammy ?
	ORA	A
	JNZ	dobprizn
	INX	H
	CALL	PRINAME
	MOV	A,M
	STA	priznak			; modif.programmu
MODREG	EQU	$+1
	JMP	CQLC			; modif.komanda
;;
dobprizn:
	LXI	B,14
	DAD	B
priznak	EQU	$+1
	MVI	A,0			; modif.komanda !!!
	MOV	M,A
	JMP	CNOPRG
;;;;						- 13 -
;;  dlq revima '?'
opros:
	CALL	CI
	ORA	A
	JZ	CQLC
	CPI	';'
	MVI	C,1
	JZ	INCLUDE
	MVI	C,0
	CPI	'-'
	JNZ	CQLC
INCLUDE:
	MOV	M,C
	LXI	H,NUMFL
	DCR	M
	MVI	C,19H
	CALL	CO
	JMP	CQLC
;;
;;  wywod imeni programmy i dop.inform.
;;  whod:
;;    <H,L> - adres imeni programmy W KEY
;;  wyhod:
;;    <H,L> - adres priznaka kopirowaniq
PRINAME:
	MVI	C,' '
	CALL	CO
	MVI	B,8			; imq programmy
	CALL	BMCO
	LXI	B,320H
	CALL	BCO
	LXI	B,5
	DAD	B
	MOV	A,M
	LXI	D,NOWRT			; dalee podprogramma PRINT !!!
;;
;;  wywod soob}eniq po ego nomeru
;;  whod:
;;    <A> - nomer soob}eniq
;;    <D,E> - na~alo perwogo soob}eniq
PRINT:
	PUSH	H
	MOV	B,A
CPRI:
	DCR	B
	JM	PRI
	LDAX	D
	INX	D
	CPI	'$'
	JNZ	$-4
	JMP	CPRI
;;
PRI:
	CALL	PEC
	POP	H
	RET
;;;;						- 14 -
;;  maskiruemyj wywod na disk
;;  whod: s drajwera wwoda
;;  wyhod: <A> - bajt inform.
TODISK:
	CALL	DRVRD
	PUSH	B
	MOV	C,A
MODCOPY	EQU	$+1			; modificiruemaq komanda
	MVI	A,0
	ORA	A
	CNZ	DRVWR
	MOV	A,C
	POP	B
	RET
;;
;;  wywod na disk wybrannyh programm
WPROGRAM:
	LXI	H,SNCFILE		; podgotowitx SNC fajl
	LXI	D,RFCB+9		;  dlq ~teniq
	LXI	B,3
	CALL	MOVE
	CALL	OPEN
	XRA	A
	STA	NUMFL
	STA	MODCOPY			; sbrositx priznak kopirowaniq
	LXI	D,zagtip
	CALL	PEC
;;
WFILE:
	LXI	H,NUMFL
	INR	M
	MOV	A,M			; nomer zapisi SNC
	CALL	KEYCNT
	MOV	A,M
	INR	A
	RZ				; posl.zapisx SNC?
;;
	INX	H			; na~alo programmy?
	MOV	A,M
	ORA	A
	JNZ	RDR
;;
	CALL	CRLF
	INX	H
	CALL	PRINAME			; datx inf. o programme
	MOV	A,M
	STA	MODCOPY			; ustanowitx priznak kopirowaniq
;;
RDR:
	CALL	TODISK			; dlina fajla SINCLAIR
	MOV	C,A
	CALL	TODISK
	MOV	B,A
	ORA	C
	RZ				; poslednij fajl w SNC
;;
COPYFILE:
	CALL	kopirowatx
	JMP	WFILE
;;;;						- 15 -
;;  svatie KEY taclicy
SQUKEY:
	LHLD	NEWKEY
CSQU:
	SHLD	NEWKEY			; nowye zapisi budut dobawlqtxsq
	MOV	A,M			;  w konec tablicy KEY
	INR	A
	RZ				; kon~ilasx tablica KEY ?
;;
	XCHG
	LXI	H,15
	DAD	D
	MOV	A,M
	ORA	A
	JZ	udalitx
;;
	MVI	M,2			; priznak = WRITE
	INX	H
	JMP	CSQU
;;
udalitx:
	PUSH	D
	LXI	H,16
	DAD	D
;;
	LXI	B,16	; <-----+
	MOV	A,M	;	!
	CPI	0FFH	;	!
	PUSH	PSW	;	!
	CALL	MOVE	;	!
	POP	PSW	;	!
	JNZ	$-11	; ------+
	POP	H
	JMP	CSQU
;;
;;  komanda kopirowaniq SNC i svatiq KEY
WCOM:
	CALL	WPROGRAM
	CALL	SQUKEY
	JMP	COMAND
;;;;						- 16 -
;;  komanda wyhoda iz programmy
ECOM:
	CALL	CLOSE
;;
	LXI	H,KEYFILE
	LXI	D,WFCB+9
	LXI	B,3
	CALL	MOVE
	CALL	CREATE			; sozdatx fajl rezulxtata
;;
	LHLD	WDISK
	SHLD	WDCNT
;;
	LXI	H,KEYS			; na~alo tabl. KEY
CKEY:
	MVI	B,16
	MOV	A,M
	CPI	0FFH
	PUSH	PSW
	CALL	MOVEDSK
	POP	PSW
	JNZ	CKEY
;;
	CALL	CLOSE
	JMP	WARM
;;
;;  wywod na disk bloka dannyh
;;  whod:
;;    <B> - razmer
;;    <H,L> - adres na~ala
MOVEDSK:
	MOV	C,M
	INX	H
	CALL	DRVWR
	DCR	B
	JNZ	MOVEDSK
	RET
;;;;						- 17 -
PROGRAM:
	LXI	SP,FIELD-1
	LXI	D,ADVERT
	CALL	PEC
;;
	LXI	H,FCB			; zapomnitx imq fajla rezulxtata
	LXI	D,WFCB
	LXI	B,9
	CALL	MOVE
	LXI	H,SNCFILE
	LXI	D,WFCB+9
	LXI	B,3
	CALL	MOVE
	CALL	CREATE			; sozdatx fajl rezulxtata
;;
	LHLD	NEWKEY			; sbrositx KEY fajl
	MVI	M,0FFH
;;
COMAND:
	LXI	SP,FIELD-1
;;
	LHLD	NEWKEY			; wosstanowitx tek. adres dlq
	SHLD	TABKEY			;  raboty s KEY fajlom
;;
	LXI	D,PROMT
	CALL	PEC
	LXI	D,BUFER			; podgotowitx komandu
	CALL	wwodkom
	LXI	D,BUFER+2
	LDAX	D
	CPI	'E'			; wyhod + zakrytx SNC i KEY fajly
	JZ	ECOM
	CPI	'I'			; wwod fajla KEY
	JZ	ICOM
	CPI	'?'			; prosmotr wsego KEY fajla
	JZ	QUESTCOM
	CPI	'P'			; modif. tek.~asti KEY fajla
	JZ	PCOM
	CPI	'W'			; zapisx na disk tek. programm
	JZ	WCOM
NOTCOM:
	LXI	D,ERRCOM
BADCOM:
	CALL	PEC
	JMP	COMAND
;;;;						- 18 -
;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	' SINCLAIR FILE PROGRAM ',18H,18H
	DB	' VERS.3.5.59 '
	DB	0DH,0AH,1BH,5CH
	DB	' (s)1990,filippow e.w. ',18H,18H
	DB	'  15-FEB-90  '
	DB	0DH,0AH,1BH,'a',1BH,5EH,0FH,'$'
;;
zagtip:
	DB	0DH,0AH,1BH,05CH,1BH,'b',0DH,0AH
	DB	' programma  ----- '
	DB	1BH,'a',0DH,0AH,0FH,'$'
;;
PROMT:
	DB	0DH,0AH
	DB	'*$'
;;
literal:
	DB	1BH,5CH,'$'
;;
READERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri ~tenii fajla',0FH,'$'
WRTERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri zapisi fajla',0FH,'$'
FILEEND:
	DB	1BH,5CH
	DB	0DH,0AH,'fajl zakon~en',0FH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
;;
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
NONAME:
	DB	1BH,5CH
	DB	0DH,0AH,'newerno ukazano imq fajla',0FH,'$'
ERRCOM:
	DB	0DH,0AH,'?$'
;;
SNCFILE:
	DB	'SNC'
KEYFILE:
	DB	'KEY'
;;
NOWRT:
	DB	' --- $'
	DB	' +++ $'
	DB	'WRITE$'
;;;;						- 19 -
	ORG	($ OR 0FH) + 1
;;
	DB	'----------------'
	DB	'  filippow e.w. '
	DB	'    g.ki{inew   '
	DB	'   t.52-80-27   '
	DB	'  wersiq 3.5.59 '
	DB	'----------------'
;;
	END
