	ORG	0DB00H
BDOSENTER			EQU	05H
CI				EQU	0F803H
CO				EQU	0F809H
FCB				EQU	5CH
LO				EQU	0F80FH
PO				EQU	0F80CH
PROGRAM				EQU	0100H
RDELAY				EQU	0FFC5H
RI				EQU	0F806H
STACKBIOS			EQU	0EB00H
STATCI				EQU	0F812H
SYSDMA				EQU	80H
WDELAY				EQU	0FFC4H
	JMP	INIBIOS					;0DB21H
	JMP	INIBIOS					;0DB21H
	JMP	GRSTATUS				;0DB29H
	JMP	GRINPUT					;0DB32H
	JMP	GROUTPUT				;0DB3BH
	JMP	ADRDPH					;0DCEDH
	JMP	RDWRDISK				;0DD31H
	JMP	ADRMESSAGE				;0E3E1H
	JMP	USERCOMMAND				;0DB44H
	JMP	CLEARCDISK				;0E390H

LDB1E:					;0DB1EH
	DB	1

LDB1F:					;0DB1FH
	DB	'P',0

INIBIOS:				;0DB21H
	XRA	A
	STA	LE95A					;0E95AH
	STA	LE954					;0E954H
	RET

GRSTATUS:				;0DB29H
	CALL	CASEFROM3				;0DB5BH
	DW	STATCONIN				;0DB75H
	DW	STATLO					;0DCE4H
	DW	STATAUX					;0DB62H

GRINPUT:				;0DB32H
	CALL	CASEFROM3				;0DB5BH
	DW	CONIN					;0DB78H
	DW	STATAUX					;0DB62H
	DW	AUXIN					;0DCE7H

GROUTPUT:				;0DB3BH
	CALL	CASEFROM3				;0DB5BH
	DW	CONOUT					;0DB7BH
	DW	PRINTERS				;0DB85H
	DW	AUXOUT					;0DCEAH

USERCOMMAND:				;0DB44H
	CALL	LDB64					;0DB64H
	DW	USERK0					;0DF24H
	DW	USERK1					;0E19BH
	DW	USERK2					;0E22EH
	DW	USERK3					;0E286H
	DW	USERK4					;0E38FH
	DW	USERK5					;0E37BH
	DW	USERK4					;0E38FH
	DW	USERK4					;0E38FH
	DW	USERK8					;0E395H
	DW	USERK4					;0E38FH

CASEFROM3:				;0DB5BH
	POP	H
	MOV	A,D
	CPI	3
	JC	LDB65					;0DB65H

STATAUX:				;0DB62H
	XRA	A
	RET

LDB64:					;0DB64H
	POP	H

LDB65:					;0DB65H
	CALL	HLEQUFROMHLADD2A			;0DB69H
	PCHL

HLEQUFROMHLADD2A:			;0DB69H
	ADD	A
	ADD	L
	MOV	L,A
	JNC	LDB70					;0DB70H
	INR	H

LDB70:					;0DB70H
	MOV	E,M
	INX	H
	MOV	H,M
	MOV	L,E
	RET

STATCONIN:				;0DB75H
	JMP	STATCI					;0F812H

CONIN:					;0DB78H
	JMP	CI					;0F803H

CONOUT:					;0DB7BH
	JMP	CO					;0F809H
	PUSH	PSW
	MVI	A,'#'	;23H
	OUT	10H
	POP	PSW
	RET

PRINTERS:				;0DB85H
	PUSH	PSW
	PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,LDCA0					;0DCA0H
	SHLD	LDC70+1					;0DC71H
	SHLD	LDC8B+1					;0DC8CH
	MVI	A,'0'	;30H
	STA	LDC9A+1					;0DC9BH
	LDA	PRTBIT4					;0DCE1H
	ANA	A
	JZ	LDBAC					;0DBACH
	LXI	H,LDCC0					;0DCC0H
	SHLD	LDC70+1					;0DC71H
	SHLD	LDC8B+1					;0DC8CH
	MVI	A,' '	;20H
	STA	LDC9A+1					;0DC9BH

LDBAC:					;0DBACH
	LDA	PRTBIT03				;0DCE0H
	CPI	3
	JNC	LDBB8					;0DBB8H
	MOV	A,C
	ANI	7FH
	MOV	C,A

LDBB8:					;0DBB8H
	LDA	PRTBIT03				;0DCE0H
	CPI	0
	JZ	PRT0					;0DC7AH
	CPI	1
	JZ	PRT1					;0DC67H
	CPI	2
	JZ	PRT2					;0DC22H
	CPI	3
	JZ	PRT3					;0DBDEH
	CPI	4
	JZ	PRT4					;0DBFBH
	JMP	LDC7D					;0DC7DH

LDBD7:					;0DBD7H
	DB	1BH,'R',1

LDBDA:					;0DBDAH
	DB	0,1BH,'R',0

PRT3:					;0DBDEH
	MOV	A,C
	CPI	80H
	JC	PRT0					;0DC7AH
	MOV	A,C
	ANI	7FH
	STA	LDBDA					;0DBDAH
	LXI	H,LDBD7					;0DBD7H
	MVI	B,7

LDBEF:					;0DBEFH
	MOV	C,M
	CALL	LO					;0F80FH
	INX	H
	DCR	B
	JNZ	LDBEF					;0DBEFH
	JMP	LDC7D					;0DC7DH

PRT4:					;0DBFBH
	MOV	A,C
	CPI	80H
	JC	PRT2					;0DC22H
	MVI	A,2
	STA	PRTBIT03				;0DCE0H
	MOV	A,C
	ANI	7FH
	STA	LDBDA					;0DBDAH
	LXI	H,LDBD7					;0DBD7H
	MVI	B,7

LDC11:					;0DC11H
	MOV	C,M
	CALL	PRINTERS				;0DB85H
	INX	H
	DCR	B
	JNZ	LDC11					;0DC11H
	MVI	A,4
	STA	PRTBIT03				;0DCE0H
	JMP	LDC7D					;0DC7DH

PRT2:					;0DC22H
	MOV	A,C
	CPI	1BH
	JZ	LDC3B					;0DC3BH
	LDA	LDCE2					;0DCE2H
	ORA	A
	JZ	LDC59					;0DC59H
	CPI	1BH
	JZ	LDC41					;0DC41H
	MOV	A,C
	ANI	1
	STA	LDCE3					;0DCE3H

LDC3A:					;0DC3AH
	XRA	A

LDC3B:					;0DC3BH
	STA	LDCE2					;0DCE2H
	JMP	LDC7D					;0DC7DH

LDC41:					;0DC41H
	MOV	A,C
	CPI	'R'	;52H
	JNZ	LDC4D					;0DC4DH
	STA	LDCE2					;0DCE2H
	JMP	LDC7D					;0DC7DH

LDC4D:					;0DC4DH
	MVI	C,1BH
	CALL	LO					;0F80FH
	MOV	C,A
	CALL	LO					;0F80FH
	JMP	LDC3A					;0DC3AH

LDC59:					;0DC59H
	LDA	LDCE3					;0DCE3H
	CPI	0
	JZ	PRT0					;0DC7AH
	MOV	A,C
	CPI	60H
	JC	LDC82					;0DC82H

PRT1:					;0DC67H
	MOV	A,C
	ANI	7FH
	MOV	C,A
	CPI	60H
	JC	PRT0					;0DC7AH
;
;  modif. komanda

LDC70:					;0DC70H
	LXI	H,LDCA0					;0DCA0H
	MVI	D,0
	SUI	60H
	MOV	E,A
	DAD	D
	MOV	C,M

PRT0:					;0DC7AH
	CALL	LO					;0F80FH

LDC7D:					;0DC7DH
	POP	B
	POP	D
	POP	H
	POP	PSW
	RET

LDC82:					;0DC82H
	MOV	A,C
	ANI	7FH
	MOV	C,A
	CPI	'@'	;40H
	JC	PRT0					;0DC7AH
;
;  modif. komanda

LDC8B:					;0DC8BH
	LXI	H,LDCA0					;0DCA0H
	MVI	D,0
	SUI	'@'	;40H
	MOV	E,A
	DAD	D
	MOV	A,M
	CPI	80H
	JC	LDC9C					;0DC9CH
;
;  modif. komanda

LDC9A:					;0DC9AH
	ADI	'0'	;30H

LDC9C:					;0DC9CH
	MOV	C,A
	JMP	PRT0					;0DC7AH

LDCA0:					;0DCA0H
	DB	0C0H,0A1H,0A2H,0B8H,0A5H,0A6H,0B6H
	DB	0A4H,0B7H,0AAH,0ABH,0ACH,0ADH,0AEH
	DB	0AFH,0B0H,0B1H,0C1H,0B2H,0B3H,0B4H
	DB	0B5H,0A8H,0A3H,0BEH,0BDH,0A9H,0BAH
	DB	0BFH,0BBH,0B9H,5FH

LDCC0:					;0DCC0H
	DB	0CEH,0B0H,0B1H,0C6H,0B4H,0B5H,0C4H
	DB	0B3H,0C5H,0B8H,0B9H,0BAH,0BBH,0BCH
	DB	0BDH,0BEH,0BFH,0CFH,0C0H,0C1H,0C2H
	DB	0C3H,0B6H,0B2H,0CCH,0CBH,0B7H,0C8H
	DB	0CDH,0C9H,0C7H,5FH

PRTBIT03:				;0DCE0H
	DB	02H

PRTBIT4:				;0DCE1H
	DB	00H

LDCE2:					;0DCE2H
	DB	00H

LDCE3:					;0DCE3H
	DB	00H

STATLO:					;0DCE4H
	MVI	A,1
	RET

AUXIN:					;0DCE7H
	JMP	RI					;0F806H

AUXOUT:					;0DCEAH
	JMP	PO					;0F80CH

ADRDPH:					;0DCEDH
	LXI	H,0
	MOV	A,C
	CPI	3
	RNC
	CALL	LDCFD					;0DCFDH
	DW	DPHA					;0DD11H
	DW	DPHB					;0DD21H
	DW	DPHC					;0DD01H

LDCFD:					;0DCFDH
	POP	H
	JMP	HLEQUFROMHLADD2A			;0DB69H

DPHC:					;0DD01H
	DW	XLT					;0E919H
	DW	0
	DW	0
	DW	0
	DW	DIRBUF					;0EA48H
	DW	DPBC					;0E8ECH
	DW	0
	DW	ALVC					;0E961H

DPHA:					;0DD11H
	DW	XLT					;0E919H
	DW	0
	DW	0
	DW	0
	DW	DIRBUF					;0EA48H
	DW	DPBA					;0E8FBH
	DW	CSVA					;0EA08H
	DW	ALVA					;0E982H

DPHB:					;0DD21H
	DW	XLT					;0E919H
	DW	0
	DW	0
	DW	0
	DW	DIRBUF					;0EA48H
	DW	DPBB					;0E90AH
	DW	CSVB					;0EA28H
	DW	ALVB					;0E9B5H

RDWRDISK:				;0DD31H
	PUSH	H
	LXI	H,2
	DAD	SP
	SHLD	LDD6D+1					;0DD6EH
	SHLD	LE52C+1					;0E52DH
	POP	H
	LXI	SP,STACKBIOS				;0EB00H
	MOV	A,M
	CPI	0
	JZ	ABDRIVERS				;0E525H
	CPI	1
	JZ	ABDRIVERS				;0E525H
	PUSH	H
	PUSH	B
	PUSH	D
	LXI	D,DISKDSC				;0E9E8H
	MVI	B,0AH

LDD53:					;0DD53H
	MOV	A,M
	STAX	D
	DCR	B
	INX	H
	INX	D
	JNZ	LDD53					;0DD53H
	LDA	FUNC					;0E9EAH
	CPI	4
	JZ	RDCDISK					;0E84AH
	CPI	6
	JZ	WRCDISK					;0E8B3H
	XRA	A

LDD69:					;0DD69H
	ANA	A
	POP	D
	POP	B
	POP	H
;
;  modif. komanda

LDD6D:					;0DD6DH
	LXI	SP,0
	RET

ERRDISKMSG:				;0DD71H
	PUSH	PSW
	LXI	H,DISKDSC				;0E9E8H
	LXI	D,TXTDISKMSG				;0DD91H
	MVI	B,9

LDD7A:					;0DD7AH
	XCHG
	PUSH	PSW
	CALL	PEC					;0DDC4H
	POP	PSW
	XCHG
	PUSH	H
	PUSH	D
	CALL	LBYTE					;0DDBEH
	POP	D
	POP	H
	MOV	A,M
	INX	H
	INX	D
	DCR	B
	JNZ	LDD7A					;0DD7AH
	POP	PSW
	RET

TXTDISKMSG:				;0DD91H
	DB	0DH,0AH,'ER=',0,'  D=',0
	DB	' CHW=',0,' OP=',0,' NS='
	DB	0,' T=',0,' S=',0,' A2='
	DB	0,' A1=',0

LBYTE:					;0DDBEH
	PUSH	B
	CALL	LABYTE					;0DDD1H
	POP	B
	RET

PEC:					;0DDC4H
	MOV	A,M
	ANA	A
	RZ
	PUSH	B
	MOV	C,M
	CALL	COBDOS					;0E005H
	POP	B
	INX	H
	JMP	PEC					;0DDC4H

LABYTE:					;0DDD1H
	MOV	B,A
	MOV	A,B
	RRC
	RRC
	RRC
	RRC
	CALL	LLOW					;0DDDBH
	MOV	A,B

LLOW:					;0DDDBH
	ANI	0FH
	CPI	0AH
	JM	LDDE4					;0DDE4H
	ADI	7

LDDE4:					;0DDE4H
	ADI	'0'	;30H
	MOV	C,A
	JMP	COBDOS					;0E005H

CPREPARE:				;0DDEAH
	LDA	TRACK					;0E9ECH
	LXI	H,RAMDISKTAB				;0DE38H
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	A,M
	RRC
	RRC
	RRC
	RRC
	MOV	H,A
	ANI	0CH
	ORI	10H
	MOV	B,A
	MOV	A,H
	RRC
	RRC
	ORI	3
	MOV	H,A
	MVI	L,0FFH
	INX	H
	LDA	SEKTOR					;0E9EDH
	LXI	D,0FF80H

LDE0E:					;0DE0EH
	DCR	A
	JZ	LDE16					;0DE16H
	DAD	D
	JMP	LDE0E					;0DE0EH

LDE16:					;0DE16H
	SHLD	DISKCADR				;0E9F2H
	MVI	A,'#'	;23H
	ADD	B
	STA	BANK					;0E9F4H
	LDA	TRACK					;0E9ECH
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	LDA	SEKTOR					;0E9EDH
	DCR	A
	ADD	A
	ADD	L
	MOV	L,A
	LXI	D,0F000H
	DAD	D
	SHLD	ADRCSUM					;0E9F5H
	RET

RAMDISKTAB:				;0DE38H
	DB	0FBH,0FAH,0F9H,0F8H,0E7H,0E6H,0E5H
	DB	0E4H,0E3H,0E2H,0E1H,0E0H,0DFH,0DEH
	DB	0DDH,0DCH,0DBH,0DAH,0D9H,0D8H,0D7H
	DB	0D6H,0D5H,0D4H,0D3H,0D2H,0D1H,0D0H
	DB	0CFH,0CEH,0CDH,0CCH,0CBH,0CAH,0C9H
	DB	0C8H,0C7H,0C6H,0C5H,0C4H,0C3H,0C2H
	DB	0C1H,0C0H
;
;  bank 2
	DB	0BFH,0BEH,0BDH,0BCH,0BBH,0BAH,0B9H
	DB	0B8H,0B7H,0B6H,0B5H,0B4H,0B3H,0B2H
	DB	0B1H,0B0H,0AFH,0AEH,0ADH,0ACH,0ABH
	DB	0AAH,0A9H,0A8H,0A7H,0A6H,0A5H,0A4H
	DB	0A3H,0A2H,0A1H,0A0H,9FH,9EH,9DH
	DB	9CH,9BH,9AH,99H,98H,97H,96H
	DB	95H,94H,93H,92H,91H,90H,8FH
	DB	8EH,8DH,8CH,8BH,8AH,89H,88H
	DB	87H,86H,85H,84H,83H,82H,81H
	DB	80H
;
;  bank 1
	DB	7FH,7EH,7DH,7CH,7BH,7AH,79H
	DB	78H,77H,76H,75H,74H,73H,72H
	DB	71H,70H,6FH,6EH,6DH,6CH,6BH
	DB	6AH,69H,68H,67H,66H,65H,64H
	DB	63H,62H,61H,60H,5FH,5EH,5DH
	DB	5CH,5BH,5AH,59H,58H,57H,56H
	DB	55H,54H,53H,52H,51H,50H,4FH
	DB	4EH,4DH,4CH,4BH,4AH,49H,48H
	DB	47H,46H,45H,44H,43H,42H,41H
	DB	40H
;
;  bank 0
	DB	3FH,3EH,3DH,3CH,3BH,3AH,39H
	DB	38H,37H,36H,35H,34H,33H,32H
	DB	31H,30H,2FH,2EH,2DH,2CH,2BH
	DB	2AH,29H,28H,27H,26H,25H,24H
	DB	23H,22H,21H,20H,1FH,1EH,1DH
	DB	1CH,1BH,1AH,19H,18H,17H,16H
	DB	15H,14H,13H,12H,11H,10H,0FH
	DB	0EH,0DH,0CH,0BH,0AH,09H,08H
	DB	07H,06H,05H,04H,03H,02H,01H
	DB	00H

USERK0:					;0DF24H
	CALL	CRLF					;0E4EBH
	LXI	D,FCB+1					;5DH
	LDAX	D
	CALL	HEXSTRING				;0E128H
	LXI	D,FCB+17				;6DH
	LDAX	D
	CPI	'R'	;52H
	JZ	SETRDELAY				;0DF53H
	CPI	'W'	;57H
	JZ	SETWDELAY				;0DF58H
	CPI	'A'	;41H
	JZ	SETSCREEN				;0DF5DH
	CPI	'P'	;50H
	JZ	SETCOLOR				;0DF69H
	CPI	'L'	;4CH
	JZ	SETPRINTER				;0DF78H
	CPI	'M'	;4DH
	JZ	SETLISTPRINTER				;0DF8AH
	JMP	AMBNAME					;0E121H

SETRDELAY:				;0DF53H
	MOV	A,L
	STA	RDELAY					;0FFC5H
	RET

SETWDELAY:				;0DF58H
	MOV	A,L
	STA	WDELAY					;0FFC4H
	RET

SETSCREEN:				;0DF5DH
	PUSH	H
	MVI	C,1BH

LDF60:					;0DF60H
	CALL	CONOUT					;0DB7BH
	POP	H
	MOV	C,L
	CALL	CONOUT					;0DB7BH
	RET

SETCOLOR:				;0DF69H
	PUSH	H
	MVI	C,1BH
	CALL	CONOUT					;0DB7BH
	MVI	C,'P'	;50H
	CALL	CONOUT					;0DB7BH
	MOV	C,H
	JMP	LDF60					;0DF60H

SETPRINTER:				;0DF78H
	MOV	A,L
	CPI	0FH
	JNC	AMBNAME					;0E121H
	ANI	8
	STA	PRTBIT4					;0DCE1H
	MOV	A,L
	ANI	7
	STA	PRTBIT03				;0DCE0H
	RET

SETLISTPRINTER:				;0DF8AH
	MOV	A,L
	STA	BETWEEN					;0DFA9H
	MOV	A,H
	STA	HIGHPRT					;0DFAFH
	LXI	H,LDFA0					;0DFA0H

LDF95:					;0DF95H
	MOV	C,M
	XRA	A
	CMP	M
	RZ
	INX	H
	CALL	LO					;0F80FH
	JMP	LDF95					;0DF95H

LDFA0:					;0DFA0H
	DB	1BH,'M',1BH,'S0',1BH,0FH
	DB	1BH,'3'

BETWEEN:				;0DFA9H
	DB	12H,1BH,'N',6,1BH,'C'

HIGHPRT:				;0DFAFH
	DB	0CH,7,0

READTAPEANDINF:				;0DFB2H
	CALL	FROMTAPE				;0E012H
	PUSH	D
	PUSH	PSW
	LXI	H,FCB+1					;5DH
	MOV	M,D
	LXI	H,PROGRAM				;0100H
	CALL	LADDR					;0DFF7H
	XCHG
	CALL	LADDR					;0DFF7H
	LHLD	BGNTAPE					;0E9F7H
	CALL	LADDR					;0DFF7H
	LHLD	ENDTAPE					;0E9F9H
	CALL	LADDR					;0DFF7H
	LXI	H,FCB+17				;6DH

TYPEFILENAME:				;0DFD4H
	MVI	B,8

LDFD6:					;0DFD6H
	MOV	C,M
	CALL	COBDOS					;0E005H
	INX	H
	DCR	B
	JNZ	LDFD6					;0DFD6H
	MVI	C,'.'	;2EH
	CALL	COBDOS					;0E005H
	MVI	B,3

LDFE6:					;0DFE6H
	MOV	C,M
	INX	H
	CALL	COBDOS					;0E005H
	DCR	B
	JNZ	LDFE6					;0DFE6H
	MVI	C,' '	;20H
	CALL	COBDOS					;0E005H
	POP	PSW
	POP	D
	RET

LADDR:					;0DFF7H
	MOV	A,H
	CALL	LBYTE					;0DDBEH
	MOV	A,L
	CALL	LBYTE					;0DDBEH
	MVI	C,' '	;20H
	CALL	COBDOS					;0E005H
	RET

COBDOS:					;0E005H
	PUSH	PSW
	PUSH	B
	PUSH	H
	PUSH	D
	MOV	E,C
	CALL	BDOSCONOUT				;0E4E1H
	POP	D
	POP	H
	POP	B
	POP	PSW
	RET

FROMTAPE:				;0E012H
	CALL	CRLF					;0E4EBH
	CALL	PO					;0F80CH
	HLT
	DI

LE01A:					;0E01AH
	LXI	B,4008H

LE01D:					;0E01DH
	MOV	A,C
	CALL	RI					;0F806H
	CPI	0
	JZ	LE02B					;0E02BH
	CPI	0FFH
	JNZ	LE01A					;0E01AH

LE02B:					;0E02BH
	DCR	B
	JNZ	LE01D					;0E01DH
	MVI	A,0FFH
	CALL	RI					;0F806H
	MOV	H,A
	MOV	A,C
	CALL	RI					;0F806H
	MOV	L,A
	MOV	A,C
	CALL	RI					;0F806H
	MOV	D,A
	MOV	A,C
	CALL	RI					;0F806H
	MOV	E,A
	SHLD	BGNTAPE					;0E9F7H
	XCHG
	SHLD	ENDTAPE					;0E9F9H
	MOV	A,E
	CMA
	MOV	E,A
	MOV	A,D
	CMA
	MOV	D,A
	DAD	D
	INX	H
	LXI	D,PROGRAM				;0100H
	DAD	D
	XCHG
	MVI	B,0

LE05A:					;0E05AH
	MOV	A,C
	CALL	RI					;0F806H
	MOV	M,A
	ADD	B
	MOV	B,A
	CALL	CHECKMAXADR				;0E10BH
	INX	H
	JNZ	LE05A					;0E05AH
	MOV	A,C
	DCX	H
	XCHG
	CALL	RI					;0F806H
	CMP	B
	JZ	READFILENAME				;0E07CH
	LXI	H,TXTIOERR				;0E0A9H

LE075:					;0E075H
	CALL	PEC					;0DDC4H
	MVI	A,0FFH
	ANA	A
	RET

READFILENAME:				;0E07CH
	MVI	C,0BH
	LXI	H,FCB+17				;6DH

LE081:					;0E081H
	MVI	A,8
	CALL	RI					;0F806H
	MOV	M,A
	ADD	B
	MOV	B,A
	INX	H
	DCR	C
	JNZ	LE081					;0E081H
	MVI	A,8
	CALL	RI					;0F806H
	CMP	B
	LXI	H,TXTNAMEERR				;0E09DH
	MVI	A,0
	CNZ	LE075					;0E075H
	RET

TXTNAMEERR:				;0E09DH
	DB	'NAME ERROR-',0

TXTIOERR:				;0E0A9H
	DB	'I/O ERRORS-',0

TOTAPE:					;0E0B5H
	CALL	CRLF					;0E4EBH
	CALL	DELAYTURNONTAPE				;0E119H
	DI
	XRA	A
	MOV	B,A

LE0BE:					;0E0BEH
	CALL	PO					;0F80CH
	DCR	B
	JNZ	LE0BE					;0E0BEH
	MVI	A,0E6H
	CALL	PO					;0F80CH
	MVI	A,1
	MOV	H,A
	CALL	PO					;0F80CH
	XRA	A
	MOV	L,A
	CALL	PO					;0F80CH
	LDA	FCB+17					;6DH
	MOV	D,A
	CALL	PO					;0F80CH
	MVI	A,0FFH
	MOV	E,A
	CALL	PO					;0F80CH
	MVI	B,0

LE0E4:					;0E0E4H
	MOV	A,M
	ADD	B
	MOV	B,A
	MOV	A,M
	CALL	PO					;0F80CH
	CALL	CHECKMAXADR				;0E10BH
	INX	H
	JNZ	LE0E4					;0E0E4H
	MOV	A,B
	CALL	PO					;0F80CH
	LXI	H,FCB+1					;5DH
	MVI	C,0BH

LE0FB:					;0E0FBH
	MOV	A,M
	CALL	PO					;0F80CH
	ADD	B
	MOV	B,A
	INX	H
	DCR	C
	JNZ	LE0FB					;0E0FBH
	MOV	A,B
	CALL	PO					;0F80CH
	RET

CHECKMAXADR:				;0E10BH
	IN	1
	ANI	'@'	;40H
	RZ
	MOV	A,H
;
;  prowerka na perese~enie s BDOS
	CPI	0B8H
	RZ
	CMP	D
	RNZ
	MOV	A,E
	CMP	L
	RET

DELAYTURNONTAPE:			;0E119H
	MVI	A,96H

LE11B:					;0E11BH
	HLT
	DCR	A
	JNZ	LE11B					;0E11BH
	RET

AMBNAME:				;0E121H
	LXI	D,AMBNAMETXT				;0E450H
	CALL	TYPE					;0E4EEH
	RET

HEXSTRING:				;0E128H
	LXI	H,0

HEXCHAR:				;0E12BH
	LDAX	D
	INX	D
	CPI	' '	;20H
	RZ
	SUI	'0'	;30H
	JM	NOTHEX					;0E152H
	CPI	0AH
	JM	DECHEX					;0E146H
	CPI	11H
	JM	NOTHEX					;0E152H
	CPI	17H
	JP	NOTHEX					;0E152H
	SUI	7

DECHEX:					;0E146H
	MOV	C,A
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	JC	NOTHEX					;0E152H
	DAD	B
	JMP	HEXCHAR					;0E12BH

NOTHEX:					;0E152H
	CALL	AMBNAME					;0E121H
	LXI	D,FCB					;5CH
	CALL	CLOSEFILE				;0E4F8H
	STC
	RET

WRITE128:				;0E15DH
	PUSH	H
	PUSH	B
	XCHG
	CALL	SETDMA					;0E520H
	LXI	D,FCB					;5CH
	CALL	WRITE					;0E511H
	LXI	D,DISKFULLTXT				;0E170H
	ORA	A
	POP	B
	POP	H
	RET

DISKFULLTXT:				;0E170H
	DB	'OUT OF DATA SPACE$'

DIRFULLTXT:				;0E182H
	DB	'NO DIRECTORY SPACE$'

OKTXT:					;0E195H
	DB	0DH,0AH,' OK$'

USERK1:					;0E19BH
	CALL	CRLF					;0E4EBH
	LXI	D,FCB+1					;5DH
	CALL	HEXSTRING				;0E128H
	RC

STORETODISK:				;0E1A5H
	XRA	A
	CMP	L
	JZ	AMBNAME					;0E121H
	SHLD	QBLCSTORE				;0E95FH
	LXI	D,FCB					;5CH
	LXI	H,FCB+16				;6CH
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	MVI	B,0BH

LE1B9:					;0E1B9H
	MOV	A,M
	STAX	D
	ANI	7FH
	CPI	0
	JZ	LE1E0					;0E1E0H
	CPI	' '	;20H
	JZ	LE1E0					;0E1E0H
	CPI	'?'	;3FH
	JZ	AMBNAME					;0E121H
	CPI	5BH
	JNC	AMBNAME					;0E121H
	CPI	'A'	;41H
	JNC	LE1E0					;0E1E0H
	CPI	'/'	;2FH
	JC	AMBNAME					;0E121H
	CPI	':'	;3AH
	JNC	AMBNAME					;0E121H

LE1E0:					;0E1E0H
	INX	D
	INX	H
	DCR	B
	JNZ	LE1B9					;0E1B9H
	MVI	B,19H

LE1E8:					;0E1E8H
	XRA	A
	STAX	D
	INX	D
	DCR	B
	JNZ	LE1E8					;0E1E8H
	LXI	D,FCB					;5CH
	CALL	DELETEFILE				;0E507H
	LXI	D,FCB					;5CH
	CALL	CREATEFILE				;0E516H
	LXI	D,DIRFULLTXT				;0E182H
	INR	A
	JZ	LE22A					;0E22AH
	LDA	QBLCSTORE				;0E95FH
	MOV	B,A
	LXI	H,PROGRAM				;0100H

LE209:					;0E209H
	CALL	WRITE128				;0E15DH
	JNZ	LE22A					;0E22AH
	LXI	D,SYSDMA				;80H
	DAD	D
	CALL	WRITE128				;0E15DH
	JNZ	LE22A					;0E22AH
	LXI	D,SYSDMA				;80H
	DAD	D
	DCR	B
	JNZ	LE209					;0E209H
	LXI	D,FCB					;5CH
	CALL	CLOSEFILE				;0E4F8H
	LXI	D,OKTXT					;0E195H

LE22A:					;0E22AH
	CALL	TYPE					;0E4EEH
	RET

USERK2:					;0E22EH
	CALL	CRLF					;0E4EBH
	LXI	D,FCB+1					;5DH
	CALL	HEXSTRING				;0E128H
	MOV	C,L
	XRA	A
	CMP	L
	RZ
	LXI	H,FCB+16				;6CH
	MOV	A,M
	STA	AUXCELL					;0EA06H
	INX	H
	LXI	D,FILENAME				;0E9FBH
	MVI	A,' '	;20H
	CMP	M
	RZ
	MVI	B,0BH

LE24C:					;0E24CH
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	LE24C					;0E24CH

LE254:					;0E254H
	PUSH	B
	CALL	READTAPEANDINF				;0DFB2H
	POP	B
	CPI	0
	RNZ
	LXI	H,FCB+16				;6CH
	LDA	AUXCELL					;0EA06H
	MOV	M,A
	INX	H
	LXI	D,FILENAME				;0E9FBH
	MVI	B,0BH

LE269:					;0E269H
	LDAX	D
	CPI	'?'	;3FH
	JZ	LE273					;0E273H
	CMP	M
	JNZ	LE254					;0E254H

LE273:					;0E273H
	INX	D
	INX	H
	DCR	B
	JNZ	LE269					;0E269H
	LHLD	FCB+1					;5DH
	PUSH	B
	CALL	STORETODISK				;0E1A5H
	POP	B
	DCR	C
	JNZ	LE254					;0E254H
	RET

USERK3:					;0E286H
	MVI	C,0
	PUSH	B
	CALL	CRLF					;0E4EBH
	MVI	C,0BH
	LXI	H,FCB+1					;5DH
	LXI	D,FILENAME				;0E9FBH

LE294:					;0E294H
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	LE294					;0E294H

LE29C:					;0E29CH
	LXI	D,SYSDMA				;80H
	CALL	SETDMA					;0E520H
	CALL	PREPFCB					;0E35EH
	CALL	FRSTSEARCH				;0E4FDH
	LXI	D,NOFILETXT				;0E45FH
	POP	B
	MOV	B,A
	CPI	4
	JNC	TYPE					;0E4EEH
	PUSH	B
	MVI	E,0FFH
	CALL	DIRECTCONSOL				;0E4E6H
	POP	B
	ANA	A
	LXI	D,TXTCRLF				;0E469H
	JNZ	TYPE					;0E4EEH
	MOV	A,C
	CPI	0
	JNZ	NEXTFILES				;0E2D6H
	STA	COUNT					;0EA07H
	MOV	A,B
	CALL	READFILEFROMDISK			;0E2FDH
	INR	C
	MOV	A,C
	STA	COUNT					;0EA07H
	PUSH	B
	JMP	LE29C					;0E29CH

NEXTFILES:				;0E2D6H
	PUSH	B

LE2D7:					;0E2D7H
	PUSH	B
	LXI	D,SYSDMA				;80H
	CALL	SETDMA					;0E520H
	CALL	PREPFCB					;0E35EH
	CALL	NEXTSEARCH				;0E502H
	POP	B
	CPI	4
	JNC	LE2FB					;0E2FBH
	DCR	C
	JNZ	LE2D7					;0E2D7H
	CALL	READFILEFROMDISK			;0E2FDH
	POP	B
	INR	C
	MOV	A,C
	STA	COUNT					;0EA07H
	PUSH	B
	JMP	LE29C					;0E29CH

LE2FB:					;0E2FBH
	POP	B
	RET

READFILEFROMDISK:			;0E2FDH
	PUSH	B
	LXI	H,SYSDMA+1				;81H
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	L
	MOV	L,A
	XCHG
	CALL	PREPFINDEDFCB				;0E361H
	CALL	OPENFILE				;0E4F3H
	XRA	A
	STA	FCB+32					;7CH
	LXI	D,PROGRAM				;0100H

LE316:					;0E316H
	PUSH	D
	CALL	SETDMA					;0E520H
	LXI	D,FCB					;5CH
	CALL	READ					;0E50CH
	CPI	1
	JZ	LE33C					;0E33CH
	POP	D
	LXI	H,SYSDMA				;80H
	DAD	D
	XCHG
	MOV	A,D
;
;  prowerka na perese~enie s BDOS
	CPI	0B8H
	JZ	LE35C					;0E35CH
	JMP	LE316					;0E316H

LE334:					;0E334H
	PUSH	D
	PUSH	PSW
	LXI	H,FCB+1					;5DH
	JMP	TYPEFILENAME				;0DFD4H

LE33C:					;0E33CH
	CALL	LE334					;0E334H
	POP	D
	MOV	A,E
	CPI	0
	JZ	LE347					;0E347H
	INR	D

LE347:					;0E347H
	DCR	D
	POP	B
	MOV	L,D
	LDA	COUNT					;0EA07H
	MOV	H,A
	INR	H
	PUSH	B
	PUSH	D
	CALL	LADDR					;0DFF7H
	POP	D
	MOV	A,D
	STA	FCB+17					;6DH
	CALL	TOTAPE					;0E0B5H

LE35C:					;0E35CH
	POP	B
	RET

PREPFCB:				;0E35EH
	LXI	D,FILENAME				;0E9FBH

PREPFINDEDFCB:				;0E361H
	MVI	C,0BH
	LXI	H,FCB+1					;5DH

LE366:					;0E366H
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	LE366					;0E366H
	MVI	C,18H

LE370:					;0E370H
	XRA	A
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE370					;0E370H
	LXI	D,FCB					;5CH
	RET

USERK5:					;0E37BH
	LXI	D,FCB					;5CH
	CALL	RENAMEFILE				;0E51BH
	CPI	4
	LXI	D,OKTXT					;0E195H
	JC	TYPE					;0E4EEH
	LXI	D,AMBNAMETXT				;0E450H
	JMP	TYPE					;0E4EEH

USERK4:					;0E38FH
	RET

CLEARCDISK:				;0E390H
	MVI	A,6
	JMP	WORKWITHALLCDISK			;0E397H

USERK8:					;0E395H
	MVI	A,4

WORKWITHALLCDISK:			;0E397H
	STA	FUNC					;0E9EAH
	LXI	D,1
	LXI	H,DIRBUF				;0EA48H
	SHLD	ABUFF					;0E9EEH
	MVI	C,80H
	MVI	A,0E5H

LE3A7:					;0E3A7H
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE3A7					;0E3A7H
	MVI	A,2
	STA	DISKDSC					;0E9E8H

LE3B2:					;0E3B2H
	MOV	A,E
	STA	SEKTOR					;0E9EDH
	MOV	A,D
	STA	TRACK					;0E9ECH
	LHLD	ABUFF					;0E9EEH
	PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,DISKDSC				;0E9E8H
	CALL	RDWRDISK				;0DD31H
	CNZ	ERRDISKMSG				;0DD71H
	POP	B
	POP	D
	POP	H
	SHLD	ABUFF					;0E9EEH
	INR	E
	MOV	A,E
	CPI	9
	JNZ	LE3B2					;0E3B2H
	MVI	E,1
	INR	D
	MOV	A,D
;
;  dlq kwazidiska 235k tolxko !!!
	CPI	0ECH
	JNZ	LE3B2					;0E3B2H
	XRA	A
	RET

ADRMESSAGE:				;0E3E1H
	LXI	H,LE3E5					;0E3E5H
	RET

LE3E5:					;0E3E5H
	DW	BDOSERRTXT				;0E3FFH
	DW	DISKERRTXT				;0E40EH
	DW	NOTTXT					;0E41AH
	DW	SYSFILETXT				;0E41BH
	DW	DELETETXT				;0E46CH
	DW	SPACETXT				;0E431H
	DW	IGNORETXT				;0E433H
	DW	FILEEXTXT				;0E443H
	DW	ROTXT					;0E4D7H
	DW	NOFILETXT				;0E45FH
	DW	NOFILETXT				;0E45FH
	DW	ADVERT					;0E47EH
	DW	ADVERT					;0E47EH

BDOSERRTXT:				;0E3FFH
	DB	'BDOS ERROR ON $'

DISKERRTXT:				;0E40EH
	DB	' DISK ERROR$'

NOTTXT:					;0E41AH
	DB	'$'

SYSFILETXT:				;0E41BH
	DB	' SYSTEM FILE$SELECT  $'

SPACETXT:				;0E431H
	DB	' $'

IGNORETXT:				;0E433H
	DB	'IGNORE (Y/N) ? $'

FILEEXTXT:				;0E443H
	DB	' FILE EXISTS$'

AMBNAMETXT:				;0E450H
	DB	'AMBIGOUSE NAME$'

NOFILETXT:				;0E45FH
	DB	0DH,0AH,'NO FILES'

TXTCRLF:				;0E469H
	DB	0DH,0AH,'$'

DELETETXT:				;0E46CH
	DB	0DH,0AH,'DELETE (Y/N) ? $'

ADVERT:					;0E47EH
	DB	1BH,']',1BH,'b',0DH,0AH,' '
	DB	'  *   VECTOR-06C   *   '
	DB	0DH,0AH,'  *  BIOS VER(3.11) '
	DB	' *  ',0DH,0AH,'   * ABC-DISK '
	DB	'DRIVE *   ',1BH,'^',1BH
	DB	'a',0DH,0AH,'$'

ROTXT:					;0E4D7H
	DB	' FILE R/O$'

BDOSCONOUT:				;0E4E1H
	MVI	C,2
	JMP	BDOSENTER				;5

DIRECTCONSOL:				;0E4E6H
	MVI	C,6
	JMP	BDOSENTER				;5

CRLF:					;0E4EBH
	LXI	D,TXTCRLF				;0E469H

TYPE:					;0E4EEH
	MVI	C,9
	JMP	BDOSENTER				;5

OPENFILE:				;0E4F3H
	MVI	C,0FH
	JMP	BDOSENTER				;5

CLOSEFILE:				;0E4F8H
	MVI	C,10H
	JMP	BDOSENTER				;5

FRSTSEARCH:				;0E4FDH
	MVI	C,11H
	JMP	BDOSENTER				;5

NEXTSEARCH:				;0E502H
	MVI	C,12H
	JMP	BDOSENTER				;5

DELETEFILE:				;0E507H
	MVI	C,13H
	JMP	BDOSENTER				;5

READ:					;0E50CH
	MVI	C,14H
	JMP	BDOSENTER				;5

WRITE:					;0E511H
	MVI	C,15H
	JMP	BDOSENTER				;5

CREATEFILE:				;0E516H
	MVI	C,16H
	JMP	BDOSENTER				;5

RENAMEFILE:				;0E51BH
	MVI	C,17H
	JMP	BDOSENTER				;5

SETDMA:					;0E520H
	MVI	C,1AH
	JMP	BDOSENTER				;5

ABDRIVERS:				;0E525H
	SHLD	LE945					;0E945H
	CALL	LE530					;0E530H
	ORA	A
;
;  modif. komanda

LE52C:					;0E52CH
	LXI	SP,0
	RET

LE530:					;0E530H
	MOV	A,M
	STA	LE948					;0E948H
	INX	H
	INX	H
	MOV	A,M
	STA	LE947					;0E947H
	INX	H
	INX	H
	MOV	A,M
	STA	LE949					;0E949H
	INX	H
	MOV	A,M
	DCR	A
	STA	LE94B					;0E94BH
	INX	H
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	SHLD	LE95D					;0E95DH
	LDA	LE947					;0E947H
	CPI	4
	JZ	LE55D					;0E55DH
	CPI	6
	JZ	LE571					;0E571H
	XRA	A
	RET

LE55D:					;0E55DH
	XRA	A
	STA	LE954					;0E954H
	MVI	A,1
	STA	LE951					;0E951H
	STA	LE952					;0E952H
	MVI	A,2
	STA	LE950					;0E950H
	JMP	LE603					;0E603H

LE571:					;0E571H
	XRA	A
	STA	LE951					;0E951H
	LDA	LE95E					;0E95EH
	CPI	0EAH
	MVI	C,1
	JZ	LE59C					;0E59CH
	PUSH	D
	LDA	LE949					;0E949H
	SUI	0
	MOV	D,A
	LDA	LE94B					;0E94BH

LE589:					;0E589H
	DCR	D
	JZ	LE592					;0E592H
	ADI	'('	;28H
	JMP	LE589					;0E589H

LE592:					;0E592H
	POP	D
	ANI	0FH
	MVI	C,0
	JNZ	LE59C					;0E59CH
	MVI	C,2

LE59C:					;0E59CH
	MOV	A,C
	STA	LE950					;0E950H
	CPI	2
	JNZ	LE5BC					;0E5BCH
	MVI	A,10H
	STA	LE954					;0E954H
	LDA	LE948					;0E948H
	STA	LE955					;0E955H
	LHLD	LE949					;0E949H
	SHLD	LE956					;0E956H
	LDA	LE94B					;0E94BH
	STA	LE958					;0E958H

LE5BC:					;0E5BCH
	LDA	LE954					;0E954H
	ORA	A
	JZ	LE5FB					;0E5FBH
	DCR	A
	STA	LE954					;0E954H
	LDA	LE948					;0E948H
	LXI	H,LE955					;0E955H
	CMP	M
	JNZ	LE5FB					;0E5FBH
	LXI	H,LE956					;0E956H
	CALL	LE6A2					;0E6A2H
	JNZ	LE5FB					;0E5FBH
	LDA	LE94B					;0E94BH
	LXI	H,LE958					;0E958H
	CMP	M
	JNZ	LE5FB					;0E5FBH
	INR	M
	MOV	A,M
	CPI	'('	;28H
	JC	LE5F4					;0E5F4H
	MVI	M,0
	LHLD	LE956					;0E956H
	INX	H
	SHLD	LE956					;0E956H

LE5F4:					;0E5F4H
	XRA	A
	STA	LE952					;0E952H
	JMP	LE603					;0E603H

LE5FB:					;0E5FBH
	XRA	A
	STA	LE954					;0E954H
	INR	A
	STA	LE952					;0E952H

LE603:					;0E603H
	XRA	A
	STA	LE953					;0E953H
	LDA	LE94B					;0E94BH
	ORA	A
	RAR
	ORA	A
	RAR
	ORA	A
	RAR
	STA	LE959					;0E959H
	LXI	H,LE95A					;0E95AH
	MOV	A,M
	MVI	M,1
	ORA	A
	JZ	LE641					;0E641H
	LDA	LE948					;0E948H
	LXI	H,LE94C					;0E94CH
	CMP	M
	JNZ	LE63A					;0E63AH
	LXI	H,LE94D					;0E94DH
	CALL	LE6A2					;0E6A2H
	JNZ	LE63A					;0E63AH
	LDA	LE959					;0E959H
	LXI	H,LE94F					;0E94FH
	CMP	M
	JZ	LE65E					;0E65EH

LE63A:					;0E63AH
	LDA	LE95B					;0E95BH
	ORA	A
	CNZ	LE6AE					;0E6AEH

LE641:					;0E641H
	LDA	LE948					;0E948H
	STA	LE94C					;0E94CH
	LHLD	LE949					;0E949H
	SHLD	LE94D					;0E94DH
	LDA	LE959					;0E959H
	STA	LE94F					;0E94FH
	LDA	LE952					;0E952H
	ORA	A
	CNZ	LE76F					;0E76FH
	XRA	A
	STA	LE95B					;0E95BH

LE65E:					;0E65EH
	LDA	LE94B					;0E94BH
	ANI	7
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	LXI	D,STACKBIOS				;0EB00H
	DAD	D
	XCHG
	LHLD	LE95D					;0E95DH
	MVI	C,80H
	LDA	LE951					;0E951H
	ORA	A
	JNZ	LE684					;0E684H
	MVI	A,1
	STA	LE95B					;0E95BH
	XCHG

LE684:					;0E684H
	LDAX	D
	INX	D
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE684					;0E684H
	LDA	LE950					;0E950H
	CPI	1
	LDA	LE953					;0E953H
	RNZ
	ORA	A
	RNZ
	XRA	A
	STA	LE95B					;0E95BH
	CALL	LE6AE					;0E6AEH
	LDA	LE953					;0E953H
	RET

LE6A2:					;0E6A2H
	XCHG
	LXI	H,LE949					;0E949H
	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	LDAX	D
	CMP	M
	RET

LE6AE:					;0E6AEH
	CALL	LE72F					;0E72FH
	JNZ	LE708					;0E708H
	CALL	LE792					;0E792H
	JNZ	LE708					;0E708H
	DI
	PUSH	H
	MVI	A,0A0H
	CALL	LE724					;0E724H

LE6C1:					;0E6C1H
	IN	1BH
	ANA	E
	JZ	LE6C1					;0E6C1H
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE6C1					;0E6C1H
	INR	H

LE6CF:					;0E6CFH
	IN	1BH
	ANA	E
	JZ	LE6CF					;0E6CFH
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE6CF					;0E6CFH
	INR	H

LE6DD:					;0E6DDH
	IN	1BH
	ANA	E
	JZ	LE6DD					;0E6DDH
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE6DD					;0E6DDH
	INR	H

LE6EB:					;0E6EBH
	IN	1BH
	ANA	E
	JZ	LE6EB					;0E6EBH
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE6EB					;0E6EBH
	INR	H

LE6F9:					;0E6F9H
	CALL	LE768					;0E768H
	POP	H
	LDA	LE95C					;0E95CH
	OUT	1CH
	IN	1BH
	ANI	0DDH
	EI
	RZ

LE708:					;0E708H
	STA	LE953					;0E953H
	LDA	LE947					;0E947H
	CPI	6
	JZ	LE71F					;0E71FH
	XRA	A
	STA	LE954					;0E954H
	STA	LE95A					;0E95AH
	MVI	A,1
	STA	LE952					;0E952H

LE71F:					;0E71FH
	LDA	LE953					;0E953H
	ANA	A
	RET

LE724:					;0E724H
	MVI	E,2
	OUT	1BH

LE728:					;0E728H
	IN	1BH
	RRC
	JNC	LE728					;0E728H
	RET

LE72F:					;0E72FH
	LDA	LE94C					;0E94CH
	ANI	3
	ORI	'0'	;30H
	STA	LE95C					;0E95CH
	MVI	H,4
	LDA	LE94D					;0E94DH
	ANI	1
	JZ	LE74C					;0E74CH
	LDA	LDB1E					;0DB1EH
	ANA	A
	JZ	LE74C					;0E74CH
	MVI	H,0

LE74C:					;0E74CH
	LDA	LE95C					;0E95CH
	ORA	H
	STA	LE95C					;0E95CH

LE753:					;0E753H
	LDA	LE95C					;0E95CH
	OUT	1CH
	IN	1BH
	RLC
	JNC	LE764					;0E764H
	CALL	LE768					;0E768H
	JMP	LE753					;0E753H

LE764:					;0E764H
	MVI	A,0D0H
	OUT	1BH

LE768:					;0E768H
	MVI	A,80H

LE76A:					;0E76AH
	DCR	A
	JNZ	LE76A					;0E76AH
	RET

LE76F:					;0E76FH
	CALL	LE72F					;0E72FH
	CALL	LE792					;0E792H
	JNZ	LE708					;0E708H
	DI
	PUSH	H
	LXI	D,LE6F9					;0E6F9H
	PUSH	D
	MVI	A,80H
	CALL	LE724					;0E724H

LE783:					;0E783H
	IN	1BH
	RRC
	RNC
	RRC
	JNC	LE783					;0E783H
	IN	18H
	MOV	M,A
	INX	H
	JMP	LE783					;0E783H

LE792:					;0E792H
	LDA	LE94C					;0E94CH
	ANI	3
	MOV	L,A
	MVI	H,0
	LXI	D,LE941					;0E941H
	DAD	D
	LDA	LDB1E					;0DB1EH
	ANA	A
	MOV	A,M
	JZ	LE7A8					;0E7A8H
	ORA	A
	RAR

LE7A8:					;0E7A8H
	MOV	D,A
	IN	1AH
	CMP	D
	MOV	A,D
	OUT	1AH
	LDA	LE94D					;0E94DH
	MOV	M,A
	JZ	LE7C6					;0E7C6H
	LDA	LDB1E					;0DB1EH
	ANA	A
	MOV	A,M
	JZ	LE7C0					;0E7C0H
	ORA	A
	RAR

LE7C0:					;0E7C0H
	MOV	E,A
	OUT	18H
	JMP	LE7D7					;0E7D7H

LE7C6:					;0E7C6H
	LDA	LDB1E					;0DB1EH
	ANA	A
	MOV	A,M
	JZ	LE7D0					;0E7D0H
	ORA	A
	RAR

LE7D0:					;0E7D0H
	MOV	E,A
	OUT	18H
	CMP	D
	JZ	LE823					;0E823H

LE7D7:					;0E7D7H
	CMP	D
	JZ	LE804					;0E804H
	MVI	A,'Y'	;59H
	JNC	LE7E2					;0E7E2H
	MVI	A,79H

LE7E2:					;0E7E2H
	CALL	LE836					;0E836H

LE7E5:					;0E7E5H
	LDA	LDB1F					;0DB1FH
	CPI	'P'	;50H
	CNZ	LE7F9					;0E7F9H
	IN	1AH
	CMP	E
	JZ	LE804					;0E804H
	CALL	LE7FF					;0E7FFH
	JMP	LE7E5					;0E7E5H

LE7F9:					;0E7F9H
	MVI	A,'('	;28H

LE7FB:					;0E7FBH
	CALL	LE836					;0E836H
	RET

LE7FF:					;0E7FFH
	MVI	A,'8'	;38H
	JMP	LE7FB					;0E7FBH

LE804:					;0E804H
	MVI	A,1CH
	CALL	LE836					;0E836H
	IN	1BH
	ANI	18H
	JZ	LE823					;0E823H
	STA	LE953					;0E953H
	CALL	LE768					;0E768H
	CALL	LE82E					;0E82EH
	CALL	LE768					;0E768H
	MVI	M,0
	LDA	LE953					;0E953H
	ORA	A
	RET

LE823:					;0E823H
	LDA	LE94F					;0E94FH
	INR	A
	OUT	19H
	XRA	A
	LXI	H,STACKBIOS				;0EB00H
	RET

LE82E:					;0E82EH
	PUSH	PSW
	MVI	A,0
	CALL	LE836					;0E836H
	POP	PSW
	RET

LE836:					;0E836H
	OUT	1BH
	CALL	LE768					;0E768H

LE83B:					;0E83BH
	LDA	LE95C					;0E95CH
	OUT	1CH
	IN	1BH
	RRC
	JC	LE83B					;0E83BH
	CALL	LE768					;0E768H
	RET

RDCDISK:				;0E84AH
	CALL	CPREPARE				;0DDEAH
	LXI	H,0
	DAD	SP
	SHLD	STACK+1					;0E8A3H
	LHLD	DISKCADR				;0E9F2H
	MOV	A,L
	SUI	80H
	MOV	L,A
	JNC	LE85F					;0E85FH
	DCR	H

LE85F:					;0E85FH
	DI
	SPHL
	LHLD	ABUFF					;0E9EEH
	MVI	C,' '	;20H
	LDA	BANK					;0E9F4H
	OUT	10H
	XRA	A

LE86C:					;0E86CH
	POP	D
	MOV	M,E
	ADD	M
	INX	H
	MOV	M,D
	ADD	M
	INX	H
	POP	D
	MOV	M,E
	ADD	M
	INX	H
	MOV	M,D
	ADD	M
	INX	H
	DCR	C
	JNZ	LE86C					;0E86CH
	MOV	B,A
	MVI	A,'?'	;3FH
	OUT	10H
	LHLD	ADRCSUM					;0E9F5H
	SPHL
	POP	D
	MOV	A,E
	CMP	D
	JNZ	LE896					;0E896H
	CMP	B
	JZ	STACK					;0E8A2H
	MVI	C,2
	JMP	STACK					;0E8A2H

LE896:					;0E896H
	CMP	B
	JZ	LE8AE					;0E8AEH
	MOV	A,D
	CMP	B
	MOV	E,D
	JZ	LE8AF					;0E8AFH
	MVI	C,3
;
;  modif. komanda

STACK:					;0E8A2H
	LXI	SP,0
	MVI	A,'#'	;23H
	OUT	10H
	EI
	MOV	A,C
	JMP	LDD69					;0DD69H

LE8AE:					;0E8AEH
	MOV	D,E

LE8AF:					;0E8AFH
	PUSH	D
	JMP	STACK					;0E8A2H

WRCDISK:				;0E8B3H
	CALL	CPREPARE				;0DDEAH
	LXI	D,7FH
	LXI	H,0
	DAD	SP
	SHLD	STACK+1					;0E8A3H
	LHLD	DISKCADR				;0E9F2H
	DI
	SPHL
	LHLD	ABUFF					;0E9EEH
	DAD	D
	MVI	C,'@'	;40H
	LDA	BANK					;0E9F4H
	OUT	10H
	XRA	A

LE8D1:					;0E8D1H
	MOV	D,M
	ADD	D
	DCX	H
	MOV	E,M
	ADD	E
	DCX	H
	PUSH	D
	DCR	C
	JNZ	LE8D1					;0E8D1H
	MOV	D,A
	MVI	A,'?'	;3FH
	OUT	10H
	LHLD	ADRCSUM					;0E9F5H
	INX	H
	INX	H
	MOV	E,D
	SPHL
	PUSH	D
	JMP	STACK					;0E8A2H

DPBC:					;0E8ECH
	DW	8

BSHC:					;0E8EEH
	DB	03H

BLMC:					;0E8EFH
	DB	07H

EXMC:					;0E8F0H
	DB	00H

DSMC:					;0E8F1H
	DW	0EBH

DRMC:					;0E8F3H
	DW	3FH

AL0C:					;0E8F5H
	DB	0C0H

AL1C:					;0E8F6H
	DB	00H

CKSC:					;0E8F7H
	DW	0

OFFC:					;0E8F9H
	DW	0

DPBA:					;0E8FBH
	DW	28H

BSHA:					;0E8FDH
	DB	04H

BLMA:					;0E8FEH
	DB	0FH

EXMA:					;0E8FFH
	DB	00H

DSMA:					;0E900H
	DW	0187H

DRMA:					;0E902H
	DW	7FH

AL0A:					;0E904H
	DB	0C0H

AL1A:					;0E905H
	DB	00H

CKSA:					;0E906H
	DW	20H

OFFA:					;0E908H
	DW	8

DPBB:					;0E90AH
	DW	28H

BSHB:					;0E90CH
	DB	04H

BLMB:					;0E90DH
	DB	0FH

EXMB:					;0E90EH
	DB	00H

DSMB:					;0E90FH
	DW	0187H

DRMB:					;0E911H
	DW	7FH

AL0B:					;0E913H
	DB	0C0H

AL1B:					;0E914H
	DB	00H

CKSB:					;0E915H
	DW	20H

OFFB:					;0E917H
	DW	8

XLT:					;0E919H
	DB	01H,02H,03H,04H,05H,06H,07H
	DB	08H,09H,0AH,0BH,0CH,0DH,0EH
	DB	0FH,10H,11H,12H,13H,14H,15H
	DB	16H,17H,18H,19H,1AH,1BH,1CH
	DB	1DH,1EH,1FH,20H,21H,22H,23H
	DB	24H,25H,26H,27H,28H

LE941:					;0E941H
	DB	00H,00H,00H,00H

LE945:					;0E945H
	DB	00H,00H

LE947:					;0E947H
	DB	00H

LE948:					;0E948H
	DB	00H

LE949:					;0E949H
	DB	00H,00H

LE94B:					;0E94BH
	DB	00H

LE94C:					;0E94CH
	DB	00H

LE94D:					;0E94DH
	DB	00H,00H

LE94F:					;0E94FH
	DB	00H

LE950:					;0E950H
	DB	00H

LE951:					;0E951H
	DB	00H

LE952:					;0E952H
	DB	00H

LE953:					;0E953H
	DB	00H

LE954:					;0E954H
	DB	00H

LE955:					;0E955H
	DB	00H

LE956:					;0E956H
	DB	00H,00H

LE958:					;0E958H
	DB	00H

LE959:					;0E959H
	DB	00H

LE95A:					;0E95AH
	DB	00H

LE95B:					;0E95BH
	DB	00H

LE95C:					;0E95CH
	DB	00H

LE95D:					;0E95DH
	DB	00H

LE95E:					;0E95EH
	DB	00H

QBLCSTORE:				;0E95FH
	DW	0

ALVC:					;0E961H
	DS	0021H

ALVA:					;0E982H
	DS	0033H

ALVB:					;0E9B5H
	DS	0033H

DISKDSC:				;0E9E8H
	DB	00H

CHWORD:					;0E9E9H
	DB	00H

FUNC:					;0E9EAH
	DB	00H

NUMB:					;0E9EBH
	DB	00H

TRACK:					;0E9ECH
	DB	00H

SEKTOR:					;0E9EDH
	DB	00H

ABUFF:					;0E9EEH
	DW	0

HTRACK:					;0E9F0H
	DB	00H

HSEKTOR:				;0E9F1H
	DB	00H

DISKCADR:				;0E9F2H
	DW	0

BANK:					;0E9F4H
	DB	00H

ADRCSUM:				;0E9F5H
	DW	0

BGNTAPE:				;0E9F7H
	DW	0

ENDTAPE:				;0E9F9H
	DW	0

FILENAME:				;0E9FBH
	DS	000BH

AUXCELL:				;0EA06H
	DB	00H

COUNT:					;0EA07H
	DB	00H

CSVA:					;0EA08H
	DS	0020H

CSVB:					;0EA28H
	DS	0020H

DIRBUF:					;0EA48H
	DS	0080H
	DS	0038H

STACKBIOS:				;0EB00H
	END
0E