;;
;;*****************************************
;;     formirowanie znakogeneratora
;;  ------------  blok 1  ---------------
;;  wers.2.3.22 ---------- data:16-APR-89
;;*****************************************
;;
	MACLIB	CHAR

;blok1	EQU	2000H		; rabota s |kranom
;blok2	EQU	blok1+400H	; rabota so znakogeneratorami
;blok3	EQU	blok2+200H	; glawnaq programma
;blok4	EQU	blok3+400H	; oblastx znakogeneratorow

;	ORG	blok1
;;
;PUBLIC	blok3
PUBLIC	nast1
PUBLIC	kopir
PUBLIC	DISP0	; DISP1+DISP3
PUBLIC	DISP2
PUBLIC	MARK0	; MARK1+MARK3
PUBLIC	MARK2
PUBLIC	FROM
PUBLIC	TO
PUBLIC	FUNC	; DISP 4
PUBLIC	INVERS
PUBLIC	LIGHT
PUBLIC	DARK
PUBLIC	SEECHR
PUBLIC	STORE
PUBLIC	LOAD
PUBLIC	REGIM
PUBLIC	SW
PUBLIC	TOTV
PUBLIC	FROMTV
PUBLIC	NET
PUBLIC	obmen	; dlq obmena so "specialistom"
;;
;;  stranica dannyh
;;
DATA:
;;
CXY1:	DS	2
CXY2:	DS	2
CXY3:	DS	2
;;
TV1:	DS	2
TV2:	DS	2
TV3:	DS	2
;;
stolbec:
	DW	0B100H
SHIF3:
	DS	2
;;
SSW:	DB	0
;;
kopiq:
	DW	0000H
	DW	0000H
	DW	0000H
	DW	0B400H
	DW	0A018H
	DW	0A080H
	DW	00000H
;;
nast1:
	LXI	H,kopiq
	LXI	D,DATA
	LXI	B,12
;;
;;  kopirowanie dannyh
;;  whod:	
;;    <H,L> - otkuda
;;    <D,E> - kuda
;;    <B,C> - dlina
kopir:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	kopir
	RET
;;
;; str.1 dwivenie w znakogeneratore,bufere i znake
;;
sdwig	MACRO	REG,SHIFT,MASREG,JUMP
	MOV	A,REG
	CPI	MASREG
	MVI	REG,JUMP
	RZ
	ADI	SHIFT
	MOV	REG,A
	RET
	ENDM
;;
MOVE	MACRO	XY,SHX,MASX,SHY,MASY
	LOCAL	wlewo,wprawo,wwerh,wniz
	LHLD	XY
	CALL	$+7
	SHLD	XY
	RET
;;
	DCR	A
	JZ	wlewo
	DCR	A
	JZ	wprawo
	DCR	A
	JZ	wwerh
	DCR	A
	JZ	wniz
	RET
;;
wlewo:
	sdwig	H,-SHX,0,MASX
wprawo:
	sdwig	H,SHX,MASX,0
wwerh:
	sdwig	L,SHY,MASY,0
wniz:
	sdwig	L,-SHY,0,MASY
;;
	ENDM
;;
QSW	MACRO	MASKA
	MVI	A,MASKA
	CALL	SW
	ENDM
;;
DISP0:
	MOV	B,A
	QSW	1
	MOV	A,B
	JNZ	DISP3
DISP1:
	MOVE	CXY1,02H,06H,10H,0F0H
DISP2:
	MOVE	CXY2,01H,0EH,08H,50H
DISP3:
	MOVE	CXY3,01H,0FH,08H,78H
;;
;;  str.1.2
;;
REGIM:
	PUSH	B
	MOV	B,A
	LDA	SSW
	XRA	B
	STA	SSW
	POP	B
	RET
SW:
	PUSH	B
	MOV	B,A
	LDA	SSW
	ANA	B
	POP	B
	RET
;;0TT>;;  str.2.1  markery
TVAD	MACRO	XY,TV
	LHLD	XY
	XCHG
	LHLD	TV
	DAD	D
	RET
	ENDM
;;
TVAD1:	TVAD	CXY1,TV1
TVAD2:	TVAD	CXY2,TV2
TVAD3:	TVAD	CXY3,TV3
;;
MARK0:
	QSW	1
	JNZ	MARK3
MARK1:
	CALL	TVAD1
	JMP	$+6
MARK2:
	CALL	TVAD2
	MOV	A,H
	ORI	0E0H
	MOV	H,A
	PUSH	H
	CALL	XR16
	POP	H
	INR	H
XR16:
	CALL	$+3
	CALL	$+3
	CALL	$+3
	MOV	A,M
	CMA
	MOV	M,A	
	INX	H
	MOV	A,M
	CMA
	MOV	M,A	
	INX	H
	RET
;;
MAR3	MACRO	MA
	MVI	A,MA
	XRA	M
	MOV	M,A
	INX	H
	ENDM
MARK3:
	CALL	TVAD3
	MOV	A,H	
	ANI	9FH
	MOV	H,A
	CALL	wert
	MAR3	0FFH
	MAR3	0FFH
wert:
	MAR3	18H
	MAR3	18H
	MAR3	18H
	RET	
;;
;;
;;  str.3.1 kopirowanie znakow
OLDCHAR:	DS	2	; isto~nik
NEWCHAR:	DS	2	; priemnik
;;
;;  whod w podprogrammu kopirowaniq znaka
;;  whod:
;;    <A> - tip preobrazowaniq
;;	0 - kopiq
;;	1 - zerkalo po X
;;	2 - zerkalo po Y
;;	3 - poworot 90 grad
;;	4 - <--
;;	5 - -->
;;	6 - sdwig wwerh
;;	7 - sdwig wniz
DISCOP	MACRO	XY
	DCR	A
	JNZ	$+9
	LXI	H,XY
	JMP	COPY
	ENDM
;;
COPYI:
	PUSH	H
	DISCOP	XY1
	DISCOP	XY2
	DISCOP	XY3
	DISCOP	XY4
	DISCOP	XY5
	DISCOP	XY6
	DISCOP	XY7
	LXI	H,XY0
COPY:
	SHLD	MODXY
	POP	H
;;
;;  kopirowanie znaka s preobrazowaniem
;;    koordinat
;;  whod:
;;    OLDCHAR i NEWCHAR - ish. i rez-tat
;;  wyhod:
;;     CHAR:=NEWCHAR
;;
COPYCHAR:
	PUSH	H
	PUSH	B
	MVI	B,0
sled:
	MOV	C,B
	LHLD	OLDCHAR	; na~alo ishodnogo znaka
	CALL	POINT
	ANA	M
	PUSH	PSW	; zapomnitx to~ku
;;
	MOV	A,B
MODXY	EQU	$+1
	CALL	XY1	; MODIFY X,Y
	MOV	C,A
;;
;;  str.3.2
	LHLD	NEWCHAR	; na~alo nowogo znaka
	CALL	POINT
	MOV	C,A
	POP	PSW	; ustanowitx to~ku
	MOV	A,C
MOLIGH	EQU	$	; inwersiq ?
	JNZ	$+8
	CMA
	ANA	M
	JMP	$+4
	ORA	M
	MOV	M,A
;;
	INR	B
	JNZ	sled
	MVI	A,0C2H	; JNZ
	STA	MOLIGH
	POP	B
	POP	H
	RET
;;
;;  preobrazowanie koordinat
;;  whod:
;;    <A> - XY
;;  wyhod:
;;    <A> - XY preobraz.
XY1:
	XRI	0F0H	; X=^X
;;			; Y=Y
XY0:
	RET
XY3:
	RRC		; Y=X
	RRC		; X=Y
	RRC
	RRC
XY2:
	XRI	0FH	; Y=^Y
	RET		; X=X
XY4:
	SUI	10H	; <--
	RET
XY5:
	ADI	10H	; -->
	RET
XY6:
	PUSH	B
	MVI	B,1	; sdwig wwerh
	JMP	$+7
XY7:
	PUSH	B
	MVI	B,-1	; sdwig wniz
	MOV	C,A
	ANI	0FH
	ADD	B
	ANI	0FH
	MOV	B,A
	MOV	A,C
	ANI	0F0H
	ORA	B
	POP	B
	RET
;;
;;  str.3.3
;;
;;  koordinata i maska to~ki
;;  whod:
;;    <C> - XY koord.
;;    <H,L> - na~alo znaka
;;
;;  wyhod:
;;    <H,L> - adres to~ki
;;    <A> - maska to~ki
POINT:
	PUSH	D
	PUSH	H
	MOV	A,C
	ANI	0FH
	MOV	E,A
	MOV	A,C
	RLC
	ANI	01H
	MOV	D,A
	MOV	A,C
	ANI	70H
	RRC
	RRC
	RRC
	RRC
	LXI	H,TABL
	ADD	L
	MOV	L,A
	JNC	$+4
	INR	H
	MOV	A,M
	POP	H
	DAD	D
	POP	D
	RET
;;
TABL:
	DB	80H,40H,20H,10H
	DB	08H,04H,02H,01H
;;
;;
;; str.4 kopirowanie i preobrazowanie znakow
;;
;dopoln	EQU	blok4+5000H
;;
FROM:
	QSW	1
	RNZ
;;
	CALL	TVAD1
	SHLD	OLDCHAR
	CALL	TVAD2
	XCHG
	LHLD	SHIF3
	DAD	D
	SHLD	NEWCHAR
	XRA	A
	CALL	COPYI
	JMP	SEECHR
;;
;;  iz bufera w znakogenerator
TO:
	QSW	1		; tolxko w revIME 0
	RNZ
;;
	CALL	TVAD2
	SHLD	OLDCHAR
	CALL	TVAD1
	SHLD	NEWCHAR
	XRA	A
	JMP	COPYI
;;  inwertirowatx znak
INVERS:
	MVI	A,0CAH	; JZ
	STA	MOLIGH
	XRA	A
;;
;;  preobrazowatx znak
;;  whod:
;;    <A> - tip preobrazowaniq (sm.COPYI)
FUNC:
	MOV	B,A
	QSW	1
	RZ
	MOV	A,B
	PUSH	PSW
	CALL	TVAD2
	SHLD	OLDCHAR
	LXI	H,dopoln
	SHLD	NEWCHAR
	POP	PSW
	CALL	COPYI
	LXI	H,dopoln
	SHLD	OLDCHAR
	CALL	TVAD2
	SHLD	NEWCHAR
	XRA	A
	CALL	COPYI
	JMP	SEECHR
;;
;;  str.5.1 rabota so znakom
LIGHT:
	LXI	H,00B6H	; NOP + ORA M
	JMP	$+6
DARK:
	LXI	H,0A62FH	; CMA + ANA M
	SHLD	tip
	QSW	1		; rabotaet tolxko w revime 1
	RZ
;;
	CALL	TVAD3
	MOV	A,E
	RLC
	ORA	D
	RRC
	RRC
	RRC
	RRC
	MOV	C,A
	PUSH	H
	CALL	TVAD2
	CALL	POINT
	PUSH	PSW
tip:
	NOP
	NOP
	MOV	M,A
	POP	PSW
	ANA	M
	JZ	$+5
	MVI	A,0FFH
	POP	H
wyw8:
	CALL	$+3
	MOV	M,A
	INX	H
	MOV	M,A
	INX	H
	MOV	M,A
	INX	H
	MOV	M,A
	INX	H
	RET
;;
;;  str.5.2
SEECHR:
	LXI	H,02000H
	SHLD	SHIF3
	CALL	$+9
	LXI	H,0
	SHLD	SHIF3
;;
	MVI	C,0
SEE:
	CALL	TVAD2
	CALL	POINT
	XCHG
	LHLD	SHIF3
	DAD	D
	ANA	M
	MOV	B,A
	JZ	$+5
	MVI	B,0FFH
	MOV	A,C
	ANI	0F0H
	RRC
	RRC
	RRC
	RRC
	MOV	D,A
	MOV	A,C
	ANI	0FH
	RLC
	RLC
	RLC
	MOV	E,A
	LHLD	TV3
	DAD	D
	XCHG
	LHLD	SHIF3
	DAD	D
	MOV	A,B
	CALL	wyw8
	DCR	C
	JNZ	SEE
	LXI	H,0
	SHLD	CXY3
	RET
;;
;;  str.6 obmen stolbcami
;;
adstolb:
	QSW	1
	JZ	adrst
;	INX	SP
;	INX	SP
	POP	PSW
	RET
;;
adrst:
	LHLD	CXY1
	MVI	L,0	; Y:=0
	XCHG
	LHLD	TV1
	DAD	D
	XCHG
	LHLD	stolbec
	RET
;;
STORE:
	CALL	adstolb
	JMP	$+7
;;
LOAD:
	CALL	adstolb
	XCHG
	LXI	B,200H
	JMP	kopir
;;
;;  str.7 znakogenerator<-->ozu
;;
;; whod:
;;   <H,L> - znakogenerator
TOTV:
	XCHG
	LHLD	TV1
	XCHG
	JMP	$+7
;;
FROMTV:
	XCHG
	LHLD	TV1
;;
	LXI	B,800H
	JMP	kopir
;;
;;  str.8 mas{t.setka
;;
NET:
	LXI	H,02000H
	SHLD	SHIF3
	CALL	FROM
	LXI	H,0
	SHLD	SHIF3
	RET
;;
;;  str.9 podgotowka dlq"specialista"
obmen:
	CALL	adstolb
	XCHG
obmznak:
	CALL	obmstolb
	INR	H
	CALL	obmstolb
	DCR	H
	MOV	A,L
	ADI	10H
	MOV	L,A
	JNZ	obmznak
	RET
;;
obmstolb:
	MVI	C,16
	LXI	D,dopoln
	PUSH	H
	MOV	A,M
	INR	L
	STAX	D
	INR	E
	DCR	C
	JNZ	$-5
	POP	H
	MVI	C,16
	PUSH	H
	DCR	E
	LDAX	D
	MOV	M,A
	INR	L
	DCR	C
	JNZ	$-5
	POP	H
	RET
;;
	END
