
;   ANSI 
;  -------------------------
;  : 29-dec-93

	maclib	Test
	IF	TEST = 1
	Common	/ansi/
	db	'ANSI		v.2.17	26-jan-94$'
	ENDIF

	maclib	STRCT
	STRUCTURE

extrn	FromIn, ToOut
extrn	ReadTimer, ChkTm
extrn	AK8, K8A
extrn	What, FileExchange, FCBF, bfname, excode
extrn	InpBuf, ZAString, MakeCName, MakeFCBName, CopyString
extrn	OneMarker

CO	equ	0f809h
Inkey	equ	0f81bh

OK	equ	0
USAbort	equ	4

F1		equ	0		; help
F2		equ	1		; upload
F3		equ	2		; download

CHANAL		equ	0	;  STATIN
INPUTANSI	equ	1
COMANDANSI	equ	2
UPLOAD		equ	3
DOWNLOAD	equ	4

KEYCHANAL	equ	0	;  STATKEY
BGNINPNAME	equ	1
INPNAME		equ	2

	DSeg
public	NameF
NameF:				;     
	db	true
	db	14
	ds	1
TNameF:	ds	14		; V:NNNNNNNN.XXX
	db	0

	CSeg

public	TermANSI
TermANSI:
	call IniANSI
	DO
	  call DrvANSI
	  call OneMarker
	  SWITCH
	    call OneMarker
	    mov a,l
	  CASE OK
	  CASE USAbort		;  -     .
	    BREAK		;   !!!
	  DEFAULT
	    sta excode
	    LEAVE
	  ENDCASE
	  mIF Z
	    in 1
	    ani 60h		;  : + !!!
	  mTHEN
	    LETBC excode,USAbort
	    LEAVE
	  mENDIF
	ENDDO
	ret


;   ANSI 
;  :
;      
;  :
;      

public	DrvANSI
DrvANSI:
	call SetTANSI		;     ANSI 

	DO
	  mIF C
	    call ChkTANSI
	  mTHEN
	    LEAVE
	  mENDIF

	  LETBC EoW,false
	  SWITCH
	    lda STATIN
	  CASE CHANAL
	    mIF Z
	      call FromIn		;    
	    mTHEN
	      LETBC EoW,true
	      BREAK
	    mENDIF
	    mIF Z
	      cpi ESC
	    mTHEN
	      LETBC STATIN,INPUTANSI
	      LETWC AInpANSI,InpANSI
	    mELSE
	      call K8A			; -8 <-- .
	      mov c,a
	      call CO
	    mENDIF
	    BREAK

	  CASE INPUTANSI
	    mIF Z
	      call FromIn		;   ANSI   
	    mTHEN
	      LETBC EoW,true
	      BREAK
	    mENDIF
	      lhld AInpANSI
	      mov m,a
	      inx h			;    . 
	      shld AInpANSI	      
	    mIF Z
	     cpi '['
	    mTHEN
	      BREAK
	    mENDIF
	    mIF C
	      sui 'A'			; 41h
	      cpi 'z'-'A'+1		; Char -> A..z ???
	    mTHEN			;   ANSI  ?
	      LETBC STATIN,COMANDANSI
	    mENDIF
	    BREAK

	  CASE COMANDANSI
	    call CANSI			; ANSI 
	    LETBC STATIN,CHANAL
	    BREAK

	  CASE UPLOAD
	    LETBC What,-1
	    PRINTLN < UPLOAD STARTED>
	    call FileExchange
	    PRINTLN <UPLOAD ENDED>
	    LETBC STATIN,CHANAL
	    BREAK

	  CASE DOWNLOAD
	    LETBC What,0
	    PRINTLN < DOWNLOAD STARTED>
	    call FileExchange
	    PRINT <FILE: >
	    PRINTDZ bfname
	    PRINTLN < DOWNLOAD ENDED>
	    LETBC STATIN,CHANAL

	  DEFAULT
	  ENDCASE

	  SWITCH
	    lda STATKEY
	  CASE KEYCHANAL
	    SWITCH
	      call Inkey
	    CASE 0ffh
	      BREAK
	    CASE F1
	      PRINTD CRLF
	      PRINT <F2 - upload, F3 - download, AP2 - >
	      call ShowM
	      BREAK
	    CASE ESC
	      lda ReF
	      cma
	      sta ReF
	      call ShowM
	      BREAK
	    CASE F2
	      LETBC NameF,true
	      LETBC NameF+2,0
	      LETBC STATKEY,INPNAME
	      PRINTLN <ENTER FILE NAME - >
	      BREAK
	    CASE F3
	      LETBC STATIN,DOWNLOAD
	      BREAK
	    DEFAULT
	      call AK8			; . <-- -8
	      call WriteRing
	    ENDCASE
	    BREAK

	  CASE INPNAME
	    call Inkey
	    lxi h,NameF
	    call InpBuf
	    mIF Z
	      lda NameF
	      ora a				; false ?
	    mTHEN
	      lxi h,NameF			;  C STRING
	      call ZAString
	      PRINT <FILE: >
	      PRINTDZ TNameF
	      lxi d,bfname
	      lxi h,TNameF
	      call CopyString
	      LETBC STATKEY,KEYCHANAL
	      LETBC STATIN,UPLOAD
	    mENDIF
	  DEFAULT
	  ENDCASE

	  mIF Z
	    lda CRing
	    ora a
	  mTHEN				;    
	    mIF Z
	      lda EoW
	      cpi true
	    mTHEN			;      
	      LEAVE
	    mENDIF
	  mELSE				;    
	    call ReadRing
	    mIF NZ
	      call ToOut		;    
	    mTHEN
	      call NextReadRing
	    mENDIF
	  mENDIF

	ENDDO
	ret


public	CANSI
CANSI:
	SWITCH
	  lhld AInpANSI
	  dcx h
	  mov a,m
	  dcx h
	CASE 'H'
	CASE 'f'
	  mIF NZ
	    mov a,m
	    cpi '['
	  mTHEN
	    call INTASC
	    dcr a
	    mov b,a			; X
	    dcx h
	    call INTASC
	    dcr a
	    mov c,a			; Y
	  mELSE
	    lxi b,0			; (X,Y) := (0,0)
	  mENDIF
	  lxi h,'  '			; ???
	  dad b
	  shld XY
	  lxi h,TXY
	  call PEC			;  
	  BREAK
	CASE 'A'
	  call INTASC
	  mov b,a			;  
	  mvi c,Up
	  call BCO
	  BREAK
	CASE 'B'
	  call INTASC
	  mov b,a
	  mvi c,Down
	  call BCO
	  BREAK
	CASE 'C'
	  call INTASC
	  mov b,a
	  mvi c,Right
	  call BCO
	  BREAK
	CASE 'D'
	  call INTASC
	  mov b,a
	  mvi c,Left
	  call BCO
	  BREAK
	CASE 'J'
	  mvi c,ClrScr
	  call CO
	  BREAK
	CASE 'K'
	  call FindXY
	  shld ANSIXY
	  lxi h,ClearR
	  call PEC
	CASE 'u'
	  lhld ANSIXY
	  lxi b,'  '
	  dad b
	  shld XY
	  lxi h,TXY
	  call PEC
	  BREAK
	CASE 's'
	  call FindXY
	  shld ANSIXY
	  BREAK
	case 'n'
	  mvi a,ESC
	  call WriteRing
	  mvi a,'['
	  call WriteRing
	  call FindXY
	  mov a,h		; X
	  inr a
	  call IntToRing
	  mvi a,';'
	  call WriteRing
	  mov a,l		; Y
	  inr a
	  call WriteRing
	  mvi a,'H'
	  call WriteRing
	  BREAK
	DEFAULT
	ENDCASE
	ret

PEC:
	mov a,m
	ora a
	rz
	mov c,a
	call CO
	inx h
	jmp PEC

BCO:
	push b
	call CO
	pop b
	dcr b
	jnz BCO
	ret

ShowM:
	mIF Z
	  lda ReF
	  ora a
	mTHEN
	  PRINTLN <NEW FILE.>
	mELSE
	  PRINTLN <OLD FILE.>
	mENDIF
	ret


	DSeg

public	TXY, ANSIXY
TXY:
	db	ESC,'Y'
XY:	ds	2		; Low -> Y+' ', High -> X+' '
	db	0
ANSIXY:
	dw	0
ClearR:				;    
	db	ESC,'K',0

int AInpANSI			;    
char InpANSI,16			;  

char WARing,1			;      (0..15)
char RARing,1			;      (0..15)
char CRing,1			;        (0..15)
char Ring,16			;   ( "")

int TANSI			; -    
				;   ANSI 

char EoW,1
char STATIN,1
char STATKEY,1

CRLF: db 0dh,0ah,'$'

	CSeg

QTANSI	equ	80/20		; 80 ms

public	SetTANSI, ChkTANSI
SetTANSI:			;     ANSI 
	call ReadTimer
	shld TANSI
	ret

ChkTANSI:			;    ANSI 
	lxi d,QTANSI
	lhld TANSI
	jmp ChkTm		; :  C=1 - - 

public	IniANSI
IniANSI:			;  ANSI 
	xra a
	sta CRing
	sta WARing
	sta RARing
	LETBC STATIN,CHANAL
	LETBC STATKEY,KEYCHANAL
	xra a
	sta ReF			;  
	ret

public	ReadRing
ReadRing:			;     
	lda RARing
	mov c,a
	mvi b,0
	lxi h,Ring
	dad b
	mov a,m			; <a> - 
	ret

public NextReadRing
NextReadRing:			;     
	lda RARing
	inr a
	ani 0fh
	sta RARing
	DECB CRing
	ret

public	WriteRing
WriteRing:			;   <a>   
	mov b,a

	lda CRing
	inr a
	cpi 16
	cmc
	rc			; :  C=1 -  
	sta CRing

	lda WARing
	mov c,a
	inr a
	ani 0fh
	sta WARing

	push h
	mov a,b
	mvi b,0
	lxi h,Ring
	dad b
	mov m,a
	xra a			; :  C=0 -   
	pop h
	ret


public	IntToRing
IntToRing:
	push h
	call ASCINT
	mov a,h
	ora a
	cnz WriteRing
	mov a,l
	call WriteRing
	pop h
	ret

;    ASCII  INTEGER
;  :
;    <hl> -    (- )
;  :
;    <hl> -  -
;    <a> - INTEGER 

public	INTASC
INTASC:
	push	b
	mov	a,m
	sui	'0'
	mov	b,a
	dcx	h

	mov	a,m
	sui	'0'
	cpi	10
	jnc	ExCPr

	mov	c,a
	add	a
	add	a
	add	c
	add	a
	add	b
	mov	b,a
	dcx	h
ExCPr:
	mov	a,b
	pop	b
	ret


;   INTEGER  ASCII
;  :
;    <a> - INTEGER 0..99
;  :
;    <hl> - ASCII

public	ASCINT
ASCINT:
	push	b
	mvi	c,0
	mov	b,a

	sui	10
	inr	c
	jnc	$-3
	adi	10
	mov	b,a

	dcr	c
	mov	a,c		;  
	adi	'0'
	mov	h,a

	mov	a,b		;  
	adi	'0'
	mov	l,a
	pop	b
	ret

;    10
;  :
;    <a> -  0..255
;  :
;    <a> - /10

DIV	macro	NN
	local LL
	mvi c,NN
	cpi NN*10
	jc LL
	sui NN*10
	dad b
    LL:	endm

public	ADiv10
ADiv10:
	push h
	push b
	lxi h,0
	DIV 16
	DIV 8
	DIV 4
	DIV 2
	DIV 1
	mov a,l
	pop b
	pop h
	ret

;      
;  :
;    <hl> - X,Y 

ScrollCell	equ	0f820h		;  !!!
YCell		equ	0f823h		;     BIOS F/FP
XCell		equ	0f824h

FindXY:
	lda YCell		; 10*Y := Scroll-10-YH !!!
	mov b,a
	lda ScrollCell
	sub b
	sui 10
	call ADiv10		; Y := (Scroll-10-YH) / 10
	mov l,a			; Y 
	lda XCell
	mov h,a			; X 
	ret

	DSeg

char ReF,1		; true - /

 	end



