;      "" 
;  -------------------------------------------

	maclib	TEST
	IF	TEST = 1
	extrn	PrintVers
	Common	/Naked/
First:
	db	'Naked		v.1.32	28-dec-93$'
	ENDIF

System	equ	0

	CSeg

	maclib	SYS
	maclib	STRCT
	STRUCTURE

Letter	equ	2800h

Left	equ	08h
Right	equ	18h
Up	equ	19h
Down	equ	1ah

false	equ	0
true	equ	-1

	CSeg

extrn	FileExchange, File, What, bfname, ClrBuf, RcvF
extrn	flen, ENUMB, HLDE, HLsubDE, Message
extrn	Begin, SetBord, SetBeginDisp, SetScroll, SetClr, PEC, CI, CO
extrn	SetChar, SetPlane
extrn	LoadROM, SaveROM, LineFile, CellRepeat, FileStart, NamePRG

	DSeg
	char NewT,1		; -1 ->   
	CSeg

	lxi	sp,100h

	IF	TEST = 1		;  
	lxi	h,First
	call	PrintVers
	ENDIF

	lxi	h,Letter
	call	SetChar
	LETWC	File,Letter+800h
	LETBC	RcvF,0
	call	Begin
	xra	a
	call	SetBord
	call	SetBeginDisp
	mvi	a,-1
	call	SetScroll
	lxi	d,TClr
	call	SetClr
	mvi	a,0001b
	call	SetPlane
	LETBC	TapeC,0
	call	SetTAPE
	lxi	h,Titul
	call	PEC
	LETBC	NewT,true

	DO
	  ei
	  lxi sp,100h
	  call ClrBuf
	  LETWC	WorkTxt+3,MenuT
	  call	TypeWork
	  LETBC ENUMB,1			;      ???
	  mIF NZ
	    lda NewT
	    ora a
	  mTHEN
	    call InfoT			;  .   
	  mENDIF
	  LETBC NewT,true
	  SWITCH
	    call CI
	  CASE '1'
	    LETWC WorkTxt+3,ReadT
	    call TypeWork
	    LETBC What,0
	    call Work
	    BREAK

	  CASE '2'
	    LETWC WorkTxt+3,WrtT
	    call TypeWork
	    LETBC What,-1
	    call Work
	    BREAK

	  CASE '3'
	    LETWC WorkTxt+3,TReadT
	    call TypeWork
	    call LoadROM
	    LETBC RcvF,True
	    lda LineFile		;   
	    mov l,a
	    mvi h,0
	    dad h
	    shld flen
	    lxi h,bfname		;     C
	    lxi d,NamePrg
	    call MakeCName
	    BREAK

	  CASE '4'
	    mIF NZ
	      lda RcvF
	      ora a
	    mTHEN
	      LETWC WorkTxt+3,TWrtT
	      call TypeWork
	      lhld flen			;   
	      ora a
	      mov a,h
	      rar
	      mov h,a
	      mov a,l
	      rar
	      sta LineFile
	      lxi h,bfname		;     FCB
	      lxi d,NamePrg
	      call MakeName
	      lda RptC ! sta CellRepeat
	      lda StartC ! sta FileStart
	      call SaveROM
	    mENDIF
	    BREAK

	  CASE '5'
	    call ChngTAPE
	    lxi h,curTAPE
	    call PEC
	    LETBC NewT,false
	    BREAK

	  IF System = 1
	  CASE '0'
	    mvi a,0e0h
	    out 10h
	    call 0f800h
	    jmp 0b903h
;           BREAK
	  ENDIF

	  DEFAULT
	    LETBC NewT,false		;   
	  ENDCASE
	ENDDO

;      C 
;  :
;    <hl> - C 
;    <de> - FCB 

public	MakeCName
MakeCName:
	mvi	b,8
	call	UpToSpace
	mvi	m,'.'
	inx	h
	mvi	b,3
	call	UpToSpace
	mvi	m,0
	ret

UpToSpace:
	ldax	d
	inx	d
	cpi	' '
	jz	$+5
	mov	m,a
	inx	h
	dcr	b
	jnz	UpToSpace
	ret

;   FCB  
;  :
;    <hl> - C 
;    <de> - FCB 

public	MakeName
MakeName:
	push	d			;  
	mvi	b,11
	mvi	a,' '
	stax	d
	inx	d
	dcr	b
	jnz	$-3
	pop	d

	push	d			; 
	mvi	b,'.'
	call	UpToB
	pop	d
	xchg
	lxi	b,8
	dad	b
	xchg
	mvi	b,0			; 
UpToB:	
	mov	a,m
	inx	h
	cmp	b
	rz
	stax	d
	inx	d
	jnz	UpToB
	ret

Work:
	call	FileExchange
	call	ClrBuf
	lxi	h,MsgT
	call	PEC
	call	Message
	call	CI
	lxi	h,CopyRight
	jmp	PEC

InfoT:
	lxi h,FileT
	call PEC
	mIF Z
	  lda RcvF
	  ora a
	mThen
	  lxi h,NoneF
	  call PEC
	  call BadBlk
	mELSE
	  lxi h,bfname
	  call PEC
	  call InfoFile
	mENDIF
	ret

BadBlk:
	lxi b,QAllT
	call BadNumber
	lxi b,QBlkT
	call BadNumber
	jmp ShowBlk


;    

public	InfoFile
InfoFile:
	  lhld ENUMB
	  dcx h
	  xchg
	  lhld flen
	  inx h
	  inx h
	  inx h
	  xra a
	  rept 6 ! dad h ! adc a ! endm
	  mov l,h ! mov h,a		; <hl> /:= 4

;   - 
;  :
;    <hl> - 
;    <de> - 

public	FileBlk
FileBlk:
	push d
	lxi b,QAllT
	call DeHe
	pop h
	lxi b,QBlkT
	call DeHe
ShowBlk:
	lxi h,BlkInfoT
	jmp PEC

;    
;  :
;    <bc> -  Dec   
;    <hl> - Hex

public	DeHe
DeHe:
	call BadNumber
	lxi d,1000
	call HLDE
	rnc
	push b
	lxi d,100
	call OneDeHe
	lxi d,10
	call OneDeHe
	lxi d,1
	call OneDeHe
	pop h
	mvi c,2		;  2 
clDZ:	mov a,m
	cpi '0'
	rnz
	mvi m,' '
	inx h
	jmp clDZ

OneDeHe:
	push b
	mvi b,'0'-1
clODH:	call HLsubDE
	inr b
	jnc clODH
	dad d
	mov a,b
	pop b
	stax b
	inx b
	ret

BadNumber:
	mvi a,'*'
	push b
	stax b
	inx b
	stax b
	inx b
	stax b
	pop b
	ret


TypeWork:
	lxi	h,WorkCur
	jmp	PEC


	DSeg

CurL	macro
	cur 16,YY
	YY set YY-1
	endm

YW	equ	17

YY	set	YW
TMenu:
	CurL
	db	0aah
	subtxt	1,WorkTxt
	db	08fh
	CurL
	subtxt	1,TSpL
	CurL
YBlk	set	YY
	db	083h,' '
	lr	<   >
	db	' ',083h
	CurL
	subtxt	1,TSpL
	CurL
	subtxt	1,TSpL
	CurL
	DnG	14
	db	0

BlkInfoT:
	HighD	-2
	cur	18,YBlk
QBlkT:	db	'***'
	cur	26,YBlk
QAllT:	db	'***'
	HighD	0
	db	0

WorkCur:
	cur	17,YW
WorkTxt:
	subtxt	1,MenuT
	db	0
MenuT:
	db	094h,094h,094h,094h
	br	<  >
	db	094h,094h,094h,094h
	db	0
WrtT:
	db	094h,094h
	br	<  >
	db	094h,094h
	db	0
ReadT:
	db	094h,094h,094h
	br	<  >
	db	094h,094h,094h,094h
	db	0
TWrtT:
	db	094h,094h,094h
	br	<  >
	db	094h,094h,094h
	db	0
TReadT:
	db	094h,094h,094h
	br	<  >
	db	094h,094h,094h
	db	0

YF	set	10

public	FileT
FileT:
	cur	18,YF-2
	count	12,' '
	cur	18,YF-2
	db	0
NoneF:
	db	'None',0

TClr:
	rept	8
	db	000h,0f6h
	endm

YY	set	31
Titul:
	db	1fh
	CurL
	color	1,0
	db	0aah,' ADD1200/V 1.1',08fh
	CurL
	subtxt	1,TSpL
	CurL
	db	083h,' '
	color	0,1
	db	' 1 '
	color	1,0
	br	<     >
	db	083h
	CurL
	subtxt	1,TSpL
	CurL
	db	083h,' '
	color	0,1
	db	' 2 '
	color	1,0
	br	< ~ >
	db	083h
	Curl
	subtxt	1,TSpL
	CurL
	db	083h,' '
	color	0,1
	db	' 3 '
	color	1,0
	br	< ~   >
	db	083h
	CurL
	subtxt	1,TSpL
	CurL
	db	083h,' '
	color	0,1
	db	' 4 '
	color	1,0
	br	<    >
	db	083h
	CurL
	subtxt	1,TSpL

YTape	equ	YY
	CurL
	db	083h,' '
	color	0,1
	db	' 5 '
	color	1,0
	subtxt	1,CurTAPE
	db	083h
	CurL
	subtxt	1,TSpL
	CurL
	DnG	14

	subtxt	1,TMenu

YY	set	YF
	CurL
	db	0aah,094h,' File name ',094h,094h,08fh
	CurL
	subtxt	1,TSpL
	CurL
	subtxt	1,TSpL
	CurL
	subtxt	1,TSpL
	CurL
	DnG	14


YMsg	equ	4
YY	set	YMsg
CopyRight:
	CurL
	db	0aah,094h,' Copyright ',094h,094h,08fh
	CurL
	subtxt	1,TSpL
	CurL
	db	083h,' (C) ADD,1993 ',083h
	CurL
	subtxt	1,TSpL
	CurL
	DnG	14
	db	0

YY	set	YMsg
MsgT:	CurL
	db	0aah,094h
	br	<  >
	db	094h,094h,08fh
YY	set	YY-1
	CurL
	db	Right
	db	0

TSpL:
	MidG	14
	db	0

;  

	CSeg

ChngTAPE:
	lxi h,TapeC
	inr m

SetTAPE:
	SWITCH
	  lda TapeC
	CASE 0
	  lxi h,0101h		; Start + Repeat
	  BREAK
	CASE 1
	  lxi h,0001h
	  BREAK
	CASE 2
	  lxi h,0102h
	  BREAK
	CASE 3
	  lxi h,0002h
	  BREAK
	DEFAULT
	  LETBC TapeC,0
	  lxi h,0101h
	ENDCASE
	shld RptC
	lda RptC
	adi '0'
	sta RptT
	lda StartC
	adi '0'
	sta StartT
	ret


	DSeg

CurTAPE:
	cur	22,YTape
	subtxt	1,ROM
	db	0
ROM:
	db	'ROM S'
StartT:	db	'1 R'
RptT:	db	'1',0

TapeC:	ds	1
RptC:	ds	1
StartC:	ds	1

	end

