;         V23
;  --------------------------------------------
;  .1.9			 :20-aug-93

	maclib	DEL

TEST	equ	0

extrn	TabLinkAddr, Hz2100, Hz1300
public	V23, Alabel, Blabel, B0label, B1Label

PA	equ	7
PB	equ	6
PC	equ	5


OUTSIN	macro
	ldax	b	;  7
	out	PA	; 10
	inx	b	;  5
	nop		;  4 ; = 26 (: 52-26 = 26)
	if	TEST=1
	push	h
	lhld	GrfAddr
	mov	m,a
	inx	h
	shld	GrfAddr
	pop	h
	endif
	endm

	if	TEST=1
	DSeg
public	GrfAddr
GrfAddr:
	ds	2
Grafic:
	dw	1000h
	endif

IniGrf	macro
	if	TEST=1
	lhld	Grafic
	shld	GrfAddr
	lxi	d,4000h
	mvi	m,0
	inx	h
	dcx	d
	mov	a,d
	ora	e
	jnz	$-6
	endif
	endm


SKIP	macro	nn	; nn > 1 !!!
	local	SkipL
	OUTSIN
	DELAY19		; 19
	mvi	h,nn-1	;  7 ; = 26
SkipL:	OUTSIN
	DELAY11		; 11
	dcr	h	;  5
	jnz	SkipL	; 10 ; = 26
	endm

	DSeg

public	IByte, QBits, Bit, BgnBit, PlaceBit, Bufer, LineBufer

IByte:				;   
	ds	1
QBits:				;   
	ds	1
Bit:				; . 
	ds	1
BgnBit:				;   . 
	ds	1
PlaceBit:			; 0 - . / 1 - - / 2 - .
	ds	1
Bufer:				;   . 
	ds	2
LineBufer:			;  .  ()
	ds	2

	CSeg

;        V23
;  :
;    <hl> -   
;    <de> -  .  ( )

V23:
	shld	Bufer
	xchg
	shld	LineBufer

	iniGrf

	lxi	h,32*100h+0ffh
	shld	IByte
	xra	a
	mov	h,a
	shld	Bit
	sta	PlaceBit

	lxi	b,Hz1300

	di

Alabel:
	OUTSIN					; 1 
	lxi	h,QBits		; 10
	dcr	m		; 10
	DELAY5			;  5 ; = 25
	OUTSIN					; 2 
	DELAY16			; 16
	jz	Blabel		; 10 ; = 26
	SKIP	9				; 3,4,5,6,7,8,9,10,11 
ReturnB:
	OUTSIN					; 12 
	lda	Bit		; 13
	ora	a		;  4
	DELAY8			;  9 ; = 25
	OUTSIN					; 13 
	jz	case0		; 10
	mvi	d,4		;  7
	jmp	excs0		; 10 ; = 27
case0:
	mvi	d,0		;  7
	jmp	excs0		; 10 ; = 27
excs0:
	OUTSIN					; 14 
	lxi	h,IByte		; 13
	DELAY13			; 13 ; = 26
	OUTSIN					; 15 
	DELAY5			;  5
	mov	a,m		;  7
	rrc			;  4
	mov	m,a		;  7 ; = 25
	OUTSIN					; 16 
	sbb	a		;  4
	sta	Bit		; 13
	jz	case00		; 10 ; = 27
	OUTSIN					; 17 
	mvi	e,2		;  7
	jmp	excs00		; 10
case00:
	OUTSIN					; 17 
	mvi	e,0		;  7
	jmp	excs00		; 10
excs00:
	DELAY9			;  9 ; = 26
	OUTSIN					; 18 
	mov	a,d		;  5
	add	e		;  4
	mov	e,a		;  4
	mvi	d,0		;  7 ; = 26
	OUTSIN					; 19 
	lxi	h,TabLinkAddr	; 10
	dad	d		; 10
	mov	e,m		;  7 ; = 27
	OUTSIN					; 20 
	inx	h		;  5
	mov	d,m		;  7
	DELAY13			; 13 ; = 25
	OUTSIN					; 21 
	lda	BgnBit		; 13
	mov	l,a		;  5
	DELAY8			;  8 ; = 26
	OUTSIN					; 22 
	mov	a,l		;  5
	add	a		;  4
	add	l		;  4
	mov	l,a		;  5
	mvi	h,0		;  7 ; = 25
	OUTSIN					; 23 
	dad	d		; 10
	mov	e,m		;  7
	inx	h		;  5
	DELAY5			;  5 ; = 27
	OUTSIN					; 24 
	mov	d,m		;  7
	inx	h		;  5
	DELAY14			; 14 ; = 26
	OUTSIN					; 25 
	mov	a,m		;  7
	sta	BgnBit		; 13
	DELAY	5		;  5 ; = 25
	SKIP	12				; 26,27,28,29,30,31
						; 32,33,34,35,36,37
	OUTSIN					; 38 
	mov	b,d		;  5
	mov	c,e		;  5
	DELAY5			;  5
	jmp	Alabel		; 10 ; = 25


Blabel:
	OUTSIN					; 3 
	lxi	h,PlaceBit	; 10
	dcr	m		; 10
	DELAY5			;  5 ; = 25
	OUTSIN					; 4 
	DELAY7			;  7
	jm	B0label		; 10
	jz	B1label		; 10 ; = 27
	OUTSIN					; 5 
	lhld	Bufer		; 16
	mov	d,m		;  7
	DELAY4			;  4 ; = 27
	OUTSIN					; 6 
	inx	h		;  5
	shld	Bufer		; 16
	DELAY4			;  4 ; = 25
	OUTSIN					; 7 
	mov	a,d		;  5
	sta	IByte		; 13
	DELAY8			;  8 ; = 26
	OUTSIN					; 8 
	mvi	a,8		;  7
	sta	QBits		; 13
	DELAY7			;  7 ; = 27
	SKIP	2				; 9,10 
	OUTSIN					; 11 
	DELAY15			; 15
	jmp	returnB		; 10 ; = 25

B0label:
	DELAY10			; 10 ; = 27
	OUTSIN					; 5 
	lhld	LineBufer	; 16
	mov	a,l		;  5
	ora	h		;  4 ; = 25
	OUTSIN					; 6 
	dcx	h		;  5
	shld	LineBufer	; 16
	DELAY5			;  5 ; = 26
	OUTSIN					; 7 
	jz	ExitV23		; 10
	DELAY16			; 16 ; = 26
	OUTSIN					; 8 
	mvi	a,2		;  7
	sta	PlaceBit	; 13
	DELAY5			;  5 ; = 25
	OUTSIN					; 9 
	mvi	a,0		;  7
	sta	IByte		; 13
	DELAY7			;  7 ; = 27
	OUTSIN					; 10 
	mvi	a,1		;  7
	sta	QBits		; 13
	DELAY7			;  7 ; = 27
	OUTSIN					; 11 
	DELAY15			; 15
	jmp	ReturnB		; 10 ; = 25

B1label:
	OUTSIN					; 5 
	mvi	a,0ffh		;  7
	sta	IByte		; 13
	DELAY5			;  5 ; = 25
	OUTSIN					; 6 
	mvi	a,8		;  7 ;   
	sta	QBits		; 13
	DELAY7			;  7 ; = 27
	SKIP	4				; 7,8,9,10 
	OUTSIN					; 11 
	DELAY16			; 16
	jmp	ReturnB		; 10 ; = 26

extrn	MidDAC
ExitV23:
	lda	MidDAC		;  
	out	PA
	ei
	ret

	end
