;	diskowye operacii s blokami dannyh
;  ----------------------------------------------
;  a) wyhod w mikro-dos			01-DEC-91
;  b) wwod-wywod BASIC programmy	08-APR-92
;  w) wwod i zapusk programmy		11-DEC-91
;  w) wwod-wywod bloka dannyh		09-DEC-91
;  g) izmenenie HIMEM			14-DEC-91
;  ----------------------------------------------

	MACLIB	SOSBAS


	ORG	23F2H
	DW	NEWRUN

	ORG	241EH
	DW	SOSEXIT		; VERIFY

	ORG	2414H
	DW	LOAD		; CLOAD
	DW	SAVE		; CSAVE

	ORG	1780H
	JMP	NEWHIMEM	; izmenenie HIMEM

	ORG	0247H		; obrabotka komandnogo bufera
	JMP	CHANGECOMBUFWORK

	ORG	17EBH
	JMP	FORDELETE

	ORG	1844H
	JZ	FORRENUM

;----------------------------------------------------

	ORG	1A2DH

;	JMP	SYSTEM
	JMP	SCREEN
	JMP	PARAM
	JMP	PREPARENAME
	JMP	PREPHLFCB
	JMP	PREPFCB
	JMP	DISKERR		; whod: <C> - nomer diskowoj o{ibki

PFCB:	DS	2
	DW	@FCB

ADRBAS:
	DS	2

MESSAGE:
	DS	20H

;------------------------------------------------------------------
SYSTEM:
	EI
	HLT
	DI
	PUSH	PSW
	MVI	A,23H
	OUT	10H
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	@STACK
	LHLD	@STACKSOS
	SPHL
	PUSH	D
	CALL	@@SYSTEM
	POP	D
	LHLD	@STACK
	SPHL
	JMP	EXSS
;	POP	H
;	POP	PSW
;	EI
;	RET


SOSEXIT:					; wyhod w mikro-dos
	MVI	A,23H
	OUT	10H
	JMP	@EXIT

SCREEN:
	EI
	HLT
	DI
	PUSH	PSW
	PUSH	H
	MVI	A,23H
	OUT	10H
	LXI	H,0
	DAD	SP
	SHLD	@STACK
	LHLD	@STACKSOS
	SPHL
	CALL	@@SCREEN
	LHLD	@STACK
	SPHL
	XRA	A
	OUT	10H
EXSS:	POP	H
	POP	PSW
	EI
	RET

DISKERR:
	MVI	A,23H
	OUT	10H
	CALL	@@DISKERR
	CALL	SCREEN
	LXI	H,MESSAGE
	CALL	PEC
	INX	H
	MOV	E,M
	JMP	PRINTERRMSG

;  podgotowka imeni
;  whod:
;    <HL> - adres na~ala imeni (na kawy~ke)
;  wyhod:
;    <HL> - adres za zakrywa`}ej kawy~koj / zapominaetsq w ADRBAS

PREPARENAME:
	MOV	A,M
	CPI	'"'
	JNZ	ERROR2
	INX	H
	SHLD	PFCB
CPNAME:
	MOV	A,M
	INX	H
	ORA	A
	JZ	ERROR2
	CPI	'"'
	JNZ	CPNAME
	SHLD	ADRBAS
	RET

;-----------------------------------------------------------
;  wywod na disk

SAVE:
	DCX	H
	RST	2
	CPI	083H		; DATA ?
	JZ	SAVEDATA

	CALL	PREPARENAME
	CALL	PREPBASFCB

	LHLD	ADRESBASICBEGINPROGRAM
	XCHG
	LHLD	ADRESBASICBEGINDATA
DATASAVE:
	MOV	B,H
	MOV	C,L
	LHLD	PFCB+2
	CALL	@WRTFILE		; zapisatx programmu
	JC	EXADRBAS
	JZ	CLOSEFILE

ERROR:
	CALL	SCREEN
	MVI	C,0
ERRLOAD:
	LXI	H,DISKERR
	PUSH	H
	CPI	1		; o{ibka 0/SAVE - 5/LOAD
	RZ
	MVI	C,1		; o{ibka 1
	CPI	2
	RZ
;	INR	C		; o{ibka 2: newerno wybran disk
;	CPI	4		; --> otsleviwaetsq PREPFCB
;	RZ
	INR	C		; o{ibka 3
	CPI	9
	RZ
	INR	C		; o{ibka 4
	CPI	6
	RNZ
	MOV	C,A		; o{ibka 6
	RET

CLOSEFILE:
	MVI	C,16		; CLOSE FILE
	LXI	D,@FCB
	CALL	5
	INR	A
	JZ	ERROR

EXADRBAS:
	CALL	SCREEN
	LHLD	ADRBAS
	RET

;  ~tenie programmy s diska

LOAD:
	DCX	H
	RST	2
	CPI	083H		; DATA ?
	JZ	LOADDATA

	CALL	LOADBAS		; zagruzitx BASIC programmu

	CALL	SETEOFBASPROGRAM

FORDELETE:
	SHLD	ADRESBASICBEGINDATA
	DCR	C
	RZ

FORRENUM:
	MVI	A,1
	STA	FLAGSHOWONDISPLEY
	JMP	168H

;----------------------------------------------------------

LOADBAS:
	CALL	PREPARENAME

RUNLOADBAS:
	CALL	PREPBASFCB

	LHLD	ADRESBASICBEGINPROGRAM
	XCHG
	LXI	H,-16		; maks. razre{ennyj adres konca programmy
	DAD	SP
DATALOAD:
	MOV	B,H
	MOV	C,L
	LHLD	PFCB+2
	CALL	@READFILE
	CALL	EXADRBAS
	ORA	A
	RZ
	CPI	2
	RZ

	MVI	C,5
	JMP	ERRLOAD


; najti konec programmy

SETEOFBASPROGRAM:
	LXI	H,-1
	SHLD	BASOPERATORNUMBER

	LHLD	ADRESBASICBEGINPROGRAM
SEARCH3ZERO:
	LXI	B,300H
SEARCHZERO:
	MOV	A,M
	INX	H
	ORA	A
	JNZ	SEARCH3ZERO
	DCR	B
	JNZ	SEARCHZERO

	SHLD	ADRESBASICBEGINDATA
	RET

; podgotowitx FCB dlq zadannogo imeni
; whod:
;  <HL> - adres za zakrywa`}ej skobkoj imeni
;  <A> - tip ras{ireniq
;    0 - .BAS
;    1 - .DBA
;   -1 - proizwolxnyj (zadaetsq w operatore)
;  adres na~ala imeni hranitsq w PFCB
; prime~anie:
;  zakr.kawy~ku sna~ala zamenitx 0, a zatem wosstanowitx

PREPBASFCB:
	XRA	A
PREPFCB:
	LXI	D,@FCB

PREPHLFCB:
	CALL	SYSTEM
	JMP	@@PREPHLFCB

;----------------------------------------------------
NEWRUN:
	JZ	RUN
	CPI	'"'
	JNZ	RUN+3

	CALL	PREPARENAME

	LXI	D,0
	PUSH	H
	DCX	H
	RST	2
	JZ	RUNNUMBLESS
;	RST	1
;	DB	','
;	CALL	057EH		; najti ~islowoj parametr
	CALL	PARAM
	POP	D
RUNNUMBLESS:
	POP	H
	PUSH	D
	CALL	RUNLOADBAS
	CALL	SETEOFBASPROGRAM
	POP	H		; nomer operatora w RUN
	MOV	A,L
	ORA	H
	JZ	RUN

	SHLD	ADRBAS
	CALL	NEWVAR
	LXI	B,CHECKBREAK
	PUSH	B
	LHLD	ADRBAS
	XCHG
	LHLD	ADRESBASICBEGINPROGRAM
	DCX	H
	JMP	GOTO+6

;---------------------------------------------------

;  wy~islenie parametra posle zapqtoj
;  wyhod:
;    parametr w steke
PARAM:
	RST	1
	DB	','
	CALL	DIGITWITHCHECKMODEPARAM
	RST	5
	CALL	INTFROMFLOAT
	XCHG
	XTHL
	PUSH	H
	XCHG
	RET

SAVEDATA:
	RST	2
	CALL	PREPARENAME
	SHLD	EONAME		; adres za zakr.skobkoj imeni
	CALL	PARAM
	CALL	PARAM
	SHLD	ADRBAS		; adres za wtorym parametrom

	LHLD	EONAME
	MVI	A,1
	CALL	PREPFCB
	POP	H
	POP	D
	RST	4		; na~. i kon. adresa sowpada`t ?
	MVI	A,6
	JZ	ERROR
	JMP	DATASAVE
		
LOADDATA:
	RST	2
	CALL	PREPARENAME
	SHLD	EONAME		; adres za zakr.skobkoj imeni
	CALL	PARAM
	SHLD	ADRBAS		; adres za perwym parametrom

EONAME	EQU	$+1
	LXI	H,0
	MVI	A,1
	CALL	PREPFCB
	POP	D
	LXI	H,0A000H	; wwod wplotx do 0A000H
	JMP	DATALOAD

;-------------------------------------------------------------
;  modifikaciq HIMEM

NEWHIMEM:
	LXI	H,0A000H
	RST	4
	JC	1789H
	LHLD	ADRESFREEFIELD
	JMP	1783H

;-------------------------------------------------------------
;  modifikaciq obrabotki komandnoj stroki
CHANGECOMBUFWORK:
	JNZ	024DH
	PUSH	D
	DCX	D
	DCX	D
	LDAX	D
	CPI	' '
	JZ	$-4
	POP	D
	CPI	9AH		; kod operatora LOAD
	JZ	$+5
	CPI	9BH		; kod operatora SAVE
	MVI	A,49H		; (kod operatora DATA)-80H
	JZ	024DH
	JMP	024AH

;------------------------------------------------------------

;TEST:
;	PUSH	PSW
;	LXI	H,@EXDSC
;	LXI	D,7000H
;	MVI	C,16
;	CALL	COPY
;	LXI	H,@FCB
;	MVI	C,30H
;	CALL	COPY
;	POP	PSW
;	STA	7040H
;	RET

	END
