;      
;  -----------------------------------------------------

	MACLIB	TEST
	IF	TEST = 1
	Common	/protocol/
	db	'protocol	v.2.43	12-jan-94$'
	CSeg
	ENDIF

public	Space, AccWaitLA, NotAccLr, WaitConnect, SendLR, IniWaitLR, RepeatLR
public	NoConnect, ConnLA, ConnLJ, ConnGood

DLE		equ	10h
STX		equ	02h
ETX		equ	03h

SizeFrame	equ	128		; max   


;  

OK		equ	0
Error		equ	-1
EndOfRepeat	equ	1		;   
TimeA		equ	2		;  -  
NoMarker	equ	3		;  
US		equ	4		;   

extrn	modeOut, modeInp, WriteModem, ReadModem
extrn	ReadTimer, ChkTm
extrn	ResFree, RcvInfo, SendInfo, OutHowMany
extrn	HLsubDE, FindCredit, SetC0, ChkC0


;     .   
;
;  		
; ------------------------------------------------------------------------
;   0		   
;   1		 ,    
;   2...3
;   4		  		LR
;   5		   (1-/0-)		LI
;   6		  (1-)				LJ
;   7		  (1-)			LA

LA	equ	80h			;  
LJ	equ	40h			;    
LI	equ	20h			;   ()
LR	equ	10h			;   

RcvFrame	equ	02h		;    ./
SendFrame	equ	01h		;   

;     .    = 
;  -----------------------------------------------------------------------

N1	equ	8			;    
					;     
N2	equ	5			;   ./

QT1	equ	16*50			; - 1 16 
QT2	equ	4*50			; - T2 4 
QTLR	equ	20*50			; -  LR  20 


	DSeg

extrn	CRCStat

public	Cn1, Cn2
Cn1:					;   
	ds	1
Cn2:					;   ./
	ds	1

public	T1, T1Stat, T2, TLR
T1:
	ds	2			;     T1
T1Stat:					;    - T1
	ds	1			; 0 -->  / -1 --> 

T2:					;     2
	ds	2
TLR:					;     TLR
	ds	2

public	NSendFrame, NRcvFrame
NSendFrame:				;     
	ds	1			;   
NRcvFrame:				;     
	ds	1			;   

public	RcvSys, RcvCredite
RcvSys:					;    
	ds	1
RcvCredite:				;    
	ds	1

public	SendSys, SendCredite
SendSys:				;      
	ds	1
SendCredite:				;   
	ds	1

public	LAStat, LJStat, LIStat
LAStat:					;   ?
	ds	1			;   (0 -> , -1 -> )
LJStat:					;   ?
	ds	1			;   (0 -> , -1 -> )
LIStat:					;   ?
	ds	1			;   (0 -> , -1 -> )

public	BoD
BoD:					;      
	ds	2

extrn	ToModem				;     
					;     Out  

public	BytesToModem
BytesToModem:				;     
	ds	2			;     CRC

public	ModemBuf
ModemBuf:
	ds	SizeFrame		;     STX, ETX, 
	ds	16			;   .   CRC


DELAY	macro	NN
	ei
	mvi	a,NN
	hlt
	dcr	a
	jnz	$-2
	endm

	CSeg

;        
;    

public	IniModem
IniModem:
	call	SetC0

	xra	a
	sta	LIStat
	sta	LJStat
	sta	LAStat
	sta	SendCredite

	lxi	h,0
	shld	ToModem

	mvi	a,0
	sta	NSendFrame
	sta	NRcvFrame
	ret

;     -   

public	SetupModem
SetupModem:
	mvi	a,N1
	sta	Cn1
	mvi	a,N2
	sta	Cn2
	call	DropT1			;  - T1
	call	SetT2			;  - T2

	lda	RcvCredite
	ora	a
	rz
	mvi	a,-1			;    , 
	sta	LIStat			;      
	ret


;    
;  :
;    <hl> -> OK  Error

extrn	SpaceMarker, IsMarker

public	Acceptor
Acceptor:
	call	IniModem
	call	modeOut
	DELAY	2
	call	SetTLR			;  -   LR

Space:
	call	SpaceMarker

AccWaitLR:
	call	modeInp
	call	ReadModem
	lxi	d,US
	call	HLDE
	jz	ABOCT

	call	modeOut
	DELAY	2

	lda	CRCStat			;  ,    ?
	ora	a
	jz	NotAccLR

	call	RcvFrameSys
	jc	NotAccLR		;    .  ?

	lda	RcvSys
	ani	LR
	jnz	AccWaitLA		;  LR  ?

NotAccLR:
	call	ChkC0			;    ?
	jz	NoConnect

	call	ChkTLR			;  -   LR ?
	jnc	Space
	jmp	NoConnect

AccWaitLA:
	call	SendLR			;  LR 

	call	modeInp
	call	ReadModem
	lxi	d,US
	call	HLDE
	jz	ABOCT

	call	modeOut
	DELAY	2

	lda	CRCStat
	ora	a
	jz	WaitConnect		;       ?

	call	RcvFrameSys
	jc	WaitConnect		;    .  ?

	lda	RcvSys
	mov	b,a
	ani	LR
	jnz	WaitConnect		;  LR ?

	mov	a,b
	ani	LA
	jnz	ConnLA			;   ?

	mov	a,b
	ani	LJ
	jnz	ConnLA			;   ?

	mov	a,b
	ani	LI			;  GOOD CRC !!!
	jnz	ConnLJ			;     -> 

WaitConnect:
	call	ChkC0			;    ?
	jz	NoConnect

	call	ChkTLR			;  -   LR ?
	jnc	AccWaitLA
	jmp	NoConnect


SendLR:					;  LR 
	call	FindCredit		;  LR 
	sta	SendCredite
	mvi	a,LR
	sta	SendSys
	call	PrepModemBuf
	call	WriteModem
	ret

;--------------------------------------------------------------------------

;    
;  :
;    <hl> -> OK  Error

public	Sender
Sender:
	call	SetTLR			;  -   LR

IniWaitLR:
	call	ChkC0			;    ?
	jz	NoConnect

	call	ChkTLR			;  -   LR ?
	jc	NoConnect

	call	modeInp
	call	ReadModem
	lxi	d,US
	call	HLDE
	jz	ABOCT

	call	modeOut
	DELAY	2

	lda	IsMarker
	ora	a			;   ? ->    !!!
	jz	IniWaitLR

	lda	CRCStat
	ora	a
	jz	RepeatLR		;   .  ?

	call	RcvFrameSys
	jc	RepeatLR		;    .  ?

	lda	RcvSys
	ani	LR
	jnz	ConnLA			;  LR ?

RepeatLR:
	call	SendLR			;  LR 
	jmp	IniWaitLR

;-------------------------------------------------------------------

;      

NoConnect:
	lxi	h,Error			;   !!!
	ret
ConnLA:
	mvi	a,-1			;  
	sta	LAStat			;  
	jmp	ConnGood
ConnLJ:
	mvi	a,-1			;  
	sta	LJStat			;  

ConnGood:
	call	SetupModem
	lxi	h,OK
	ret
ABOCT:
	lxi	h,US			;    
	ret



;     
;  :
;      <hl>	 
;    ---------------------------------------------------------
;	0	 
;	1	   
;	2	 -    
;	3	    
;	4	  

DELKEY	macro	NN
	mvi	a,NN
	ei
	dcr	a
	hlt
	jnz	$-2
	endm

public	OneMarker
OneMarker:
	lda	Cn1
	ora	a
	lxi	h,EndOfRepeat		;    
	rm

	call	PrepFrame
	call	WriteModem

	lda	SendSys			;  - 1   
	ani	LI			;  
	cnz	SetT1

	call	modeInp

	DELKEY	1			; 20 ms   

	call	ReadModem
	lxi	d,US
	call	HLDE
	lxi	h,US
	rz

	call	ChkC0			;   
	lxi	h,NoMarker
	rz
	rm

	call	ReceiveFrame
	call	modeOut

	DELKEY	2			; 40 ms   

	call	ChkT1
	lxi	h,OK			;  
	rnc
	lxi	h,TimeA			;  -  
	ret


;  / -

public	SetT1, SetT2, DropT1

SetT1:
	call	ReadTimer
	shld	T1
	mvi	a,-1
	sta	T1Stat
	ret
DropT1:
	xra	a
	sta	T1Stat
	ret
SetT2:
	call	ReadTimer
	shld	T2
	ret
SetTLR:
	call	ReadTimer
	shld	TLR
	ret


;   -
;  :
;     =1 - - 

public	ChkT2, ChkTLR
ChkT1:
	lda	T1Stat		;    ?
	ora	a
	rz
	lxi	d,QT1
	lhld	T1
	jmp	ChkTm
ChkT2:
	lxi	d,QT2
	lhld	T2
	jmp	ChkTm
ChkTLR:
	lxi	d,QTLR
	lhld	TLR
	jmp	ChkTm
	

;    

public	ReceiveFrame
ReceiveFrame:
	call	RcvFrameSys
	rc			;   ?

	call	RcvLI		;       CRC

	lda	CRCStat		;       
	ora	a		;       CRC
	rz

	call	RcvLA
	call	RcvLJ
	ret


;    
;  :
;     C=1 -   

public	RcvFrameSys
RcvFrameSys:
	lxi	h,ModemBuf+1
	call	FromBufModem
	rc				;  ETX ( ) ?
	mov	e,a
	call	FromBufModem
	rc				;   ?
	mov	d,a

	lda	CRCStat
	ora	a
	jz	CheckLI			; CRC  ? (0 -> )

	shld	BoD			;    
					; (  )
	mov	a,d
	sta	RcvCredite
	mov	a,e
	sta	RcvSys
	ret

CheckLI:				;   CRC   LI
	mov	a,e
	ani	LI
	sta	RcvSys
	ret


;   

public	RcvLI
RcvLI:
	lda	RcvSys
	ani	LI
	rz			;   ?

	mvi	a,N2		;   ./
	sta	Cn2

	call	SetT2		;   - T2

	lda	CRCStat
	ora	a
	jz	SetLJ		;    ?

	mvi	a,-1		;  
	sta	LAStat
	xra	a
	sta	LJStat

	lda	RcvSys
	ani	SendFrame
	mov	b,a
	jz	$+5		;    
	mvi	b,1
	mov	a,b
	sta	NRcvFrame

	lhld	BoD		;      
	jmp	RcvInfo


SetLJ:
	mvi	a,-1			;  
	sta	LJStat
	xra	a
	sta	LAStat
	ret

;        
;  :
;    <hl> -    
;  :
;    <a> -    
;    <hl> -  .    
;     =1 -  ETX

public	FromBufModem
FromBufModem:
	mov	a,m
	inx	h
	cpi	ETX
	stc
	rz
	cpi	DLE
	jnz	$+5
	mov	a,m
	inx	h
	ora	a
	ret


;   
;  :
;    ,  CRC 

public	RcvLJ
RcvLJ:
	lda	RcvSys
	ani	LJ
	rz			;   ?

	call	DropT1		;  - 1

	lda	RcvSys
	ani	RcvFrame
	mov	b,a
	jz	$+5		;   
	mvi	b,1

	mvi	a,-1		; .  
	sta	LIStat

	lda	NSendFrame
	cmp	b
	rz			;     ?

	;     ->    (  )
	;   ->      

	jmp	FreeResource


;   
;  :
;    ,  CRC 

public	RcvLA
RcvLA:
	lda	RcvSys
	ani	LA
	rz			;   ?

	call	DropT1		;  - 1

	lda	RcvSys
	ani	RcvFrame
	mov	b,a
	jz	$+5		;    (0/1) ?
	mvi	b,1

	mvi	a,-1		; .  
	sta	LIStat

	lda	NSendFrame
	cmp	b
	rnz			;      ?

	;   ->    (  )
	;     ->      

;    Out    
;         
;  :
;     Z=1 -      ( )

public	FreeResource
FreeResource:
	lda	NSendFrame		;    
	xri	1
	sta	NSendFrame

	mvi	a,N1			;     
	sta	Cn1			;   

	jmp	ResFree

;---------------------------------------------------------------------

;     

public	PrepFrame
PrepFrame:
	xra	a
	sta	SendSys
	call	SendLA
	call	SendLJ
	call	SendLI
	call	PrepModemBuf
	ret

;   

public	SendLA
SendLA:
	lda	LAStat
	ora	a
	rz

	call	ChkCn2T2		;    LA ?
	rnc

	lda	SendSys
	ori	LA
	mov	b,a
	lda	NRcvFrame
	ora	a
	jz	$+5			;   
	mvi	a,RcvFrame
	ora	b
	sta	SendSys
	ret

;   

public	SendLJ
SendLJ:
	lda	LJStat
	ora	a
	rz

	call	ChkCn2T2		;    LJ ?
	rnc

	lda	SendSys
	ori	LJ
	mov	b,a
	lda	NRcvFrame
	xri	1
	jz	$+5			;  .. + 1
	mvi	a,RcvFrame
	ora	b
	sta	SendSys
	ret

public	ChkCn2T2
ChkCn2T2:
	lda	Cn2
	dcr	a
	sta	Cn2
	stc
	rp			;    ?
	xra	a
	sta	Cn2

	call	ChkT2
	rnc
	call	SetT2		;  - 2 
	stc
	ret


;   

public	SendLI
SendLI:
	lda	LIStat
	ora	a
	rz

	lda	RcvCredite		;   ?
	ora	a
	rz

	call	OutHowMany
	mov	a,l
	ora	h
	rz				;   ?

	lda	SendSys
	ori	LI
	mov	b,a
	lda	NSendFrame
	ora	a
	jz	$+5			;  .   
	mvi	a,SendFrame
	ora	b
	sta	SendSys

	xra	a			;   LI  
	sta	LIStat			;   

	lda	Cn1			;    
	dcr	a
	sta	Cn1
	ret


;      	

public	PrepModemBuf
PrepModemBuf:
	lxi	h,ModemBuf
	mvi	m,STX
	inx	h
	lda	SendSys
	ani	0f0h
	jnz	FrameWithInfo

	lda	SendCredite		;   
	ora	a
	jnz	SetETX			;   ?

FrameWithInfo:
	call	SendFrameSys		;  . 
	shld	BoD

	lda	SendSys
	ani	LI
	jz	SetETX			;    ?

	call	OutHowMany		; <hl> := min(CountOut, RcvCredite)
	xchg
	lda	RcvCredite
	mov	l,a
	mvi	h,0
	call	HLDE
	jc	$+4
	xchg				; CountOut < RcvCredite

	mov	c,l
	lhld	BoD			;   . 
	mvi	b,SizeFrame		; max .   

extrn	SendInfo			;   Bufers
	call	SendInfo

SetETX:
	mvi	m,ETX
	inx	h

	lxi	d,ModemBuf		;    
	call	HLsubDE			;   ( CRC)
	shld	BytesToModem
	ret


public	SendFrameSys
SendFrameSys:				;     . 
	lxi	h,ModemBuf+1
	lda	SendSys
	call	ToBufModem
	push	h
	call	FindCredit
	sta	SendCredite		;  .  
	pop	h

;     .   
;  :
;    <a> -  
;    <hl> -    
;  :
;    <hl> -   . 

public	ToBufModem
ToBufModem:
	cpi	DLE
	jz	HLSpecial
	cpi	STX
	jz	HLSpecial
	cpi	ETX
	jnz	HLOrdinary
HLSpecial:
	mvi	m,DLE
	inx	h
HLOrdinary:
	mov	m,a
	inx	h
	ret


public	HLDE
HLDE:
	mov	a,h
	cmp	d
	rnz
	mov	a,l
	cmp	e
	ret

	end
