;;						- 1 -
;;**************************************
;;      blok sistemnyh podprogramm
;;  ----------------------------------
;;  VERS.1.3		DATA:14-DEC-90
;;**************************************
;;
strok	EQU	9		; ~islo strok na displee
;;
	ORG	100H
;;
		DS	3
@RI:		DS	3
@PO:		DS	3
@INKEY:		DS	3
@BORD:		DS	3
@SCROLL:	DS	3
@SETCLR:	DS	3
;;
BLOCK	EQU	0
;;
	MACLIB	LIFE
;;
	ORG	LIFE0
;;
	DS	3		; perehod na MAIN-PROGRAM
;;
	JMP	@RI
	JMP	CI
	JMP	INKEY
	JMP	CO
	JMP	@PO
	JMP	PEC
	JMP	LADDR
	JMP	LBYTE
	JMP	LHIGH
	JMP	LLOW
	JMP	SETBEGINDISP
	JMP	SETMARKDISP
	JMP	DECHEX
	JMP	CONV
	JMP	@BORD
	JMP	@SCROLL
	JMP	@SETCLR
	JMP	spec
	JMP	DELAY
	JMP	CIHL
;;
BEGINDISP:			; adres na~ala tekst.displeq
	DW	8B10H
MARKINF:			; marker tekst.displeq
	DW	0
;;
;;  ustanowka na~ala tekst.displeq
;;  whod:
;;    <H,L> - adres nivn.lewogo ugla disleq
SETBEGINDISP:
	SHLD	BEGINDISP
	RET
;;;;						- 2 -
;;  ustanowka markera
SETMARKDISP:
	MOV	A,H
	CPI	12
	JC	$+5
	MVI	H,11
	MOV	A,L
	CPI	strok+1
	JC	$+5
	MVI	L,strok
	SHLD	MARKINF
	RET
;;
;;  drajwer litern.displeq
;;  whod:
;;    <s> - bajt dlq wywoda
;;    MARKINF - marker
;;    BEGINDISP - adres nivn.lewogo ugla displeq
CO:
	MOV	A,C
	ANI	07FH
	CPI	20H
	JNC	COTEXT	; normalxnyj tekst
	PUSH	H
	LHLD	MARKINF
	CPI	0DH
	JZ	wk
	CPI	0AH
	JZ	ps
	CPI	0CH
	JZ	HOME
	CPI	1FH
	JZ	str
	CPI	08H
	JZ	wlewo
	CPI	18H
	JZ	wprawo
	CPI	01H
	JZ	INVERS
	CPI	02H
	JZ	POZITIV
	CPI	0EH
	JZ	RUS
	CPI	0FH
	JZ	LAT
	POP	H
	RET
;;
INVERS:
	MVI	A,CMA
	JMP	$+5
POZITIV:
	MVI	A,NOP
	STA	MODOUT
	POP	H
	RET
;;
RUS:	MVI	A,40H
	JMP	$+5
LAT:	MVI	A,0
	STA	MODCHAR
	POP	H
	RET
;;;;						- 3 -
wk:	MVI	H,0
	JMP	EXCTRL
ps:	DCR	L
	JP	EXCTRL
	MVI	L,strok
	JMP	EXCTRL
str:	CALL	DARKSEEL	; steretx displej
HOME:	LXI	H,strok
	JMP	EXCTRL
wlewo:	DCR	H
	JP	EXCTRL
	MVI	H,11
	JMP	EXCTRL
wprawo:	INR	H
	MOV	A,H
	CPI	12
	JNZ	EXCTRL
	MVI	H,0
EXCTRL:	SHLD	MARKINF
	POP	H
	RET
;;;;						- 4 -
COTEXT:
	PUSH	H
	PUSH	D
	PUSH	B
;;
	ANI	7FH
	SUI	20H
	CPI	20H
	JC	$+5
MODCHAR	EQU	$+1
	ADI	0		; rus/lat
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	LXI	D,CHAR
	DAD	D
	XCHG			; adres znaka
;;
	LHLD	MARKINF
	MOV	A,H
	CPI	12
	CZ	wkps
	MOV	B,H
	INR	H
	SHLD	MARKINF
	MOV	A,L
	ADD	A
	ADD	A
	ADD	L
	ADD	A
	MOV	C,A
;;
	LHLD	BEGINDISP
	DAD	B
;;
	MVI	B,8
	LDAX	D
MODOUT:	NOP			; inwers./pozitiw
	MOV	M,A
	INX	H
	INX	D
	DCR	B
	JNZ	$-6
;;
	POP	B
	POP	D
	POP	H
	RET
;;;;						- 5 -
wkps:	MVI	H,0		; wkps pri perepoln.stroki
	DCR	L
	RP
	MVI	L,0
	RET
;;
;;  wywod tekstowoj posledowatelxnosti
;;  whod: PEC
;;    <H,L> - adres stroki
@PEC:	MOV	C,A
	CALL	CO
PEC:
	MOV	A,M
	INX	H
	ORA	A
	JM	@CCO
	JNZ	@PEC
	RET
;;
@CCO:				; obrabotka posledowatelxnosti :
	PUSH	B		;  ukazatelx cikla ==> 80H-0FFH
	ANI	7FH		;  litera
	MOV	B,A
	MOV	C,M
	INX	H
BCO:
	CALL	CO
	DCR	B
	JNZ	BCO
	POP	B
	JMP	PEC
;;
LADDR:
	MOV	A,H
	CALL	LBYTE
	MOV	A,L
LBYTE:
	CALL	LHIGH
LHIGH:
	RRC
	RRC
	RRC
	RRC
LLOW:
	PUSH	PSW
	ANI	0FH
	CALL	CONV
	MOV	C,A
	CALL	CO
	POP	PSW
	RET
;;
CONV:
	ADI	90H
	DAA
	ACI	40H
	DAA
	RET
;;;;						- 6 -
;;  preobrazowatx HEX w DEC
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <H,L> - DEC
DECHEX:
	LXI	H,0
	MVI	B,8
;;
	ADD	A
	PUSH	PSW
	MOV	A,L
	ADC	L
	DAA
	MOV	L,A
	MOV	A,H
	ADC	H
	DAA
	MOV	H,A
	POP	PSW
	ORA	A
	DCR	B
	JNZ	DECHEX+5
	RET
;;
INKEY:	PUSH	B
	MVI	A,0FFH
INK:	MOV	B,A
	CALL	@INKEY
	CPI	0FFH
	JNZ	INK
	MOV	A,B
	POP	B
	RET
;;
CI:	CALL	INKEY
	CPI	0FFH
	JZ	CI
	RET
;;
spec:	PUSH	D
	MOV	D,M
	INX	H
	MVI	E,1
poisk:	CMP	M
	INX	H
	JZ	najdena
	INR	E
	DCR	D
	JNZ	poisk
	MOV	E,D		; = 0 !!!
najdena:
	MOV	A,E
	POP	D
	RET
;;;;						- 7 -
;;  zadervka <a> kadrow
;;  wyhod:
;;    flag Z := 0 pri wyhode po navatii na l`bu` klawi{u
DELAY:	PUSH	B
	MOV	B,A
DELAYC:	CALL	INKEY
	CPI	0FFH
	JNZ	EXDEL
	HLT
	DCR	B
	JNZ	DELAYC
EXDEL:	POP	B
	RET
;;
;;  wwod stroki s klawiatury
;;  whod:
;;    <H,L> - adres na~ala bufera
;;    <D> - MAX razmer bufera
CIHL:
	PUSH	H
	PUSH	B
	MVI	C,01H
	CALL	CO
	MVI	C,0EH
	CALL	CO
BGNTXT:	MVI	B,1
NEXTLIT:CALL	CI
	MOV	C,A
	CPI	0DH
	JZ	kontekst
	CPI	7FH
	JZ	DELLIT
	MOV	A,B
	DCR	A
	CMP	D
	JZ	NEXTLIT
	CALL	CO
	MOV	M,C
	INX	H
	INR	B
	JMP	NEXTLIT
;;
TXTZABOJ:
	DB	08H,02H,0FH,5FH,0EH,08H,01H,0
DELLIT:
	DCR	B
	JZ	BGNTXT
	DCX	H
	MVI	M,' '
	PUSH	H
	LXI	H,TXTZABOJ
	CALL	PEC
	POP	H
	JMP	NEXTLIT
kontekst:
	MVI	C,0FH
	CALL	CO
	POP	B
	POP	H
	RET
;;
	END
