;;						- 1 -
;;******************************	******************
;;	L I F E - P L A Y		  
;;  --------------------------		  --------------
;; VERS.5.15	DATA:02-JAN-91		    MAIN-BLOCK
;;******************************	******************
;;
BLOCK	EQU	6
;;
	MACLIB	LIFE
;;
	ORG	LIFE0
;;
	JMP	PROGRAM
;;
	ORG	LIFE6
;;
wyzow:	DB	0
GRIDCELL:
	DB	0
INFCELL:
	DB	0
TABCOM:
	DB	7
	DB	0CH		; wyswetitx lupu
	DB	1FH		; pogasitx lupu
	DB	18H,1AH,08H,19H	; wprawo,wniz,wlewo,wniz
TABC1:
	DB	11
	DB	' FH'
	DB	10H,1EH		; us+p,us+~
	DB	'P^'		;    p,   ~
	DB	'I',14H,'TS'
TABM:
	DB	6
	DB	02H,1BH		; otkrytx,zakrytx rabo~ij makros
	DB	00H,01H		; rabota s sist.makrosami
	DB	03H,04H		; tove s rabo~imi
;;
PROGRAM:
	LXI	SP,100H
	XRA	A
	OUT	10H
	STA	INFCELL
	STA	FLAGMAC		; sbros makrosa
	LDA	wyzow
	ORA	A
	JNZ	FORCLS		; perwyj prohod ?
;;
	STA	GRIDCELL	; nastrojka tolxko pri perwom prohode
	CMA
	STA	wyzow
	LXI	D,TABCLRA
	CALL	SETCLR
	XRA	A
	CALL	BORD
	MVI	A,-1
	CALL	SCROLL
	CALL	prizyw
	LXI	D,TABCLR1
	CALL	SETCLR
	CALL	CLS
	CALL	GRID
;;;;						- 2 -
FORCLS:
	LXI	SP,100H
	CALL	INITIME
	IN	1
	ANI	01000000B
	JNZ	INPCOM
;;
	CALL	CLSFIELD			; nowoe pole pri navatom us
	CALL	COPYBLOCK
;;
INPCOM:	LXI	SP,100H
	CALL	SAVEBLOCK
	MVI	A,1			; wkl`~itx displej
	CALL	SETCOM
	CALL	uprdisplej
	CALL	dopinf
	CALL	SETC
	CALL	INF2
PLAY:	CALL	smlupa
	CALL	displej
	CALL	INFTIME
	CALL	NEWBLOCK
	ORA	A
	JNZ	INPCOM
	CALL	INCTIME
	JMP	PLAY
;;
TABCLR1:
	DB	000H,022H,036H,036H	; ~ernyj,kirpi~nyj,veltyj,veltyj
	DB	0D0H,0D0H,0D0H,0D0H	; goluboj
	DB	036H,036H,036H,036H	; veltyj
	DB	036H,036H,036H,036H	; veltyj
TABCLR0:
	DB	000H,000H,0ADH,0ADH	; ~ernyj,~ernyj,belyj,belyj
	DB	0D0H,0D0H,0D0H,0D0H	; goluboj
	DB	036H,036H,036H,036H	; veltyj
	DB	036H,036H,036H,036H	; veltyj
;;;;						- 3 -
SETC:	CALL	displej
	CALL	smlupa
	CALL	INF1
	CALL	INFMAC
SETC2:	CALL	DATAMARK
	CALL	INFXY
	CALL	MARKINKEY
	CPI	0FFH
	JZ	$-5
SETC3:	MOV	B,A
	LXI	H,TABM
	CALL	spec
	ORA	A
	JNZ	MACROS
	MOV	A,B
	LXI	H,TABC1
	CALL	spec
	ORA	A
	JNZ	dopkom
	MOV	A,B
	LXI	H,TABCOM
	CALL	spec
	ORA	A
	JZ	SETC2
	CALL	WRITEMAC
	CALL	uprawlenie
	CALL	CHECKLIGHT
	JM	SETC2
	CALL	MACEND
	MVI	A,10
	CALL	DELAY
	RET
dopkom:
	DCR	A
	RZ			; na~alo igry
	DCR	A
	JZ	@SEENAME
	DCR	A
	JZ	TIME
	DCR	A
	JZ	@OUTPUT
	DCR	A
	JZ	@INPUT
	DCR	A
	JZ	@DUMPER
	DCR	A
	JZ	@REDUMPER
	DCR	A
	JZ	informaciq
	DCR	A		; steretx pole
	JZ	FORCLS
	DCR	A
	JZ	@strokno
COLORGRID:
	LDA	GRIDCELL
	XRI	80H
	STA	GRIDCELL
	LXI	D,TABCLR0
	JM	$+6
	LXI	D,TABCLR1
	CALL	SETCLR
	JMP	SETC
;;;;						- 4 -
@SEENAME:
	CALL	SEENAME
	JMP	SETC
TIME:
	CALL	INF2
	CALL	INFTIME
	MVI	A,2*50
	CALL	DELAY
	CALL	INF1
	CALL	INFXY
	JMP	SETC
@DUMPER:
	CALL	DUMPER
	JMP	SETC
@REDUMPER:
	CALL	REDUMPER
	CALL	COPYBLOCK
	JMP	SETC
@INPUT:
	CALL	INPUT
	JMP	SETC
@OUTPUT:
	CALL	OUTPUT
	JMP	SETC
informaciq:
	CALL	CHECKLIGHT
	JP	SETC2
	CALL	INFORM
	JMP	SETC
@strokno:
	CALL	strokno
	CALL	SAVEBLOCK
	JMP	SETC
;;
uprawlenie:
	MOV	B,A
	ANI	01000000B
	JZ	uprlupa			; us
;;
	MOV	A,B
	ANI	00100000B
	JZ	puprdisplej		; ss
	JMP	uprmarker		; prostoj
;;
puprdisplej:
	CALL	INFDARK
	CALL	uprdisplej
	CALL	INF1
	RET
;;;;						- 5 -
;;  obrabotka komand makro revima
MACROS:
	DCR	A
	JNZ	MKS2
	CALL	BGNMAC
	JMP	SETC
MKS2:
	DCR	A
	JNZ	MKS3
	CALL	MACEND
	JMP	SETC
MKS3:
	DCR	A
	MOV	C,A
	CALL	MARKINKEY		; ukazatx naprawlenie
	CPI	0FFH
	JZ	$-5
	LXI	H,TABDIRKEYS
	CALL	spec
	ORA	A
	JZ	SETC2
	DCR	A
	MOV	B,A			; naprawlenie
	MOV	A,C
	ANI	1			; zerk.otobravenie ?
	ADD	A
	ADD	A
	ADD	B
	MOV	B,A
;;
	MOV	A,C
	ANI	2
	LXI	H,BUFMAC
	JNZ	MKS5			; rabo~ij makros ?
;;
	CALL	MARKINKEY		; sistemnye makrosy
	CPI	0FFH
	JZ	$-5
	LXI	H,TABSYSTEM
	CALL	spec
	ORA	A
	JZ	SETC2
	DCR	A			; ukazan nomer sist.makrosa
	ADD	A
	LXI	H,TABADRMACROS
	ADD	L
	MOV	L,A
	JNC	$+4
	INR	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	JMP	MKS6
;;;;						- 6 -
MKS5:
	LDA	FLAGMAC			; rabo~ij makros zakryt ?
	ANI	01000000B
	JZ	SETC2
;;
MKS6:
	CALL	READMAC
	CALL	INFXY
	CALL	MARKINKEY
	CPI	0FFH
	JZ	$-5
	CPI	07FH		; zaboj
	JNZ	SETC3
	CALL	RESTOREPOINT
	CALL	COPYBLOCK
	CALL	RESTORESTATUS	; wosstanowitx sostoqnie do makrosa
	JMP	SETC2
;;
;;  wkl.revim wwoda makrosa komand
BGNMAC:
	LDA	FLAGMAC
	ORI	10000000B
	ANI	10111111B
	STA	FLAGMAC
	LXI	H,BUFMAC
	SHLD	ADRMAC
	RET
;;
;;  pisatx w makros komand
;;  whod:
;;    <A> - komanda dlq lupy
WRITEMAC:
	MOV	B,A
	CALL	SETCOM
	IN	1
	ANI	01100000B
	PUSH	PSW
	ORA	B
	MOV	B,A
	LDA	FLAGMAC
	ORA	A
	JP	EXWRTM		; pisatx ?
	MOV	A,B
	CPI	20H
	JZ	EXWRTM
	CPI	40H
	JZ	EXWRTM
	CPI	00H
	JZ	EXWRTM
	LHLD	ADRMAC
	MOV	M,B
	INX	H
	MVI	M,0
	SHLD	ADRMAC
EXWRTM:	POP	PSW
	RET
;;;;						- 7 -
;;  zakon~itx makros komand
MACEND:
	LDA	FLAGMAC
	ANI	10111111B
	RP			; makros ne otkrywali dlq zapisi ?
	XRI	11000000B
	STA	FLAGMAC
	RET
;;
;;  ~itatx makros
;;  whod:
;;    <B> - naprawlenie
;;    <H,L> - adres na~ala makrosa
READMAC:
	PUSH	H
	PUSH	B
	LXI	H,FIELD-1	; iniciirowotx spisok to~ek
	SHLD	LIST
	XRA	A
	STA	POINTS
	CALL	STORESTATUS
	POP	B
	POP	H
;;
CREADM:
	MOV	A,M
	ORA	A
	RZ
	PUSH	B
	PUSH	H
	ANI	00001111B
	CALL	CHANGEDIR
	CALL	SETCOM
	CPI	3
	CC	PUSHPOINTTOLIST		; esli menqem to~ku
	MOV	A,M
	CALL	uprawlenie
	CALL	DATAMARK
	POP	H
	POP	B
	INX	H
	JMP	CREADM
;;
TABSYSTEM:
	DB	16
	DB	'0123456789ABCDEF'
TABDIRKEYS:
	DB	4
	DB	19H,18H,1AH,08H		; 0,90,180,270 grad.
;;;;						- 8 -
;;  smenitx naprawlenie
;;  whod:
;;  <A> - komanda 0-6
;;  <B> - izmenenie naprawl.
;;    1 - 0 grad.,
;;    2 - 90 grad.
;;    3 - 180 grad.
;;    4 - 270 grad.
;;  wyhod:
;;    <A> - komanda 0-2 i nowaq 3-6
CHANGEDIR:
	CPI	3		; ne komandy naprawleniq
	RC
	PUSH	H
	SUI	3
	MOV	L,A
	MOV	A,B
	ANI	00000111B
	ADD	A
	ADD	A
	ADD	L
	LXI	H,TABCHDIR
	ADD	L
	MOV	L,A
	JNC	$+4
	INR	H
	MOV	A,M
	POP	H
	RET
;;
TABCHDIR:
	DB	3,4,5,6
	DB	4,5,6,3
	DB	5,6,3,4
	DB	6,3,4,5
;;
	DB	3,6,5,4
	DB	4,3,6,5
	DB	5,4,3,6
	DB	6,5,4,3
;;
INFMAC:
	LDA	FLAGMAC
	ORA	A
	RP
	LXI	H,TXTMAC
	JMP	PEC
;;
TXTMAC:
	DB	1,'M',80H+5,18H,'M',0DH,2,0
;;;;						- 9 -
;;  wnesti to~ku w spisok
PUSHPOINTTOLIST:
	PUSH	H
	PUSH	D
	PUSH	B
	CALL	FINDPOINT
	XCHG
	LHLD	LIST
	MOV	M,C		; tip to~ki
	DCX	H
	MOV	M,D		; X
	DCX	H
	MOV	M,E		; Y
	DCX	H
	SHLD	LIST
	LDA	POINTS		; ~islo izm.to~ek
	INR	A
	STA	POINTS
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wosstanowitx to~ki iz spiska
RESTOREPOINT:
	LDA	POINTS
	DCR	A
	RM
	STA	POINTS
	LHLD	LIST
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	MOV	C,M		; tip to~ki
	SHLD	LIST
	XCHG
	CALL	SETPOINT
	JMP	RESTOREPOINT
;;
POINTS:
	DB	0
LIST:
	DW	FIELD-1
;;
FLAGMAC:
	DB	0		; bit 7  => pisatx makros (0-net/1-da)
;				;     6  => estx makros     --"--"--
;;;;						- 10 -
prizyw:
	LXI	H,TGOOD
	JMP	TEXTOUT
;;
dopinf:
	LDA	INFCELL
	ORA	A
	RNZ
	CMA
	STA	INFCELL
	LXI	H,TADDINF
TEXTOUT:
	CALL	PEC
	MVI	A,0
	CALL	DELAY
	RET
TADDINF:
	DB	0CH,0EH,80H+9,0AH
	DB	1,'I',2,'-informaciq',0FH,0
TGOOD:
	DB	0CH,0EH,80H+8,0AH
	DB	2,' ',1,'PROGRAMMA',2,80H+3,' ',1,'zagruvena',2,'  ',0FH,0
TABCLRA:
	DB	  0,128,208, 16, 54,134,  6,173
	DB	 54, 54, 54, 54, 54, 54, 54, 54
;;
;;  tablica adresow sist.makrosow
TABADRMACROS:
	DW	blok
	DW	badxq
	DW	ulej
	DW	prud
	DW	lodka
	DW	korablx
	DW	planer
	DW	legkij
	DW	srednij
	DW	tqvelyj
	DW	ruvxe
	DW	poviratelx
	DW	parowoz
	DW	migalka
	DW	swetofor
	DW	pulxsar
;;
;;  spisok sistemnyh makrosow
blok:								; 0
	DB	'afacadae',0
badxq:								; 1
	DB	'eafcaddacfae',0
ulej:								; 2
	DB	'eafcacadcadeaeaf',0
prud:								; 3
	DB	'eafafcacacdadadeaeaf',0
lodka:								; 4
	DB	'eafcacdadaeaf',0
korablx:							; 5
	DB	'eafacadcadaeaf',0
planer:								; 6
	DB	'edacacafafead',0
legkij:								; 7
	DB	'eeeadcacacacafafafeadd',0
srednij:							; 8
	DB	'eeeeadcacacacacafafafeadd',0
tqvelyj:							; 9
	DB	'eeeeeadcacacacacacafafafeadd',0
ruvxe:								; 10
	DB	' cadadacafafafcacfacdadcadadade'
	DB	'adeaefaff#cccccacafaea%%eeeeafafaeaeaeadadacacad'
	DB	'aeaeaeadaffffffadacacacad%eeeeaeadaca##cd',0
poviratelx:							; 11
	DB	'facadadeaeaeadaccff',0
parowoz:							; 12
	DB	'eeaeafaeadadacafcccfaffafcacac'
	DB	'acadadadeaddadcadadaeaeaeaefaffaf',0
migalka:							; 13
	DB	'eacacae',0
swetofor:							; 14
	DB	'eeeafaddadcdcacacacfcfafafafefeaeaeadddc',0
pulxsar:							; 15
	DB	'eeeaedadadcdcacacfafeafeafffaeafacadcdcdcdcdacadaeafefef',0
;;
ADRMAC:
	DW	BUFMAC
BUFMAC:
	DB	0
;;
	END
