
;         V23
;  -----------------------------------

	maclib	Timer

DTest	equ	2

	maclib	TEST
	IF	TEST = 1
	Common	/v23in/
	db	'v23in		v.2.23'
	if	DTest=1
	db	'T'
	endif
	if	DTest=2
	db	'D'
	endif
	db	'	11-jan-94$'
	ENDIF

	CSeg

;   

OK	equ	0
TimeA	equ	1	;  -
US	equ	4	;   


Rus	equ	4
PC	equ	5
PB	equ	6
PA	equ	7


extrn	Middle, TabCorrect
Lower	equ	300
Upper	equ	700
Hz1200	equ	1214+32
Bound	equ	24*Hz1200/16
Addict	equ	48

FindZ	macro
	local	clFindZ
	local	ExFindZ
	in	PC	; 10
	ani	1	;  7
	mov	h,a	;  5
	mvi	l,100h/4	;  7
clFindZ:
	dcr	l		;  5
	jz	ExFindZ		; 10
	in	PC		; 10
	ani	1		;  7
	cmp	h		;  5
	jz	clFindZ		; 10
	lhld	TimeCount
	xchg
	RdTime	8		; 47
	shld	TimeCount
	HLeqDEsubHL
	shld	Delta		;   
	stc
ExFindZ:
	cmc
	endm

FindZZ	macro
	local	clFindZ
	local	ExFindZ
	in	PC	; 10
	ani	1	;  7
	mov	h,a	;  5
	mvi	l,100h/4	;  7
clFindZ:
	dcr	l		;  5
	jz	ExFindZ		; 10
	in	PC		; 10
	ani	1		;  7
	cmp	h		;  5
	jz	clFindZ		; 10
	sta	NewLevel
	lhld	TimeCount
	xchg
	RdTime	8		; 47
	shld	TimeCount
	HLeqDEsubHL
	shld	Delta		;   
	stc
ExFindZ:
	cmc
	endm


extrn	IniTimer, ChngTimer

	DSeg

T1	equ	3*50		; 3  - 1
T2100	equ	40*50		; 20  -   2100 Hz
Q2100	equ	3*2100*2	;    2100 Hz  3- .

public	Time1
Time1:
	ds	2
Time2100:
	ds	2
NewLevel:
	ds	1
OldLevel:
	ds	1

	CSeg

;   - T1
;  :
;     =1 - - 

extrn	CountRst7
public	ChkT1
ChkT1:
	lhld	Time1
	xchg
	lhld	CountRst7
	HLsubDE
	lxi	d,T1
	HLDE
	cmc
	ret

;   - T1
;  :
;     =1 - - 

public	ChkT2100
ChkT2100:
	lhld	Time2100
	xchg
	lhld	CountRst7
	HLsubDE
	lxi	d,T2100
	HLDE
	cmc
	ret


;    
;      C=1 -    - !!!
;    <hl> -  

public	Find2100
Find2100:
	di
	IniTime	0,3,0,0
	WrtTime	0,0ffffh

	call	ReadTimer	;  - T2100
	shld	Time2100

	FindZ			;  
All2100:
	lxi	b,Q2100
Next2100:
	in	1
	ani	040h
	cpi	040h
	jnz	ExUS		;    C !!!
	call	ChngTimer	;  
	cc	ChkT2100		;  - T2100
	jc	ExTime			; - T2100  ?
	FindZZ			; 180
	jc	All2100		;  10

	mvi	d,0		;  
	lda	OldLevel
	mov	e,a
	lda	NewLevel
	sta	OldLevel
	cmp	e
	jnz	GoodLevel
	
	mvi	d,-1		;  
	mov	a,h		;  =0 !!!
	rar
	mov	h,a
	mov	a,l
	rar
	mov	l,a		; <hl> / 2
	
GoodLevel:
	mov	a,d
	sta	GoodInterval+1	;  !!!
	xchg
	lhld	Middle		;  10
	xchg
	HLDE			;  30
	jnc	All2100		;  10
	lxi	d,Lower		;  16
	HLsubDE			;  30
	jc	All2100		;  10

public	GoodInterval
GoodInterval:
	mvi	a,0
	ora	a		;     ?
	dcx	b
	jz	$+4
	dcx	b

	mov	a,b		;   5
	ora	a		;   5
	jp	Next2100	;  10
				;   !!!
	lxi	h,OK
	ret
ExUS:				;   
	lxi	h,US
	ret
ExTime:				;  -
	lxi	h,TimeA
	ret


;    
;      C=1 -    - !!!
;    <hl> -  

extrn	ReadTimer
public	Sync
Sync:
	di
	IniTime	0,3,0,0
	WrtTime	0,0ffffh

	call	ReadTimer	;  - T1
	shld	Time1

	FindZ			;  
AllWhistle:
	mvi	b,20
NextWhistle:
	in	1
	ani	040h
	cpi	040h
	jnz	ExUS
	call	ChngTimer	;  
	cc	ChkT1		;  - T1
	jc	ExTime		; - T1  ?
	FindZ			; 180
	jc	AllWhistle	;  10
	lxi	d,Upper		;  10
	HLDE			;  30
	jnc	AllWhistle	;  10
	xchg			;   4
	lhld	Middle		;  16
	xchg			;   4
	HLsubDE			;  30
	jc	AllWhistle	;  10
	dcr	b		;   5
	jnz	NextWhistle	;  10
	ora	a			;   !!!
	lxi	h,OK
	ret			;  10 ; sum = 336 ( call) ; *(3/5) = 205


Dump	equ	8802h
IniToMem	macro
	if	DTest=1
	DSeg
	public	AdrDump
AdrDump:
	ds	2
	CSeg
	push	h		; 10
	lxi	h,Dump		; 10
	mov	m,d		;  7
	inx	h		;  5
	mov	m,e		;  7
	inx	h		;  5
	shld	AdrDump		; 16
	pop	h		; 11 ; sum = 51
	endif
	if	DTest=2
	CSeg
	push	psw
	nop
	pop	psw
	push	psw
	nop
	pop	psw		; sum = 42+8=50
	endif
	endm
ToMem	macro
	if	DTest=1
	push	h		; 10
	lhld	AdrDump		; 16
	mov	m,d		;  7
	inx	h		;  5
	mov	m,e		;  7
	inx	h		;  5
	mvi	m,0		;  7
	inx	h		;  5
	inx	h		;  5
	shld	AdrDump		; 16
	pop	h		; 11 ; sum = 94
	endif
	if	DTest=2
	push	psw
	mvi	a,4		;  7
	dcr	a		;  5
	jnz	$-1		; 10 ; sum = 21 + 7 + 4*15 = 88
	pop	psw
	endif
	endm

ToMemPoint	macro
	if	DTest=1
	push	h
	lhld	AdrDump
	mov	m,d
	inx	h
	mov	m,e
	inx	h
	mvi	m,-1
	inx	h
	inx	h
	shld	AdrDump
	pop	h
	endif
	if	DTest=2
	push	psw
	mvi	a,4		;  7
	dcr	a		;  5
	jnz	$-1		; 10 ; sum = 21 + 7 + 4*15 = 88
	pop	psw
	endif
	endm


;      V23
;  :
;     c=1 - 
;    <a> - 

FindTZ	macro
	call	ChngTimer	;   
;	cc	ChkT1		;  - T1
;	jc	ExitV23		; - T1  ?
	FindZ
	jc	ExitV23
	endm

public	ReadV23
ReadV23:
	push	h
	push	d
SrcFill:
	FindTZ			; 180
	xchg			;   4
	lhld	Middle
	xchg
	HLsubDE
	HLdiv16
	mov	b,a		; J
	jm	SrcFill

public	SearchStart
SearchStart:
	FindZ			; 180
	jc	ExitV23				; !!!
	xchg			;   4
	lhld	Middle		;  16
	HLsubDE			;  30 ; D2 := Middle-Delta2
	HLdiv16
	jp	Start		;  10

	IniToMem
	cma
	inr	a		;  16 ; J := -I
	mov	b,a

	dcr	a
	mov	c,a	; j-1
	add	a	; *2
	add	a	; *4
	add	a	; *8
	add	a	; *16
	mov	c,a	; (j-1)*16 ;  !!!

	jmp	SearchStart	;  10 ; sum := 300 (*3/5) -> 180

public	Start
Start:
	ToMem
	ora	a
	jz	IZero		;  10 ; i
	dcr	a
	add	c
	mov	c,a	; Index := 13*(j-1)+(i-1)
	mov	a,b
	ora	a
	jz	JZero
	mvi	b,0
	lxi	h,TabCorrect
	dad	b
	dad	b
	mov	a,m		; 
	inx	h
	mov	h,m
	mov	l,a
	jmp	SetTime

JZero:
	lhld	Delta
	mov	d,h
	mov	e,l
	dad	h
	dad	d		; Delta*3
	jmp	SetHalf
IZero:
	lhld	Delta
SetHalf:
	ora	a
	mov	a,h		; div 2
	rar
	mov	h,a
	mov	a,l
	rar
	mov	l,a

SetTime:
;	shld	Time		; T := 

	lxi	d,-Addict	; ???   
	dad	d

public	Info
Info:
	lxi	b,0009h		; Info, N 

CHECK	macro	RegH,RegL,Word
LW	set	Low Word
HW	set	High Word
	local	exc
	mov	a,RegH
	cpi	HW
	jnz	exc
	mov	a,RegL
	cpi	LW
exc:
	endm

public	clInfo
clInfo:
	push	h
	lhld	Delta		; Delta[i-1]
	shld	DeltaP
	FindZ			; hl - Delta
	pop	d		; de - Time
	jc	ExitV23
	xchg
	dad	d		; T := T + Delta (hl)
				; Delta (de)
	CHECK	H,L,Bound	; 1.5* 1200 Hz
	jc	clInfoMem

	ToMemPoint

	dcr	c
	jz	ExInfo

	lxi	d,-Hz1200	; Time -:=  1200Hz
	dad	d

	push	h
	lhld	DeltaP		; Delta[i-1]+Delta[i]*2
	xchg
	lhld	Delta
	dad	h
	dad	d
	shld	DeltaP
	FindZ			; hl - Delta
	pop	d		; de - Time
	jc	ExitV23
	xchg
	dad	d		; T := T + Delta (hl)
				; Delta (de)
	push	h
	lhld	DeltaP
	dad	d		; Delta[i-1]+Delta[i]*2+Delta[i+1]
	Check	H,L,445*4
	mov	a,b
	rar
	mov	b,a
	pop	h
	ToMem
	jmp	clInfo

clInfoMem:
	ToMem
	jmp	clInfo

public	ExInfo
ExInfo:
	mov	a,d
	add	a
	ora	a

;	cmc		;     !!!

ExitV23:
	mov	a,b
	cma
	pop	d
	pop	h
	ret


	DSeg

public	Delta, DeltaP, Time, TimeCount
Delta:
	ds	2
DeltaP:
	ds	2
Time:
	ds	2
TimeCount:
	ds	2

	end



