;  LOADROM	:31-jan-94
;  ---------------------------


extrn	File
extrn	PO, RI, RDel
extrn	Inform, NamePrg, LineFile
extrn	SaveROM

	CSeg

FindControlSum:
	push	psw
	push	h
	push	b
	push	d

	lda	File+1			; 27/12/93
	dcr	a			; 
	mov	e,a			; 

	mov	a,d
;	sui	High (File-100h)
	sub	e			; 27/12/93
	sta     LineFile
	inx	d
;	lxi	b,File
	lhld	File			; 27/12/93
	mov	b,h			; 
	mov	c,l			; 
	lxi	h,0

L033b:
	push	d
	ldax	b
	mvi	d,0
	mov	e,a
	dad	d
	pop	d
	inx	b
	mov	a,e
	cmp	c
        jnz     L033b
	mov	a,d
	cmp	b
        jnz     L033b
        shld    ContrSumCell
	pop	d
	pop	b
	pop	h
	pop	psw
	ret

public	LoadROM
LoadROM:
	lxi	h,0
	dad	sp
	shld	Stack
	call	ReadFile
Exit:
	lhld	stack
	sphl
	ret

ErrorLoad:
	stc
	jmp	Exit

ReadFile:
	call	ClrMark
	hlt
	di

L03a3:
        call    FindAverageBit

L03a6:
	mov	d,a
	ora	a
	rar
	mov	e,a
	add	d
	mov	h,a
        call    FindAverageBit
	cmp	h
        jc      L03a6
	add	d
	sta	RDel
	mvi	e,0ch

L03b9:
	mvi	a,8
        call    ReadByte
        cpi     55h
        jz      L03c8
	cpi	0aah
        jnz     L03a3

L03c8:
	dcr	e
        jnz     L03b9

L03cc:
        call    ReadSubBlock
	mov	e,a
	mov	a,m
	cpi	0
        jnz     L03cc
	push	d
	push	b
        lxi     h,Inform
        lxi     b,SystemBufer
	mvi	d,1dh

L03e0:
	ldax	b
	mov	m,a
	inx	b
	inx	h
	dcr	d
        jnz     L03e0
	xra	a
	mov	m,a
	pop	b
	pop	d
        lxi     h,L062d
	mov	a,m
	dcx	h
	cmp	m
        jnz     L03a3
	mov	d,a
        sta     LineFile
	sta	NowBlocks
	dcx	h
	push	psw
	mov	a,m
        sta     L0631
	pop	psw
	mov	b,m

L0401:
        call    ReadSubBlock
	push	psw
	mov	a,m
	cpi	0
        jz      L0450
	add	a
	add	a
	add	a
	add	a
	add	a
	mov	c,a
	pop	psw
	inx	h
	mov	a,m
	cmp	e
        jnz     L0401
	push	d
	push	b
	inx	h
        lda     L0631
	mov	d,a
	mov	a,b
	sub	d
;	adi	High (File)
	mov	b,a			; 27/12/93
	lda	File+1			; 
	add	b			; 
	mov	b,a			; 
	lxi	d,207eh

L0427:
	mov	a,m
	stax	b
	inx	h
	inr	c
	dcr	d
        jnz     L0427
	pop	b
	mov	l,c
	mov	h,b
        call    SetAdrMark
	mov	m,e
	pop	d
        call    CheckFullBlock
        jz      L0401
	mov	a,d
	cpi	1
        jnz     L0401
        lda     LineFile
;	adi	High (File-100h)
	mov	d,a			; 27/12/93
	lda	File+1			; 
	dcr	a			; 
	add	d			; 
	mov	d,a
	mvi	e,0ffh
        call    FindControlSum
	xra	a
	ret

L0450:
	pop	psw
	sub	e
        jz      L0401
	inr	a
        jnz     ErrorLoad
        call    CheckFullBlock
        jz      ErrorLoad
        call    ClrMark
	dcr	e
	inr	b
	dcr	d
	push	h
	push	d
	lxi	d,MarkTape
	lhld	NowBlocks
	dcx	h
	shld	NowBlocks
	dad	d
	mvi	m,0fh		;   256 
	pop	d
	pop	h
        jmp     L0401

CheckFullBlock:
	mvi	l,0
	mov	h,b
        call    SetAdrMark

L046e:
	mov	a,m
	ana	a
	rz
	inx	h
	cpi	81h
        jnz     L046e
	ana	a
	ret

FindLenghtBit:
	push	d
	call	findleveltape

L047d:
	in	1
	ani	10h
	cmp	e
        jz      L047d
	mov	e,a
	mvi	d,0

L0488:
	in	1
	ani	10h
	inr	d
	cmp	e
        jz      L0488
	mov	a,d
	add	a
	add	a
	pop	d
	ret

FindAverageBit:
	push	h
	push	d

L0498:
        call    FindLenghtBit
	mov	b,a
	ora	a
	rar
	mov	c,a
	lxi	h,0
        mvi     d,20h

L04a4:
        call    FindLenghtBit
	push	d
	mvi	d,0
	mov	e,a
	dad	d
	pop	d
	mov	e,a
	sub	b
        jnc     L04b4
	mov	a,b
	sub	e

L04b4:
	cmp	c
        jnc     L0498
	dcr	d
        jnz     L04a4
	dad	h
	mov	a,h
	pop	d
	pop	h
	ret

ReadSubBlock:
	push	b
        lxi     h,Bufer35byte

L04c5:
	push	h
	lxi	b,23h
	mvi	a,0ffh

L04cb:
        call    ReadByte
	mov	m,a
	inx	h
	add	b
	mov	b,a
	mvi	a,8
	dcr	c
        jnz     L04cb
	dcx	h
	mov	a,b
	sub	m
	sub	m
	mov	a,m
	pop	h
        jnz     L04c5
	pop	b
	ret

ReadByte:
	jmp	RI

FindLevelTape:
	lda	RDel

L0529:
	dcr	a
        jnz     L0529

L052d:
	in	1
	ani	10h
	mov	e,a
	ret

ClrMark:
	push	psw
	push	h
	mvi	a,8
        lxi     h,FieldMarker

L053a:
	mvi	m,0
	inx	h
	dcr	a
        jnz     L053a
	mvi	m,81h			; 27/12/93
	pop	h
	pop	psw
	ret

SetAdrMark:
	push	d
	mov	a,l
	rlc
	rlc
	rlc
	ani	7
	mov	l,a
	mvi	h,0
        lxi     d,FieldMarker
	dad	d
	pop	d
	ret

	ASeg
	org	0ef00h
MarkTape:

	org	0ee00h

FieldMarker:
	ds	9	; 0,0,0,0,0,0,0,0,81h

	ds	10h	;    (  )

Bufer35byte:
	ds	4
SystemBufer:
	ds	001dh
L062d:
	ds	3

L0631:
	ds	1
buf1:
	ds	2
ContrSumCell:
	ds	2
NowBlocks:
	ds	2
Stack:
	ds	2

	end
