
;  dizassembl. tekst  BIOS  wers.3.1
;  ---------------------------------
;       (C) filippow e.w., 1992

BDOSENTER			EQU	05H
CI				EQU	0F803H
CO				EQU	0F809H
FCB				EQU	5CH
LO				EQU	0F80FH
PO				EQU	0F80CH
PROGRAM				EQU	0100H
RDELAY				EQU	0FFC5H
RI				EQU	0F806H
STATCI				EQU	0F812H
SYSDMA				EQU	80H
WDELAY				EQU	0FFC4H

;	ORG	0DB00H

	JMP	INIBIOS
	JMP	INIBIOS
	JMP	GRSTATUS
	JMP	GRINPUT
	JMP	GROUTPUT
	JMP	ADRDPH
	JMP	RDWRDISK
	JMP	ADRMESSAGE
	JMP	USERCOMMAND
	JMP	CLEARCDISK

LDB1E:
	DB	01H

LDB1F:
	DB	'P',0

INIBIOS:
	XRA	A
	STA	LE96D
	STA	LE967
	RET

GRSTATUS:
	CALL	CASEFROM3
	DW	STATCONIN
	DW	STATLO
	DW	STATAUX

GRINPUT:
	CALL	CASEFROM3
	DW	CONIN
	DW	STATAUX
	DW	AUXIN

GROUTPUT:
	CALL	CASEFROM3
	DW	CONOUT
	DW	PRINTERS
	DW	AUXOUT

USERCOMMAND:
	CALL	LDB64
	DW	USERK0
	DW	USERK1
	DW	USERK2
	DW	USERK3
	DW	USERK4
	DW	USERK5
	DW	USERK4
	DW	USERK4
	DW	USERK8
	DW	USERK4

CASEFROM3:
	POP	H
	MOV	A,D
	CPI	3
	JC	LDB65

STATAUX:
	XRA	A
	RET

LDB64:
	POP	H

LDB65:
	CALL	HLEQUFROMHLADD2A
	PCHL

HLEQUFROMHLADD2A:
	ADD	A
	ADD	L
	MOV	L,A
	JNC	LDB70
	INR	H

LDB70:
	MOV	E,M
	INX	H
	MOV	H,M
	MOV	L,E
	RET

STATCONIN:
	JMP	STATCI

CONIN:
	JMP	CI

CONOUT:
	JMP	CO
;
;  podkl`~itx kwazidisk wmesto |kranow

SETSYS:
	PUSH	PSW
	MVI	A,'#'	;23H
	OUT	10H
	POP	PSW
	RET

PRINTERS:
	PUSH	PSW
	PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,LDCA0
	SHLD	LDC70+1
	SHLD	LDC8B+1
	MVI	A,'0'	;30H
	STA	LDC9A+1
	LDA	PRTBIT4
	ANA	A
	JZ	LDBAC
	LXI	H,LDCC0
	SHLD	LDC70+1
	SHLD	LDC8B+1
	MVI	A,' '	;20H
	STA	LDC9A+1

LDBAC:
	LDA	PRTBIT03
	CPI	3
	JNC	LDBB8
	MOV	A,C
	ANI	7FH
	MOV	C,A

LDBB8:
	LDA	PRTBIT03
	CPI	0
	JZ	PRT0
	CPI	1
	JZ	PRT1
	CPI	2
	JZ	PRT2
	CPI	3
	JZ	PRT3
	CPI	4
	JZ	PRT4
	JMP	LDC7D

LDBD7:
	DB	1BH,52H,01H

LDBDA:
	DB	00H,1BH,52H,00H

PRT3:
	MOV	A,C
	CPI	80H
	JC	PRT0
	MOV	A,C
	ANI	7FH
	STA	LDBDA
	LXI	H,LDBD7
	MVI	B,7

LDBEF:
	MOV	C,M
	CALL	LO
	INX	H
	DCR	B
	JNZ	LDBEF
	JMP	LDC7D

PRT4:
	MOV	A,C
	CPI	80H
	JC	PRT2
	MVI	A,2
	STA	PRTBIT03
	MOV	A,C
	ANI	7FH
	STA	LDBDA
	LXI	H,LDBD7
	MVI	B,7

LDC11:
	MOV	C,M
	CALL	PRINTERS
	INX	H
	DCR	B
	JNZ	LDC11
	MVI	A,4
	STA	PRTBIT03
	JMP	LDC7D

PRT2:
	MOV	A,C
	CPI	1BH
	JZ	LDC3B
	LDA	LDCE2
	ORA	A
	JZ	LDC59
	CPI	1BH
	JZ	LDC41
	MOV	A,C
	ANI	1
	STA	LDCE3

LDC3A:
	XRA	A

LDC3B:
	STA	LDCE2
	JMP	LDC7D

LDC41:
	MOV	A,C
	CPI	'R'	;52H
	JNZ	LDC4D
	STA	LDCE2
	JMP	LDC7D

LDC4D:
	MVI	C,1BH
	CALL	LO
	MOV	C,A
	CALL	LO
	JMP	LDC3A

LDC59:
	LDA	LDCE3
	CPI	0
	JZ	PRT0
	MOV	A,C
	CPI	60H
	JC	LDC82

PRT1:
	MOV	A,C
	ANI	7FH
	MOV	C,A
	CPI	60H
	JC	PRT0

LDC70:					; modif. komanda
	LXI	H,LDCA0
	MVI	D,0
	SUI	60H
	MOV	E,A
	DAD	D
	MOV	C,M

PRT0:
	CALL	LO

LDC7D:
	POP	B
	POP	D
	POP	H
	POP	PSW
	RET

LDC82:
	MOV	A,C
	ANI	7FH
	MOV	C,A
	CPI	'@'	;40H
	JC	PRT0

LDC8B:					; modif. komanda
	LXI	H,LDCA0
	MVI	D,0
	SUI	'@'	;40H
	MOV	E,A
	DAD	D
	MOV	A,M
	CPI	80H
	JC	LDC9C

LDC9A:					; modif. komanda
	ADI	'0'	;30H

LDC9C:
	MOV	C,A
	JMP	PRT0

LDCA0:
	DB	0C0H,0A1H,0A2H,0B8H,0A5H,0A6H,0B6H
	DB	0A4H,0B7H,0AAH,0ABH,0ACH,0ADH,0AEH
	DB	0AFH,0B0H,0B1H,0C1H,0B2H,0B3H,0B4H
	DB	0B5H,0A8H,0A3H,0BEH,0BDH,0A9H,0BAH
	DB	0BFH,0BBH,0B9H,5FH

LDCC0:
	DB	0CEH,0B0H,0B1H,0C6H,0B4H,0B5H,0C4H
	DB	0B3H,0C5H,0B8H,0B9H,0BAH,0BBH,0BCH
	DB	0BDH,0BEH,0BFH,0CFH,0C0H,0C1H,0C2H
	DB	0C3H,0B6H,0B2H,0CCH,0CBH,0B7H,0C8H
	DB	0CDH,0C9H,0C7H,5FH

PRTBIT03:
	DB	02H

PRTBIT4:
	DB	00H

LDCE2:
	DB	00H

LDCE3:
	DB	00H

STATLO:
	MVI	A,1
	RET

AUXIN:
	JMP	RI

AUXOUT:
	JMP	PO

ADRDPH:
	LXI	H,0
	MOV	A,C
	CPI	3
	RNC
	CALL	LDCFD
	DW	DPHA
	DW	DPHB
	DW	DPHC

LDCFD:
	POP	H
	JMP	HLEQUFROMHLADD2A

DPHC:
	DW	XLT
	DW	0
	DW	0
	DW	0
	DW	DIRBUF
	DW	DPBC
	DW	0
	DW	ALVC

DPHA:
	DW	XLT
	DW	0
	DW	0
	DW	0
	DW	DIRBUF
	DW	DPBA
	DW	CSVA
	DW	ALVA

DPHB:
	DW	XLT
	DW	0
	DW	0
	DW	0
	DW	DIRBUF
	DW	DPBB
	DW	CSVB
	DW	ALVB

RDWRDISK:
	MOV	A,M
	CPI	0
	JZ	ABDRIVERS
	CPI	1
	JZ	ABDRIVERS
	PUSH	H
	PUSH	B
	PUSH	D
	LXI	D,DISKDSC
	MVI	B,0AH

LDD44:
	MOV	A,M
	STAX	D
	DCR	B
	INX	H
	INX	D
	JNZ	LDD44
	LDA	FUNC
	CPI	4
	JZ	RDCDISK
	CPI	6
	JZ	WRCDISK
	XRA	A

LDD5A:
	ANA	A
	POP	D
	POP	B
	POP	H
	RET

ERRDISKMSG:
	PUSH	PSW
	LXI	H,DISKDSC
	LXI	D,TXTDISKMSG
	MVI	B,9

LDD68:
	XCHG
	PUSH	PSW
	CALL	PEC
	POP	PSW
	XCHG
	PUSH	H
	PUSH	D
	CALL	LBYTE
	POP	D
	POP	H
	MOV	A,M
	INX	H
	INX	D
	DCR	B
	JNZ	LDD68
	POP	PSW
	RET

TXTDISKMSG:
	DB	0DH,0AH,'ER=',0,'  D=',0
	DB	' CHW=',0,' OP=',0,' NS='
	DB	0,' T=',0,' S=',0,' A2='
	DB	0,' A1=',0

LBYTE:
	PUSH	B
	CALL	LABYTE
	POP	B
	RET

PEC:
	MOV	A,M
	ANA	A
	RZ
	PUSH	B
	MOV	C,M
	CALL	COBDOS
	POP	B
	INX	H
	JMP	PEC

LABYTE:
	MOV	B,A
	MOV	A,B
	RRC
	RRC
	RRC
	RRC
	CALL	LLOW
	MOV	A,B

LLOW:
	ANI	0FH
	CPI	0AH
	JM	LDDD2
	ADI	7

LDDD2:
	ADI	'0'	;30H
	MOV	C,A
	JMP	COBDOS

RDCDISK:
	CALL	CPREPARE
	LXI	H,0
	DAD	SP
	SHLD	STACK+1
	LHLD	DISKCADR
	MOV	A,L
	SUI	80H
	MOV	L,A
	JNC	LDDED
	DCR	H

LDDED:
	DI
	SPHL
	LHLD	ABUFF
	MVI	C,' '	;20H
	LDA	BANK
	OUT	10H
	XRA	A

LDDFA:
	POP	D
	MOV	M,E
	ADD	M
	INX	H
	MOV	M,D
	ADD	M
	INX	H
	POP	D
	MOV	M,E
	ADD	M
	INX	H
	MOV	M,D
	ADD	M
	INX	H
	DCR	C
	JNZ	LDDFA
	MOV	B,A
	MVI	A,'?'	;3FH
	OUT	10H
	LHLD	ADRCSUM
	SPHL
	POP	D
	MOV	A,E
	CMP	D
	JNZ	LDE24
	CMP	B
	JZ	STACK
	MVI	C,2
	JMP	STACK

LDE24:
	CMP	B
	JZ	LDE3C
	MOV	A,D
	CMP	B
	MOV	E,D
	JZ	LDE3D
	MVI	C,3

STACK:
	LXI	SP,0
	MVI	A,'#'	;23H
	OUT	10H
	EI
	MOV	A,C
	JMP	LDD5A

LDE3C:
	MOV	D,E

LDE3D:
	PUSH	D
	JMP	STACK

WRCDISK:
	CALL	CPREPARE
	LXI	D,7FH
	LXI	H,0
	DAD	SP
	SHLD	STACK+1
	LHLD	DISKCADR
	DI
	SPHL
	LHLD	ABUFF
	DAD	D
	MVI	C,'@'	;40H
	LDA	BANK
	OUT	10H
	XRA	A

LDE5F:
	MOV	D,M
	ADD	D
	DCX	H
	MOV	E,M
	ADD	E
	DCX	H
	PUSH	D
	DCR	C
	JNZ	LDE5F
	MOV	D,A
	MVI	A,'?'	;3FH
	OUT	10H
	LHLD	ADRCSUM
	INX	H
	INX	H
	MOV	E,D
	SPHL
	PUSH	D
	JMP	STACK

CPREPARE:
	LDA	TRACK
	LXI	H,LDEC8
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	A,M
	RRC
	RRC
	RRC
	RRC
	MOV	H,A
	ANI	0CH
	ORI	10H
	MOV	B,A
	MOV	A,H
	RRC
	RRC
	ORI	3
	MOV	H,A
	MVI	L,0FFH
	INX	H
	LDA	SEKTOR
	LXI	D,0FF80H

LDE9E:
	DCR	A
	JZ	LDEA6
	DAD	D
	JMP	LDE9E

LDEA6:
	SHLD	DISKCADR
	MVI	A,'#'	;23H
	ADD	B
	STA	BANK
	LDA	TRACK
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	LDA	SEKTOR
	DCR	A
	ADD	A
	ADD	L
	MOV	L,A
	LXI	D,0F000H
	DAD	D
	SHLD	ADRCSUM
	RET

LDEC8:
	DB	0FBH,0FAH,0F9H,0F8H,0E7H,0E6H,0E5H
	DB	0E4H,0E3H,0E2H,0E1H,0E0H,0DFH,0DEH
	DB	0DDH,0DCH,0DBH,0DAH,0D9H,0D8H,0D7H
	DB	0D6H,0D5H,0D4H,0D3H,0D2H,0D1H,0D0H
	DB	0CFH,0CEH,0CDH,0CCH,0CBH,0CAH,0C9H
	DB	0C8H,0C7H,0C6H,0C5H,0C4H,0C3H,0C2H
	DB	0C1H,0C0H,0BFH,0BEH,0BDH,0BCH,0BBH
	DB	0BAH,0B9H,0B8H,0B7H,0B6H,0B5H,0B4H
	DB	0B3H,0B2H,0B1H,0B0H,0AFH,0AEH,0ADH
	DB	0ACH,0ABH,0AAH,0A9H,0A8H,0A7H,0A6H
	DB	0A5H,0A4H,0A3H,0A2H,0A1H,0A0H,9FH
	DB	9EH,9DH,9CH,9BH,9AH,99H,98H
	DB	97H,96H,95H,94H,93H,92H,91H
	DB	90H,8FH,8EH,8DH,8CH,8BH,8AH
	DB	89H,88H,87H,86H,85H,84H,83H
	DB	82H,81H,80H,7FH,7EH,7DH,7CH
	DB	7BH,7AH,79H,78H,77H,76H,75H
	DB	74H,73H,72H,71H,70H,6FH,6EH
	DB	6DH,6CH,6BH,6AH,69H,68H,67H
	DB	66H,65H,64H,63H,62H,61H,60H
	DB	5FH,5EH,5DH,5CH,5BH,5AH,59H
	DB	58H,57H,56H,55H,54H,53H,52H
	DB	51H,50H,4FH,4EH,4DH,4CH,4BH
	DB	4AH,49H,48H,47H,46H,45H,44H
	DB	43H,42H,41H,40H,3FH,3EH,3DH
	DB	3CH,3BH,3AH,39H,38H,37H,36H
	DB	35H,34H,33H,32H,31H,30H,2FH
	DB	2EH,2DH,2CH,2BH,2AH,29H,28H
	DB	27H,26H,25H,24H,23H,22H,21H
	DB	20H
	DB	1FH,1EH,1DH,1CH,1BH,1AH,19H
	DB	18H,17H,16H,15H,14H,13H,12H
	DB	11H,10H,0FH,0EH,0DH,0CH,0BH
	DB	0AH,09H,08H,07H,06H,05H,04H
	DB	03H,02H,01H,00H

USERK0:
	CALL	CRLF
	LXI	D,FCB+1					;5DH
	LDAX	D
	CALL	HEXSTRING
	LXI	D,FCB+17				;6DH
	LDAX	D
	CPI	'R'	;52H
	JZ	SETRDELAY
	CPI	'W'	;57H
	JZ	SETWDELAY
	CPI	'A'	;41H
	JZ	SETSCREEN
	CPI	'P'	;50H
	JZ	SETCOLOR
	CPI	'L'	;4CH
	JZ	SETPRINTER
	CPI	'M'	;4DH
	JZ	SETLISTPRINTER
	JMP	AMBNAME

SETRDELAY:
	MOV	A,L
	STA	RDELAY
	RET

SETWDELAY:
	MOV	A,L
	STA	WDELAY
	RET

SETSCREEN:
	PUSH	H
	MVI	C,1BH

LDFF0:
	CALL	CONOUT
	POP	H
	MOV	C,L
	CALL	CONOUT
	RET

SETCOLOR:
	PUSH	H
	MVI	C,1BH
	CALL	CONOUT
	MVI	C,'P'	;50H
	CALL	CONOUT
	MOV	C,H
	JMP	LDFF0

SETPRINTER:
	MOV	A,L
	CPI	0FH
	JNC	AMBNAME
	ANI	8
	STA	PRTBIT4
	MOV	A,L
	ANI	7
	STA	PRTBIT03
	RET

SETLISTPRINTER:
	MOV	A,L
	STA	BETWEEN
	MOV	A,H
	STA	HIGHPRT
	LXI	H,LE030

LE025:
	MOV	C,M
	XRA	A
	CMP	M
	RZ
	INX	H
	CALL	LO
	JMP	LE025

LE030:
	DB	1BH,4DH,1BH,53H,30H,1BH,0FH
	DB	1BH,33H

BETWEEN:
	DB	12H,1BH,4EH,06H,1BH,43H

HIGHPRT:
	DB	0CH,07H,00H

READTAPEANDINF:
	CALL	FROMTAPE
	PUSH	D
	PUSH	PSW
	LXI	H,FCB+1					;5DH
	MOV	M,D
	LXI	H,PROGRAM
	CALL	LADDR
	XCHG
	CALL	LADDR
	LHLD	BGNTAPE
	CALL	LADDR
	LHLD	ENDTAPE
	CALL	LADDR
	LXI	H,FCB+17				;6DH

TYPEFILENAME:
	MVI	B,8

LE066:
	MOV	C,M
	CALL	COBDOS
	INX	H
	DCR	B
	JNZ	LE066
	MVI	C,'.'	;2EH
	CALL	COBDOS
	MVI	B,3

LE076:
	MOV	C,M
	INX	H
	CALL	COBDOS
	DCR	B
	JNZ	LE076
	MVI	C,' '	;20H
	CALL	COBDOS
	POP	PSW
	POP	D
	RET

LADDR:
	MOV	A,H
	CALL	LBYTE
	MOV	A,L
	CALL	LBYTE
	MVI	C,' '	;20H
	CALL	COBDOS
	RET

COBDOS:
	PUSH	PSW
	PUSH	B
	PUSH	H
	PUSH	D
	MOV	E,C
	CALL	BDOSCONOUT
	POP	D
	POP	H
	POP	B
	POP	PSW
	RET

FROMTAPE:
	CALL	CRLF
	CALL	PO
	HLT
	DI

LE0AA:
	LXI	B,4008H

LE0AD:
	MOV	A,C
	CALL	RI
	CPI	0
	JZ	LE0BB
	CPI	0FFH
	JNZ	LE0AA

LE0BB:
	DCR	B
	JNZ	LE0AD
	MVI	A,0FFH
	CALL	RI
	MOV	H,A
	MOV	A,C
	CALL	RI
	MOV	L,A
	MOV	A,C
	CALL	RI
	MOV	D,A
	MOV	A,C
	CALL	RI
	MOV	E,A
	SHLD	BGNTAPE
	XCHG
	SHLD	ENDTAPE
	MOV	A,E
	CMA
	MOV	E,A
	MOV	A,D
	CMA
	MOV	D,A
	DAD	D
	INX	H
	LXI	D,PROGRAM
	DAD	D
	XCHG
	MVI	B,0

LE0EA:
	MOV	A,C
	CALL	RI
	MOV	M,A
	ADD	B
	MOV	B,A
	CALL	CHECKMAXADR
	INX	H
	JNZ	LE0EA
	MOV	A,C
	DCX	H
	XCHG
	CALL	RI
	CMP	B
	JZ	READFILENAME
	LXI	H,TXTIOERR

LE105:
	CALL	PEC
	MVI	A,0FFH
	ANA	A
	RET

READFILENAME:
	MVI	C,0BH
	LXI	H,FCB+17				;6DH

LE111:
	MVI	A,8
	CALL	RI
	MOV	M,A
	ADD	B
	MOV	B,A
	INX	H
	DCR	C
	JNZ	LE111
	MVI	A,8
	CALL	RI
	CMP	B
	LXI	H,TXTNAMEERR
	MVI	A,0
	CNZ	LE105
	RET

TXTNAMEERR:
	DB	'NAME ERROR-',0

TXTIOERR:
	DB	'I/O ERRORS-',0

TOTAPE:
	CALL	CRLF
	CALL	DELAYTURNONTAPE
	DI
	XRA	A
	MOV	B,A

LE14E:
	CALL	PO
	DCR	B
	JNZ	LE14E
	MVI	A,0E6H
	CALL	PO
	MVI	A,1
	MOV	H,A
	CALL	PO
	XRA	A
	MOV	L,A
	CALL	PO
	LDA	FCB+17					;6DH
	MOV	D,A
	CALL	PO
	MVI	A,0FFH
	MOV	E,A
	CALL	PO
	MVI	B,0

LE174:
	MOV	A,M
	ADD	B
	MOV	B,A
	MOV	A,M
	CALL	PO
	CALL	CHECKMAXADR
	INX	H
	JNZ	LE174
	MOV	A,B
	CALL	PO
	LXI	H,FCB+1					;5DH
	MVI	C,0BH

LE18B:
	MOV	A,M
	CALL	PO
	ADD	B
	MOV	B,A
	INX	H
	DCR	C
	JNZ	LE18B
	MOV	A,B
	CALL	PO
	RET

CHECKMAXADR:
	IN	1
	ANI	'@'	;40H
	RZ
	MOV	A,H
	CPI	0B8H
	RZ
	CMP	D
	RNZ
	MOV	A,E
	CMP	L
	RET

DELAYTURNONTAPE:
	MVI	A,96H

LE1AB:
	HLT
	DCR	A
	JNZ	LE1AB
	RET

AMBNAME:
	LXI	D,AMBNAMETXT
	CALL	TYPE
	RET

HEXSTRING:
	LXI	H,0

HEXCHAR:
	LDAX	D
	INX	D
	CPI	' '	;20H
	RZ
	SUI	'0'	;30H
	JM	NOTHEX
	CPI	0AH
	JM	DECHEX
	CPI	11H
	JM	NOTHEX
	CPI	17H
	JP	NOTHEX
	SUI	7

DECHEX:
	MOV	C,A
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	JC	NOTHEX
	DAD	B
	JMP	HEXCHAR

NOTHEX:
	CALL	AMBNAME
	LXI	D,FCB					;5CH
	CALL	CLOSEFILE
	STC
	RET

WRITE128:
	PUSH	H
	PUSH	B
	XCHG
	CALL	SETDMA
	LXI	D,FCB					;5CH
	CALL	WRITE
	LXI	D,DISKFULLTXT
	ORA	A
	POP	B
	POP	H
	RET

DISKFULLTXT:
	DB	'OUT OF DATA SPACE$'

DIRFULLTXT:
	DB	'NO DIRECTORY SPACE$'

OKTXT:
	DB	0DH,0AH,' OK$'

USERK1:
	CALL	CRLF
	LXI	D,FCB+1					;5DH
	CALL	HEXSTRING
	RC

STORETODISK:
	XRA	A
	CMP	L
	JZ	AMBNAME
	SHLD	QBLCSTORE
	LXI	D,FCB					;5CH
	LXI	H,FCB+16				;6CH
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	MVI	B,0BH

LE249:
	MOV	A,M
	STAX	D
	ANI	7FH
	CPI	0
	JZ	LE270
	CPI	' '	;20H
	JZ	LE270
	CPI	'?'	;3FH
	JZ	AMBNAME
	CPI	5BH
	JNC	AMBNAME
	CPI	'A'	;41H
	JNC	LE270
	CPI	'/'	;2FH
	JC	AMBNAME
	CPI	':'	;3AH
	JNC	AMBNAME

LE270:
	INX	D
	INX	H
	DCR	B
	JNZ	LE249
	MVI	B,19H

LE278:
	XRA	A
	STAX	D
	INX	D
	DCR	B
	JNZ	LE278
	LXI	D,FCB					;5CH
	CALL	DELETEFILE
	LXI	D,FCB					;5CH
	CALL	CREATEFILE
	LXI	D,DIRFULLTXT
	INR	A
	JZ	LE2BA
	LDA	QBLCSTORE
	MOV	B,A
	LXI	H,PROGRAM

LE299:
	CALL	WRITE128
	JNZ	LE2BA
	LXI	D,SYSDMA				;80H
	DAD	D
	CALL	WRITE128
	JNZ	LE2BA
	LXI	D,SYSDMA				;80H
	DAD	D
	DCR	B
	JNZ	LE299
	LXI	D,FCB					;5CH
	CALL	CLOSEFILE
	LXI	D,OKTXT

LE2BA:
	CALL	TYPE
	RET

USERK2:
	CALL	CRLF
	LXI	D,FCB+1					;5DH
	CALL	HEXSTRING
	MOV	C,L
	XRA	A
	CMP	L
	RZ
	LXI	H,FCB+16				;6CH
	MOV	A,M
	STA	AUXCELL
	INX	H
	LXI	D,FILENAME
	MVI	A,' '	;20H
	CMP	M
	RZ
	MVI	B,0BH

LE2DC:
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	LE2DC

LE2E4:
	PUSH	B
	CALL	READTAPEANDINF
	POP	B
	CPI	0
	RNZ
	LXI	H,FCB+16				;6CH
	LDA	AUXCELL
	MOV	M,A
	INX	H
	LXI	D,FILENAME
	MVI	B,0BH

LE2F9:
	LDAX	D
	CPI	'?'	;3FH
	JZ	LE303
	CMP	M
	JNZ	LE2E4

LE303:
	INX	D
	INX	H
	DCR	B
	JNZ	LE2F9
	LHLD	FCB+1					;5DH
	PUSH	B
	CALL	STORETODISK
	POP	B
	DCR	C
	JNZ	LE2E4
	RET

USERK3:
	MVI	C,0
	PUSH	B
	CALL	CRLF
	MVI	C,0BH
	LXI	H,FCB+1					;5DH
	LXI	D,FILENAME

LE324:
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	LE324

LE32C:
	LXI	D,SYSDMA				;80H
	CALL	SETDMA
	CALL	PREPFCB
	CALL	FPSTSEARCH
	LXI	D,NOFILETXT
	POP	B
	MOV	B,A
	CPI	4
	JNC	TYPE
	PUSH	B
	MVI	E,0FFH
	CALL	DIRECTCONSOL
	POP	B
	ANA	A
	LXI	D,TXTCRLF
	JNZ	TYPE
	MOV	A,C
	CPI	0
	JNZ	NEXTFILES
	STA	COUNT
	MOV	A,B
	CALL	READFILEFROMDISK
	INR	C
	MOV	A,C
	STA	COUNT
	PUSH	B
	JMP	LE32C

NEXTFILES:
	PUSH	B

LE367:
	PUSH	B
	LXI	D,SYSDMA				;80H
	CALL	SETDMA
	CALL	PREPFCB
	CALL	NEXTSEARCH
	POP	B
	CPI	4
	JNC	LE38B
	DCR	C
	JNZ	LE367
	CALL	READFILEFROMDISK
	POP	B
	INR	C
	MOV	A,C
	STA	COUNT
	PUSH	B
	JMP	LE32C

LE38B:
	POP	B
	RET

READFILEFROMDISK:
	PUSH	B
	LXI	H,SYSDMA+1				;81H
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	L
	MOV	L,A
	XCHG
	CALL	PREPFINDEDFCB
	CALL	OPENFILE
	XRA	A
	STA	FCB+32					;7CH
	LXI	D,PROGRAM

LE3A6:
	PUSH	D
	CALL	SETDMA
	LXI	D,FCB					;5CH
	CALL	READ
	CPI	1
	JZ	LE3CC
	POP	D
	LXI	H,SYSDMA				;80H
	DAD	D
	XCHG
	MOV	A,D
	CPI	0B8H
	JZ	LE3EC
	JMP	LE3A6

LE3C4:
	PUSH	D
	PUSH	PSW
	LXI	H,FCB+1					;5DH
	JMP	TYPEFILENAME

LE3CC:
	CALL	LE3C4
	POP	D
	MOV	A,E
	CPI	0
	JZ	LE3D7
	INR	D

LE3D7:
	DCR	D
	POP	B
	MOV	L,D
	LDA	COUNT
	MOV	H,A
	INR	H
	PUSH	B
	PUSH	D
	CALL	LADDR
	POP	D
	MOV	A,D
	STA	FCB+17					;6DH
	CALL	TOTAPE

LE3EC:
	POP	B
	RET

PREPFCB:
	LXI	D,FILENAME

PREPFINDEDFCB:
	MVI	C,0BH
	LXI	H,FCB+1					;5DH

LE3F6:
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	LE3F6
	MVI	C,18H

LE400:
	XRA	A
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE400
	LXI	D,FCB					;5CH
	RET

USERK5:
	LXI	D,FCB					;5CH
	CALL	RENAMEFILE
	CPI	4
	LXI	D,OKTXT
	JC	TYPE
	LXI	D,AMBNAMETXT
	JMP	TYPE

USERK4:
	RET

CLEARCDISK:
	MVI	A,6
	JMP	WORKWITHALLCDISK

USERK8:
	MVI	A,4

WORKWITHALLCDISK:
	STA	FUNC
	LXI	D,1
	LXI	H,DIRBUF
	SHLD	ABUFF
	MVI	C,80H
	MVI	A,0E5H

LE437:
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE437
	MVI	A,2
	STA	DISKDSC

LE442:
	MOV	A,E
	STA	SEKTOR
	MOV	A,D
	STA	TRACK
	LHLD	ABUFF
	PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,DISKDSC
	CALL	RDWRDISK
	CNZ	ERRDISKMSG
	POP	B
	POP	D
	POP	H
	SHLD	ABUFF
	INR	E
	MOV	A,E
	CPI	9
	JNZ	LE442
	MVI	E,1
	INR	D
	MOV	A,D
	CPI	0ECH
	JNZ	LE442
	XRA	A
	RET

ADRMESSAGE:
	LXI	H,TABMSG
	RET

TABMSG:
	DW	DBOSERRTXT
	DW	DISKERRTXT
	DW	NOTTXT
	DW	SYSFILETXT
	DW	DELETETXT
	DW	SPACETXT
	DW	IGNORETXT
	DW	FILEEXTXT
	DW	ROTXT
	DW	NOFILETXT
	DW	NOFILETXT
	DW	ADVERT
	DW	ADVERT

DBOSERRTXT:
	DB	'BDOS ERROR ON $'

DISKERRTXT:
	DB	' DISK ERROR$'

NOTTXT:
	DB	'$'

SYSFILETXT:
	DB	' SYSTEM FILE$'

SELTXT:
	DB	'SELECT  $'

SPACETXT:
	DB	' $'

IGNORETXT:
	DB	'IGNORE (Y/N) ? $'

FILEEXTXT:
	DB	' FILE EXISTS$'

AMBNAMETXT:
	DB	'AMBIGOUSE NAME$'

NOFILETXT:
	DB	0DH,0AH,'NO FILES'

TXTCRLF:
	DB	0DH,0AH,'$'

DELETETXT:
	DB	0DH,0AH,'DELETE (Y/N) ? $'

ADVERT:
	DB	1BH,5DH,1BH
	DB	'b',0DH,0AH,'   *   VECTOR-06C '
	DB	'  *   ',0DH,0AH,'  *  BIOS '
	DB	'VERS(3.1)  *  ',0DH,0AH
	DB	'   * ABC-DISK DRIVE *   '
	DB	1BH,5EH,1BH
	DB	'a',0DH,0AH,'$'

ROTXT:
	DB	' FILE R/O$'

BDOSCONOUT:
	MVI	C,2
	JMP	BDOSENTER				;5

DIRECTCONSOL:
	MVI	C,6
	JMP	BDOSENTER				;5

CRLF:
	LXI	D,TXTCRLF

TYPE:
	MVI	C,9
	JMP	BDOSENTER				;5

OPENFILE:
	MVI	C,0FH
	JMP	BDOSENTER				;5

CLOSEFILE:
	MVI	C,10H
	JMP	BDOSENTER				;5

FPSTSEARCH:
	MVI	C,11H
	JMP	BDOSENTER				;5

NEXTSEARCH:
	MVI	C,12H
	JMP	BDOSENTER				;5

DELETEFILE:
	MVI	C,13H
	JMP	BDOSENTER				;5

READ:
	MVI	C,14H
	JMP	BDOSENTER				;5

WRITE:
	MVI	C,15H
	JMP	BDOSENTER				;5

CREATEFILE:
	MVI	C,16H
	JMP	BDOSENTER				;5

RENAMEFILE:
	MVI	C,17H
	JMP	BDOSENTER				;5

SETDMA:
	MVI	C,1AH
	JMP	BDOSENTER				;5

ABDRIVERS:
	SHLD	LE958
	CALL	LE5BD
	ORA	A
	RET

LE5BD:
	MOV	A,M
	STA	LE95B
	INX	H
	INX	H
	MOV	A,M
	STA	LE95A
	INX	H
	INX	H
	MOV	A,M
	STA	LE95C
	INX	H
	MOV	A,M
	DCR	A
	STA	LE95E
	INX	H
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	SHLD	LE970
	LDA	LE95A
	CPI	4
	JZ	LE5EA
	CPI	6
	JZ	LE5FE
	XRA	A
	RET

LE5EA:
	XRA	A
	STA	LE967
	MVI	A,1
	STA	LE964
	STA	LE965
	MVI	A,2
	STA	LE963
	JMP	LE690

LE5FE:
	XRA	A
	STA	LE964
	LDA	LE971
	CPI	0EAH
	MVI	C,1
	JZ	LE629
	PUSH	D
	LDA	LE95C
	SUI	0
	MOV	D,A
	LDA	LE95E

LE616:
	DCR	D
	JZ	LE61F
	ADI	'('	;28H
	JMP	LE616

LE61F:
	POP	D
	ANI	0FH
	MVI	C,0
	JNZ	LE629
	MVI	C,2

LE629:
	MOV	A,C
	STA	LE963
	CPI	2
	JNZ	LE649
	MVI	A,10H
	STA	LE967
	LDA	LE95B
	STA	LE968
	LHLD	LE95C
	SHLD	LE969
	LDA	LE95E
	STA	LE96B

LE649:
	LDA	LE967
	ORA	A
	JZ	LE688
	DCR	A
	STA	LE967
	LDA	LE95B
	LXI	H,LE968
	CMP	M
	JNZ	LE688
	LXI	H,LE969
	CALL	LE72F
	JNZ	LE688
	LDA	LE95E
	LXI	H,LE96B
	CMP	M
	JNZ	LE688
	INR	M
	MOV	A,M
	CPI	'('	;28H
	JC	LE681
	MVI	M,0
	LHLD	LE969
	INX	H
	SHLD	LE969

LE681:
	XRA	A
	STA	LE965
	JMP	LE690

LE688:
	XRA	A
	STA	LE967
	INR	A
	STA	LE965

LE690:
	XRA	A
	STA	LE966
	LDA	LE95E
	ORA	A
	RAR
	ORA	A
	RAR
	ORA	A
	RAR
	STA	LE96C
	LXI	H,LE96D
	MOV	A,M
	MVI	M,1
	ORA	A
	JZ	LE6CE
	LDA	LE95B
	LXI	H,LE95F
	CMP	M
	JNZ	LE6C7
	LXI	H,LE960
	CALL	LE72F
	JNZ	LE6C7
	LDA	LE96C
	LXI	H,LE962
	CMP	M
	JZ	LE6EB

LE6C7:
	LDA	LE96E
	ORA	A
	CNZ	LE73B

LE6CE:
	LDA	LE95B
	STA	LE95F
	LHLD	LE95C
	SHLD	LE960
	LDA	LE96C
	STA	LE962
	LDA	LE965
	ORA	A
	CNZ	LE7FC
	XRA	A
	STA	LE96E

LE6EB:
	LDA	LE95E
	ANI	7
	MOV	L,A
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	LXI	D,LEB00
	DAD	D
	XCHG
	LHLD	LE970
	MVI	C,80H
	LDA	LE964
	ORA	A
	JNZ	LE711
	MVI	A,1
	STA	LE96E
	XCHG

LE711:
	LDAX	D
	INX	D
	MOV	M,A
	INX	H
	DCR	C
	JNZ	LE711
	LDA	LE963
	CPI	1
	LDA	LE966
	RNZ
	ORA	A
	RNZ
	XRA	A
	STA	LE96E
	CALL	LE73B
	LDA	LE966
	RET

LE72F:
	XCHG
	LXI	H,LE95C
	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	LDAX	D
	CMP	M
	RET

LE73B:
	CALL	LE7BC
	JNZ	LE795
	CALL	LE847
	JNZ	LE795
	DI
	PUSH	H
	MVI	A,0A0H
	CALL	LE7B1

LE74E:
	IN	1BH
	ANA	E
	JZ	LE74E
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE74E
	INR	H

LE75C:
	IN	1BH
	ANA	E
	JZ	LE75C
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE75C
	INR	H

LE76A:
	IN	1BH
	ANA	E
	JZ	LE76A
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE76A
	INR	H

LE778:
	IN	1BH
	ANA	E
	JZ	LE778
	MOV	A,M
	OUT	18H
	INR	L
	JNZ	LE778
	INR	H

LE786:
	CALL	LE7F5
	POP	H
	LDA	LE96F
	OUT	1CH
	IN	1BH
	ANI	0DDH
	EI
	RZ

LE795:
	STA	LE966
	LDA	LE95A
	CPI	6
	JZ	LE7AC
	XRA	A
	STA	LE967
	STA	LE96D
	MVI	A,1
	STA	LE965

LE7AC:
	LDA	LE966
	ANA	A
	RET

LE7B1:
	MVI	E,2
	OUT	1BH

LE7B5:
	IN	1BH
	RRC
	JNC	LE7B5
	RET

LE7BC:
	LDA	LE95F
	ANI	3
	ORI	'0'	;30H
	STA	LE96F
	MVI	H,4
	LDA	LE960
	ANI	1
	JZ	LE7D9
	LDA	LDB1E
	ANA	A
	JZ	LE7D9
	MVI	H,0

LE7D9:
	LDA	LE96F
	ORA	H
	STA	LE96F

LE7E0:
	LDA	LE96F
	OUT	1CH
	IN	1BH
	RLC
	JNC	LE7F1
	CALL	LE7F5
	JMP	LE7E0

LE7F1:
	MVI	A,0D0H
	OUT	1BH

LE7F5:
	MVI	A,80H

LE7F7:
	DCR	A
	JNZ	LE7F7
	RET

LE7FC:
	CALL	LE7BC
	CALL	LE847
	JNZ	LE795
	DI
	PUSH	H
	MVI	A,80H
	CALL	LE7B1

LE80C:
	IN	1BH
	ANA	E
	JZ	LE80C
	IN	18H
	MOV	M,A
	INR	L
	JNZ	LE80C
	INR	H

LE81A:
	IN	1BH
	ANA	E
	JZ	LE81A
	IN	18H
	MOV	M,A
	INR	L
	JNZ	LE81A
	INR	H

LE828:
	IN	1BH
	ANA	E
	JZ	LE828
	IN	18H
	MOV	M,A
	INR	L
	JNZ	LE828
	INR	H

LE836:
	IN	1BH
	ANA	E
	JZ	LE836
	IN	18H
	MOV	M,A
	INR	L
	JNZ	LE836
	INR	H
	JMP	LE786

LE847:
	LDA	LE95F
	ANI	3
	MOV	L,A
	MVI	H,0
	LXI	D,LE954
	DAD	D
	LDA	LDB1E
	ANA	A
	MOV	A,M
	JZ	LE85D
	ORA	A
	RAR

LE85D:
	MOV	D,A
	IN	1AH
	CMP	D
	MOV	A,D
	OUT	1AH
	LDA	LE960
	MOV	M,A
	JZ	LE87B
	LDA	LDB1E
	ANA	A
	MOV	A,M
	JZ	LE875
	ORA	A
	RAR

LE875:
	MOV	E,A
	OUT	18H
	JMP	LE88C

LE87B:
	LDA	LDB1E
	ANA	A
	MOV	A,M
	JZ	LE885
	ORA	A
	RAR

LE885:
	MOV	E,A
	OUT	18H
	CMP	D
	JZ	LE8D8

LE88C:
	CMP	D
	JZ	LE8B9
	MVI	A,'Y'	;59H
	JNC	LE897
	MVI	A,79H

LE897:
	CALL	LE8EB

LE89A:
	LDA	LDB1F
	CPI	'P'	;50H
	CNZ	LE8AE
	IN	1AH
	CMP	E
	JZ	LE8B9
	CALL	LE8B4
	JMP	LE89A

LE8AE:
	MVI	A,'('	;28H

LE8B0:
	CALL	LE8EB
	RET

LE8B4:
	MVI	A,'8'	;38H
	JMP	LE8B0

LE8B9:
	MVI	A,1CH
	CALL	LE8EB
	IN	1BH
	ANI	18H
	JZ	LE8D8
	STA	LE966
	CALL	LE7F5
	CALL	LE8E3
	CALL	LE7F5
	MVI	M,0
	LDA	LE966
	ORA	A
	RET

LE8D8:
	LDA	LE962
	INR	A
	OUT	19H
	XRA	A
	LXI	H,LEB00
	RET

LE8E3:
	PUSH	PSW
	MVI	A,0
	CALL	LE8EB
	POP	PSW
	RET

LE8EB:
	OUT	1BH
	CALL	LE7F5

LE8F0:
	LDA	LE96F
	OUT	1CH
	IN	1BH
	RRC
	JC	LE8F0
	CALL	LE7F5
	RET

DPBC:
	DW	8

BSHC:
	DB	03H

BLMC:
	DB	07H

EXMC:
	DB	00H

DSMC:
	DW	0EBH

DRMC:
	DW	3FH

AL0C:
	DB	0C0H

AL1C:
	DB	00H

CKSC:
	DW	0

OFFC:
	DW	0

DPBA:
	DW	28H

BSHA:
	DB	04H

BLMA:
	DB	0FH

EXMA:
	DB	00H

DSMA:
	DW	0187H

DRMA:
	DW	7FH

AL0A:
	DB	0C0H

AL1A:
	DB	00H

CKSA:
	DW	20H

OFFA:
	DW	8

DPBB:
	DW	28H

BSHB:
	DB	04H

BLMB:
	DB	0FH

EXMB:
	DB	00H

DSMB:
	DW	0187H

DRMB:
	DW	7FH

AL0B:
	DB	0C0H

AL1B:
	DB	00H

CKSB:
	DW	20H

OFFB:
	DW	8
;
;  tablica perewoda log.sektorow w fizi~eskie

XLT:
	DB	01H,02H,03H,04H,05H,06H,07H
	DB	08H,09H,0AH,0BH,0CH,0DH,0EH
	DB	0FH,10H,11H,12H,13H,14H,15H
	DB	16H,17H,18H,19H,1AH,1BH,1CH
	DB	1DH,1EH,1FH,20H,21H,22H,23H
	DB	24H,25H,26H,27H,28H

LE954:
	DB	00H,00H,00H,00H

LE958:
	DW	0

LE95A:
	DB	00H

LE95B:
	DB	00H

LE95C:
	DW	0

LE95E:
	DB	00H

LE95F:
	DB	00H

LE960:
	DW	0

LE962:
	DB	00H

LE963:
	DB	00H

LE964:
	DB	00H

LE965:
	DB	00H

LE966:
	DB	00H

LE967:
	DB	00H

LE968:
	DB	00H

LE969:
	DW	0

LE96B:
	DB	00H

LE96C:
	DB	00H

LE96D:
	DB	00H

LE96E:
	DB	00H

LE96F:
	DB	00H

LE970:
	DB	00H

LE971:
	DB	00H

QBLCSTORE:
	DW	0

ALVC:
	DS	0021H

ALVA:
	DS	0033H

ALVB:
	DS	0033H

DISKDSC:
	DB	00H

CHWORD:
	DB	00H

FUNC:
	DB	00H

NUMB:
	DB	00H

TRACK:
	DB	00H

SEKTOR:
	DB	00H

ABUFF:
	DW	0

HTRACK:
	DB	00H

HSEKTOR:
	DB	00H

DISKCADR:
	DW	0

BANK:
	DB	00H

ADRCSUM:
	DW	0

BGNTAPE:
	DW	0

ENDTAPE:
	DW	0

FILENAME:
	DS	000BH
;
;  wspom.q~ejka 1.~islo blokow 256 bajt, 2.disk dlq zapisi s magn.

AUXCELL:
	DS	0001H

COUNT:
	DS	1

CSVA:
	DS	0020H

CSVB:
	DS	0020H

DIRBUF:
	DS	0080H
	DS	0025H

LEB00:
	DS	0400H
	END
