	ORG	0F800H
CHARGEN				EQU	0F300H
JMPRST8				EQU	38H
SCREEN				EQU	0A000H
TABCURS				EQU	0EF00H
	JMP	START					;0F81EH
	JMP	CI					;0FF62H
	JMP	RI					;0F86DH
	JMP	CO					;0FF91H
	JMP	PO					;0F8C1H
	JMP	LO					;0F832H
	JMP	STATCON					;0FF53H
	JMP	LBYTE					;0F854H
	JMP	PEC					;0F847H
	JMP	INKEY					;0FF6BH

START:					;0F81EH
	MVI	A,0C3H
	STA	JMPRST8					;38H
	LXI	H,RST7					;0FDC6H
	SHLD	JMPRST8+1				;39H
	MVI	A,'#'	;23H
	OUT	10H
	EI
;
;  ispolxzuetsq pri nastrojke bloka drajwerow pri inicial. DOSABC31.COM
	LXI	H,TABCURS				;0EF00H
	RET

LO:					;0F832H
	PUSH	PSW

WAITLO:					;0F833H
	IN	5
	ANI	1
	JNZ	WAITLO					;0F833H
	MOV	A,C
	OUT	7
	MVI	A,0EFH
	OUT	5
	MVI	A,0FFH
	OUT	5
	POP	PSW
	RET

PEC:					;0F847H
	MOV	A,M
	ANA	A
	RZ
	PUSH	B
	MOV	C,M
	CALL	CO					;0FF91H
	POP	B
	INX	H
	JMP	PEC					;0F847H

LBYTE:					;0F854H
	MOV	B,A
	MOV	A,B
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW					;0F85EH
	MOV	A,B

CLOW:					;0F85EH
	ANI	0FH
	CPI	0AH
	JM	DECIMAL					;0F867H
	ADI	7

DECIMAL:				;0F867H
	ADI	'0'	;30H
	MOV	C,A
	JMP	CO					;0FF91H

RI:					;0F86DH
	PUSH	B
	PUSH	D
	MVI	C,0
	MOV	D,A
	IN	1
	ANI	10H
	MOV	E,A

RBIT:					;0F877H
	IN	1
	ANI	10H
	CMP	E
	JZ	RBIT					;0F877H
	RLC
	RLC
	RLC
	RLC
	MOV	A,C
	RAL
	MOV	C,A
	CALL	RDELAY					;0F8B7H
	IN	1
	ANI	10H
	MOV	E,A
	MOV	A,D
	ORA	A
	JP	NEXTBIT					;0F8ACH
	MOV	A,C
	CPI	0E6H
	JNZ	READ					;0F8A0H
	XRA	A
	STA	INVERS					;0FFC9H
	JMP	FINDSYNCH				;0F8AAH

READ:					;0F8A0H
	CPI	19H
	JNZ	RBIT					;0F877H
	MVI	A,0FFH
	STA	INVERS					;0FFC9H

FINDSYNCH:				;0F8AAH
	MVI	D,9

NEXTBIT:				;0F8ACH
	DCR	D
	JNZ	RBIT					;0F877H
	LDA	INVERS					;0FFC9H
	XRA	C
	POP	D
	POP	B
	RET

RDELAY:					;0F8B7H
	PUSH	PSW
	LDA	RDEL					;0FFC5H

RCKL:					;0F8BBH
	DCR	A
	JNZ	RCKL					;0F8BBH
	POP	PSW
	RET

PO:					;0F8C1H
	PUSH	B
	PUSH	D
	PUSH	PSW
	MOV	D,A
	MVI	C,8

WBIT:					;0F8C7H
	MOV	A,D
	RLC
	MOV	D,A
	MVI	A,1
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY					;0F8E6H
	MVI	A,0
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY					;0F8E6H
	DCR	C
	JNZ	WBIT					;0F8C7H
	POP	PSW
	POP	D
	POP	B
	RET

WDELAY:					;0F8E6H
	PUSH	PSW
	LDA	WDEL					;0FFC4H
	JMP	RCKL					;0F8BBH

SHRF0:					;0F8EDH
	DW	CHARGEN					;0F300H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+140H				;0F440H
	DW	CHARGEN+1E0H				;0F4E0H
	DW	CHARGEN+280H				;0F580H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+3C0H				;0F6C0H
	DW	CHARGEN+460H				;0F760H

SHRF1:					;0F8FDH
	DW	CHARGEN					;0F300H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+3C0H				;0F6C0H
	DW	CHARGEN+460H				;0F760H
	DW	CHARGEN+280H				;0F580H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+140H				;0F440H
	DW	CHARGEN+1E0H				;0F4E0H

SHRF2:					;0F90DH
	DW	CHARGEN					;0F300H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+140H				;0F440H
	DW	CHARGEN+460H				;0F760H
	DW	CHARGEN+280H				;0F580H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+1E0H				;0F4E0H
	DW	CHARGEN+3C0H				;0F6C0H

SHRF3:					;0F91DH
	DW	CHARGEN					;0F300H
	DW	CHARGEN+0A0H				;0F3A0H
	DW	CHARGEN+140H				;0F440H
	DW	CHARGEN+1E0H				;0F4E0H
	DW	CHARGEN+280H				;0F580H
	DW	CHARGEN+320H				;0F620H
	DW	CHARGEN+3C0H				;0F6C0H
	DW	CHARGEN+460H				;0F760H

LF92D:					;0F92DH
	PUSH	H
	LXI	H,0
	DAD	SP
	LXI	SP,0
	XRA	A
	OUT	10H
	LDA	MARKTIME				;0FFC3H
	CALL	CURSOR					;0F946H
	XRA	A
	STA	LFFC6					;0FFC6H
	JMP	EXOFF					;0FFA1H

DARKCURSOR:				;0F945H
	XRA	A

CURSOR:					;0F946H
	STA	TIMER+1					;0FFC8H
	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW
	CALL	TVXY					;0FB82H
	DCR	E
	POP	PSW
	MVI	H,7

SEVENPOINT:				;0F954H
	PUSH	H
	ANA	A
	JZ	DARKPOINT				;0F961H
	PUSH	PSW
	CALL	ADRESTV					;0FB9BH
	ORA	M
	JMP	LIGHTPOINT				;0F967H

DARKPOINT:				;0F961H
	PUSH	PSW
	CALL	ADRESTV					;0FB9BH
	CMA
	ANA	M

LIGHTPOINT:				;0F967H
	MOV	M,A
	XCHG
	POP	PSW
	POP	H
	INX	B
	DCR	H
	JNZ	SEVENPOINT				;0F954H
	POP	B
	POP	D
	POP	H
	RET

ONLYCO:					;0F974H
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LDA	TIMER+1					;0FFC8H
	ANA	A
	CNZ	DARKCURSOR				;0F945H

CIRCLECO:				;0F97FH
	LXI	H,STATCO				;0FFAEH
	MOV	A,M
	CPI	80H
	JZ	NOWGRF					;0FD29H
	CPI	'@'	;40H
	JZ	CHANGECOLOR				;0FD5FH
	CPI	' '	;20H
	JZ	OUTGRCHR				;0FAE4H
	CPI	60H
	JZ	REGPOZNEG				;0F9C4H
	ORA	A
	JNZ	SEQAR2					;0F9D9H
;
; STATCO=0 !!!
	MOV	A,C
	CPI	1BH
	JNZ	NOTAR2					;0F9A5H

INCSTATCO:				;0F9A1H
	INR	M
	JMP	EXCO2					;0FC87H

NOTAR2:					;0F9A5H
	CPI	1
	JNZ	NOT01HSYMBOL				;0F9B2H
;
;  sled. wywoditx tolxko kak simwol (ne reag. na upr. kody)
	MVI	A,80H
	STA	STATCO					;0FFAEH
	JMP	EXCO2					;0FC87H

NOT01HSYMBOL:				;0F9B2H
	CPI	0CH
	JZ	CLRSCREEN				;0FC45H
	CPI	1FH
	JM	CTRL1					;0FC6CH
	JMP	OUTGRCHR				;0FAE4H

SEQPOZNEG:				;0F9BFH
	MVI	M,60H
	JMP	EXCO2					;0FC87H

REGPOZNEG:				;0F9C4H
	MOV	A,C
	CPI	'C'	;43H
	JZ	NEGATIVE				;0FD81H
	CPI	'@'	;40H
	JZ	POZITIVE				;0FD7DH
	CPI	'A'	;41H
	JZ	NEGATIVE				;0FD81H
	MVI	M,0
	JMP	CIRCLECO				;0F97FH

SEQAR2:					;0F9D9H
	CPI	1
	JNZ	SETCOORD				;0FA96H
	MOV	A,C
	CPI	80H
	JNC	LFA92					;0FA92H
	CPI	'Y'	;59H
	JZ	INCSTATCO				;0F9A1H
	CPI	'T'	;54H
	JZ	INCSTATCO				;0F9A1H
	CPI	'E'	;45H
	MVI	C,0CH
	JZ	INIDISP					;0FD30H
	CPI	'J'	;4AH
	MVI	C,0CH
	JZ	INTERNALSYMBOL				;0FD22H
	CPI	'K'	;4BH
	JZ	RIGHTCLEAR				;0FBF8H
	MVI	C,0BH
	JZ	INTERNALSYMBOL				;0FD22H
	CPI	'M'	;4DH
	JZ	LFA40					;0FA40H
	CPI	'L'	;4CH
	JZ	LFA4A					;0FA4AH
	CPI	'H'	;48H
	JZ	INTERNALSYMBOL				;0FD22H
	CPI	5EH
	JZ	SEQPOZNEG				;0F9BFH
	CPI	5CH
	JZ	SETFONT2				;0FD48H
	CPI	5BH
	JZ	SETFONT3				;0FD4EH
	CPI	'P'	;50H
	JZ	FONCHRCOLOR				;0FD57H
	CPI	61H
	JZ	POZITIVE				;0FD7DH
	CPI	'7'	;37H
	JZ	POZITIVE				;0FD7DH
	CPI	62H
	JZ	NEGATIVE				;0FD81H
	CPI	'6'	;36H
	JZ	NEGATIVE				;0FD81H
	JMP	ZEROSTATCO				;0FADCH

LFA40:					;0FA40H
	CALL	TVXY					;0FB82H
	MOV	A,E
	STA	LFFCA					;0FFCAH
	JMP	ZEROSTATCO				;0FADCH

LFA4A:					;0FA4AH
	CALL	TVXY					;0FB82H
	MOV	B,E
	LDA	LFFCA					;0FFCAH
	CMP	E
	JZ	RIGHTCLEAR				;0FBF8H
	JNC	LFA7D					;0FA7DH
	MOV	A,B
	ADI	0AH
	MOV	B,A
	LDA	LFFCA					;0FFCAH
	MOV	E,A
	ADI	0AH
	LXI	H,2C1CH

LFA65:					;0FA65H
	SHLD	LFA8D					;0FA8DH
	MOV	L,A
	MVI	C,'@'	;40H
	MVI	D,0A0H

LFA6D:					;0FA6DH
	MOV	H,D
	PUSH	H
	PUSH	D
	CALL	LFA88					;0FA88H
	POP	D
	POP	H
	INR	D
	DCR	C
	JNZ	LFA6D					;0FA6DH
	JMP	RIGHTCLEAR				;0FBF8H

LFA7D:					;0FA7DH
	ADI	0AH
	MOV	E,A
	SUI	0AH
	LXI	H,2D1DH
	JMP	LFA65					;0FA65H

LFA88:					;0FA88H
	MOV	A,B
	CMP	L
	RZ
	MOV	A,M
	STAX	D

LFA8D:					;0FA8DH
	INR	L
	INR	E
	JMP	LFA88					;0FA88H
;
;  obrabotka wtorogo bajta posl. 1BH,80H+Y,80H+X

LFA92:					;0FA92H
	INR	M

LFA93:					;0FA93H
	SUI	60H
	MOV	C,A

SETCOORD:				;0FA96H
	MOV	A,C
	CPI	80H
	JNC	LFA93					;0FA93H
	MOV	A,M
	CPI	3
	JNC	LFAC6					;0FAC6H
	MOV	A,C
	SUI	' '	;20H
	JP	LFAAB					;0FAABH
	JMP	LFAB0					;0FAB0H

LFAAB:					;0FAABH
	CPI	19H
	JM	SETYCOORD				;0FAB2H

LFAB0:					;0FAB0H
	MVI	A,18H

SETYCOORD:				;0FAB2H
	RLC
	MOV	C,A
	RLC
	RLC
	ADD	C
	CMA
	INR	A
	SUI	0AH
	MOV	C,A
	LDA	ROLIC					;0FFABH
	ADD	C
	STA	YTV					;0FFACH
	JMP	INCSTATCO				;0F9A1H

LFAC6:					;0FAC6H
	MOV	A,C
	SUI	' '	;20H
	JP	LFACF					;0FACFH
	JMP	LFAD7					;0FAD7H

LFACF:					;0FACFH
	CPI	'P'	;50H
	JP	LFAD7					;0FAD7H
	JMP	LFAD9					;0FAD9H

LFAD7:					;0FAD7H
	MVI	A,'O'	;4FH

LFAD9:					;0FAD9H
	STA	XTV					;0FFADH

ZEROSTATCO:				;0FADCH
	LXI	H,STATCO				;0FFAEH
	MVI	M,0
	JMP	EXCO2					;0FC87H

OUTGRCHR:				;0FAE4H
	LXI	H,SHRF0					;0F8EDH
	MOV	A,C
	ANA	A
	JZ	EXCO2					;0FC87H
	MVI	D,8
;
; poisk linejki w tablice fontow

SEARCHFONTLINE:				;0FAEEH
	SUI	' '	;20H
	JNC	NEXTFONTLINE				;0FAF8H
	ADI	' '	;20H
	JMP	FINDLINEFONT				;0FAFEH

NEXTFONTLINE:				;0FAF8H
	INX	H
	INX	H
	DCR	D
	JNZ	SEARCHFONTLINE				;0FAEEH

FINDLINEFONT:				;0FAFEH
	MOV	C,M
	INX	H
	MOV	B,M
	MVI	H,0
;
; <A> := kod znaka & 1FH
	MOV	L,A
	MOV	D,H
	MOV	E,L
	DAD	H
	DAD	H
	DAD	D
	DAD	B
	PUSH	H
	CALL	TVXY					;0FB82H
	LXI	H,CHARGEN				;0F300H
	CALL	OUT8POINT				;0FB23H
	MVI	D,5
	POP	H

LFB17:					;0FB17H
	INX	B
	CALL	OUT8POINT				;0FB23H
	INX	H
	DCR	D
	JNZ	LFB17					;0FB17H
	JMP	LFBA6					;0FBA6H
;
; wywod 8 to~ek w wide wert. poloski

OUT8POINT:				;0FB23H
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	A,M
	LXI	H,TABCURS				;0EF00H
	DAD	B
	MOV	D,M
	INR	H
	INR	H
	RLC
	MOV	C,A
	MOV	A,M
	XCHG
	MOV	D,A
	CMA
	MOV	E,A
	MOV	B,L

LFB36:					;0FB36H
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	MOV	L,B
	JMP	LFB61					;0FB61H

LFB5D:					;0FB5DH
	MOV	C,A

LFB5E:					;0FB5EH
	MOV	A,E
	ANA	M
	MOV	M,A

LFB61:					;0FB61H
	MOV	A,C
	ANA	A
	CNZ	LFB6D					;0FB6DH
	JC	LFB5D					;0FB5DH
	POP	B
	POP	D
	POP	H
	RET

LFB6D:					;0FB6DH
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RET
;
; wyhod: <BC> - 1FFH & (XTV*6+10), <E> - YTV

TVXY:					;0FB82H
	LDA	XTV					;0FFADH
	MOV	L,A
	MVI	H,0
	DAD	H
	PUSH	H
	POP	B
	DAD	H
	DAD	B
	LXI	B,10H
	DAD	B
	MOV	A,H
	ANI	1
	MOV	B,A
	MOV	C,L
	LDA	YTV					;0FFACH
	MOV	E,A
	RET
;
; whod:<BC> - X, <E> - Y koord. to~ki
; wyhod: <HL> - adres, <A> - maska

ADRESTV:				;0FB9BH
	LXI	H,TABCURS				;0EF00H
	DAD	B
	MOV	D,M
	INR	H
	INR	H
	MOV	A,M
	XCHG
	RET
	POP	H

LFBA6:					;0FBA6H
	LXI	H,XTV					;0FFADH
	INR	M
	MOV	A,M
	CPI	'P'	;50H
	JM	EXCO2					;0FC87H

LFBB0:					;0FBB0H
	MVI	M,0
	LDA	YTV					;0FFACH
	SUI	0AH
	STA	YTV					;0FFACH
	MOV	C,A
	ADI	4
	MOV	B,A
	LDA	ROLIC					;0FFABH
	CMP	B
	JNZ	EXCO2					;0FC87H
	SUI	0AH
	STA	ROLIC					;0FFABH
	MOV	A,C
	SUI	5
	MOV	C,A
	MVI	H,0A0H
	MVI	A,0E0H
	MVI	D,0

LFBD4:					;0FBD4H
	MOV	L,C
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	H
	CMP	H
	JNZ	LFBD4					;0FBD4H
	JMP	EXCO2					;0FC87H
; 
; steretx prawu` ~astx stroki

RIGHTCLEAR:				;0FBF8H
	CALL	TVXY					;0FB82H

LFBFB:					;0FBFBH
	PUSH	D
	PUSH	B
	LXI	H,TABCURS				;0EF00H
	DAD	B
	MOV	D,M
	INR	H
	INR	H
	MOV	A,M
	CMA
	ANA	A
	JM	LFC0B					;0FC0BH
	XRA	A

LFC0B:					;0FC0BH
	XCHG
	MOV	D,A
	MOV	B,L
	MOV	L,B
	MVI	E,9
	JZ	LFC34					;0FC34H

LFC14:					;0FC14H
	MOV	A,D
	ANA	M
	MOV	M,A
	INR	L
	DCR	E
	JNZ	LFC14					;0FC14H

LFC1C:					;0FC1CH
	MOV	A,D
	POP	B
	POP	D
	LXI	H,1
	ANA	A
	JNZ	LFC28					;0FC28H
	MVI	L,8

LFC28:					;0FC28H
	DAD	B
	MOV	B,H
	MOV	C,L
	MOV	A,B
	CPI	2
	JNZ	LFBFB					;0FBFBH
	JMP	ZEROSTATCO				;0FADCH

LFC34:					;0FC34H
	MOV	A,H
	SUI	' '	;20H
	MOV	B,A
	MOV	C,L
	MOV	A,D

LFC3A:					;0FC3AH
	MOV	M,A
	STAX	B
	INR	C
	INR	L
	DCR	E
	JNZ	LFC3A					;0FC3AH
	JMP	LFC1C					;0FC1CH

CLRSCREEN:				;0FC45H
	LXI	H,0
	DAD	SP
	SHLD	RESETSTACK+1				;0FC62H
	DI
	LXI	SP,SCREEN+4000H				;0E000H
	LXI	B,0
	LXI	D,0FFF8H
	LXI	H,3FF8H

LFC59:					;0FC59H
	PUSH	B
	PUSH	B
	PUSH	B
	PUSH	B
	DAD	D
	JC	LFC59					;0FC59H

RESETSTACK:				;0FC61H
	LXI	SP,0
	LXI	H,ROLIC					;0FFABH
	MVI	M,0FFH
	JMP	HOME					;0FCD0H

CTRL1:					;0FC6CH
	MOV	A,C
	CPI	16H
	JZ	RIGHTCLEAR				;0FBF8H
	CPI	8
	LXI	H,XTV					;0FFADH
	JNZ	LFCA2					;0FCA2H
	MOV	A,M
	DCR	A

LFC7C:					;0FC7CH
	JP	LFC80					;0FC80H
	XRA	A

LFC80:					;0FC80H
	CPI	'O'	;4FH
	JC	LFC86					;0FC86H
	XRA	A

LFC86:					;0FC86H
	MOV	M,A

EXCO2:					;0FC87H
	LDA	STATCO					;0FFAEH
	CPI	' '	;20H
	JNZ	LFC9D					;0FC9DH
	LDA	XTV					;0FFADH
	ANI	7
	MVI	C,' '	;20H
	JNZ	CIRCLECO				;0F97FH
	XRA	A
	STA	STATCO					;0FFAEH

LFC9D:					;0FC9DH
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

LFCA2:					;0FCA2H
	CPI	18H
	JNZ	LFCAC					;0FCACH
	MOV	A,M
	INR	A
	JMP	LFC7C					;0FC7CH

LFCAC:					;0FCACH
	CPI	0AH
	JNZ	LFCB4					;0FCB4H
	JMP	LFBB0					;0FBB0H

LFCB4:					;0FCB4H
	CPI	0BH
	JZ	HOME					;0FCD0H
	CPI	0EH
	JZ	SETFONT1				;0FD3CH
	CPI	0FH
	JZ	SETFONT0				;0FD42H
	CPI	7
	JZ	BELL					;0FDA8H
	CPI	9
	JZ	TABTURNON				;0FDBDH
	JMP	LFCDF					;0FCDFH

HOME:					;0FCD0H
	XRA	A
	STA	XTV					;0FFADH
	LDA	ROLIC					;0FFABH
	SUI	0AH
	STA	YTV					;0FFACH
	JMP	EXCO2					;0FC87H

LFCDF:					;0FCDFH
	CPI	0DH
	JNZ	LFCE8					;0FCE8H
	XRA	A
	JMP	LFC86					;0FC86H

LFCE8:					;0FCE8H
	CPI	19H
	LXI	H,YTV					;0FFACH
	JNZ	LFD07					;0FD07H
	LDA	ROLIC					;0FFABH
	MVI	C,0AH

LFCF5:					;0FCF5H
	INR	M
	CMP	M
	JZ	LFD01					;0FD01H
	DCR	C
	JNZ	LFCF5					;0FCF5H
	JMP	EXCO2					;0FC87H

LFD01:					;0FD01H
	SUI	0FAH

LFD03:					;0FD03H
	MOV	M,A
	JMP	EXCO2					;0FC87H

LFD07:					;0FD07H
	CPI	1AH
	JNZ	OUTGRCHR				;0FAE4H
	LDA	ROLIC					;0FFABH
	MVI	C,0AH

LFD11:					;0FD11H
	DCR	M
	CMP	M
	JZ	LFD1D					;0FD1DH
	DCR	C
	JNZ	LFD11					;0FD11H
	JMP	EXCO2					;0FC87H

LFD1D:					;0FD1DH
	SUI	0AH
	JMP	LFD03					;0FD03H
;
; posle wnutr. nastrojki obrabotatx simwol iz <C> kak uprawl.

INTERNALSYMBOL:				;0FD22H
	XRA	A
	STA	STATCO					;0FFAEH
	JMP	CIRCLECO				;0F97FH

NOWGRF:					;0FD29H
	XRA	A
	STA	STATCO					;0FFAEH
	JMP	OUTGRCHR				;0FAE4H
;
; inicializaciq displeq

INIDISP:				;0FD30H
	LXI	H,SHRF0					;0F8EDH
	SHLD	OUTGRCHR+1				;0FAE5H
	CALL	LFD89					;0FD89H
	JMP	INTERNALSYMBOL				;0FD22H

SETFONT1:				;0FD3CH
	LXI	H,SHRF1					;0F8FDH
	JMP	SETFONTS				;0FD51H

SETFONT0:				;0FD42H
	LXI	H,SHRF0					;0F8EDH
	JMP	SETFONTS				;0FD51H

SETFONT2:				;0FD48H
	LXI	H,SHRF2					;0F90DH
	JMP	SETFONTS				;0FD51H
;
; tablica koi-8

SETFONT3:				;0FD4EH
	LXI	H,SHRF3					;0F91DH

SETFONTS:				;0FD51H
	SHLD	OUTGRCHR+1				;0FAE5H
	JMP	ZEROSTATCO				;0FADCH

FONCHRCOLOR:				;0FD57H
	MVI	A,'@'	;40H
	STA	STATCO					;0FFAEH
	JMP	EXCO2					;0FC87H

CHANGECOLOR:				;0FD5FH
	LDA	LFFC2					;0FFC2H
	CPI	0
	JZ	LFD72					;0FD72H
	XRA	A
	STA	LFFC2					;0FFC2H
	MOV	A,C
	STA	CLRCHR					;0FFC0H
	JMP	ZEROSTATCO				;0FADCH

LFD72:					;0FD72H
	INR	A
	STA	LFFC2					;0FFC2H
	MOV	A,C
	STA	CLRFON					;0FFBFH
	JMP	EXCO2					;0FC87H

POZITIVE:				;0FD7DH
	XRA	A
	JMP	SETPOZNEG				;0FD83H

NEGATIVE:				;0FD81H
	MVI	A,1

SETPOZNEG:				;0FD83H
	CALL	LFD8A					;0FD8AH
	JMP	ZEROSTATCO				;0FADCH

LFD89:					;0FD89H
	XRA	A

LFD8A:					;0FD8AH
	LXI	D,0A67BH
	LXI	H,0B67AH
	ANA	A
	JZ	LFD95					;0FD95H
	XCHG

LFD95:					;0FD95H
	SHLD	LFB5E					;0FB5EH
	MVI	A,9
	LXI	H,LFB36					;0FB36H

LFD9D:					;0FD9DH
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	INX	H
	INX	H
	DCR	A
	JNZ	LFD9D					;0FD9DH
	RET

BELL:					;0FDA8H
	LXI	H,1002H

LFDAB:					;0FDABH
	HLT
	DCR	H
	MVI	A,'6'	;36H
	OUT	8
	MOV	A,L
	OUT	0BH
	MOV	A,H
	OUT	0BH
	JNZ	LFDAB					;0FDABH
	JMP	ZEROSTATCO				;0FADCH

TABTURNON:				;0FDBDH
	MVI	A,' '	;20H
	STA	STATCO					;0FFAEH
	MOV	C,A
	JMP	CIRCLECO				;0F97FH

RST7:					;0FDC6H
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LHLD	CLRFON					;0FFBFH
	LXI	D,100FH

SETCOLOR:				;0FDD0H
	MOV	A,E
	OUT	2
	ANI	6
	MOV	A,L
	JZ	CASECOLOR				;0FDDAH
	MOV	A,H

CASECOLOR:				;0FDDAH
	OUT	0CH
	PUSH	PSW
	POP	PSW
	PUSH	PSW
	POP	PSW
	PUSH	PSW
	POP	PSW
	DCR	E
	DCR	D
	OUT	0CH
	JNZ	SETCOLOR				;0FDD0H
	LHLD	TIMER					;0FFC7H
	INX	H
	SHLD	TIMER					;0FFC7H
	MVI	A,8AH
	OUT	0
	MOV	A,L
	ANI	7
	MOV	H,A
	ANI	4
	MOV	L,A
	LDA	MARKTIME				;0FFC3H
	CMP	H
	MOV	A,L
	STA	MARKTIME				;0FFC3H
	JZ	LFE0B					;0FE0BH
	MVI	A,1

LFE08:					;0FE08H
	STA	LFFC6					;0FFC6H

LFE0B:					;0FE0BH
	IN	1
	ANI	80H
	LXI	H,RUSLATKEY				;0FFB3H
	JNZ	NORUSKEY				;0FE26H
	MOV	A,M
	ORA	A
	JZ	LFE28					;0FE28H
	MVI	M,0
	LXI	H,STATCI				;0FFB1H
	MOV	A,M
	XRI	8
	MOV	M,A
	JMP	LFE28					;0FE28H

NORUSKEY:				;0FE26H
	MVI	M,0FFH

LFE28:					;0FE28H
	XRA	A
	OUT	3
	IN	2
	CPI	0FFH
	JZ	NOKEYPRESS				;0FE4CH
	LXI	B,LFE08					;0FE08H
	LXI	D,0800H
	MOV	A,B

LFE39:					;0FE39H
	OUT	3
	IN	2
	CPI	0FFH
	JNZ	CLROW					;0FE5AH
	MOV	A,E
	ADD	D
	MOV	E,A
	MOV	A,B
	RLC
	MOV	B,A
	DCR	C
	JNZ	LFE39					;0FE39H

NOKEYPRESS:				;0FE4CH
	CALL	LFF38					;0FF38H
	XRA	A
	STA	FRSTDELAY				;0FFB0H
	CMA
	STA	OLDKEY					;0FFB2H
	JMP	EXRST7					;0FF4DH

CLROW:					;0FE5AH
	RAR
	JNC	FINDROW					;0FE62H
	INR	E
	JMP	CLROW					;0FE5AH

FINDROW:				;0FE62H
	CALL	LFF38					;0FF38H
	LXI	H,CONTRST7				;0FED8H
	PUSH	H
	IN	1
	ANI	60H
	MOV	B,A
	MOV	A,E
	CPI	'?'	;3FH
	MVI	A,' '	;20H
	RZ
	MOV	A,E
	CPI	10H
	JNC	LFE8C					;0FE8CH
	LXI	H,SPECIALKEY				;0FEC8H
	MVI	D,0
	DAD	D
	MOV	A,M
	CPI	7FH
	RNZ
	MOV	A,B
	ANI	' '	;20H
	MVI	A,5FH
	RZ
	MOV	A,M
	RET

LFE8C:					;0FE8CH
	CPI	' '	;20H
	JNC	LFEAB					;0FEABH
	CPI	1CH
	MOV	A,B
	JNC	LFEA2					;0FEA2H
	ANI	' '	;20H
	MOV	A,E
	JZ	LFE9F					;0FE9FH

LFE9D:					;0FE9DH
	ADI	10H

LFE9F:					;0FE9FH
	ADI	10H
	RET

LFEA2:					;0FEA2H
	ANI	' '	;20H
	MOV	A,E
	JNZ	LFE9F					;0FE9FH
	JMP	LFE9D					;0FE9DH

LFEAB:					;0FEABH
	MOV	A,B
	ANI	'@'	;40H
	JNZ	LFEB5					;0FEB5H
	MOV	A,E
	ANI	1FH
	RET

LFEB5:					;0FEB5H
	MOV	A,B
	ANI	' '	;20H
	MOV	B,A
	LDA	STATCI					;0FFB1H
	ANI	8
	ORA	B
	MOV	A,E
	JPO	LFEC5					;0FEC5H
	ADI	' '	;20H

LFEC5:					;0FEC5H
	ADI	' '	;20H
	RET

SPECIALKEY:				;0FEC8H
	DB	09H,0AH,0DH,7FH,08H,19H,18H
	DB	1AH,0CH,1FH,1BH,00H,01H,02H
	DB	03H,80H

CONTRST7:				;0FED8H
	LXI	H,EXRST7				;0FF4DH
	PUSH	H
	MOV	B,A
	LDA	OLDKEY					;0FFB2H
	CPI	0FFH
	JZ	LFEFD					;0FEFDH
	CMP	B
	RNZ
	LXI	H,FRSTDELAY				;0FFB0H
	MOV	A,M
	CPI	'2'	;32H
	JZ	LFEF2					;0FEF2H

LFEF0:					;0FEF0H
	INR	M
	RET

LFEF2:					;0FEF2H
	LXI	H,NEXTDELAY				;0FFAFH
	MOV	A,M
	CPI	5
	JNZ	LFEF0					;0FEF0H
	MVI	M,0

LFEFD:					;0FEFDH
	MOV	A,B
	STA	OLDKEY					;0FFB2H
	CPI	80H
	JNZ	LFF0F					;0FF0FH
	LDA	CAPSSHIFT				;0FFC1H
	ADI	80H
	STA	CAPSSHIFT				;0FFC1H
	RET

LFF0F:					;0FF0FH
	CPI	'@'	;40H
	JC	STOREKEYTOBUF				;0FF1EH
	CPI	7FH
	JZ	STOREKEYTOBUF				;0FF1EH
	LDA	CAPSSHIFT				;0FFC1H
	ADD	B
	MOV	B,A

STOREKEYTOBUF:				;0FF1EH
	LXI	H,QCHAR					;0FFB4H
	MOV	A,M
	CPI	8
	RNC
	INR	M
	LDA	CHARCOUNT				;0FFB5H
	MOV	E,A
	MVI	D,0
	LXI	H,RINGCI				;0FFB7H
	DAD	D
	INR	A
	ANI	7
	STA	CHARCOUNT				;0FFB5H
	MOV	M,B
	RET

LFF38:					;0FF38H
	MVI	A,88H
	OUT	0
	LDA	STATCI					;0FFB1H
	ANI	9
	OUT	1
	LDA	ROLIC					;0FFABH
	OUT	3
	MVI	A,10H
	OUT	2
	RET

EXRST7:					;0FF4DH
	POP	H
	POP	D
	POP	B
	POP	PSW
	EI
	RET

STATCON:				;0FF53H
	LDA	LFFC6					;0FFC6H
	ANA	A
	CNZ	LF92D					;0F92DH
	LDA	QCHAR					;0FFB4H
	ANA	A
	RZ
	MVI	A,0FFH
	RET

CI:					;0FF62H
	CALL	INKEY					;0FF6BH
	CPI	0FFH
	JZ	CI					;0FF62H
	RET

INKEY:					;0FF6BH
	PUSH	B
	PUSH	H
	CALL	STATCON					;0FF53H
	LXI	H,QCHAR					;0FFB4H
	MOV	A,M
	ORA	A
	JNZ	KEYISPRESSED				;0FF7CH
	DCR	A
	POP	H
	POP	B
	RET

KEYISPRESSED:				;0FF7CH
	DCR	M
	LXI	H,RINGCI				;0FFB7H
	LDA	COUNTCI					;0FFB6H
	MOV	C,A
	MVI	B,0
	DAD	B
	INR	A
	ANI	7
	STA	COUNTCI					;0FFB6H
	MOV	A,M
	POP	H
	POP	B
	RET

CO:					;0FF91H
	PUSH	H
	LXI	H,0
	DAD	SP
	LXI	SP,0
	PUSH	PSW
	XRA	A
	OUT	10H
	POP	PSW
	CALL	ONLYCO					;0F974H

EXOFF:					;0FFA1H
	PUSH	PSW
	MVI	A,'#'	;23H
	OUT	10H
	POP	PSW
	EI
	SPHL
	POP	H
	RET

ROLIC:					;0FFABH
	DB	0FFH

YTV:					;0FFACH
	DB	00H

XTV:					;0FFADH
	DB	00H

STATCO:					;0FFAEH
	DB	00H

NEXTDELAY:				;0FFAFH
	DB	00H

FRSTDELAY:				;0FFB0H
	DB	00H

STATCI:					;0FFB1H
	DB	06H

OLDKEY:					;0FFB2H
	DB	00H

RUSLATKEY:				;0FFB3H
	DB	0FFH

QCHAR:					;0FFB4H
	DB	00H

CHARCOUNT:				;0FFB5H
	DB	00H

COUNTCI:				;0FFB6H
	DB	00H

RINGCI:					;0FFB7H
	DS	0008H

CLRFON:					;0FFBFH
	DB	00H

CLRCHR:					;0FFC0H
	DB	28H

CAPSSHIFT:				;0FFC1H
	DB	00H

LFFC2:					;0FFC2H
	DB	00H

MARKTIME:				;0FFC3H
	DB	00H

WDEL:					;0FFC4H
	DB	32H

RDEL:					;0FFC5H
	DB	4BH

LFFC6:					;0FFC6H
	DB	00H

TIMER:					;0FFC7H
	DB	02H
	DB	00H

INVERS:					;0FFC9H
	DB	00H

LFFCA:					;0FFCAH
	DB	00H
	DS	0033H
	END
B	00H

TIMER:					;0FFC7H
	DB	02H
	DB	00H

INVERS:					;0FFC