
;*******************************
;	wwod/wywod fajlow
;  ---------------------------
;  wers.4.17	data:25-MAY-92
;*******************************

	MACLIB	EDISK

EXTRN	FCBSTORE
PUBLIC	WRALL
WRALL:
	SHLD	2752H		; komanda iz WM.COM

	CPI	'Y'
	JZ	INPUTALL
	CPI	'W'
	JNZ	05DDH

	LXI	D,FCBSTORE
	CALL	CHECKQ			; podgotowitx i proweritx FCB

	CALL	CHECKFREE
	JC	DISKFULL

	CALL	1D51H		; podgotowitx fajl

	LDA	FCB2+17		; ~islo zapisej w ADD fajle
	LHLD	FCB2+22
	PUSH	PSW
	PUSH	H
	CALL	CLEAROLD
;	MVI	A,-1		; perehod w komandnyj revim
;	STA	26A8H		; FIRSTSCREENCELL
	CALL	SETADDFCB	; kak FCB2
	POP	H
	POP	PSW
	STA	FCBADD+17
	SHLD	FCBADD+22
;	LXI	H,EDATA
;	SHLD	FCBADD+18

	CALL	RESTOREFCB

	CALL	PREPFILE

EXTRN	PREPTAPE
	CALL	PREPTAPE		; nadpisi

;	LDA	FCBADD+17
;	CALL	TYPEKBYTE

	LXI	D,FCBADD
	CALL	OUTFILE

	JMP	EXWR

RESTOREFCB:
	LXI	H,FCBSTORE
	LXI	D,FCBADD
	LXI	B,11
	PUSH	D
;	CALL	COPY
	RST	4
	POP	D
	RET

;  prowerka wozmovnosti razmestitx FCB2 w wide swqznogo fajla
;  pri newozmovnosti peredatx uprawl. na 'DISK FULL'

PUBLIC	CHECKFREE
CHECKFREE:
	LHLD	BGNONE		; razmer dobawl. oblasti
	XCHG
	LHLD	ENDONE
	CALL	HLMINUSDE
	MOV	B,H
	MOV	C,L
	LHLD	BGNTWO
	XCHG
	LHLD	ENDTWO
	CALL	HLMINUSDE
	DAD	B

	MOV	A,L		; ~islo dobawlqemyh zapisej
	ANI	7FH
	JZ	ALIGNED		; polnaq zapisx ?
	MOV	A,L
	ORI	7FH
	MOV	L,A
	INX	H
ALIGNED:
	DAD	H
	MOV	B,H

	LHLD	FCB2+22		; ~islo swobodnyh zapisej
	XCHG
	LHLD	WMBACKFCB+22

	MVI	C,0		; opredelenie neobhodimosti poprawki na |kran
	MOV	A,D
	CPI	0E0H
	JNC	NOCHN		; FCB2 >= 0E000H ?
	MVI	A,0A0H
	CMP	H
	JNC	NOCHN		; WMBACKFCB < 0A000H ?

	MVI	C,40H*2		; poprawka na |kran

NOCHN:
	CALL	HLMINUSDE
	DAD	H
	MOV	A,H
	DCR	A		; obqzatelxno s razrywom

	SUB	C		; u~et poprawki na |kran
	CMP	B
	RET

;  informaciq

PUBLIC	INFORMATION
INFORMATION:
	CALL	CHECKFREE
;	INR	A
	PUSH	PSW
	CALL	MEDATA
	LXI	D,BOUND-4000H
	DAD	D
	DAD	H
	MOV	C,H
	POP	PSW

;  <A> - ~islo swobodnyh zapisej w disk. prost.
;  <B> - ~islo zapisej w bufere
;  <C> - wsego zapisej w disK. prostr.

	MOV	L,A		; realxnoe swob. prostranstwo
	SUB	B		; movet bytx otric.
	MOV	D,A
	MVI	A,' '
	JNC	SETSIGN
	MOV	A,D		; pomenqtx znak
	CMA
	INR	A
	MOV	D,A
	MVI	A,'-'
SETSIGN:
	STA	SIGN
	MOV	A,D
	CALL	SETKB
	MOV	H,A
	MOV	A,C		; realxnaq dlina fajla
	SUB	L
	ADD	B
	CALL	SETKB
	MOV	L,A

;    <H> - dlina swob.zony (movet bytx otricatelxna)
;    <L> - dlina fajla

;	PUSH	H
;
;	CALL	HEXHLA		; ~islo zap. w swob.zone
;	SHLD	SIZEM
;
;	MOV	A,B		; ~islo zapisej w bufere
;	CALL	HEXHLA
;	SHLD	SIZET
;
;	LXI	D,FCB2		; nomer zapisi w FCB2
;	CALL	NZHLA
;	SHLD	SIZEBF
;
;	LXI	D,WMBACKFCB	; nomer zapisi w FCB2
;	CALL	NZHLA
;	SHLD	SIZENB
;
;	LXI	H,INFO
;	RST	5
;	CALL	DIN
;	RST	2
;	POP	H

	PUSH	H
	MOV	A,H
	CALL	DECHLA
	SHLD	SIZEM
	POP	H
	MOV	A,L
	CALL	DECHLA
	SHLD	SIZET

	LDA	BUFER
	CALL	DECHLA
	SHLD	SIZEBF

	LDA	NBUFER
	CALL	DECHLA
	SHLD	SIZENB

	LDA	COUNTL
	CALL	DECHLA
	SHLD	LLIST

	LDA	PRINTM
	CALL	SETPOZNEG
	MOV	A,B
	STA	FX85
	MOV	A,C
	STA	FX800

	LDA	WAITCELL
	CALL	SETPOZNEG
	MOV	A,B
	STA	CCONT
	MOV	A,C
	STA	CWAIT

	LXI	H,INFO
	RST	5		; INFO
	LXI	H,ADDH
	RST	5
;
;	CALL	DIN
;
	LXI	H,24
	CALL	SETCURSORHL
	RET

SETKB:
	PUSH	B
	RRC
	RRC
	RRC
	MOV	B,A
	ANI	11100000B
	MOV	C,A
	MOV	A,B
	ANI	00011111B
	MOV	B,A
	MOV	A,C
	ORA	A
	JZ	$+4
	INR	B
	MOV	A,B
	POP	B
	RET

SETPOZNEG:
	ORA	A
	LXI	B,6261H
	RZ
	LXI	B,6162H
	RET

	DSEG

YP	SET	10
X1	SET	16
X2	SET	36

ADDH:
	CUR	YP+10,0
	DB	'swobodno'
	CUR	YP+10,X1-1
SIGN:	DB	' '
SIZEM:	DB	'00 kbajt'

	DB	1BH,5BH
	DB	0

	CSEG

;DIN:
;	LHLD	FCB2+22
;	CALL	LADDR
;	LHLD	WMBACKFCB+22
;LADDR:
;	MVI	C,' '
;	RST	3
;	MOV	A,H
;	CALL	LBYTE
;	MOV	A,L
;	JMP	LBYTE
;
;NZHLA:
;	LXI	H,12		; nomer zapisi polnyj po TZ i C2
;	DAD	D
;	MOV	A,M
;	ANI	1
;	RRC
;	LXI	H,32
;	DAD	D
;	ORA	M
;HEXHLA:
;	LXI	H,3030H
;HCLDEC:
;	SUI	10H
;	CNC	OLDINR
;	JNC	HCLDEC
;	ADI	10H
;	ADD	H
;	CALL	CORR
;	MOV	H,A
;	MOV	A,L
;	CALL	CORR
;	MOV	L,A
;	RET
;
;CORR:
;	CPI	3AH
;	RC
;	ADI	7
;	RET
;
;HOLDINR:
;	INR	L
;	RET

DECHLA:
	LXI	H,302FH
CLDEC:
	SUI	10
	CNC	OLDINR
	JNC	CLDEC
	ADI	10
	ADD	H
	MOV	H,A
OLDINR:	INR	L
	RET


PUBLIC	INPUTALL
INPUTALL:
	LXI	D,FCBSTORE
	CALL	0966H

	CALL	CLEARBUFTXT
;	MVI	A,-1		; perehod w komandnyj revim
;	STA	26A8H		; FIRSTSCREENCELL

	CALL	SETADDFCB	; kak FCB2
;	LXI	H,EDATA
;	SHLD	FCBADD+18

	CALL	MEDATA
	LXI	D,BOUND-4000H
	DAD	D

;	LXI	H,BOUND-EDATA-4000H	; MAX razre{. dlina fajla
;					;  s u~etom dliny |krana

	CALL	RESTOREFCB

	CALL	INPUTFILE		; wwod fajla s magnitofona
					; nado ustanowitx (+17) - ~islo blokow
					;  w FCBADD

;	LDA	FCBADD+17
;	CALL	TYPEKBYTE

PUBLIC	EXWR
EXWR:
	CALL	CORRECTION

	LXI	D,FCBADD
	CALL	ADDFILE		; wypolnitx komandu Y


;	LXI	H,0		; COUNT:=0
;	SHLD	2758H

	XRA	A
	STA	275CH		; DIRECT
	CALL	0747H		; -B
EXTRN	TXTKEY
	LXI	D,TXTKEY
	CALL	TYPESTRINGDE
;	JMP	CONIN
	RST	2
	RET

;PUBLIC	TYPEKBYTE
;TYPEKBYTE:
;	CALL	TYPELBYTE
;	MOV	B,A
;	ANI	07H
;	JZ	$+5
;	MVI	A,1
;	MOV	C,A		; okruglenie
;
;	MOV	A,B		; ~islo zapisej w KBYTE s okrugl. do bolx{ego
;	RRC
;	RRC
;	RRC
;	ANI	01FH
;	ADD	C
;	LXI	B,10H		; wywod w kbajt
;	LXI	H,-10H
;	DAD	B
;	SUI	10
;	JNC	$-3
;	ADI	10
;	ADD	L
;
;TYPELBYTE:
;	CALL	0F815H		; LBYTE
;	LXI	D,KBYTE
;	JMP	TYPESTRINGDE
;
;	DSEG
;KBYTE:
;	DB	' KByte(s)',0DH,0AH,0AH,0
;
;	CSEG

;  podgotowka FILE i FILENAME
PREPFILE:
	MOV	H,D		; adres imeni fajla
	MOV	L,E
	INX	H
	SHLD	FILENAME

	LXI	H,18		; adres na~ala fajla
	DAD	D
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	SHLD	FILE
	RET

;  wwod dopolnitelxnogo fajla
;  whod:
;    <DE> - FCBADD !!!

PUBLIC	RADDFILE
RADDFILE:
	CALL	0966H
	PUSH	D
	CALL	ONLYRADD
	POP	D
	MVI	A,RET			; wykl. kursor
	STA	kursor
	RET

ONLYRADD:
	LDA	READF
	ORA	A		; fajl uve wweden ?
	RNZ

	CALL	CLRSCR		; steretx |kran tolxko perwyj raz

;	LXI	H,0A000H	; delaetsq w ADDINIKOMREGIM
;	SHLD	FCBADD+18

	LXI	H,02000H
	LXI	D,FCBADD
	CALL	INPUTFILE
;	JC	CRLF
	RC

	CALL	CORRECTION

	MVI	A,-1		; flag: dop. fajl s~itan
	STA	READF
;	JMP	CRLF
	RET

CORRECTION:
	LDA	FCBADD+17
	DCR	A
	RZ			; ne nado pri praw. organizacii kwazidiska
	STA	FCBADD+17
	RET

;  wwod fajla s magnitofona
;  whod:
;    <DE> - FCB
;    <HL> - maks. razre{. dlina fajla
;  wyhod:
;    flag C=1 - o{ibka pri ~tenii
;    ustanawliwaet dlinu w blokah FCBADD
EXTRN	FILENAME,FILE,LINE,BOF,READTAPE,WRITETAPE
PUBLIC	INPUTFILE
INPUTFILE:
	SHLD	LINE

	XRA	A			; sbrositx ~islo zapisej w fajle
	STA	FCBADD+17

	CALL	PREPFILE
	CALL	READTAPE
	EI
	RC

	LHLD	LINE		; ukazatx dlinu fajla w zapisqh
	MOV	A,L
	ORI	7FH
	MOV	L,A
	DAD	H
	MOV	A,H
	ORA	A
	STA	FCBADD+17
	RET

;  wywod dop. fajla na magnitofon
;  whod:
;    <DE> - FCBADD !!!

PUBLIC	WADDFILE
WADDFILE:
	LXI	H,0A000H
	SHLD	FCBADD+18
	CALL	PREPFILE
;	CALL	0F803H			; CONIN vdatx pered wywodom na magn.
	RST	2
	CALL	OUTFILE

CLRSCR:
	LXI	H,CLS
;	CALL	PRINT
;	JMP	CRLF
	RST	5
	RET

	DSEG
CLS:
	DB	0CH
LD:
	CUR	24,0			; movno wyzwytx w /W i /Y dlq sootw.
	DB	0			; kursora w drajwere i WMC.COM

	CSEG

;  wywod fajla na magnitofon
;  <DE> - FCB

PUBLIC	OUTFILE
OUTFILE:
;	LDA	FCBADD+17	; fajl ne pust ?
;	ORA	A
;	JZ	FILENOTFOUND

	LXI	H,22		; najti dlinu fajla
	DAD	D
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	LXI	D,80H		; posl.blok
	DAD	D
	XCHG
	LHLD	FILE
	XCHG
	CALL	HLMINUSDE

	XCHG

	PUSH	D
	CALL	MEDATA
	LXI	D,0A000H
	DAD	D
	POP	D

;	LXI	H,0A000H-EDATA

EXTRN	HLDE
	CALL	HLDE
	XCHG
	JNC	SHORTFILE
	LXI	D,4000H		; u~estx dlinu |krana
	CALL	HLMINUSDE

SHORTFILE:
	SHLD	LINE
	JMP	WRITETAPE

MEDATA:
	LHLD	ADRVDISK	; HL := -EDATA
	MOV	A,L
	CMA
	MOV	L,A
	MOV	A,H
	CMA
	MOV	H,A
	INX	H
	RET

	END
