
;      blok sistemnyh podprogramm
;  -----------------------------------
;  VERS.1.6		DATA:16-SEP-92

strok	EQU	31		; ~islo strok na displee-1
kolonki	EQU	31		; ~islo liter w stroke-1

EXTRN	INKEY

	CSEG

;  ukazatx teku}ij cwet
;  whod:
;    <A> - cwet bukwy/podlovki

PUBLIC	SETCOLOR
SETCOLOR:
	STA	COLOR	
	PUSH	H
	PUSH	D
	PUSH	B
	MVI	B,4
	MOV	C,A
	LXI	H,MODCLR
CLCLR:
	ANI	88H
	JP	CLR0X
	LXI	D,0FF3EH		; MVI A,-1
	JPE	$+6
	LXI	D,0001AH		; LDAX D + NOP
	JMP	SETOUT
CLR0X:
	LXI	D,0003EH		; MVI A,0
	JPE	$+6
	LXI	D,02F1AH		; LDAX D + CMA
SETOUT:
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	INX	H
	INX	H
	MOV	A,C			; sled. ploskostx
	RLC
	MOV	C,A
	DCR	B
	JNZ	CLCLR
	POP	B
	POP	D
	POP	H
	RET

;  ukazatx aktiwnye ploskosti
;  whod:
;    <A> - bity 3...0 - ploskosti 8000H,A000H,C000H,E000H

PUBLIC	SETPLANE
SETPLANE:
	STA	PLANE
	PUSH	H
	PUSH	B
	MVI	B,4
	MOV	C,A
	LXI	H,MODCLR+2
CLPLN:
	ANI	08H
	MVI	M,0			; NOP
	JZ	$+5
	MVI	M,77H			; MOV M,A
	INX	H
	INX	H
	INX	H
	INX	H
	MOV	A,C			; sled. ploskostx
	RLC
	MOV	C,A
	DCR	B
	JNZ	CLPLN
	POP	B
	POP	H
	RET

;  najti teku}ij cwet
PUBLIC	SEECOLOR
SEECOLOR:
	LDA	COLOR
	RET

;  najti teku}ie aktiwnye ploskosti
PUBLIC	SEEPLANE
SEEPLANE:
	LDA	PLANE
	RET

;  ukazatx adres znakogeneratora
;  whod:
;    <HL> - adres na~ala bukw. znakogeneratora

PUBLIC	SETCHAR
SETCHAR:
	SHLD	ADRCHAR
	RET

	DSEG

COLOR:	DB	0F0H
PLANE:	DB	00FH

PUBLIC	BEGINDISP,MARKINF
BEGINDISP:			; wysota perwoj stroki tekst.displeq
	DB	00H
MARKINF:			; marker tekst.displeq
	DW	31

	CSEG

;  ustanowka na~ala tekst.displeq
;  whod:
;    <A> - wysota perwoj stroki

PUBLIC	SETBEGINDISP
SETBEGINDISP:
	STA	BEGINDISP
	RET

;  ustanowka markera

PUBLIC	SETMARKDISP
SETMARKDISP:
	MOV	A,H
	CPI	kolonki+1
	JC	$+5
	MVI	H,kolonki
	MOV	A,L
	CPI	strok+1
	JC	$+5
	MVI	L,strok
	SHLD	MARKINF
	RET

;  drajwer litern.displeq
;  whod:
;    <s> - bajt dlq wywoda
;    MARKINF - marker
;    BEGINDISP - wysota perwoj stroki na displee

PUBLIC	CO
CO:
	MOV	A,C
	CPI	20H
	JNC	COTEXT	; normalxnyj tekst
	PUSH	H
	LHLD	MARKINF
	CPI	0DH
	JZ	wk
	CPI	0AH
	JZ	ps
	CPI	0CH
	JZ	HOME
	CPI	1FH
	JZ	str
	CPI	08H
	JZ	wlewo
	CPI	18H
	JZ	wprawo
	POP	H
	RET

wk:	MVI	H,0
	JMP	EXCTRL
ps:	DCR	L
	JP	EXCTRL
	MVI	L,strok
	JMP	EXCTRL
str:	CALL	DARKSEEL	; steretx displej
HOME:	LXI	H,strok
	JMP	EXCTRL
wlewo:	DCR	H
	JP	EXCTRL
	MVI	H,kolonki
	JMP	EXCTRL
wprawo:	INR	H
	MOV	A,H
	CPI	kolonki+1
	JNZ	EXCTRL
	MVI	H,0
EXCTRL:	SHLD	MARKINF
	POP	H
	RET

PUBLIC	COTEXT
COTEXT:
	PUSH	H
	PUSH	D
	PUSH	B

	MOV	L,C
	MVI	H,0
	DAD	H
	DAD	H
	DAD	H
	XCHG

	LXI	H,TABGRF		; sme}enie dlq 32 znakow
	MOV	A,D
	ADD	L
	MOV	L,A
	JNC	$+4
	INR	H
	MOV	H,M
	MVI	L,0
	MOV	D,L		; !!!
	DAD	D

ADRCHAR	EQU	$+1
	LXI	D,0		; adres na~ala znakogeneratora
	DAD	D
	XCHG			; adres znaka

	LHLD	MARKINF
	MOV	A,H
	CPI	kolonki+1
	CZ	wkps
	INR	H
	SHLD	MARKINF

	MOV	A,H
	DCR	A
	ORI	80H
	MOV	H,A

	MOV	A,L
	ADD	A
	ADD	A
;	ADD	L
	ADD	A
	MOV	L,A

	LDA	BEGINDISP
	ADD	L
	MOV	L,A

	MVI	B,8
CLOUT:
	PUSH	B
	LXI	B,2000H
	PUSH	D
	PUSH	H
MODCLR:
	REPT	4
	LDAX	D
	NOP
	MOV	M,A
	DAD	B
	ENDM
	POP	H
	POP	D
	INR	E
	INR	L
	POP	B
	DCR	B
	JNZ	CLOUT

	POP	B
	POP	D
	POP	H
	RET

	DSEG

TABGRF:
	DB	0		; CONTROL
	DB	0		; znaki
	DB	1		; latynx werh.
	DB	2		; latynx nivn.
	DB	5		; grafika 1
	DB	6		; grafika 2
	DB	4		; russkij nivn.
	DB	3		; russkij werh.

wkps:	MVI	H,0		; wkps pri perepoln.stroki
	DCR	L
	RP
	MVI	L,0
	RET

;  wywod tekstowoj posledowatelxnosti
;  whod: PEC
;    <H,L> - adres stroki

@PEC:
	MOV	C,A
	CALL	CO

PUBLIC	PEC
PEC:
	MOV	A,M
	INX	H
	CPI	1BH
	JZ	AR2
	ORA	A
	JNZ	@PEC
	RET

@CCO:				; obrabotka posledowatelxnosti :
	PUSH	B		;  ukazatelx cikla ==> 80H-0FFH
	ANI	7FH		;  litera
	MOV	B,A
	MOV	C,M
	INX	H
BCO:
	CALL	CO
	DCR	B
	JNZ	BCO
	POP	B
	JMP	PEC


AR2:
	MOV	A,M
	INX	H
	ORA	A
	JM	@CCO		; s~et~ik ?

	CPI	'C'
	JZ	NEXTCOLOR
	CPI	'Y'
	JNZ	PEC

	PUSH	D
	MOV	A,M
	SUI	' '
	MOV	E,A		; Y
	INX	H
	MOV	A,M
	SUI	' '
	MOV	D,A		; X
	INX	H
	XCHG
	CALL	SETMARKDISP
	XCHG
	POP	D
	JMP	PEC

NEXTCOLOR:
	MOV	A,M
	INX	H
	CALL	SETCOLOR
	JMP	PEC

PUBLIC	LADDR,LBYTE,LHIGH,LLOW
LADDR:
	MOV	A,H
	CALL	LBYTE
	MOV	A,L
LBYTE:
	CALL	LHIGH
LHIGH:
	RRC
	RRC
	RRC
	RRC
LLOW:
	PUSH	PSW
	ANI	0FH
	CALL	CONV
	MOV	C,A
	CALL	CO
	POP	PSW
	RET

PUBLIC	CONV
CONV:
	ADI	90H
	DAA
	ACI	40H
	DAA
	RET

;  preobrazowatx HEX w DEC
;  whod:
;    <A> - HEX
;  wyhod:
;    <H,L> - DEC

PUBLIC	DECHEX
DECHEX:
	LXI	H,0
	MVI	B,8

CLDH:	ADD	A
	PUSH	PSW
	MOV	A,L
	ADC	L
	DAA
	MOV	L,A
	MOV	A,H
	ADC	H
	DAA
	MOV	H,A
	POP	PSW
	ORA	A
	DCR	B
	JNZ	CLDH
	RET

PUBLIC	LASTINKEY
LASTINKEY:
	PUSH	B
	MVI	A,0FFH
INK:	MOV	B,A
	CALL	INKEY
	CPI	0FFH
	JNZ	INK
	MOV	A,B
	POP	B
	RET

PUBLIC	CI
CI:
	CALL	LASTINKEY
	CPI	0FFH
	JZ	CI
	RET

PUBLIC	spec
spec:
	PUSH	D
	MOV	D,M
	INX	H
	MVI	E,1
poisk:	CMP	M
	INX	H
	JZ	najdena
	INR	E
	DCR	D
	JNZ	poisk
	MOV	E,D		; = 0 !!!
najdena:
	MOV	A,E
	POP	D
	RET

;  zadervka <a> kadrow
;  wyhod:
;    flag Z := 0 pri wyhode po navatii na l`bu` klawi{u

PUBLIC	DELAY
DELAY:
	PUSH	B
	MOV	B,A
DELAYC:	CALL	LASTINKEY
	CPI	0FFH
	JNZ	EXDEL
	HLT
	DCR	B
	JNZ	DELAYC
EXDEL:	POP	B
	RET

;  wwod stroki s klawiatury
;  whod:
;    <H,L> - adres na~ala bufera
;    <D> - MAX razmer bufera

PUBLIC	CIHL
CIHL:
	PUSH	H
	PUSH	B
	MVI	C,01H
	CALL	CO
	MVI	C,0EH
	CALL	CO
BGNTXT:	MVI	B,1
NEXTLIT:CALL	CI
	MOV	C,A
	CPI	0DH
	JZ	kontekst
	CPI	7FH
	JZ	DELLIT
	MOV	A,B
	DCR	A
	CMP	D
	JZ	NEXTLIT
	CALL	CO
	MOV	M,C
	INX	H
	INR	B
	JMP	NEXTLIT

TXTZABOJ:
	DB	08H,' ',08H,0
DELLIT:
	DCR	B
	JZ	BGNTXT
	DCX	H
	MVI	M,' '
	PUSH	H
	LXI	H,TXTZABOJ
	CALL	PEC
	POP	H
	JMP	NEXTLIT
kontekst:
	MVI	C,0FH
	CALL	CO
	POP	B
	POP	H
	RET

DARKSEEL:
	LXI	H,8000H
	LXI	D,8000H
	MVI	M,0
	INX	H
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	$-6
	RET


	END
