
;        
;  -----------------------------------
;  vers.1.6		data:16-sep-92

	equ	31		;    -1
	equ	31		;    -1

extrn	Inkey

	cseg

;    
;  :
;    <a> -  /

public	SetColor
SetColor:
	sta	Color	
	push	h
	push	d
	push	b
	mvi	b,4
	mov	c,a
	lxi	h,modClr
clclr:
	ani	88h
	jp	clr0x
	lxi	d,0ff3eh		; mvi a,-1
	jpe	$+6
	lxi	d,0001ah		; ldax d + nop
	jmp	setout
clr0x:
	lxi	d,0003eh		; mvi a,0
	jpe	$+6
	lxi	d,02f1ah		; ldax d + cma
setout:
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	inx	h
	inx	h
	mov	a,c			; . 
	rlc
	mov	c,a
	dcr	b
	jnz	clclr
	pop	b
	pop	d
	pop	h
	ret

;    
;  :
;    <a> - bity 3...0 -  8000h,a000h,c000h,e000h

public	SetPlane
SetPlane:
	sta	Plane
	push	h
	push	b
	mvi	b,4
	mov	c,a
	lxi	h,modClr+2
clpln:
	ani	08h
	mvi	m,0			; nop
	jz	$+5
	mvi	m,77h			; mov m,a
	inx	h
	inx	h
	inx	h
	inx	h
	mov	a,c			; . 
	rlc
	mov	c,a
	dcr	b
	jnz	clpln
	pop	b
	pop	h
	ret

;    
public	SeeColor
SeeColor:
	lda	Color
	ret

;     
public	SeePlane
SeePlane:
	lda	Plane
	ret

;    
;  :
;    <hl> -   . 

public	SetChar
SetChar:
	shld	AdrChar
	ret

	DSeg

Color:	db	0f0h
Plane:	db	00fh

public	BeginDisp,MarkInf
BeginDisp:			;    . 
	db	00h
MarkInf:			;  . 
	dw	31

	CSeg

;    . 
;  :
;    <a> -   

public	SetBeginDisp
SetBeginDisp:
	sta	BeginDisp
	ret

;   

public	SetMarkDisp
SetMarkDisp:
	mov	a,h
	cpi	+1
	jc	$+5
	mvi	h,
	mov	a,l
	cpi	+1
	jc	$+5
	mvi	l,
	shld	MarkInf
	ret

;    
;  :
;    <s> -   
;    MarkInf - 
;    BeginDisp -     

public	CO
CO:
	mov	a,c
	cpi	20h
	jnc	COtext	; . 
	push	h
	lhld	MarkInf
	cpi	0dh
	jz	
	cpi	0ah
	jz	
	cpi	0ch
	jz	Home
	cpi	1fh
	jz	
	cpi	08h
	jz	
	cpi	18h
	jz	
	pop	h
	ret

:	mvi	h,0
	jmp	exctrl
:	dcr	l
	jp	exctrl
	mvi	l,
	jmp	exctrl
:	call	DarkSeeL	; steretx displej
Home:	lxi	h,
	jmp	exctrl
:	dcr	h
	jp	exctrl
	mvi	h,
	jmp	exctrl
:	inr	h
	mov	a,h
	cpi	+1
	jc	exctrl
	mvi	h,0
exctrl:	shld	MarkInf
	pop	h
	ret

public	COtext
cotext:
	push	h
	push	d
	push	b

	mov	l,c
	mvi	h,0
	dad	h
	dad	h
	dad	h
	xchg

	lxi	h,TabGrf		;   32 
	mov	a,d
	add	l
	mov	l,a
	jnc	$+4
	inr	h
	mov	h,m
	mvi	l,0
	mov	d,l		; !!!
	dad	d

AdrChar	equ	$+1
	lxi	d,0		;   
	dad	d
	xchg			;  

	lhld	MarkInf
	mov	a,h
	cpi	+1
	cz	
	inr	h
	shld	MarkInf

	mov	a,h
	dcr	a
	ori	80h
	mov	h,a

	mov	a,l
	add	a
	add	a
;	add	l
	add	a
	mov	l,a

	lda	BeginDisp
	add	l
	mov	l,a

	mvi	b,8
clout:
	push	b
	lxi	b,2000h
	push	d
	push	h
modClr:
	rept	4
	ldax	d
	nop
	mov	m,a
	dad	b
	endm
	pop	h
	pop	d
	inr	e
	inr	l
	pop	b
	dcr	b
	jnz	clout

	pop	b
	pop	d
	pop	h
	ret

	DSeg

TabGrf:
	db	0		; Control
	db	0		; 
	db	1		;  .
	db	2		;  .
	db	5		;  1
	db	6		;  2
	db	4		;  .
	db	3		;  .

:	mvi	h,0		;   .
	dcr	l
	rp
	mvi	l,0
	ret

;    
;  : PEC
;    <h,l> -  

@PEC:
	mov	c,a
	call	CO

public	PEC
PEC:
	mov	a,m
	inx	h
	cpi	1bh
	jz	ar2
	ora	a
	jnz	@PEC
	ret

ar2:
	mov	a,m
	inx	h
	cpi	'Q'
	jz	@cco
	cpi	'C'
	jz	nextcolor
	cpi	'P'
	jz	nextplane
	cpi	'S'
	jz	SubTxt
	cpi	'H'
	jz	HighDisp
	cpi	'Y'
	jnz	PEC

	push	d
	mov	a,m
	sui	' '
	mov	e,a		; y
	inx	h
	mov	a,m
	sui	' '
	mov	d,a		; x
	inx	h
	xchg
	call	SetMarkDisp
	xchg
	pop	d
	jmp	PEC

HighDisp:
	mov	a,m
	inx	h
	call	SetBeginDisp
	jmp	PEC

SubTxt:
	push	d
	push	b
	mov	b,m		;  
	inx	h
	mov	e,m		;  
	inx	h
	mov	d,m
	inx	h
	push	h
	xchg
cSub:
	push	h		;   <b> 
	push	b
	call	PEC
	pop	b
	pop	h
	dcr	b
	jnz	cSub

	pop	h
	pop	b
	pop	d
	jmp	PEC
	
@cco:				;   :
	push	b		;  , 
	mov	b,m
	inx	h
	mov	c,m
	inx	h
bco:
	call	CO
	dcr	b
	jnz	bco
	pop	b
	jmp	PEC

nextcolor:
	mov	a,m
	inx	h
	call	setcolor
	jmp	PEC

nextplane:
	mov	a,m
	inx	h
	call	setplane
	jmp	PEC

public	Laddr,Lbyte,Lhigh,Llow
Laddr:
	mov	a,h
	call	Lbyte
	mov	a,l
Lbyte:
	call	Lhigh
Lhigh:
	rrc
	rrc
	rrc
	rrc
Llow:
	push	psw
	ani	0fh
	call	Conv
	mov	c,a
	call	CO
	pop	psw
	ret

public	Conv
Conv:
	adi	90h
	daa
	aci	40h
	daa
	ret

;   HEX  DEC
;  :
;    <a> - HEX
;  :
;    <h,l> - DEC

public	DecHex
DecHex:
	lxi	h,0
	mvi	b,8

cldh:	add	a
	push	psw
	mov	a,l
	adc	l
	daa
	mov	l,a
	mov	a,h
	adc	h
	daa
	mov	h,a
	pop	psw
	ora	a
	dcr	b
	jnz	cldh
	ret

public	LastInkey
LastInkey:
	push	b
	mvi	a,0ffh
ink:	mov	b,a
	call	inkey
	cpi	0ffh
	jnz	ink
	mov	a,b
	pop	b
	ret

public	CI
CI:
	call	LastInkey
	cpi	0ffh
	jz	CI
	ret

public	
:
	push	d
	mov	d,m
	inx	h
	mvi	e,1
:	cmp	m
	inx	h
	jz	
	inr	e
	dcr	d
	jnz	
	mov	e,d		; = 0 !!!
:
	mov	a,e
	pop	d
	ret

;   <a> 
;  :
;     z := 0       

public	DelayKey
DelayKey:
	push	b
	mov	b,a
delayc:	call	LastInkey
	cpi	0ffh
	jnz	exdel
	hlt
	dcr	b
	jnz	delayc
exdel:	pop	b
	ret

;     
;  :
;    <h,l> -   
;    <d> -   

public	CIHL
CIHL:
	push	h
	push	b
bgntxt:	mvi	b,1
nextlit:call	ci
	mov	c,a
	cpi	0dh
	jz	
	cpi	7fh
	jz	dellit
	mov	a,b
	dcr	a
	cmp	d
	jz	nextlit
	call	CO
	mov	m,c
	inx	h
	inr	b
	jmp	nextlit

txtzaboj:
	db	08h,' ',08h,0
dellit:
	dcr	b
	jz	bgntxt
	dcx	h
	mvi	m,' '
	push	h
	lxi	h,txtzaboj
	call	PEC
	pop	h
	jmp	nextlit
:
	pop	b
	pop	h
	ret

DarkSeeL:
	lxi	h,8000h
	lxi	d,8000h
	mvi	m,0
	inx	h
	dcx	d
	mov	a,d
	ora	e
	jnz	$-6
	ret


	end
