;;						- 1 -
;;**************************************
;;	   mikroreassembler Z80
;;  ------------  test  --------------
;;  wers.2.3.103	data:20-apr-90
;;**************************************
;;
CPU	EQU	1500H
;;
	ORG	100H
;;
		JMP	Z80TEST
Z80:		JMP	CPU		; GOTO ON CPU-PROGRAM
		JMP	COMPLEX
		JMP	CBYTE
		JMP	PEC
		JMP	PRIWORDLABEL
;;
PC:		DW	0		; GLOBAL DATA FIELD
OFFSET:		DW	3000H
MODECOM:	DS	1
PCPLUSOFFSET:	DS	2
;;
BUFER:
	DB	20
	DS	1
	DS	29
PCT:
	DW	0
OFFT:
	DW	3000H
;;
Z80MICRO:
	CALL	PRILABADR
	LHLD	PC
	XCHG
	LHLD	OFFSET
	JMP	Z80
;;;;						- 2 -
Z80TEST:
	LXI	SP,100H
	LHLD	PCT
	SHLD	PC
	LHLD	OFFT
	SHLD	OFFSET
;;
	LXI	D,MENU
	MVI	C,9
	CALL	0005H
	MVI	C,6
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	MVI	C,0
	JZ	0005H
	CALL	TST
	JMP	Z80TEST
;;
TST:
	CPI	'0'
	JZ	TEST0
	CPI	'A'
	JZ	TESTA
	CPI	'B'
	JZ	TESTB
	MVI	B,0DDH
	CPI	'X'
	JZ	TESTX
	CPI	'1'
	JZ	TESTX1
	MVI	B,0FDH
	CPI	'Y'
	JZ	TESTX
	CPI	'2'
	JZ	TESTX1
	CPI	'E'
	JZ	TESTE
	CPI	'P'
	JZ	FINDP
	CPI	'O'
	JZ	FINDO
	RET
;;
MENU:
	DB	0CH,1AH,1AH,1AH
	DB	'---- test reassemblera Z-80 ----',0DH,0AH
	DB	0DH,0AH
	DB	'0 - test komand',0DH,0AH
	DB	'A - test tablicy A',0DH,0AH
	DB	'B - test tablicy B',0DH,0AH
	DB	'X - test tablicy C-X',0DH,0AH
	DB	'Y - test tablicy C-Y',0DH,0AH
	DB	'1 - test tablicy D-X',0DH,0AH
	DB	'2 - test tablicy D-Y',0DH,0AH
	DB	'E - test tablicy E',0DH,0AH
	DB	'P - ukazatx PC',0DH,0AH
	DB	'O - ukazatx OFFSET',0DH,0AH
	DB	'K - wyhod w mikro-dos',0DH,0AH
	DB	0DH,0AH,'$'
;;;;						- 3 -
ZAGL:
	LXI	D,PCTEXT
	MVI	C,9
	JMP	0005H
;;
PCOFF:
	LHLD	PC
	PUSH	D
	XCHG
	LHLD	OFFSET
	DAD	D
	POP	D
	RET
;;
ADDR:
	LHLD	PC
	CALL	CADDRS
	XCHG
	LHLD	OFFSET
	CALL	CADDRS
	DAD	D
CADDRS:
	CALL	CADDR
	JMP	SPACE
;;
PCTEXT:	DB	0DH,0AH,'.PC..OFFS.ADDR...DATA..',0DH,0AH,'$'
;;
TINF4:
	MOV	A,M
	CALL	CBYTE
	CALL	SPACE
	INX	H
TINF3:
	MOV	A,M
	CALL	CBYTE
	CALL	SPACE
	INX	H
TINF2:
	MOV	A,M
	CALL	CBYTE
	CALL	SPACE
	INX	H
TINF1:
	MOV	A,M
	CALL	CBYTE
	CALL	SPACE
	MVI	A,'-'
	CALL	COMPLEX
	JMP	SPACE
;;;;						- 4 -
TESTA:
	CALL	ZAGL
	MVI	B,0
BGNA:
	CALL	PCOFF
	MOV	M,B
	PUSH	B
	CALL	ADDR
	CALL	SPACE
	CALL	TINF3
	CALL	Z80MICRO
	MVI	C,06H
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	POP	B
	MVI	C,0
	RZ
	INR	B
	JNZ	BGNA
	RET
;;;;						- 5 -
TESTB:
	MVI	B,0
BGNB:
	CALL	PCOFF
	MVI	M,0CBH
	INX	H
	MOV	M,B
	PUSH	B
	CALL	ADDR
	CALL	SPACE
	CALL	TINF2
	CALL	Z80MICRO
	MVI	C,06H
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	POP	B
	MVI	C,0
	RZ
	INR	B
	JNZ	BGNB
	RET
;;;;						- 6 -
TESTX:
	MOV	A,B
	STA	MOD1+1
	MVI	B,0
BGNX:
	CALL	PCOFF
MOD1:
	MVI	M,0DDH
	INX	H
	MOV	M,B
	PUSH	B
	CALL	ADDR
	CALL	SPACE
	CALL	TINF4
	CALL	Z80MICRO
	MVI	C,06H
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	POP	B
	MVI	C,0
	RZ
	INR	B
	JNZ	BGNX
	RET
;;;;						- 7 -
TESTE:
	MVI	B,0
BGNE:
	CALL	PCOFF
	MVI	M,0EDH
	INX	H
	MOV	M,B
	PUSH	B
	CALL	ADDR
	CALL	SPACE
	CALL	TINF4
	CALL	Z80MICRO
	MVI	C,06H
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	POP	B
	MVI	C,0
	RZ
	INR	B
	JNZ	BGNE
	RET
;;;;						- 8 -
TESTX1:
	MOV	A,B
	STA	MOD2+1
	MVI	B,0
BGNX1:
	CALL	PCOFF
MOD2:
	MVI	M,0DDH
	INX	H
	MVI	M,0CBH
	INX	H
	INX	H
	MOV	M,B
	PUSH	B
	CALL	ADDR
	CALL	SPACE
	CALL	TINF4
	CALL	Z80MICRO
	MVI	C,06H
	MVI	E,0FDH
	CALL	0005H
	CPI	'K'
	POP	B
	MVI	C,0
	RZ
	INR	B
	JNZ	BGNX1
	RET
;;;;						- 9 -
TEST0:
	CALL	CRLF
	MVI	A,'#'
	CALL	TOBUF
;;
	LHLD	PC
	XCHG
	LHLD	OFFSET
	DAD	D
	LXI	B,4
	MOV	M,B
	DCR	C
	JNZ	$-2
;;
	LXI	D,BUFER+2
	LDAX	D
	CPI	'K'
	RZ
	CALL	PCOFF
	CALL	MBYTE
	CALL	MBYTE
	CALL	MBYTE
	CALL	MBYTE
	CALL	CRLF
	CALL	ADDR
	CALL	SPACE
	LHLD	OFFSET
	CALL	TINF4
	CALL	Z80MICRO
	JMP	TEST0
;;;;						- 10 -
;;  wwesti adres
;;  wyhod:
;;    <D,E> - adres
;;    <H,L> - 3000H-adres
FINDADDR:
	MVI	A,'>'
	CALL	TOBUF
	LXI	D,BUFER+2
	CALL	INADDR
	PUSH	H
	MOV	A,L
	CMA
	MOV	L,A
	MOV	A,H
	CMA
	MOV	H,A
	INX	H
	LXI	B,3000H
	DAD	B
	POP	D
	RET
;;
FINDO:
	CALL	FINDADDR
	JMP	FINDPO
;;
FINDP:
	CALL	FINDADDR
	XCHG
FINDPO:
	SHLD	PCT
	XCHG
	SHLD	OFFT
	RET
;;
;;  wwesti w bufer
;;  wwod:
;;    <A> - promt
TOBUF:
	CALL	COMPLEX
	LXI	H,BUFER			; steretx bufer
	MOV	B,M
	INX	H
	INR	B
	MVI	M,0
	INX	H
	DCR	B
	JNZ	$-4
;;
	LXI	D,BUFER
	MVI	C,10
	JMP	0005H
;;;;						- 11 -
;;  HEX cifra ?
;;  whod:
;;    <a> - litera
;;  wyhod:
;;    flag C = 1 - litera
QUHEX:
	SUI	'0'
	CPI	10
	RC
	SUI	'A'-'0'
	CPI	6
	RNC
	ADI	10
	STC
	RET
;;
;;  wwod adresa
;;  whod:
;;    <D,E> - adres lit. predst. bajta
;;  wyhod:
;;    <H,L> - adres
INADDR:
	CALL	INBYTE
	RNC
	JMP	INBYTE+3
;;
;;  wwod bajta
;;  whod:
;;    <D,E> - adres lit. predst. bajta
;;  wyhod:
;;    <L> - bajt , flag C = 1 - norm.
INBYTE:
	LXI	H,0
	CALL	INHEX
	RNC
INHEX:
	LDAX	D
	CALL	QUHEX
	RNC
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ORA	L
	MOV	L,A
	INX	D
	STC
	RET
;;
MBYTE:
	PUSH	H
	CALL	INBYTE
	INX	D
	MOV	A,L
	POP	H
	MOV	M,A
	INX	H
	RET
;;;;						- 12 -
CRLF:
	MVI	A,0DH
	CALL	COMPLEX
	MVI	A,0AH
	JMP	COMPLEX
;;
SPACE:
	MVI	A,' '
;;
COMPLEX:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,A
	MVI	C,2
	CALL	0005H
	POP	B
	POP	D
	POP	H
	RET
;;
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
	JMP	CBYTE
;;
CBYTE:
	PUSH	PSW
	CALL	HIGHA
	CALL	COMPLEX
	POP	PSW
	CALL	LOWA
	JMP	COMPLEX
;;
HIGHA:
	RRC
	RRC
	RRC
	RRC
LOWA:
	ANI	0FH
	CPI	10
	JC	$+5
	ADI	7
	ADI	'0'
	RET
;;
PRILABADR:
	LHLD	PC
	CALL	CADDR
	MVI	A,'	'
	JMP	COMPLEX
;;;;						- 13 -
PRIWORDLABEL:
	CALL	PWLBL
	LDA	MODECOM
	ORA	A
	RM
	MVI	A,9
	CALL	COMPLEX
	MVI	A,';'
	CALL	COMPLEX
PWLBL:
	XCHG
	MVI	A,'0'
	CALL	COMPLEX
	CALL	CADDR
	XCHG
	MVI	A,'H'
	JMP	COMPLEX
;;
PEC:
	XTHL
CLCPEC:
	MOV	A,M
	CALL	COMPLEX
	INX	H
	MOV	A,M
	ORA	A
	JNZ	CLCPEC
	INX	H
	XTHL
	RET
;;
	END
