;;						- 1 -
;;**************************************
;;	~tenie fajlow "SINCLAIR"
;;  ----------------------------------
;;  wers.2.12.100	data:06-JAN-90
;;**************************************
;;
werhswist	EQU	4FH
nivnswist	EQU	20H
perehod		EQU	1DH
;;
FILEBGN		EQU	00900H
NUMFL		EQU	FILEBGN
;MAXADDR		EQU	0C100H
MAXADDR		EQU	0B900H
OSC		EQU	MAXADDR-100H
;;
	ORG	100H
;;
	JMP	PROGRAM
	HLT
;;
ERRFL:	DB	0		; priznak o{ibki dlq tek.fajla
FILE:	DW	FILEBGN+1	; na~alo tek.fajla
LINEFL:	DW	0		; dlina tek.fajla
;;
FOUT:	DB	0		; priznak wywoda
ENDFL:	DW	FILEBGN+1	; adres za posl.fajlom
NUMBER:	DW	0		; nomer tek.fajla
;;
bufkom:	DB	32		; komandnyj bufer
	DS	34
;;
DSKBGN:	DS	2		; na~alo disk.fajla
DSKEND:	DS	2		; konec disk.fajla
DISK:	DS	2		; tek.adres disk.fajla
STATD:	DS	1		; status imeni disk.fajla
;;
FCB:	DS	36		; buf dlq tek.fajla
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:
	DS	2	; adres imeni fajla
	DS	2	; adres FCB
;;;;						- 2 -
;;  rabota s operaciqmi mikro-dos
;;  -----------------------------
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM
;;
;;  wywod stroki na konsolx
;;  whod:
;;    <D,E> - adres tekst.stroki
PEC:
	PUSH	H
	PUSH	D
	PUSH	B
	SYSTEM	9
	JMP	EXSYS
;;
;;  wwod s konsoli w revime |ho
CIO:
	PUSH	H
	PUSH	D
	PUSH	B
	SYSTEM	1
	JMP	EXSYS
;;
CRLF:
	MVI	C,0DH
	CALL	CO
	MVI	C,0AH
;;
;;  wywod na konsolx
CO:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,C
	SYSTEM	2
EXSYS:
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wyhod w sistemu
EXIT:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H
;;
;;  wwod komandnoj stroki
wwodkom:
	LXI	D,bufkom
	SYSTEM	0AH
	LXI	H,bufkom+1
	MOV	E,M
	INX	H
	MVI	D,0
	DAD	D
	MVI	M,0
	RET
;;;;						- 3 -
;;  podgotowka FCB
;;  whod: <D,E> - adres imeni fajla
DOFCB:
	LXI	H,FCB
	SHLD	PFCB+2
	XCHG
	SHLD	PFCB
	LXI	D,PFCB
	SYSTEM	98H
	RET
;;
;;  proweritx imq na neodnozna~nostx
;;  whod: <D,E> - FCB
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,11*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXWTH
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXWTH:
	POP	D
	RET
;;
;;  wwod imeni diskowogo fajla
;;  whod: <D,E> - na~alo imeni
wwodimeni:
	XRA	A		; sbrositx priznak imeni fajla
	STA	STATD
	CALL	DOFCB
	MOV	A,M
	ORA	A
	JNZ	CERROR
	LXI	D,FCB
	CALL	WITHQ
	JZ	CERROR
	MVI	A,0FFH
	STA	STATD
;;
;;  wywod imeni tek.fajla
wywimq:
	LDA	STATD
	ORA	A
	JZ	CERROR
	LXI	D,Timq
	CALL	PEC
	LXI	H,FCB
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
	RET
;;;;						- 4 -
;;  sozdatx fajl
;;  whod:
;;    DSKBGN,DSKEND
sozdatx:
	LDA	STATD		; imq podgotowleno?
	ORA	A
	JZ	CERROR
	LXI	H,FILEBGN	; granicy disk.fajla
	SHLD	DSKBGN
	LHLD	ENDFL
	SHLD	DSKEND
	XRA	A
	STA	FCB+12		; podgotowka FCB
 	STA	FCB+32
	LXI	D,FCB
	SYSTEM	13H		; udalitx fajl
	LXI	D,FCB
	SYSTEM	16H		; sozdatx fajl
	INR	A
	LXI	D,CRTERR
	JZ	PEC
CRT2:
	LHLD	DSKBGN		; na~alo fajla
	SHLD	DISK
;;
CRT21:
	LHLD	DISK		; ustanowitx bufer pdp
	XCHG
	SYSTEM	1AH
;;
CRT3:
	LXI	D,FCB		; zapisatx blok
	SYSTEM	15H
	INR	A
	LXI	D,DISCFULL
	JZ	PEC
;;
CRT4:
	LHLD	DISK		; smestitx pdp
	LXI	D,80H
	DAD	D
	SHLD	DISK
;;
	XCHG
	LHLD	DSKEND
	XCHG
	CALL	HLDE
	JC	CRT21
;;
CRT5:
	LXI	D,FCB		; zakrytx fajl
	SYSTEM	10H
	INR	A
	LXI	D,NOFILE
	JZ	PEC
	JMP	wywimq
;;;;						- 5 -
;;  s~itatx fajl s diska
READ:
	LDA	STATD		; imq podgotowleno?
	ORA	A
	JZ	CERROR
	LXI	H,FILEBGN	; granicy disk.fajla
	SHLD	DSKBGN
	XRA	A
	STA	FCB+12		; podgotowka FCB
 	STA	FCB+32
	LXI	D,FCB
	SYSTEM	0FH		; otkrytx fajl
	INR	A
	LXI	D,NOFILE
	JZ	PEC
;;
	LHLD	DSKBGN
	SHLD	DISK
;;
RD2:
	LHLD	DISK
	XCHG
	SYSTEM	1AH		; ustanowitx pdp
;;
	LXI	D,FCB
	SYSTEM	14H		; ~itatx blok
	ORA	A
	JZ	NEXTDRD
	JP	wywimq		; normalxno wwedennyj fajl
	LXI	D,RDERR
	JMP	PEC		; o{ibka pri ~tenii fajla
;;
NEXTDRD:
	LHLD	DISK		; nowyj adres pdp
	LXI	D,80H
	DAD	D
	SHLD	DISK
	SHLD	DSKEND		; konec fajla
	JMP	RD2
;;;;						- 6 -
;;  blok dopoln.podprogramm
;;  -----------------------
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RC
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;
;;  wywod stroki iz 8-mi 2-h bajtn.perem.
;;  whod:
;;    <D.E> - adres na~ala obl. 16 bajt
wyw16:
	CALL	CRLF
	MOV	A,E
	ANI	11111110B
	RRC
	CALL	CBYTE
	CALL	$+3
	CALL	$+3
	CALL	$+3
	MVI	C,' '
	CALL	CO
	LDAX	D
	MOV	L,A
	INX	D
	LDAX	D
	MOV	H,A
	INX	D
;;;;						- 7 -
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET
;;
CMEM:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	CALL	CADDR
	XCHG
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;;;						- 8 -
BMCO:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCO
	RET
;;
;;  wnesti bajt w bufer
;;  whod:
;;    <D> - bajt
;;    <H,L> - adres w bufere
;;  wyhod:
;;    <H,L>+:=1
;;    flag Z=1 - perepolnenie bufera
TOBUF:
	MVI	A,HIGH(MAXADDR)
	CMP	H
	RZ
	MOV	M,D
	INX	H
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	JNZ	$-3
	RET
;;
DELAY:
	DCX	H	;  5
	MOV	A,H	;  5
	ORA	L	;  5
	JNZ	DELAY	; 10 > SUM:=25*<H,L>/3*10**6 sek
	RET
;;;;						- 9 -
;;  blok podprogramm raboty s magnitofrnom
;;  --------------------------------------
;;  najti dlinu signala
;;  whod:
;;    <C> - pred.sostoqnie kanala
;;  wyhod:
;;    <D,E> - dlina signala (po 36 taktow)
;;  flag Z=1 - wyhod po navati` us klawi{i
COUNT:
	IN	01H
	ANI	01010000B	;  7 ;
	CMP	C		;  5 ;
	JZ	$-5		; 10 ;
	MOV	C,A		;  5 ;
	ANI	01000000B	;  7 ;
	RZ			;  5 ;
;;
korrekciq	EQU	2
;;
	LXI	D,korrekciq-1	; 10 ; SUM=65 => korrekciq:=65/36=2
;;
	IN	01H		; 10 ;
	ANI	01010000B	;  7 ;
	CMP	C		;  5 ;
	INX	D		;  4 ;
	JZ	$-6		; 10 ; SUM=36
	MOV	C,A
	ANI	01000000B
	RET
;;
;;  najti na~alo fajla
;;  wyhod:
;;    flag Z=1 - po navati` us klawi{i
BEGIN:
	IN	01H		; na~atx s perepada
	ANI	01010000B
	MOV	C,A
	LXI	H,0		; s~et~ik dlq zagolowka
NEXT:
	INX	H
;;
	CALL	COUNT
	RZ
	MOV	A,D
	ORA	A
	JNZ	BEGIN
	MOV	A,E
;;
	CPI	werhswist	; swistok ?
	JNC	BEGIN
	CPI	nivnswist
	JNC	NEXT
	CPI	perehod		; sinhrosignal ?
	JNC	BEGIN
	LXI	D,0100H		; swistok dlinnyj ?
	CALL	HLDE
	JC	BEGIN
;;
	MVI	A,0FFH
	ORA	A
	RET
;;;;						- 10 -
;;  wwod bajta
;;  whod:
;;    <C> - pred{estw.sostoqnie kanala
;;    <E> - paritet
;;  wyhod:
;;    <A> - bajt
;;    <E> - paritet
;;    flag C=1 - priznak o{ibki, pri |tom
;;	flag Z=1 - ostanowka operatorom
;;	flag Z=0 - sli{kom dlinnyj perepad
RDBYTE:
	PUSH	D
	MVI	B,01H
ciklwwod:
	CALL	COUNT
	JZ	EXRD		; wyhod po navati` us
	MOV	A,D
	ORA	A
	JNZ	EXRD		; wyhod po o{ibke ~teniq
	MVI	A,perehod
	CMP	E
	MOV	A,B
	ADC	A
	MOV	B,A
	JNC	ciklwwod
	POP	D
	XRA	E		; paritet
	MOV	E,A
	MOV	A,B
	RET
EXRD:
	STC
	POP	D
	MOV	A,E
	RET
;;
;;  zapolnenie tabl. gistogrammy dlitelxnosti signala
;;  wyhod:
;;    flag Z=1 - po navati` us klawi{i
GISTO:
	IN	01H		; na~atx s perepada
	ANI	01010000B
	MOV	C,A
GNEXT:
	CALL	COUNT
	RZ
	MOV	A,D
	ORA	A
	RNZ
	MOV	A,E
;;  whod: <D,E> - dlitelxnostx (w 36 taktow)
;;  prime~anie: ne dopuskatx <D>^=0
	LXI	H,OSC
	MVI	D,0
	DAD	D
	DAD	D
	INR	M
	JNZ	$+5
	INX	H
	INR	M
	JMP	GNEXT
;;;;						- 11 -
;;  wywod signala treb.dlitelxnosti
;;  whod:
;;    LENGHT - abs.dlina
;;    popr - poprawka na dopoln.dejstwiq
signal	MACRO	LENGHT,popr
	MVI	A,LENGHT-1-popr
	DCR	A			;  5 >
	JNZ	$-1			; 10 > -15*popr
	MVI	A,1
	OUT	00H
	MVI	A,LENGHT-1
	DCR	A
	JNZ	$-1
	MVI	A,0
	OUT	00H
	RET				; 10 > SUM:=10-15*popr
	ENDM
;;
BIT:
	JC	BIT1			; 10
;;
BIT0:	signal	42,5
BIT1:	signal	84,5
swist:	signal	105,3
;;
;;  wywod bajta
;;  whod:
;;    <C> - bajt
WBYTE:
	MVI	B,8
	MOV	A,C	;  5
	RLC		;  5
	MOV	C,A	;  5
	CALL	BIT	; 17+10+10-15*popr
	DCR	B	;  5
	JNZ	$-7	; 10 > SUM:=67-15*popr=0 pri popr:=5 menx{e na 7
	RET
;;;;						- 12 -
;;  wywod oblasti
;;  whod:
;;    <A> - dlina swistka (00H - 4000, 0FFH - 80)
;;    <H,L> - na~alo
;;    <D,E> - dlina
OUTFLD:
	ORA	A
	LXI	B,4000
	JZ	$+6
	LXI	B,800
;;
	CALL	swist	; 17
	DCX	B	;  5
	MOV	A,B	;  5
	ORA	C	;  5
	JNZ	$-6	; 10 > SUM:=32+10-15*popr=0 pri popr:=3
;;
	MVI	A,1	;  7
	DCR	A	;  5
	JNZ	$-1	; 10
	CALL	BIT0	; 17+10+5+5+5+10+22=64 dlq popr=5
;;
	MOV	C,M
	CALL	WBYTE
	INX	H
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	$-8
;;
	RET
;;;;						- 13 -
;;  podprogrammy osnownyh revimow raboty
;;  ------------------------------------
;;  wwesti fajl
;;  whod:
;;    FILE - na~alo oblasti dlq zapisi fajla
;;  wyhod:
;;    ERRFL - kod wozwrata
;;	00H - norm.wwod
;;	01H - naru{en paritet
;;	02H - po navati` us
;;	03H - is~erpana pamqtx
;;    flag C=1 - priznak o{ibki
INPFILE:
	DI
	CALL	BEGIN		; najti na~alo fajla
	MVI	A,02H
	JZ	RDERRFL		; ostanowka po us
	LHLD	FILE
	MVI	M,0		; nulewaq dlina
	INX	H
	MVI	M,0
	INX	H
	MVI	E,0		; paritet
NEXTRD:
	CALL	RDBYTE
	JC	EXRDFILE
	MOV	D,A
	CALL	TOBUF
	JNZ	NEXTRD
;;
	MVI	A,03H		; is~erpano ozu
	JMP	RDERRFL
;;
EXRDFILE:			; konec s~itywaniq
	MVI	A,02H
	JZ	RDERRFL		; po navati` us
	MOV	A,E
	ORA	A
	MVI	A,01H		; naru{en paritet
	JNZ	RDERRFL
	EI			; norm.wwod
;;
	XCHG
	LHLD	FILE
	SHLD	dlina		; modifikaciq programmy !!!
	INX	H
	INX	H
	XCHG
	CALL	SUHLDE		; dlina informacii
dlina	EQU	$+1
	SHLD	8000H		; modificiruemaq komanda
	XRA	A
	STA	ERRFL
	RET
;;
RDERRFL:
	EI
	STA	ERRFL		; kod o{ibki
	PUSH	PSW
	LXI	D,TERRD		; soob}enie ob o{ibke
	CALL	PEC		;  pri wwode fajla
	POP	PSW
	CALL	CBYTE
	STC
	RET
;;;;						- 14 -
;;  wywod fajla
;;  prime~.:
;;    predwaritelxno podgotowitx LINEFL
wywfajl:
	LHLD	LINEFL
	XCHG
	LHLD	FILE
	INX	H		; propustitx dlinu
	INX	H
	MOV	A,M
	DI
	CALL	OUTFLD
	EI
	LXI	H,0
	JMP	DELAY
;;
;;  wywod informacii o fajle
;;  whod:
;;    NUMBER,ERRFL,FILE
;;  wywhod:
;;    LINEFL
INFFILE:
	CALL	CRLF
;;
	LDA	NUMBER		; nomer fajla
	CALL	CBYTE
	CALL	SPACE
;;
	LHLD	FILE
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	SHLD	LINEFL		; podgotowka dliny tek.fajla
	XCHG
	MOV	A,M
	CALL	CBYTE		; nulewoj bajt zapisi
	MOV	A,M
	ORA	A
	JZ	zagolowok
;;
	LXI	B,23*100H+' '
	JMP	NOSTFL
;;;;						- 15 -
zagolowok:
	CALL	SPACE
	INX	H
	MOV	A,M		; tip zagolowka
	CPI	4
	JC	STANDART
;;
	CALL	CBYTE		; zagolowok 4...255
	LXI	B,20*100H+' '
NOSTFL:
	CALL	BCO
	LHLD	LINEFL		; dlina fajla dejstw.
	DCX	H
	DCX	H
	CALL	CADDR
	JMP	ostatok
;;
STANDART:
	ADD	A
	ADD	M
	ADD	A
	LXI	D,tip
	ADD	E
	MOV	E,A
	JNC	$+4
	INR	D
	CALL	PEC
;;
	CALL	SPACE
	INX	H
	MVI	B,10		; standart.tip zagolowka
	CALL	BMCO
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,16		; na~alo fajla dannyh
	DAD	D
	CALL	CMEM
;;
	CALL	SPACE
	LHLD	FILE
	LXI	D,14		; dlina fajla dannyh
	DAD	D
	CALL	CMEM
;;
ostatok:
	CALL	SPACE
	LHLD	FILE
	INX	H
	INX	H
	XCHG
	LHLD	LINEFL
	DAD	D
	XCHG
	LXI	H,MAXADDR
	CALL	SUHLDE
	JMP	CADDR
;;;;						- 16 -
;;  podprogrammy dlq dispet~era
;;  ---------------------------
;;  scenarij "wwod programmy"
;;  wyhod:
;;    FILE - adres za posledn.wwed.fajlom
;;    NUMBER - ~islo fajlow w programme
;;    flag C=1 - o{ibka pri ~tenii o~erednogo fajla
wwprg:
	LXI	H,FILEBGN+1	; podgotowka dannyh
	SHLD	FILE
	MVI	A,0
	STA	NUMBER
	JMP	dalee
;;
dopoln:				; whod dlq dopolneniq 
	LHLD	ENDFL
	SHLD	FILE
	LDA	NUMFL
	STA	NUMBER
dalee:
	LXI	D,zagtip
	CALL	PEC
;;
wwesti:
	CALL	INPFILE
	RC			; nepraw.wwedennyj fajl
;;
	LXI	H,NUMBER	; uwel. nomer fajla
	INR	M
	MOV	A,M
	STA	NUMFL		; ob}ee ~islo fajlow
;;
	CALL	INFFILE		; wywesti informaci`
;;
	LHLD	FILE		; najti na~alo dlq nowogo fajla
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	DAD	D
	SHLD	FILE
	SHLD	ENDFL		; adres za posl.fajlom
;;
	JMP	wwesti
;;;;						- 17 -
;;  scenarij polu~eniq gistogrammy
;;  whod:
;;    OSC -  adres na~ala gistogrammy
gistogramma:
	LXI	H,OSC		; obnulitx tablicu
	MVI	A,0
	MVI	M,0
	INX	H
	DCR	A
	JNZ	$-4
;;
	DI
	CALL	GISTO
	EI
;;
	LXI	H,OSC
	XCHG
	MVI	B,16
PRG:
	CALL	wyw16
	DCR	B
	JNZ	PRG
	RET
;;;;						- 18 -
;;  scenarij "prosmotr informacii" i wywod fajlow
TOTAPE:
	MVI	A,0FFH
	STA	FOUT
SEEINF:
	LDA	NUMFL
	ORA	A
	RZ
	LXI	H,FILEBGN+1
	SHLD	FILE
	XRA	A
	STA	ERRFL
	INR	A
	STA	NUMBER
;;
	LXI	D,zagtip
	CALL	PEC
SEECL:
	IN	01H
	ANI	01000000B
	JZ	EXSEE
;;
	CALL	INFFILE
;;
	LDA	FOUT
	ORA	A
	CNZ	wywfajl
	LHLD	FILE		; najti na~alo nowogo fajla
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	DAD	D
	SHLD	FILE
;;
	LXI	H,NUMBER
	INR	M
	LDA	NUMFL
	INR	A
	CMP	M
	JNZ	SEECL
EXSEE:
	XRA	A
	STA	FOUT
	RET
;;;;						- 19 -
;;  prowerka HEX-litery
;;  whod: <A> - HEX-litera
;;  wyhod: <A> - HEX-cifra
;;    flag C=1 - prawilxnoe preobr.
QUHEX:
	SUI	'0'
	CPI	10
	RC
	SUI	'A'-'0'-10
	CPI	16
	RET
;;
;;  wwod HEX-~isla
;;  whod:<D,E> - ASCII posledowatelxnostx
;;  wyhod:<H,L> - ~islo
;;    <D,E> - ukazatelx na perwu` ne HEX-literu
HEXCHAR:
	LXI	H,0
CHCH:
	LDAX	D
	CALL	QUHEX
	RNC
	INX	D
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	MOV	C,A
	MVI	B,0
	DAD	B
	JMP	CHCH
;;
;;  najti na~alo trebuemoj zapisi
;;  whod: NUMFL
;;  wyhod: NUMBER,FILE
;;    flag C=1 - nomer neprawilen
BGNZAP:
	MOV	C,A		; iskomaq zapisx
	LXI	H,FILEBGN
	MOV	A,M
	INX	H
	ORA	A
	STC
	RZ			; pustaq oblastx dannyh
	INR	A
	CMP	C
	RC
	JMP	CCBGN
CBGN:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H		
	DAD	D
CCBGN:
	DCR	C
	JNZ	CBGN
	SHLD	FILE
	RET
;;;;						- 20 -
;;  udalitx zapisx
;;  whod: FILE,ENDFL
;;  wyhod: ENDFL
DELETE:
	LHLD	FILE
	MOV	B,H		; kuda
	MOV	C,L
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	DAD	D		; otkuda
	XCHG
	LHLD	ENDFL
	XCHG
CDEL:
	MOV	A,M
	INX	H
	STAX	B
	INX	B
	CALL	HLDE
	JNZ	CDEL
	SHLD	ENDFL
	RET
;;
;;  scenarij 'udalenie zapisi'
;;  whod:
;;    <D,E> - komandnaq stroka
	INX	D
udalitx:
	LDAX	D
	CPI	' '
	JZ	udalitx-1
	CALL	HEXCHAR
	LDAX	D
	ORA	A
	JNZ	CERROR
	MOV	A,H
	ORA	A
	JNZ	CERROR
	LDA	NUMFL
	MOV	H,A
	MOV	A,L
	ORA	A
	JZ	CERROR
	INR	H
	CMP	H
	JNC	CERROR
	CALL	BGNZAP
	JC	CERROR
	CALL	DELETE
	LDA	NUMFL
	DCR	A
	STA	NUMFL
	JMP	SEEINF
;;;;						- 21 -
;;  programma-dispet~er
PROGRAM:
	LXI	SP,100H
	LXI	D,ADVERT
	CALL	PEC
PRGC:
	XRA	A
	STA	FOUT
	LDA	NUMFL
	INR	A		; za poslednim fajlom
	CALL	BGNZAP
	SHLD	ENDFL
;;
	CALL	cikl
	JMP	PRGC
;;
cikl:
	LXI	D,PROMT
	CALL	PEC
	CALL	wwodkom
	LXI	D,bufkom+1
	LDAX	D
	DCR	A
	INX	D
	LDAX	D
	JNZ	LONGCOM
;;
komanda:
	CPI	'E'
	JZ	EXIT
	CPI	'A'
	JZ	dopoln
	CPI	'G'
	JZ	gistogramma
	CPI	'P'
	JZ	wwprg
	CPI	'O'
	JZ	TOTAPE
	CPI	'D'
	JZ	SEEINF
	CPI	'?'
	JZ	wywimq
	CPI	'L'
	JZ	READ
	CPI	'S'
	JZ	sozdatx
CERROR:
	LXI	D,ERROR
	JMP	PEC
;;
LONGCOM:
	CPI	'I'
	INX	D
	JZ	wwodimeni
	CPI	'E'
	JZ	udalitx
	JMP	CERROR
;;;;						- 22 -
;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	' SINCLAIR COPY PROGRAM ',0DH,0AH
	DB	1BH,5CH
	DB	' (s)filippow e.w.,1989 ',0DH,0AH
	DB	1BH,'a',1BH,5EH,0FH,'$'
PROMT:
	DB	0DH,0AH,'*$'
ERROR:
	DB	'?$'
TERRD:
	DB	0DH,0AH,1BH,5CH,'kod wozwrata: ',0FH,'$'
tip:
	DB	'BASIC$'
	DB	'DIGIT$'
	DB	'CHAR $'
	DB	'CODE $'
zagtip:
	DB	0DH,0AH,1BH,05CH
	DB	'N  Z  tip   ...imq.... na~. dln. ozu.'
	DB	0DH,0AH,0FH
	DB	'-------------------------------------$'
;;
literal:
	DB	1BH,5CH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
;;
CRTERR:	DB	1BH,5CH
	DB	0DH,0AH,'net mesta w oglawlenii',0FH,'$'
DISCFULL:
	DB	1BH,5CH
	DB	0DH,0AH,'net mesta na diske',0FH,'$'
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
RDERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri ~tenii fajla',0FH,'$'
;;
	ORG	($ OR 0FH) + 1
;;
	DB	'  filippow e.w. '
	DB	'    g.ki{inew   '
	DB	'   t.52-80-27   '
;;
	END
