;;
;;***********************************		***************
;;  sistema programmirowaniq pzu.		  M E M O R Y
;;  --------------------------------		  -----------
;;  wers.3.1	    data:03-APR-91		  E D I T O R
;;************************************		***************
;;
PUBLIC	DUMP,	CI,	PEC,	LADDR,	LBYTE
PUBLIC	BGNDMP,	MSKDMP
;;
	DSEG
;;
BGNDMP:	DW	2000H		; adrec na~ala dampa
;;
MSKDMP:	DW	01FFH		; maska razmera dampa
;;
;;  razmer		maska
;;  --------------------------
;;  32  ( 20H)		001FH
;;  256 (100H)		00FFH
;;  1024(400H)		03FFH
;;  2048(800H)		07FFH
;;
	CSEG
;;
;;  najti adres w dampe zadannogo razmera
;;  whod:
;;    <H,L> - otnos.adres
;;  dannye:
;;    BGNDMP - na~alo dampa
ADRSHF:
	PUSH	D
	XCHG
	LHLD	BGNDMP
	DAD	D
	POP	D
	RET
;;
maska:
	PUSH	D
	XCHG			; <H,L> - otnos.adres w dampe
	LHLD	MSKDMP
	MOV	A,L
	ANA	E
	MOV	L,A
	MOV	A,H
	ANA	D
	MOV	H,A
	POP	D
	RET
;;
SPACE:
	MVI	C,' '
CO:
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	E,C
	MVI	C,2
	CALL	5
	POP	B
	POP	D
	POP	H
	RET
;;
CI:
	PUSH	H
	PUSH	D
	PUSH	B
	MVI	C,6
	MVI	E,0FDH
	CALL	5
	POP	B
	POP	D
	POP	H
	RET
wk:
	MVI	C,19H
	CALL	CO
wkps:
	MVI	C,0DH
	CALL	CO
	MVI	C,0AH
	JMP	CO
;;
LADDR:
	MOV	A,H
	CALL	LBYTE
	MOV	A,L
;;
LBYTE:
	CALL	LHIGH
LHIGH:
	RRC
	RRC
	RRC
	RRC
LLOW:
	PUSH	PSW
	ANI	0FH
	CALL	CONV
	MOV	C,A
	CALL	CO
	POP	PSW
	RET
;;
CONV:
	ADI	90H
	DAA
	ACI	40H
	DAA
	RET
;;
PECA:
	MOV	C,A
PECC:
	CALL	CO
PEC:
	MOV	A,M
	ORA	A
	INX	H
	JNZ	PECA
	RET
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	BCO
	RET
;;
;;  wywod stroki 16 bajt
;;    DUMP16:=ADDR16+LINE16+CSUM
;;  whod:
;;    <H,L> - na~.adres
;;  wyhod:
;;    <H,L> +:= 10H
;;    <D,E> - kontrolxnaq summa stroki
;;  prime~anie:
;;    na~.adres dolven bytx kratnym 10H
PUBLIC	ADDR16
;;
ADDR16:
	CALL	wkps
	CALL	SPACE
DOP16:
	JMP	LADDR
;;
PUBLIC	LINE16
;;
LINE16:
	PUSH	H
	CALL	ADRSHF
	LXI	B,0
	PUSH	B
DKSL:
	MOV	A,L
	ANI	00000011B
	CZ	SPACE
	CALL	SPACE
;;
	MOV	C,M
	INX	H
	MOV	E,M
	INX	H
;;
	XTHL
	DAD	B
	MOV	D,C
	MOV	C,E
	DAD	B
	XTHL
;;
	CALL	LDE
	MOV	A,L
	ANI	0FH
	JNZ	DKSL
	POP	D
	MOV	A,D
	ADD	E
	MOV	D,A
	POP	H
	LXI	B,10H
	DAD	B
	RET
;;
PUBLIC	DUMP16
DUMP16:
	CALL	ADDR16
	CALL	LINE16
CSUM:
	CALL	SPACE
	MVI	C,'='
	CALL	CO
	CALL	SPACE
;;
LDE:
;	XCHG
;	CALL	LADDR
;	XCHG
	PUSH	B
	MOV	A,D
	CALL	LBYTE
	CALL	SPACE
	MOV	A,E
	CALL	LBYTE
	POP	B
	RET
;;
;;  pe~atx dampa
;;  whod:
;;    <H,L> - na~.adres
;;  wyhod:
;;    <B,C> - kontr.summa bloka
PDUMP:
	MOV	A,L
	ANI	0F0H
	MOV	L,A
	MVI	D,8
	LXI	B,0
stroka:
	PUSH	D
	CALL	maska
	PUSH	B
	CALL	DUMP16
	POP	B
	XCHG
	DAD	B
	XTHL
	POP	B
	XCHG
	DCR	D
	JNZ	stroka
	RET
;;
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  wwod stroki 16 bajt
;;  whod:
;;    <H,L> - na~.adres, kratnyj 10H
INP16:
	PUSH	H
	CALL	ADRSHF
BGNLINE:
	MOV	A,L
	ANI	0F0H
	MOV	L,A
	MVI	B,0F0H
;;
komanda:
	CALL	CI
	CPI	0DH
	JNZ	$+5
	POP	H
	RET
;;
	MOV	C,A
	CPI	08H
	JNZ	wpered
	MOV	A,B
	RLC
	RLC
	RLC
	RLC
	MOV	B,A
	JNC	nazad
	MOV	A,L
	ANI	0FH
	JZ	BGNLINE
	MOV	A,L
	ANI	00000011B
	CZ	CO
	DCX	H
	CALL	CO
nazad:	CALL	CO
	JMP	komanda
;;
wpered:
	CPI	18H
	JZ	sdwig
	SUI	30H
	CPI	10H
	JC	$+12
	SUI	11H
	CPI	6
	JNC	komanda
	ADI	10
	PUSH	PSW
	CALL	CO
	MOV	A,B
	CMA
	ANA	M
	MOV	M,A
	POP	PSW
	MOV	C,A
	MOV	A,B
	RLC
	MOV	A,C
	JNC	$+7
	RRC
	RRC
	RRC
	RRC
	ORA	M
	MOV	M,A
	JMP	$+6
;;
sdwig:
	CALL	CO
	MOV	A,B
	RLC
	RLC
	RLC
	RLC
	MOV	B,A
	JC	komanda
	INX	H
	MOV	A,L
	RRC
	MVI	C,18H
;	CNC	CO
	CALL	CO
	MOV	A,L
	ANI	00000011B
	CZ	CO
	MOV	A,L
	ANI	0FH
	JNZ	komanda
	POP	H
	RET
;;
;;  modifikaciq stroki 16 bajt
;;  whod:
;;   <H,L> - adres stroki, sledu`}ej za
;;	redaktiruemoj strokoj, kratnyj 10H
MODLINE:
	MVI	C,19H
	CALL	CO
	LXI	D,-10H
	DAD	D
	CALL	MASKA
	LXI	B,(52+8+4)*100H+' '
	CALL	BCO
;;
	PUSH	H
	CALL	ADDR16
	CALL	LINE16
	LXI	B,(39+8+3)*100H+08H
	CALL	BCO
	POP	H
	CALL	INP16
	CALL	wk
	LXI	B,(53+8+4)*100H+' '
	CALL	BCO
	LXI	B,0219H
	CALL	BCO
	JMP	DUMP16
;;
CIHL:
	PUSH	H
	PUSH	B
BGNTXT:
	MVI	B,1
NEXTCHAR:
	CALL	CI
	MOV	C,A
	CPI	0DH
	JZ	ENDTXT
	CPI	' '
	JC	NEXTCHAR
	CPI	7FH
	JZ	DELCHAR
	MOV	A,B
	DCR	A
	CMP	D
	JZ	NEXTCHAR
	CALL	CO
	MOV	M,C
	INX	H
	INR	B
	JMP	NEXTCHAR
DELCHAR:
	DCR	B
	JZ	BGNTXT
	DCX	H
	CALL	CO
	CALL	SPACE
	MVI	C,08H
	CALL	CO
	JMP	NEXTCHAR
ENDTXT:
	MVI	M,0
	POP	B
	POP	H
	RET
;;
HEXLIT:
	LXI	D,0
NEXTDIG:
	MOV	A,M
	INX	H
	ORA	A
	RZ
	CALL	QUHEX
	RNC
	MOV	C,A
	MOV	A,D
	ANI	0F0H
	STC
	RNZ
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	XCHG
	MOV	A,C
	ORA	E
	MOV	E,A
	JMP	NEXTDIG
;;
QUHEX:
	SUI	'0'
	CPI	10
	RC
	SUI	11H
	CPI	6
	JC	$+7
	ADI	'A'
	ORA	A
	RET
;;
	ADI	10
	STC
	RET
;;
;;	whod w redaktor
;;
DUMP:
	LXI	H,0000H
;;
DISP:
;;
	CALL	maska
;;
	MOV	A,L		; adres na na~alo bloka 10H
	ANI	0F0H
	MOV	L,A
	PUSH	H
	LXI	H,T1
	CALL	PEC
	POP	H
	CALL	CI
	CPI	03H
	RZ
;;
	CPI	1AH
	JNZ	COM1
	CALL	MODLINE
	JMP	DISP
;;
COM1:	CPI	' '
	JZ	rulon
;;
	CPI	0DH
	JNZ	COM2
	CALL	DOP16
	CALL	SPACE
	CALL	INP16
rulon:
	MVI	C,19H
	CALL	CO
	CALL	DUMP16
	JMP	DISP
;;
COM2:	CPI	19H
	JNZ	COM3
	LXI	D,7FH
	XCHG
	DAD	D
	XCHG
	CALL	PDUMP
	JMP	DISP
;;
COM3:	CPI	'A'
	JNZ	COM4
	PUSH	H
	LXI	H,T2
	CALL	PEC
	LXI	H,bufer
	MVI	D,4
	CALL	CIHL
	CALL	HEXLIT
	POP	H
	JC	ERROR
	ORA	A
	JNZ	ERROR
;;
	XCHG
	CALL	maska
	MOV	A,L
	ANI	0F0H
	MOV	L,A
	CALL	DUMP16
	JMP	DISP
;;
COM4:
	CPI	'P'
	JNZ	DISP
	PUSH	H
	LXI	H,T3
	CALL	PEC
	LXI	H,bufer
	MVI	D,9
	CALL	CIHL
	CALL	HEXLIT
	JC	ERROR-1
	CPI	','
	JNZ	ERROR-1
	PUSH	D
	CALL	HEXLIT
	POP	H
	JC	ERROR-1
	ORA	A
	JNZ	ERROR-1
	POP	B
	CALL	PDUMP
	JMP	DISP
;;
	POP	H
;;
ERROR:
	MVI	C,'?'
	CALL	CO
	JMP	DISP
;;
	CSEG
;;
T1:
	DB	0DH,0AH,'>',0
T2:
	DB	19H,0DH,0AH,'A>',0
T3:
	DB	19H,0DH,0AH,'P>',0
;;
bufer:
	DS	9
;;
	END


