
;;**************************************
;;	podgotowka fajlow .ZXK
;;  ----------------------------------
;;  wers.4.5		data:22-MAY-93
;;**************************************

FCB		EQU	0005CH	; buf dlq tek.fajla
ZXKTAB		EQU	00800H	; tabl. fajla .ZXK
FILEBGN		EQU	01800H	; na~alo oblasti SINCLAIR zapisi

PUBLIC	NUMFL, CBYTE, SPACE, FILE, LINEFL, BCO, CADDR, tip

EXTRN	INF, CMEM, BMCO, CO, PEC, CRLF

	CSEG

	LXI	SP,ZXKTAB-1
	CALL	PROGRAM
	LXI	D,literal

;;  wyhod w sistemu s soob}eniem
;;  whod:
;;    <D,E> - adres soob}eniq
ERROR:
	CALL	PEC
	JMP	WARM

NUMFL:	DS	1		; nomer tek.fajla
ERRFL:	DS	1		; kod priema tek.fajla
FILE:	DS	2		; na~alo tek.fajla
ENDFL:	DS	2		; adres za tek.fajlom
LINEFL:	DS	2		; dlina tek.zapisi dlq INFFILE
;;
MAXADR:	DS	2		; MAX dopustimyj adres ozu
DISK:	DW	0080H		; adres pdp disk.fajla
DCOUNT:	DW	DISK		; s~et~ik dlq ~teniq disk.fajla
ZXKCNT:	DW	ZXKTAB		; s~et~ik dlq raboty s ZXKTAB
ENDZXK:	DW	ZXKTAB+1	; adres za ukazatelem konca ZXKTAB
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:	DS	2		; adres imeni fajla
	DS	2		; adres FCB

;;  rabota s operaciqmi mikro-dos
;;  -----------------------------
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM

;;  wwod litery s konsoli
CI:
	PUSH	H
	PUSH	D
	PUSH	B
	MVI	E,0FDH
	SYSTEM	6

EXSYS:
	POP	B
	POP	D
	POP	H
	RET
;;
;;  wyhod w sistemu
WARM:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H

;;  proweritx imq na neodnozna~nostx
;;  whod: <D,E> - FCB
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,11*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXWTH
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXWTH:
	POP	D
	RET
;;
;;  otkrytx diskowyj fajl
;;  wyhod: flag Z=1 - fajl otsutstwuet
SNCNAME:
	LXI	H,SNCFILE	; ras{irenie .SNC
	JMP	$+6
ZXKNAME:
	LXI	H,ZXKFILE	; ras{irenie .ZXK
	LXI	D,FCB+9
	LXI	B,3
	CALL	MOVE
	LXI	D,FCB
	CALL	WITHQ
	LXI	D,NONAME	; newerno zadano imq fajla
	JZ	ERROR		;  na diske
;;
;;  wywod imeni tek.fajla
wywimq:
	LXI	D,Timq
	CALL	PEC
	LXI	H,FCB
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
;;
;;  otkratx fajl
otkrytx:
	LXI	H,FCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,FCB
	SYSTEM	0FH		; otkrytx fajl
	INR	A
	LXI	D,NOFILE
	RET

;;  wwesti blok iz diska w ozu
;;  whod: <B,C> - dlina bloka
;;	  <D,E> - adres na~ala bloka
;;  wyhod:<flag C>=1 - END OF FILE !!!
INPBLC:
	MVI	A,-2		; ~islo wwodimyh blokow
	STA	INPLESS
;;
	LHLD	DCOUNT
INPBC:
	MOV	A,B
	ORA	C
	JZ	EXINP
;;
	MOV	A,L
	ANI	7FH
	JNZ	INPBYTE
;;
	MOV	A,C
	ANI	80H
	ORA	B
	JNZ	SPEED		; wwod polnogo bloka 128 bajt
;;
	LHLD	DISK
	XCHG
	CALL	NEWBLC
	XCHG
INPBYTE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	JMP	INPBC
;;
SPEED:
	LDA	READFLAG		; byla situaciq EOF?
	ORA	A
	STC
	RNZ
;;
	CALL	NEWBLC
	PUSH	H
	LXI	H,-80H
	DAD	B
	MOV	B,H
	MOV	C,L
INPLESS	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	JZ	$+12
	INR	A
	STA	INPLESS
	LXI	H,80H
	DAD	D
	XCHG
	POP	H
	JMP	INPBC
;;
READFLAG:	DB	0		; flag END OF FILE
;;
EXINP:
	SHLD	DCOUNT
	RET

;;  s~itatx o~erednoj blok fajla
;;  whod: <D,E> - na~alo oblasti
NEWBLC:
	PUSH	H
	PUSH	D
	PUSH	B
;;
	SYSTEM	1AH		; ustanowitx pdp
;;
	LXI	D,FCB		; ~itatx blok
	SYSTEM	14H
	CPI	0FFH
	LXI	D,READERR
	JZ	ERROR
	STA	READFLAG	; modifikaciq programmy
	POP	B
	POP	D
	POP	H
	RET

;;  blok dopoln.podprogramm
;;  -----------------------
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;
BMCOT:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCOT
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	INX	H
	JNZ	$-4
	RET

;;  s~itatx zapisx SINCLAIR
;;  whod:   FILE - adres na~ala zapisi
;;  wyhod:  ENDFL - adres za fajlom
;;	    flag <C>=1 - s~itan priznak konca fajla
INPFILE:
	LHLD	FILE
	XCHG
	LXI	B,2
	CALL	INPBLC
	LHLD	FILEBGN		; dlina zapisi
	MOV	A,H
	ORA	L
	STC
	RZ			; priznak posl.zapisi
	MOV	A,H
	MOV	B,H
	MOV	C,L
	CALL	INPBLC
	XCHG
	SHLD	ENDFL
	RET

;;  wywod informacii o fajle
;;  whod:
;;    NUMFL,ERRFL,FILE
PUBLIC	INFFILE
INFFILE:
	LHLD	ZXKCNT
	INX	H
	MOV	A,M
	ORA	A
	PUSH	H
	LXI	D,zagtip
	CZ	PEC
	POP	H
	CALL	CRLF
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	INR	A
	CALL	CBYTE		; nomer zapisi
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	ORA	A
	INX	H
	JZ	$+6
	LXI	H,pustimq
	MVI	B,8
	CALL	BMCOT
	LXI	B,220H
	CALL	BCO
	JMP	INF

;;  smena tek.nomerow w ZXKTAB
WORZXK:
	LHLD	ZXKCNT
	MOV	A,M
	ORA	A
	JZ	CHNGZXK	
	MVI	M,0		; nepraw.konec ZXKTAB
	LXI	D,10H
	DAD	D
	MVI	M,0FFH
	INX	H
	MVI	M,0FFH		; ne na~alo programmy
CHNGZXK:
	LXI	H,ZXKTAB
	INX	H
	XRA	A		; perwaq zapisx - na~alo programmy
	MOV	M,A
	MOV	B,A		; tek.nomer zapisi
	DCX	H
CKLCHG:
	MOV	A,M
	ORA	A
	INX	H
	SHLD	ENDZXK
	RNZ			; priznak konca ZXKTAB?
	MOV	A,M
	ORA	A
	JNZ	$+5
	MVI	B,-1		; nowaq programma
	INR	B
	MOV	M,B
	LXI	D,10H-1
	DAD	D
	JMP	CKLCHG
PROGRAM:
	LXI	D,ADVERT
	CALL	PEC
	LHLD	0006H
	SHLD	MAXADR
	LHLD	DISK
	SHLD	DCOUNT
;;
	CALL	ZXKNAME
	JZ	NOZXKFILE
	XRA	A
	STA	MODEXIT
	LXI	D,ZXKTAB
IZXK:
	LXI	B,10H
	CALL	INPBLC
	LXI	H,-10H
	DAD	D
	MOV	A,M
	ORA	A
	JZ	IZXK
	JMP	SNCINP
NOZXKFILE:
	MVI	A,0FFH
	STA	MODEXIT		; zapretitx wyhod po 'e'
	CALL	PEC
	LXI	H,ZXKTAB
	MVI	M,0FFH
	INX	H
	MVI	A,15
	CALL	CLR
;;
SNCINP:
	LXI	H,FILEBGN
	SHLD	FILE
	LXI	H,ZXKTAB
	SHLD	ZXKCNT
	LHLD	DISK
	SHLD	DCOUNT
	XRA	A
	STA	READFLAG
	STA	NUMFL
	CALL	SNCNAME
	JZ	ERROR
wwesti:
	CALL	INPFILE
	JC	konec
;;
	LXI	H,NUMFL		; uwel. nomer fajla
	INR	M
;;
SEELINE:
	CALL	WORZXK
	CALL	INFFILE		; wywesti informaci`
wwod:
	CALL	CI
	CPI	'B'
	JZ	SNCINP
	CPI	';'
	JZ	BGNPRG
	CPI	'-'
	JZ	NOPRG
	CPI	'E'
	JZ	konecwopr
NEXTLINE:
	LHLD	ZXKCNT		; smenitx zapisx w ZXKTAB
	LXI	D,10H
	DAD	D
	SHLD	ZXKCNT
	JMP	wwesti
;;
NOPRG:
	LHLD	ZXKCNT
	INX	H
	MVI	M,0FFH		; ubratx priznak na~ala programmy
	MVI	C,19H
	CALL	CO
	JMP	SEELINE
BGNPRG:
	LXI	D,tprg
	CALL	PEC
	LHLD	ZXKCNT
	MVI	B,10
	MVI	M,' '
	INX	H
	DCR	B
	JNZ	$-4
;;
	LHLD	ZXKCNT
	PUSH	H
	MVI	M,8
	XCHG
	SYSTEM	0AH		; wwesti tekst s konsoli
	POP	H
	MVI	M,0		; tek.zapisx
	INX	H
	MVI	M,0		; na~alo programmy
	JMP	SEELINE	
konecwopr:
MODEXIT	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	JNZ	wwod		; wyhod po 'e' zapre}en ?
konec:
	CALL	ZXKNAME
	LXI	D,FCB
	SYSTEM	13H		; udalitx fajl
	LXI	D,FCB
	SYSTEM	16H		; sozdatx fajl
	CALL	otkrytx
	LHLD	ENDZXK
	MVI	M,0
	INX	H
	MOV	A,L
	ANI	7FH
	JNZ	$-6
	LXI	D,ZXKTAB
	CALL	SUHLDE
	DAD	H
OUTZXK:
	PUSH	H
	PUSH	D
	SYSTEM	1AH		; ustanowitx pdp
	LXI	D,FCB
	SYSTEM	15H		; posled.zapisx
	POP	D
	LXI	H,80H
	DAD	D
	XCHG			; smenitx adres pdp
	POP	H
	DCR	H		; s~et~ik blokow
	JNZ	OUTZXK
	LXI	D,FCB
	SYSTEM	10H		; zakrytx fajl
	JMP	WARM
;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	'  SINCLAIR KEYS PROGRAM  4.5  ',18H,18H
	DB	1BH,5CH
	DB	' (s) 1990, 1993, filippow e.w. ',18H,18H
	DB	0DH,0AH,1BH,'a',1BH,5EH,0FH,'$'
tip:
	DB	'BASIC$'
	DB	'DIGIT$'
	DB	'CHAR $'
	DB	'CODE $'
zagtip:
	DB	0DH,0AH,1BH,05CH,1BH,'b',0DH,0AH
	DB	' nom. imq prg.  N  Z  tip   ...imq.... na~. dln. '
	DB	1BH,'a',0DH,0AH,0FH,'$'
;;
literal:
	DB	1BH,5CH,'$'
;;
READERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri ~tenii fajla',0FH,'$'
FILEEND:
	DB	1BH,5CH
	DB	0DH,0AH,'fajl zakon~en',0FH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
tprg:
	DB	0DH,0AH,1BH,5CH,'imq programmy:',0FH,'$'
;;
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
NONAME:
	DB	1BH,5CH
	DB	0DH,0AH,'newerno ukazano imq fajla',0FH,'$'
;;
ENDMEM:
	DB	1BH,5CH
	DB	0DH,0AH,'ne hwataet pamqti',0FH,'$'
;;
SNCFILE:
	DB	'ZXS'
ZXKFILE:
	DB	'ZXK'
pustimq:
	DB	'        ',0

	END

