
;;	zapisx fajlow "SINCLAIR"
;;  ----------- VERS.4.5. ------------
;;  wers.5.20		data:15-FEB-90			   B Y T E
;;  ----------------------------------			  ----------
;;  	modifikaciq: 25-MAY-93				   VERSION


PUBLIC	NUMFL, CBYTE, SPACE, FILE, LINEFL, BCO, CADDR, TIP


FCB	EQU	0005CH		; buf dlq tek.fajla
KEYTAB	EQU	00800H		; tablica kl`~ej


	LXI	SP,KEYTAB-1
	CALL	PROGRAM
	LXI	D,literal
;;
;;  wyhod w sistemu s soob}eniem
;;  whod:
;;    <D,E> - adres soob}eniq
ERROR:
	CALL	PEC
	JMP	WARM
;;
NUMFL:	DS	1		; nomer tek.fajla
ERRFL:	DS	1		; kod priema tek.fajla
FILE:	DS	2		; na~alo tek.fajla
ENDFL:	DS	2		; adres za tek.fajlom
LINEFL:	DS	2		; dlina tek.zapisi dlq INFFILE
;;
MAXADR:	DS	2		; MAX dopustimyj adres ozu
DISK:	DW	0080H		; adres pdp disk.fajla
DCOUNT:	DW	DISK		; s~et~ik dlq ~teniq disk.fajla
NRD:	DS	1		; s~et~ik s~itywaemyh "programm"
NWR:	DS	1		; s~et~ik zapisywaemyh "programm"
;;
BDOSBP:	DS	1		; kod operacii ras{.BDOS
	DS	2		; parametr
;;
PFCB:	DS	2		; adres imeni fajla
	DS	2		; adres FCB
;;
NEWPRG:	DB	0		; priznak na~ala programmy
PNAME:	DS	8		; imq "programmy"


;;  rabota s operaciqmi mikro-dos
;;  -----------------------------
SYSTEM	MACRO	NN
	MVI	C,NN
	CALL	0005H
	ENDM

EXTRN	PEC, CRLF, CO
;;
;;  wyhod w sistemu
WARM:
	LXI	D,literal
	CALL	PEC
	SYSTEM	0
	JMP	100H

;;  proweritx imq na neodnozna~nostx
;;  whod: <D,E> - FCB
;;  wyhod: flag Z=1 - imq s ras{ireniem
WITHQ:
	PUSH	D
	LXI	B,11*100H+'?'
CWTH:
	LDAX	D
	CMP	C
	JZ	EXWTH
	INX	D
	DCR	B
	JNZ	CWTH
	INR	B
EXWTH:
	POP	D
	RET
;;
;;  otkrytx diskowyj fajl
;;  wyhod: flag Z=1 - fajl otsutstwuet
SNCNAME:
	LXI	H,SNCFILE	; ras{irenie .SNC
	JMP	$+6
KEYNAME:
	LXI	H,KEYFILE	; ras{irenie .KEY
	LXI	D,FCB+9
	LXI	B,3
	CALL	MOVE
	LXI	D,FCB
	CALL	WITHQ
	LXI	D,NONAME	; newerno zadano imq fajla
	JZ	ERROR		;  na diske
;;
;;  wywod imeni tek.fajla
wywimq:
	LXI	D,Timq
	CALL	PEC
	LXI	H,FCB
;;
;;  wywod imeni fajla
;;  whod: <H,L> - adres FCB
SEENAME:
	SHLD	BDOSBP+1
	LXI	D,BDOSBP
	MVI	A,242
	STAX	D
	SYSTEM	32H
;;
;;  otkratx fajl
otkrytx:
	LXI	H,FCB+12	; podgotowitx FCB
	MVI	A,36-12
	CALL	CLR
	LXI	D,FCB
	SYSTEM	0FH		; otkrytx fajl
	INR	A
	LXI	D,NOFILE
	RET

;;  proweritx stroki na sowpadenie
;;  whod: <C> - dlina
;;    <D,E> i <H,L> - stroki
;;  wyhod: flag Z=1 - sowpada`t
CHECK:
	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	DCR	C
	JNZ	CHECK
	RET
;;
;;  s~itatx zapisx SINCLAIR
;;  whod:   FILE - adres na~ala zapisi
;;  wyhod:  ENDFL - adres za fajlom
;;	    flag <C>=1 - s~itan priznak konca fajla
INPFILE:
	LHLD	FILE
	SHLD	dlina
	XCHG
	LXI	B,2
	CALL	INPBLC
dlina	EQU	$+1
	LHLD	0000H		; modific.komanda: dlina zapisi
	MOV	A,H
	ORA	L
	STC
	RZ			; priznak posl.zapisi
	MOV	A,H
	MOV	B,H
	MOV	C,L
	CALL	INPBLC
	XCHG
	SHLD	ENDFL
	RET

;;  wywod informacii o fajle
;;  whod:
;;    NUMFL,ERRFL,FILE
INFFILE:
	CALL	KEYCNT
	INX	H
	MOV	A,M
	ORA	A		; esli rawno 0 to na~alo programmy
	STA	NEWPRG
	PUSH	H
	LXI	D,zagtip
	CZ	PEC
	POP	H
	CALL	CRLF
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	INR	A
	CALL	CBYTE		; nomer zapisi
	LXI	B,220H
	CALL	BCO
	MOV	A,M
	ORA	A
	INX	H
	JZ	$+6
	LXI	H,pustimq
	MVI	B,8
	CALL	BMCO
	LXI	B,220H
	CALL	BCO
;;
EXTRN	INF
	JMP	INF

;;  wwesti blok iz diska w ozu
;;  whod: <B,C> - dlina bloka
;;	  <D,E> - adres na~ala bloka
;;  wyhod:<flag C>=1 - blok ne pomestitsq w pamqtx
INPBLC:
	MOV	H,D		; blok pomestitsq w ozu?
	MOV	L,E
	DAD	B
	PUSH	D
	XCHG
	LHLD	MAXADR
	CALL	HLDE
	LXI	D,ENDMEM
	JC	ERROR
	POP	D
;;
	LHLD	DCOUNT
INPBC:
	MOV	A,B
	ORA	C
	JZ	EXINP
;;
	MOV	A,L
	ANI	7FH
	JNZ	INPBYTE
;;
	MOV	A,C
	ANI	80H
	ORA	B
	JNZ	SPEED		; wwod polnogo bloka 128 bajt
;;
	LHLD	DISK
	XCHG
	CALL	NEWBLC
	XCHG
INPBYTE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	JMP	INPBC
;;
SPEED:
	CALL	NEWBLC
	PUSH	H
	LXI	H,-80H
	DAD	B
	MOV	B,H
	MOV	C,L
	LXI	H,80H
	DAD	D
	XCHG
	POP	H
	JMP	INPBC
EXINP:
	SHLD	DCOUNT
	RET

;;  s~itatx o~erednoj blok fajla
;;  whod: <D,E> - na~alo oblasti
NEWBLC:
	PUSH	H
	PUSH	D
	PUSH	B
;;
	SYSTEM	1AH		; ustanowitx pdp
;;
READFLAG	EQU	$+1
	MVI	A,0		; modificiruemaq komanda
	ORA	A
	LXI	D,FILEEND
	JNZ	ERROR
;;
	LXI	D,FCB		; ~itatx blok
	SYSTEM	14H
	CPI	0FFH
	LXI	D,READERR
	JZ	ERROR
	STA	READFLAG	; modifikaciq programmy
	POP	B
	POP	D
	POP	H
	RET

;;  blok dopoln.podprogramm
;;  -----------------------
;;  srawnitx <H,L> i <D,E>
HLDE:
	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;;
;;  <H,L>:=<H,L>-<D,E>
SUHLDE:
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;;
;;  perewod HEX w ASCII
;;  whod:
;;    <A> - HEX
;;  wyhod:
;;    <A> - ASCII
ASCII:
	ANI	0FH
	ADI	'0'
	CPI	'9'+1
	RC
	ADI	'A'-'0'-10
	RET
;;
;;  wywod adresa
;;  whod:
;;    <H,L> - adres
CADDR:
	MOV	A,H
	CALL	CBYTE
	MOV	A,L
;;
;;  1-h bajt. perem. -> ASCII wywod
;;  whod:
;;    <A> - bajt
CBYTE:
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	POP	PSW
CLOW:
	CALL	ASCII
	PUSH	B
	MOV	C,A
	CALL	CO
	POP	B
	RET

CMEM:
	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	XCHG
	CALL	CADDR
	XCHG
	RET
;;
SPACE:
	MVI	C,' '
	JMP	CO
;;
BCO:
	CALL	CO
	DCR	B
	JNZ	$-4
	RET
;;
MOVE:
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MOVE
	RET
;;
BMCO:
	MOV	C,M
	MOV	A,C
	INX	H
	CPI	80H
	JNC	ERRCHR
	CPI	20H
	JNC	$+5
ERRCHR:
	MVI	C,'?'	 	; zamena 00H-1FH, 80H-0FFH
	CALL	CO
	DCR	B
	JNZ	BMCO
	RET
;;
;;  steretx oblastx
;;  whod:
;;    <H,L> - adres na~ala
;;    <A> - dlina
CLR:
	MVI	M,0
	DCR	A
	INX	H
	JNZ	$-4
	RET

;;  wywod signala treb.dlitelxnosti
;;  whod:
;;    LENGHT - abs.dlina
;;    popr - poprawka na dopoln.dejstwiq
signal	MACRO	LENGHT,popr
	LOCAL	LLL
LLL:	MVI	A,LENGHT-1-popr
	DCR	A			;  5 >
	JNZ	$-1			; 10 > -15*popr
	MVI	A,1
	OUT	00H
	MVI	A,LENGHT-1
	DCR	A
	JNZ	$-1
	MVI	A,0
	OUT	00H
	MVI	A,LENGHT-2-popr
	STA	LLL+1
	RET				; 10 > SUM:=10-15*popr
	ENDM

signal1	MACRO	LENGHT,popr
	MVI	A,LENGHT-1-popr
	DCR	A			;  5 >
	JNZ	$-1			; 10 > -15*popr
	MVI	A,1
	OUT	00H
	MVI	A,LENGHT-1
	DCR	A
	JNZ	$-1
	MVI	A,0
	OUT	00H
	RET				; 10 > SUM:=10-15*popr
	ENDM
;;
BIT:
	JC	BIT1			; 10
;;
;;    wersiq dlq "bajta"
;;
CHANGE	MACRO	SH
	MVI	A,38-1-5-SH
	STA	BIT0+1
	MVI	A,72-1-5-SH
	STA	BIT1+1
	ENDM

BIT0:	signal	38,5
BIT1:	signal	72,5
swist:	signal1	92,3
;;
;;  wersiq dlq 12 MHZ
;;
;BIT0:	signal	42,5
;BIT1:	signal	84,5
;swist:	signal1	105,3
;;
;;  wywod bajta
;;  whod:
;;    <C> - bajt

PUBLIC	WBYTE
WBYTE:
	MVI	B,8
	MOV	A,C	;  5
	RLC		;  5
	MOV	C,A	;  5
	CALL	BIT	; 17+10+10-15*popr
	DCR	B	;  5
	JNZ	$-7	; 10 > SUM:=67-15*popr=0 pri popr:=5 menx{e na 7
	RET

;;  wywod fajla

PUBLIC	wywfajl
wywfajl:
	LHLD	FILE
	MOV	E,M		; dlina fajla
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
;;
;;  wywod oblasti
;;  whod:
;;    <A> - dlina swistka (00H - 4000, ostalxnye - 1600)
;;    <H,L> - na~alo
;;    <D,E> - dlina

PUBLIC	OUTFLD
OUTFLD:
	PUSH	H
	LXI	H,INIREPACK
	SHLD	WHATRE
	POP	H

	EI
	ORA	A
	LXI	B,1600
	JNZ	$+6
	LXI	B,4000
;;
	CHANGE	0

	DI
	CALL	swist	; 17
	DCX	B	;  5
	MOV	A,B	;  5
	ORA	C	;  5
	JNZ	$-6	; 10 > SUM:=32+10-15*popr=0 pri popr:=3
;;
	MVI	A,1	;  7
	DCR	A	;  5
	JNZ	$-1	; 10
	CALL	BIT0	; 17+10+5+5+5+10+22=64 dlq popr=5

CLW:	CALL	REPACK
	JZ	EXWR
	MOV	C,A
	CALL	WBYTE
	JMP	CLW
;;
EXWR:
	EI
	LXI	H,8000H
DELAY:
	DCX	H
	MOV	A,H
	ORA	L
	JNZ	DELAY
	RET

;;  najti infrormaci` w KEYTAB
;;  whod: NUMFL
;;  wyhod: <H,L> - adres sootw.zapisi
KEYCNT:
	LDA	NUMFL
	DCR	A
	MVI	D,0
	MOV	E,A
	LXI	H,KEYTAB
	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	D
	RET
;;
;;  najti ~islo programm dlq s~it. i zapisi
;;  wyhod: NRD,NWR
NRDNWR:
	LXI	H,0000H
	SHLD	NRD
	LXI	H,PNAME
	MOV	A,M
	CPI	'$'
	RZ
;;
	LXI	H,KEYTAB-10H
	MVI	A,-1
	STA	NRD
;;
CKLCHK:
	LDA	NRD
	INR	A
	STA	NRD
;;
	MOV	A,L		; smenitx zapisx
	ANI	0F0H
	MOV	L,A
	LXI	D,10H
	DAD	D
;;
	MOV	A,M		; konec KEYTAB
	CPI	0FFH
	LXI	D,NOPROG
	JZ	ERROR
;;
	INX	H		; "programma" ?
	MOV	A,M
	ORA	A
	JNZ	CKLCHK
	LXI	D,PNAME
	MVI	C,8
	INX	H
	CALL	CHECK
	JNZ	CKLCHK

	MVI	A,0
	STA	NWR
CHPRG:
	LDA	NWR
	INR	A
	STA	NWR
;;
	MOV	A,L
	ANI	0F0H
	MOV	L,A
	LXI	D,10H
	DAD	D
;;
	MOV	A,M
	CPI	0FFH
	RZ			; konec KEYTAB
	INX	H
	MOV	A,M
	ORA	A
	JNZ	CHPRG
	RET

PROGRAM:
	LXI	D,ADVERT
	CALL	PEC
	LHLD	0006H
	SHLD	MAXADR
	LHLD	DISK
	SHLD	DCOUNT
;;
	LXI	H,FCB+11H		; zapomnitx imq "programmy"
	LXI	D,PNAME
	LXI	B,8
	CALL	MOVE
	LXI	D,tprg			; wywesti imq programy
	CALL	PEC
	LXI	H,PNAME
	MVI	B,8
	CALL	BMCO
;;
	CALL	KEYNAME			; wwesti ili sformirowatx
	LXI	D,NOFILE
	JZ	ERROR
	LXI	D,KEYTAB
IKEY:
	LXI	B,10H
	CALL	INPBLC
	LXI	H,-10H
	DAD	D
	MOV	A,M
	ORA	A
	JZ	IKEY
	XCHG				; <H,L> - adres za TABKEY
;;
SNCINP:
	SHLD	FILE			; FILE na~inatx za KEYTAB
	LHLD	DISK
;;
	SHLD	DCOUNT
	XRA	A
	STA	READFLAG
	STA	NUMFL
	CALL	SNCNAME			; otkrytx fajl .SNC
	JZ	ERROR

	CALL	NRDNWR
wwesti:
	LDA	NRD			; propustitx nenuvnye "programmy"
	ORA	A
	JZ	pisatx
	DCR	A
	STA	NRD
	CALL	INPFILE
	JC	WARM
;;
	LXI	H,NUMFL			; uwel. nomer "zapisi"
	INR	M
	CALL	INFFILE
	LXI	D,RDR
	CALL	PEC
	JMP	wwesti
;;
pisatx:
	LXI	D,TAPEINF		; ovidatx wkl.magnitofona
	CALL	PEC
WAIT:	MVI	E,0FDH
	SYSTEM	06H			; CI
	CPI	0DH
	JNZ	WAIT
magn:
	CALL	INPFILE			; wywesti "programmu" na nml
	JC	WARM
;;
	LXI	H,NUMFL
	INR	M
	CALL	INFFILE
	LXI	D,WRT
	CALL	PEC
	LDA	NEWPRG		; 0 - priznak na~ala programmy
	ORA	A
	JNZ	wywesti
	XRA	A		; 5-sek. zadervka pered na~alom programmy
	HLT
	DCR	A
	JNZ	$-2

wywesti:
	CALL	wywfajl			; wywesti zapisx na nml
;;
	IN	01H			; wyhod po navati` us
	ANI	01000000B
	JZ	WARM
;;
	IN	01H			; navatie na ss - ostanowka
	ANI	00100000B
	JNZ	GOTAPE
	IN	01H			; zatem na us - zapusk
	ANI	01000000B
	JNZ	$-4
;;
GOTAPE:
	LDA	NWR			; "programma" zakon~ena ?
	DCR	A
	STA	NWR
	JNZ	magn
	JMP	WARM

;;  oblastx tektowyh soob}enij
;;  --------------------------
ADVERT:
	DB	0CH,1BH,5EH,1BH,'b',1BH,']'
	DB	' SINCLAIR SAVE PROGRAM ',18H,18H
	DB	1BH,5CH
	DB	' (s) 1990, 1993, filippow e.w. ',18H,18H
	DB	1BH,'a',1BH,5EH,0FH,'$'
;;
tip:
	DB	'BASIC$'
	DB	'DIGIT$'
	DB	'CHAR $'
	DB	'CODE $'
;;
zagtip:
	DB	0DH,0AH,1BH,05CH,1BH,'b',0DH,0AH
	DB	' nom. imq prg.  N  Z  tip   ...imq.... dln. na~. -------'
	DB	1BH,'a',0DH,0AH,0FH,'$'
;;
literal:
	DB	1BH,5CH,'$'
;;
READERR:
	DB	1BH,5CH
	DB	0DH,0AH,'o{ibka pri ~tenii fajla',0FH,'$'
FILEEND:
	DB	1BH,5CH
	DB	0DH,0AH,'fajl zakon~en',0FH,'$'
;;
timq:
	DB	0DH,0AH,1BH,5CH,'imq fajla:',0FH,'$'
tprg:
	DB	0DH,0AH,1BH,5CH,'imq programmy:',0FH,'$'
;;
NOFILE:
	DB	1BH,5CH
	DB	0DH,0AH,'net fajla',0FH,'$'
NOPROG:
	DB	1BH,5CH
	DB	0DH,0AH,'net nuvnoj programmy',0FH,'$'
NONAME:
	DB	1BH,5CH
	DB	0DH,0AH,'newerno ukazano imq fajla',0FH,'$'
;;
ENDMEM:
	DB	1BH,5CH
	DB	0DH,0AH,'ne hwataet pamqti',0FH,'$'
;;
pustimq:
	DB	'        $'
;;
SNCFILE:
	DB	'ZXS'
KEYFILE:
	DB	'ZXK'
RDR:
	DB	'  READ$'
WRT:
	DB	'  WRITE$'
;;
TAPEINF:
	DB	1BH,5CH,0DH,0AH,0DH,0AH,'wkl`~ite magnitofon i navmite <wk>'
	DB	0FH,'$'


;  dinami~eskaq raspakowka dannyh
;  pered ispolxzowaniem zapisatx w WHATRE adres INIREPACK
;  wyhod:
;    flag Z=1 - priznak okon~aniq upakowannyh dannyh

	DSEG

PUBLIC	COUNTREPACK
COUNTREPACK:
	DS	2


	CSEG

PUBLIC	REPACK
REPACK:
	JMP	0

WHATRE	EQU	REPACK+1

PUBLIC	UNPACKPROC
UNPACKPROC:
	INX	H
	PUSH	H
	LHLD	COUNTREPACK
	DCX	H
	SHLD	COUNTREPACK
	MOV	A,H
	ORA	L
	POP	H

	JZ	INIREPACKC
	CHANGE	7
	MOV	A,M
	RET

PUBLIC	PACKPROC
PACKPROC:
	PUSH	H
	LHLD	COUNTREPACK
	DCX	H
	SHLD	COUNTREPACK
	MOV	A,H
	ORA	L
	POP	H

	CHANGE	7
	MOV	A,M
	RNZ
	INX	H

INIREPACKC:
	CHANGE	21
	JMP	INIC

PUBLIC	INIREPACK
INIREPACK:
	CHANGE	14

INIC:
	PUSH	H
	PUSH	D
	MOV	A,M		; najti s~et~ik
	INX	H
	MOV	H,M
	MOV	L,A
	MOV	A,H
	ORA	A
	LXI	D,UNPACKPROC
	JP	$+9
	LXI	D,PACKPROC
	ANI	7FH
	MOV	H,A
	SHLD	COUNTREPACK
	XCHG
	SHLD	WHATRE

	MOV	A,D		; priznak konca upak. dannyh ?
	ORA	E

	POP	D
	POP	H
	INX	H
	INX	H
	MOV	A,M
	RET
	

	END

